<?php
 /*
              Program Name : ASCIIDEF
              Package Name : Subroutine Library - layer 0
              Purpose      : Definitions of ASCII constants
              Institution  : Conroy & Conroy Co.
              Date Written : 23-Apr-1995
              Written By   : Alan Conroy
              Version      : 1.0A

              Copyright (c) 1995-2004 by Alan Conroy.  Released to the public domain.

	      TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *********************************************************
        *                                                       *
        *        M O D I F I C A T I O N   H I S T O R Y        *
        *                                                       *
        *********************************************************

             DATE      BY             REASON

        19-Nov-2015    EAC            Added additional constants.

        *********************************************************
        *                                                       *
        *           P R O G R A M   P U R P O S E               *
        *                                                       *
        *********************************************************

        Support for ASCII values, including character and numeric constants.

        *********************************************************
        *                                                       *
        *            F I L E   D E S C R I P T I O N S          *
        *                                                       *
        *********************************************************
*/

$_ASCII_Codes = array(
                                                  "NUL",
                                                  "SOH",
                                                  "STX",
                                                  "ETX",
                                                  "EOT",
                                                  "ENQ",
                                                  "ACK",
                                                  "BEL",
                                                  "BS",
                                                  "HT",
                                                  "LF",
                                                  "VT",
                                                  "FF",
                                                  "CR",
                                                  "SO",
                                                  "SI",
                                                  "DLE",
                                                  "DC1",
                                                  "DC2",
                                                  "DC3",
                                                  "DC4",
                                                  "NAK",
                                                  "SYN",
                                                  "ETB",
                                                  "CAN",
                                                  "EM",
                                                  "SUB",
                                                  "ESC",
                                                  "FS",
                                                  "GS",
                                                  "RS",
                                                  "US" ) ;

// Return ASCII code for specified value
function ASCII_Codes( $X )
{
    if(!is_numeric($X))
	{
		return;
	}
    $X = $X & 255 ;
    if( $X == 127 )
    {
        return "DEL" ;
    } ;
    if( $X < 32 )
    {
        return $_ASCII_Codes[ $X ] ;
    } ;
    return chr($X);
}
