{
        Program Name : COMLists
        Package Name : Subroutine Library Layer 0
        Purpose      : COM list class
        Institution  : Conroy & Conroy Co.
        Date Written : 1-Nov-2006
        Written By   : Alan Conroy
        Version      : 1.0

	    Copyright (C) 2006 by Alan Conroy.  All rights reserved.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

}

unit COMLists ;

interface

{$I EDEFINES.INC}

{$IFDEF DYNAMIC_OBJECTS}
uses { C&C Subroutine Library - Layer 0... }
     _COMLists, { TCOM_List }

     { Borland... }
     Classes ; { TList }

type TStandard_COM_List = class( TCOM_List )
                              public { Constructors and destructors... }
                                  constructor Create ;
                                  destructor Destroy ; override ;

                              private { Instance data... }
                                  _List : TList ;
                                  _Delta : longint ;

                              public { API... }
                                  function Add( Value : longint ) : longint ;
                                      override ; stdcall ;
                                  function Get_Count : longint ; override ; stdcall ;
                                  function Get_Item( Index : longint ) : longint ;
                                      override ; stdcall ;
                                  procedure Set_Item( Index, Value : longint ) ;
                                      override ; stdcall ;
                                  function Get_Capacity : longint ;
                                      override ; stdcall ;
                                  procedure Set_Capacity( Value : longint ) ;
                                      override ; stdcall ;
                                  function Get_Delta : longint ;
                                      override ; stdcall ;
                                  procedure Set_Delta( Value : longint ) ;
                                      override ; stdcall ;
                                  function IndexOf( Value : longint ) : longint ;
                                      override ; stdcall ;
                          end ; // TStandard_COM_List
{$ENDIF}

implementation

{$IFDEF DYNAMIC_OBJECTS}
{TCOM_List methods... }

{ Constructors and destructors... }

constructor TStandard_COM_List.Create ;

begin
    inherited Create ;

    _List := TList.Create ;
end ;


destructor TStandard_COM_List.Destroy ;

begin
    _List.Free ;
    _List := nil ;

    inherited Destroy ;
end ;


{ API... }

function TStandard_COM_List.Get_Capacity : longint ;

begin
    Result := _List.Capacity ;
end ;


procedure TStandard_COM_List.Set_Capacity( Value : longint ) ;

begin
    _List.Capacity := Value ;
end ;


function TStandard_COM_List.Get_Delta : longint ;

begin
    Result := _Delta ;
end ;


procedure TStandard_COM_List.Set_Delta( Value : longint ) ;

var New_Cap : longint ;

begin
    _Delta := Value ;
    if( ( _List.Capacity mod Value ) <> 0 ) then // Need to increase current allocation
    begin
        New_Cap := ( ( _List.Count + _Delta ) div _Delta ) * _Delta ;
        if( New_Cap > _List.Capacity ) then
        begin
            _List.Capacity := New_Cap ;
        end ;
    end ;
end ;


function TStandard_COM_List.Add( Value : longint ) : longint ;

var New_Cap : longint ;

begin
    New_Cap := ( ( _List.Count + _Delta + 1 ) div _Delta ) * _Delta ;
    if( New_Cap > _List.Capacity ) then
    begin
        _List.Capacity := New_Cap ;
    end ;
    _List.Add( pointer( Value ) ) ;
    Result := _List.Count - 1 ;
end ;


function TStandard_COM_List.Get_Count : longint ;

begin
    Result := _List.Count ;
end ;


function TStandard_COM_List.Get_Item( Index : longint ) : longint ;

begin
    Result := longint( _List[ Index ] ) ;
end ;


procedure TStandard_COM_List.Set_Item( Index, Value : longint ) ;

begin
    _List[ Index ] := pointer( Value ) ;
end ;


function TStandard_COM_List.IndexOf( Value : longint ) : longint ;

begin
    Result := _List.Indexof( pointer( Value ) ) ;
end ;
{$ENDIF}



end.

