<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
	<title>C&amp;C Subroutine Library</title>
</head>
<body>
<?php
include "lb_header.php"
?>
<p>
<b>TSDebug_Interface</b><br>
What: Class<br>
Ancestor: <a href="TObject.php">TObject</a><br>
File: _DebugIn<br>
Layer: 0<br>
Platforms: C++, Javascript, Pascal (All), PHP, Python<br>
<br>
This class is the abstract base class for debug iterators.  Unlike 
the <a href="TCOM_Debug_Interface.php">TCOM_Debug_Interface</a> class, the methods
are not stdcall (other than C++ and Pascal, this is the ancestor of the other class).  
The class contains the following methods:
</p>
<p>
<b>Activate</b><br>
void Activate()<br>
procedure Activate<br>
Indicates that the user wished to activate this level.  The behavior is undefined 
and up to the implementor.  Typically, this does nothing unless this level is a terminal
representing some complex data which is not viewable in a hierarchical form.
</p>
<p>
<b>Arbitrary_Length</b><br>
bool Arbitrary_Length()<br>
function Arbitrary_Length : boolean<br>
Returns true if the number of children can very.
</p>
<p>
<b>Can_Change</b><br>
bool Can_Change()<br>
function Can_Change : boolean<br>
Returns True if this item can be modified.
</p>
<p>
<b>Child</b><br>
TCOM_Debug_Interface *Child( int32 Index )<br>
function Child( Index : longint ) : TCOM_Debug_Interface<br>
Returns a debug interface for the specified child level (first child level is 0).
</p>
<p>
<b>Context</b><br>
property Context : longint<br>
(Not available in C++).<br>
Access to the object context value.
</p>
<p>
<b>Count</b><br>
int32 Count()<br>
function Count : longint<br>
Returns the number of child components under this level.  If this is a terminal (leaf) 
node, the method returns 0.
</p>
<p>
<b>Get_Context</b><br>
int32 Get_Context()<br>
function Get_Context : longint<br>
Returns the context for the object.
</p>
<p>
<b>Get_Title</b><br>
char* Get_Title()<br>
function Get_Title : PAnsiChar<br>
Returns text representing this level (such as "Cached data").
</p>
<p>
<b>Has_Children</b><br>
bool Has_Children()<br>
function Has_Children : boolean<br>
Returns whether or not there are child components under this level.  If this is a 
terminal (leaf) node, the method returns false.
</p>
<p>
<b>Kill</b><br>
void Kill()<br>
procedure Kill<br>
Tells object to destroy itself.
</p>
<p>
<b>Modify</b><br>
char* Modify( char* Data, int Size )<br>
function Modify( Data : PAnsiChar ; Size : integer ) : PAnsiChar<br>
Modifies data.  If Size is -1, Data is assumed to be null-terminated and its length 
is automatically determined.  The result will be nil or a pointer to a null string 
to indicate success and error text otherwise.
</p>
<p>
<b>Recursive</b><br>
bool Recursive()<br>
function Recursive : boolean<br>
Returns true if this item is recursive.
</p>
<p>
<b>Set_Context</b><br>
void Set_Context( int32 Value )<br>
procedure Set_Context( Value : longint )<br>
Sets the object context.
</p>
<p>
<b>Set_Title</b><br>
void Set_Title( char* Value )<br>
procedure Set_Title<br>
Sets text representing this level.
</p>
<p>
<b>Title</b><br>
property Title : PAnsiChar<br>
(Not available in C++).<br>
Access to the object title.
</p>
