<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
	<title>C&amp;C Subroutine Library</title>
</head>
<body>
<?php
include "lb_header.php"
?>
<p>
<b>TSGeneric_Method</b><br>
What: class <a href="TObject.php">TObject</a><br>
File: <a href="_GenVal.php">_GenVal</a><br>
Layer: 0<br>
Platforms: C++, Javascript, Pascal (Delphi), PHP, Python<br>
<br>
This is the abstract base class for representing composite data types.
</p>
<p>
<b>C_Order</b><br>
bool C_Order()<br>
function C_Order : boolean<br>
Returns true if the method uses the C calling convention.
</p>
<p>
<b>Compile_Time</b><br>
bool Compile_Time()<br>
function Compile_Time : boolean<br>
Returns true if the routine can be evaluated at compile-time.
</p>
<p>
<b>Execute</b><br>
TGeneric_Value* Execute( TGeneric_Value* Parameters )<br>
function Execute( Parameters : TGeneric_Value ) : TGeneric_Value<br>
Execute the method.
</p>
<p>
<b>Is_Abstract</b><br>
bool Is_Abstract()<br>
function Is_Abstract : boolean<br>
Returns true if the method is abstract (pure virtual).
</p>
<p>
<b>Is_Constructor</b><br>
bool Is_Constructor()<br>
function Is_Constructor : boolean<br>
Return true if this method is a constructor.
</p>
<p>
<b>Is_Destructor</b><br>
bool Is_Destructor()<br>
function Is_Destructor : boolean<br>
Returns true if this method is a destructor.
</p>
<p>
<b>Is_Virtual</b><br>
bool Is_Virtual()<br>
function Is_Virtual : boolean<br>
Returns true if this method is virtual.
</p>
<p>
<b>Standard</b><br>
bool Standard()<br>
function Standard : boolean<br>
Returns true if the method is standard (stack) calling convention.
</p>
<p>
<b>Static</b><br>
bool Static()<br>
function Static : boolean<br>
Returns true if this is a static method.
</p>
<p>
<b>Count</b><br>
int32 Count()<br>
function Count : longint<br>
Returns number of parameters (run-time).
</p>
<p>
<b>Max_Count</b><br>
int32 Max_Count()<br>
function Max_Count : longint<br>
Returns maximum potential number of parameters.
</p>
<p>
<b>Method_Class</b><br>
TMethod_Class Method_Class()<br>
function Method_Class : TMethod_Class<br>
Returns true if the method uses the C calling convention.
</p>
<p>
<b>Parameter</b><br>
TGeneric_Value* Parameter( int Index )<br>
function Parameter( Index : integer ) : TGeneric_Value<br>
Returns parameter for specified index.
</p>
<p>
<b>Target</b><br>
bool Target()<br>
function Target : boolean<br>
Returns true if a target function.
</p>
