<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
	<title>C&amp;C Subroutine Library</title>
</head>
<body>
<?php
include "lb_header.php"
?>
<p>
<b>TSGeneric_Value</b><br>
What: class <a href="TObject.php">TObject</a><br>
File: <a href="_GenVal.php">_GenVal</a><br>
Layer: 0<br>
Platforms: C++, Javascript, Pascal (Delphi), PHP, Python<br>
<br>
This is the abstract base class for representing composite data types/values.
</p>
<p>
<b>_Char</b><br>
char _Char()<br>
property _Char : char read Get_Char write Set_Char<br>
Access to the value as a character.
</p>
<p>
<b>_Clone</b><br>
TGeneric_Value* Clone()<br>
function Clone : TGeneric_Value<br>
Returns a clone of the instance.
</p>
<p>
<b>_Double</b><br>
double _Double()<br>
property _Double : double read Get_Double write Set_Double<br>
Access to the value as a 64-bit floating point value.
</p>
<p>
<b>_Extended</b><br>
long double _Extended()<br>
property _Extended : extended read Get_Extended write Set_Extended<br>
Access to the value as an 80-bit floating point value.
</p>
<p>
<b>_PChar</b><br>
char* _PChar()<br>
property _PChar : PChar read Get_PChar write Set_PChar<br>
Access to the value as a pointer to characters.
</p>
<p>
<b>_Single</b><br>
float _Single()<br>
property _Single : single read Get_Single write Set_Single<br>
Access to the value as a 32-bit floating point value.
</p>
<p>
<b>_String</b><br>
string _String()<br>
property _String : string read Get_String Set_String<br>
Access to the value as a string.
</p>
<p>
<b>Bool</b><br>
bool Bool()<br>
property Bool : boolean read Get_Boolean write Set_Boolean<br>
Access to the value as a boolean.
</p>
<p>
<b>Byte_Bool</b><br>
ByteBool Byte_Bool()<br>
proeprty Byte_Bool : bytebool read Get_Byte_Bool write Set_Byte_Bool<br>
Access to the value as an 8-bit boolean value.
</p>
<p>
<b>Can_Convert</b><br>
bool Can_Convert( TValue_Data_Type Typ )<br>
function Can_Convert( Typ : TValue_Data_Type ) : boolean<br>
Returns true if value can be converted to the specified data type.
</p>
<p>
<b>Cast</b><br>
void Cast( TGeneric_Value* Typ )<br>
procedure Cast( Typ : TGeneric_Value )<br>
Casts the type to the type of the specified value.
</p>
<p>
<b>Constant</b><br>
bool Constant()<br>
function Constant : boolean<br>
Returns true if the type is a constant.
</p>
<p>
<b>Convert</b><br>
TGeneric_Value* Convert( TGeneric_Value* Class_Type, bool &Loss )<br>
function Convert( Class_Type : TGeneric_Value ; var Loss : boolean ) : TGeneric_Value<br>
Returns a version of the value converted to the passed type specification.  Returns nil if the
conversion cannot be done.  Loss is ignored when passed and is True on return if there was a loss
of precision.
</p>
<p>
<b>Data_Type</b><br>
TValue_Data_Type Data_Type()<br>
function Data_Type : TValue_Data_Type<br>
Returns the data type.
</p>
<p>
<b>Dereference</b><br>
TGeneric_Value* Dereference()<br>
function Dereference : TGeneric_Value<br>
Dereferences a pointer.
</p>
<p>
<b>Deserialize</b><br>
void Deserialize( char* Value )<br>
procedure Deserialize( Value : PChar )<br>
Constructs the object from the passed serialization string.
</p>
<p>
<b>Family</b><br>
TData_Type_Family Family()<br>
function Family : TData_Type_Family<br>
Returns family of the type.
</p>
<p>
<b>Get_Boolean</b><br>
bool Get_Boolean()<br>
function Get_Boolean : boolean<br>
Returns the value as a boolean.
</p>
<p>
<b>Get_ByteBool</b><br>
ByteBool Get_ByteBool()<br>
function Get_ByteBool : bytebool<br>
Returns the value as a single-byte boolean.
</p>
<p>
<b>Get_Char</b><br>
char Get_Char()<br>
function Get_Char : char <br>
Returns the value as a character.
</p>
<p>
<b>Get_Double</b><br>
double Get_Double()<br>
function Get_Double : double<br>
Returns the value as a 64-bit floating point value.
</p>
<p>
<b>Get_Extended</b><br>
long double Get_Extended()<br>
function Get_Extended : extended<br>
Returns the value as an 80-bit floating point value.
</p>
<p>
<b>Get_Integer8</b><br>
int8 Get_Integer8()<br>
function Get_Integer8 : int8<br>
Returns the value as an 8-bit signed integer.
</p>
<p>
<b>Get_Integer16</b><br>
int16 Get_Integer16()<br>
function Get_Integer16 : int16<br>
Returns the value as an 16-bit signed integer.
</p>
<p>
<b>Get_Integer32</b><br>
int32 Get_Integer32()<br>
function Get_Integer32 : int32<br>
Returns the value as a 32-bit signed integer.
</p>
<p>
<b>Get_Integer64</b><br>
int64 Get_Integer64()<br>
function Get_Integer64 : int64<br>
(Note: Delphi 3 and up only for Delphi)<br>
Returns the value as a 64-bit signed integer.
</p>
<p>
<b>Get_LongBool</b><br>
BOOL Get_LongBool()<br>
function Get_LongBool : longbool<br>
Returns the value as a 32-bit boolean.
</p>
<p>
<b>Get_PChar</b><br>
char* Get_PChar()<br>
function Get_PChar : PChar<br>
Returns a pointer to the data.
</p>
<p>
<b>Get_Single</b><br>
float Get_Single()<br>
function Get_Single : single<br>
Returns the value as a 32-bit floating point value.
</p>
<p>
<b>Get_String</b><br>
string Get_String()<br>
function Get_String : string<br>
Returns the value as a string.
</p>
<p>
<b>Get_Undefined</b><br>
void Get_Undefined( void* Buffer, int32 Len )<br>
procedure Get_Undefined( Buffer : pointer ; Len : longint )<br>
Gets the value as a binary value, writing it to the specified buffer.  If the passed
buffer length is too small to hold the entire value, only Len bytes are written to
the buffer.
</p>
<p>
<b>Get_Unsigned_Integer8</b><br>
uint8 Get_Unsigned_Integer8()<br>
function Get_Unsigned_Integer8 : uint8<br>
Returns the value as an 8-bit signed integer.
</p>
<p>
<b>Get_Unsigned_Integer16</b><br>
uint16 Get_Unsigned_Integer16()<br>
function Get_Unsigned_Integer16 : uint16<br>
Returns the value as a 16-bit unsigned integer.
</p>
<p>
<b>Get_Unsigned_Integer32</b><br>
uint32 Get_Unsigned_Integer32()<br>
(Note: In Delphi, only applies to Delphi 2 and later)<br>
function Get_Unsigned_Integer32 : uint32<br>
Returns the value as a 32-bit unsigned integer.
</p>
<p>
<b>Get_Unsigned_Integer64</b><br>
int64 Get_Unsigned_Integer64()<br>
function Get_Unsigned_Integer64 : int64<br>
(Note: Delphi 3 and up only for Delphi)<br>
Returns the value as a 64-bit signed integer.
</p>
<p>
<b>Get_WordBool</b><br>
WordBool Get_WordBool()<br>
function Get_WordBool : wordbool<br>
Returns the value as a 16-bit boolean.
</p>
<p>
<b>Integer8</b><br>
int8 Integer8()<br>
property Integer8 : int8 read Get_Integer8 write Set_Integer8<br>
Access to the value as an 8-bit signed integer.
</p>
<p>
<b>Integer16</b><br>
int16 Integer16()<br>
int16 Integer16 : int16 read Get_Integer16 write Set_Integer16<br>
Access to the value as a 16-bit signed integer.
</p>
<p>
<b>Integer32</b><br>
int32 Integer32()<br>
property Integer32 : int32 read Get_Integer32 write Set_Integer32<br>
Access to the value as a 32-bit signed integer.
</p>
<p>
<b>Integer64</b><br>
int64 Integer64()<br>
property Integer64 : int64 read Get_Integer64 write Set_Integer64<br>
Access to the value as a 64-bit signed integer.
</p>
<p>
<b>Long_Bool</b><br>
BOOL Long_Bool()<br>
property Long_Bool : longbool read Get_Long_Bool write Set_Long_Bool<br>
Access to the value as a 32-bit boolean.
</p>
<p>
<b>Name</b><br>
string Name()<br>
function Name : string<br>
Returns the name of the type.
</p>
<p>
<b>Serialize</b><br>
char* Serialize()<br>
function Serialize : PCha<br>
Returns a string that can later be used by Deserialize to reconstruct the object
instance.
</p>
<p>
<b>Set_Boolean</b><br>
void Set_Boolean( bool B )<br>
procedure Set_Boolean( B : boolean )<br>
Sets the value to the passed boolean.
</p>
<p>
<b>Set_ByteBool</b><br>
void Set_ByteBool( ByteBool B )<br>
procedure Set_ByteBool( B : bytebool )<br>
Sets the value to a single-byte boolean of B.
</p>
<p>
<b>Set_Char</b><br>
void Set_Char( char C )<br>
procedure Set_Char( C : char )<br>
Sets the value to the passed character.
</p>
<p>
<b>Set_Double</b><br>
void Set_Double( double D )<br>
procedure Set_Double( D : double )<br>
Sets the value to the specified 64-bit floating point value.
</p>
<p>
<b>Set_Extended</b><br>
void Set_Extended( long double E )<br>
procedure Set_Extended( E : extended )<br>
Sets the value to the specified 80-bit floating point value.
</p>
<p>
<b>Set_Integer8</b><br>
void Set_Integer8( int8 I )<br>
procedure Set_Integer8( I : int8 )<br>
Sets the value to the passed 8-bit integer value.
</p>
<p>
<b>Set_Integer16</b><br>
void Set_Integer16( int16 I )<br>
procedure Set_Integer16( I : int16 )<br>
Sets the value to the passed 16-bit integer value.
</p>
<p>
<b>Set_Integer32</b><br>
void Set_Integer32( int32 I )<br>
procedure Set_Integer32( I : int32 )<br>
Sets the value to the passed 32-bit integer value.
</p>
<p>
<b>Set_Integer64</b><br>
void Set_Integer64( int64 I )<br>
procedure Set_Integer64( I : int64 )<br>
Sets the value to the passed 64-bit integer value.
</p>
<p>
<b>Set_LongBool</b><br>
void Set_LongBool( BOOL B )<br>
procedure Set_LongBool( B : longbool )<br>
Sets the value to the passed 32-bit boolean.
</p>
<p>
<b>Set_Null</b><br>
void Set_Null()<br>
procedure Set_Null<br>
Sets the value to null.
</p>
<p>
<b>Set_PChar</b><br>
void Set_PChar( char* P )<br>
procedure Set_PChar( P : PChar )<br>
Sets the value to the passed zero-terminated value.
</p>
<p>
<b>Set_Single</b><br>
void Set_Single( float S )<br>
procedure Set_Single( S : single )<br>
Sets the value to the specified 32-bit floating point value.
</p>
<p>
<b>Set_String</b><br>
void Set_String( const string S )<br>
procedure Set_String( const S : string )<br>
Sets the value to the specified string.
</p>
<p>
<b>Set_Undefined</b><br>
void Set_Undefined( void* Buffer, int32 Len )<br>
procedure Set_Undefined( Buffer : pointer ; Len : longint )<br>
Sets the value to the passed binary data of Len bytes.
</p>
<p>
<b>Set_Unsigned_Integer8</b><br>
void Set_Unsigned_Integer8( uint8 I )<br>
procedure Set_Unsigned_Integer8( I : uint8 )<br>
Sets the value to the passed 8-bit unsigned integer value.
</p>
<p>
<b>Set_Unsigned_Integer16</b><br>
void Set_Unsigned_Integer16( uint16 I )<br>
procedure Set_Unsigned_Integer16( I : uint16 )<br>
Sets the value to the passed 16-bit unsigned integer value.
</p>
<p>
<b>Set_Unsigned_Integer32</b><br>
void Set_Unsigned_Integer32( uint32 I )<br>
procedure Set_Unsigned_Integer32( I : uint32 )<br>
Sets the value to the passed 32-bit unsigned integer value.
</p>
<p>
<b>Set_Unsigned_Integer64</b><br>
void Set_Unsigned_Integer64( uint32 I )<br>
procedure Set_Unsigned_Integer64( I : uint32 )<br>
Sets the value to the passed 64-bit unsigned integer value.
</p>
<p>
<b>Set_WordBool</b><br>
void Set_WordBool( WordBool B )<br>
procedure Set_WordBool( B : wordbool )<br>
Sets the value to the passed 16-bit boolean.
</p>
<p>
<b>Simple_Cast</b><br>
void Simple_Cast( TValue_Data_Type Typ )<br>
procedure Simple_Cast( Typ : TValue_Data_Type )<br>
Casts the type to the specified type.
</p>
<p>
<b>Size</b><br>
int32 Size()<br>
function Size : longint<br>
Returns the size of the type, in bytes.
</p>
<p>
<b>Total_Size</b><br>
int32 Total_Size()<br>
function Total_Size : longint<br>
Size of all associated data, in bytes.  For instance, Size may return the size of 
an object but Total_Size also includes the size of any associated data.
</p>
<p>
<b>Type_Information</b><br>
TType_Information* Type_Information()<br>
function Type_Information : TType_Information<br>
Returns type information.
</p>
<p>
<b>Unsigned_Integer8</b><br>
uint8 Unsigned_Integer8()<br>
property Unsigned_Integer8 : uint8 read Get_Unsigned_Integer8 write Set_Unsigned_Integer8<br>
Access to the value as an 8-bit unsigned integer.
</p>
<p>
<b>Unsigned_Integer16</b><br>
uint16 Unsigned_Integer16()<br>
property Unsigned_Integer16 : uint16 read Get_Unsigned_Integer16 write Set_Unsigned_Integer16<br>
Access to the value as a 16-bit unsigned integer.
</p>
<p>
<b>Unsigned_Integer32</b><br>
uint32 Unsigned_Integer32()<br>
property Unsigned_Integer32 : uint32 read Get_Unsigned_Integer32 write Set_Unsigned_Integer32<br>
Access to the value as a 32-bit unsigned integer.
</p>
<p>
<b>Unsigned_Integer64</b><br>
uint64 Unsigned_Integer64()<br>
property Unsigned_Integer64 : uint64 read Get_Unsigned_Integer64 write Set_Unsigned_Integer64<br>
Access to the value as a 64-bit unsigned integer.
</p>
<p>
<b>User_Data_Type_Name</b><br>
string User_Data_Type_Name()<br>
function User_Data_Type_Name : string<br>
Returns nil if not a composite (eg array).
</p>
<p>
<b>Word_Bool</b><br>
wordbool Word_Bool()<br>
property Word_Bool : wordbool read Get_Word_Bool write Set_Word_Bool<br>
Access to the value as a 16-bit boolean.
</p>
