<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
	<title>C&amp;C Subroutine Library</title>
</head>
<body>
<?php
include "lb_header.php"
?>
<p>
<b>tUnified_Exception</b><br>
What: classs <a href="_UE.php">_UE</a><br>
Layer: 0<br>
Platforms: C++, Pascal (Delphi), PHP<br>
<br>
This is the abstract base class for unified exception objects.  All methods use the
stdcall calling convention.
</p>
<p>
<b>Attach</b><br>
void Attach()<br>
procedure Attach<br>
(C++ and Pascal only)<br>
Increment the reference count for the instance.
</p>
<p>
<b>Code</b><br>
long Code()<br>
function Code : longint<br>
Returns the error code.
</p>
<p>
<b>Detach</b><br>
void Detach()<br>
procedure Detach<br>
(C++ and Pascal only)<br>
Decrement the reference count and self-destruct if reference count goes to zero.
</p>
<p>
<b>Error_Text</b><br>
char* Error_Text( long &Size, long &Typ)<br>
function Error_Text( var Size, Typ : longint ) : PAnsiChar<br>
Returns the text of the exception.  Typ is filled with the exception type (severity) and Size
is set to the length of the returned text.  See the Severity method for details on
the severity values.
</p>
<p>
<b>Facility</b><br>
long Facility()<br>
function Facility : longint<br>
Returns the facility ID.
</p>
<p>
<b>Facility_Version</b><br>
long Facility_Version()<br>
function Facility_Version : longint<br>
Returns the version of the facility.
</p>
<p>
<b>Free</b><br>
void Free()<br>
procedure Free<br>
(C++ and Pascal only)<br>
Calls the Detach method. 
</p>
<p>
<b>Get_Error</b><br>
long Get_Error()<br>
function Get_Error : longint<br>
Returns the error code.
</p>
<p>
<b>Get_Facility</b><br>
long Get_Facility()<br>
function Get_Facility<br>
Returns the facility ID.
</p>
<p>
<b>Get_Facility_Version</b><br>
long Get_Facility_Version()<br>
function Get_Facility_Version : longint<br>
Returns the facility version.
</p>
<p>
<b>Get_Previous</b><br>
TDebug_Interface *Get_Previous()<br>
function Get_Previous : PsUnified_Exception<br>
Returns the previous exception instance for chained exceptions.  NULL if none.
</p>
<p>
<b>Severity</b><br>
long Severity()<br>
function Severity<br>
Returns the severity of the exception.
<table>
<tr><th>Value</th><th>Meaning</th></tr>
<tr><td>UE_Success</td><td>Operation was succesful.</td></tr>
<tr><td>UE_Informational</td><td>Operation was succesful, but additional information is available.</td></tr>
<tr><td>UE_Warning</td><td>Operation did not complete but no error occurred, or completed with a warning.</td></tr>
<tr><td>UE_Error</td><td>Error ocurred.</td></tr>
<tr><td>UE_Fatal</td><td>Fatal error ocurred.</td></tr>
</table>
</p>
<p>
<b>Terminate</b><br>
void Terminate()<br>
procedure Terminate<br>
Called when the object self-destructs.
</p>
<p>
<b>Version</b><br>
long Version()<br>
function Version : longint<br>
Returns the facility version.
</p>
