/*
        Program Name : L10n
        Package Name : LB
        Purpose      : Localization for LB
        Institution  : Conroy & Conroy Co.
        Date Written : 23-August-2010
        Written By   : Alan Conroy
        Version      : 1.0

        Copyright (C) 2010-2020 by Alan Conroy.  All rights reserved.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          This unit provides for localization of the text used in LB.
*/

#ifndef L10N_HPP
#define L10N_HPP

#include <string>
#include <vector>

using namespace std;


std::vector<string> Texts ;

string Substitute( const string Value, const string Sub, const string X );
string Substitute1( const string Value, const string Sub1 );
string Substitute2( const string Value, const string Sub1, const string Sub2 );
string Substitute3( const string Value, const string Sub1, const string Sub2, const string Sub3 );
string Get_Text( const int ID, const string Default );
void Load_Text( const string N );
string Text_Error_Allocation_Table_Load_Failure();
string Text_Error_Execution_Exceeds_ms();
string Text_Error_Adding_Existing_Object_Or_Failure_To_Delete_Old_Object();
string Text_Error_Found_Object_Has_Facility_Mismatch();
string Text_Error_Facility_Out_Of_Range();
string Text_Error_Removing_Non_Existant_Object();
string Text_Error_Facility_Mismatch();
string Text_Press_Enter_To_Continue();
string Text_Application();
string Text_Unsigned();
string Text_Signed();
string Text_Byte();
string Text_Word();
string Text_Longint();
string Text_Binary();
string Text_Octal();
string Text_Decimal();
string Text_Hexadecimal();
string Text_Radix_50();
string Text_Base_n();
string Text_Size_Amp();
string Text_Base_Amp();
string Text_Binary_Amp();
string Text_Octal_Amp();
string Text_Decimal_Amp();
string Text_Hexadecimal_Amp();
string Text_Radix_50_Amp();
string Text_Err_Writing_To_Log_File();
string Text_Volume_ID_Is();
string Text_Error_Invalid_Output_Drive();
string Text_Error_FAT_Is_Too_Big();
string Text_Initialization_Error_Correct_And_Press_Any_Key_To_Continue();
string Text_Initialization_Error();
string Text_Error_Unknown_Command_Or_Invalid_Drive();
string Text_Error_Bad_Address_Mark();
string Text_Error_Sector_Not_Found();
string Text_Error_DMA_Failure();
string Text_Error_Data_Error_CRC();
string Text_Error_Controller_Failure();
string Text_Error_Seek_Failure();
string Text_Error_Drive_Does_Not_Respond();
string Text_Error_Drive_Is_Write_Locked();
string Text_Error_Unknown_Unit();
string Text_Error_Drive_Not_Ready();
string Text_Error_Unknown_Command_In_Absolute_Sector_Write();
string Text_Error_Bad_Request_Structure_Length();
string Text_Error_Seek_Error();
string Text_Error_Unknown_Media_Type();
string Text_Error_Printer_Out_Of_Paper();
string Text_Error_Write_Fault();
string Text_Error_Read_Fault();
string Text_Error_General_Failure();
string Text_Error_Error_13_In_Absolute_Sector_Write();
string Text_Error_Error_14_In_Absolute_Sector_Write();
string Text_Error_Invalid_Disk_Change();
string Text_Place_Saveset_Volume_Into_Drive_And_Press_Return();
string Text_Place_Saveset_Volume_Into_Drive();
string Text_Success();
string Text_Error_No_Dictionary_Open();
string Text_Error_Already_Defined();
string Text_Error_Invalid_Syntax_Type();
string Text_Error_Not_Defined();
string Text_Error_Attach_Failed();
string Text_Error_Detach_Failed();
string Text_True();
string Text_False();
string Text_Error_Invalid_Base();
string Text_Error_Numeric_Error();
string Text_Error_Abstract_Method_Called();
string Text_Other_Ellipse();
string Text_Signed_Amp();
string Text_Byte_Amp();
string Text_Word_Amp();
string Text_Long_Amp();
string Text_Quad_Amp();
string Text_EBCDIC_Amp();
string Text_Goto_Address_Ellipse();
string Text_Find_Ellipse();
string Text_Modify_Ellipse();
string Text_Nothing_Found();
string Text_Month_Jan();
string Text_Month_Feb();
string Text_Month_Mar();
string Text_Month_Apr();
string Text_Month_May();
string Text_Month_Jun();
string Text_Month_Jul();
string Text_Month_Aug();
string Text_Month_Sep();
string Text_Month_Oct();
string Text_Month_Nov();
string Text_Month_Dec();
string Text_Month_January();
string Text_Month_February();
string Text_Month_March();
string Text_Month_April();
string Text_Month_June();
string Text_Month_July();
string Text_Month_August();
string Text_Month_September();
string Text_Month_October();
string Text_Month_November();
string Text_Month_December();
string Text_ASCII_Amp();
string Text_Day_Sunday();
string Text_Day_Monday();
string Text_Day_Tuesday();
string Text_Day_Wednesday();
string Text_Day_Thursday();
string Text_Day_Friday();
string Text_Day_Saturday();
string Text_Application_x();
string Text_Operating_System_x();
string Text_There_Is_No_Debugging_Information_Available();
string Text_Error_Opening_x();
string Text_Search_String_Not_Found();
string Text_Error_Creating();
string Text_Caption_Search();
string Text_Caption_Replace();
string Text_Replace_This_Instance();
string Text_Save_Changes_To();
string Text_Noname();
string Text_Unknown_Error_Code();
string Text_Facility_n_Error_n();
string Text_Error_Severity_Success();
string Text_Error_Severity_Notification();
string Text_Error_Severity_Warning();
string Text_Error_Severity_Error();
string Text_Error_Severity_Fatal();
string Text_DOS_Error_Success();
string Text_DOS_Error_1();
string Text_DOS_Error_2();
string Text_DOS_Error_3();
string Text_DOS_Error_4();
string Text_DOS_Error_5();
string Text_DOS_Error_6();
string Text_DOS_Error_7();
string Text_DOS_Error_8();
string Text_DOS_Error_9();
string Text_DOS_Error_10();
string Text_DOS_Error_11();
string Text_DOS_Error_12();
string Text_DOS_Error_13();
string Text_DOS_Error_14();
string Text_DOS_Error_15();
string Text_DOS_Error_16();
string Text_DOS_Error_17();
string Text_DOS_Error_18();
string Text_DOS_Error_19();
string Text_DOS_Error_20();
string Text_DOS_Error_21();
string Text_DOS_Error_22();
string Text_DOS_Error_23();
string Text_DOS_Error_24();
string Text_DOS_Error_25();
string Text_DOS_Error_26();
string Text_DOS_Error_27();
string Text_DOS_Error_28();
string Text_DOS_Error_29();
string Text_DOS_Error_30();
string Text_DOS_Error_31();
string Text_DOS_Error_32();
string Text_DOS_Error_33();
string Text_DOS_Error_34();
string Text_DOS_Error_35();
string Text_DOS_Error_36();
string Text_DOS_Error_38();
string Text_DOS_Error_50();
string Text_DOS_Error_51();
string Text_DOS_Error_52();
string Text_DOS_Error_53();
string Text_DOS_Error_54();
string Text_DOS_Error_55();
string Text_DOS_Error_56();
string Text_DOS_Error_57();
string Text_DOS_Error_58();
string Text_DOS_Error_59();
string Text_DOS_Error_60();
string Text_DOS_Error_61();
string Text_DOS_Error_62();
string Text_DOS_Error_63();
string Text_DOS_Error_64();
string Text_DOS_Error_65();
string Text_DOS_Error_66();
string Text_DOS_Error_67();
string Text_DOS_Error_68();
string Text_DOS_Error_69();
string Text_DOS_Error_70();
string Text_DOS_Error_71();
string Text_DOS_Error_72();
string Text_DOS_Error_80();
string Text_DOS_Error_81();
string Text_DOS_Error_82();
string Text_DOS_Error_83();
string Text_DOS_Error_84();
string Text_DOS_Error_85();
string Text_DOS_Error_86();
string Text_DOS_Error_87();
string Text_DOS_Error_88();
string Text_DOS_Error_89();
string Text_DOS_Error_90();
string Text_DOS_Error_91();
string Text_DOS_Error_92();
string Text_DOS_Error_93();
string Text_DOS_Error_95();
string Text_DOS_Error_100();
string Text_DOS_Error_101();
string Text_DOS_Error_102();
string Text_DOS_Error_103();
string Text_DOS_Error_104();
string Text_DOS_Error_105();
string Text_DOS_Error_106();
string Text_DOS_Error_107();
string Text_DOS_Error_108();
string Text_DOS_Error_109();
string Text_DOS_Error_110();
string Text_DOS_Error_111();
string Text_DOS_Error_112();
string Text_DOS_Error_113();
string Text_DOS_Error_114();
string Text_DOS_Error_115();
string Text_DOS_Error_116();
string Text_DOS_Error_117();
string Text_DOS_Error_118();
string Text_DOS_Error_119();
string Text_DOS_Error_120();
string Text_DOS_Error_121();
string Text_DOS_Error_122();
string Text_DOS_Error_123();
string Text_DOS_Error_124();
string Text_DOS_Error_125();
string Text_DOS_Error_126();
string Text_DOS_Error_127();
string Text_DOS_Error_128();
string Text_DOS_Error_129();
string Text_DOS_Error_130();
string Text_DOS_Error_131();
string Text_DOS_Error_132();
string Text_DOS_Error_133();
string Text_DOS_Error_134();
string Text_DOS_Error_135();
string Text_DOS_Error_136();
string Text_DOS_Error_137();
string Text_DOS_Error_138();
string Text_DOS_Error_139();
string Text_DOS_Error_140();
string Text_DOS_Error_141();
string Text_DOS_Error_142();
string Text_DOS_Error_143();
string Text_DOS_Error_144();
string Text_DOS_Error_145();
string Text_DOS_Error_146();
string Text_DOS_Error_147();
string Text_DOS_Error_148();
string Text_DOS_Error_149();
string Text_DOS_Error_150();
string Text_DOS_Error_151();
string Text_DOS_Error_152();
string Text_DOS_Error_153();
string Text_DOS_Error_154();
string Text_DOS_Error_155();
string Text_DOS_Error_156();
string Text_DOS_Error_157();
string Text_DOS_Error_158();
string Text_DOS_Error_159();
string Text_DOS_Error_160();
string Text_DOS_Error_161();
string Text_DOS_Error_162();
string Text_DOS_Error_163();
string Text_DOS_Error_164();
string Text_DOS_Error_165();
string Text_DOS_Error_180();
string Text_DOS_Error_181();
string Text_DOS_Error_182();
string Text_DOS_Error_183();
string Text_DOS_Error_184();
string Text_DOS_Error_185();
string Text_DOS_Error_186();
string Text_DOS_Error_187();
string Text_DOS_Error_188();
string Text_DOS_Error_189();
string Text_DOS_Error_190();
string Text_DOS_Error_191();
string Text_DOS_Error_192();
string Text_DOS_Error_193();
string Text_DOS_Error_194();
string Text_DOS_Error_195();
string Text_DOS_Error_196();
string Text_DOS_Error_197();
string Text_DOS_Error_198();
string Text_DOS_Error_199();
string Text_DOS_Error_200();
string Text_DOS_Error_201();
string Text_DOS_Error_202();
string Text_DOS_Error_203();
string Text_DOS_Error_204();
string Text_DOS_Error_205();
string Text_DOS_Error_206();
string Text_DOS_Error_207();
string Text_DOS_Error_208();
string Text_DOS_Error_209();
string Text_DOS_Error_210();
string Text_DOS_Error_211();
string Text_DOS_Error_212();
string Text_DOS_Error_213();
string Text_DOS_Error_214();
string Text_DOS_Error_215();
string Text_DOS_Error_216();
string Text_DOS_Error_600();
string Text_DOS_Error_601();
string Text_DOS_Error_602();
string Text_DOS_Error_603();
string Text_DOS_Error_604();
string Text_DOS_Error_605();
string Text_DOS_Error_606();
string Text_DOS_Error_607();
string Text_DOS_Error_608();
string Text_DOS_Error_609();
string Text_DOS_Error_610();
string Text_DOS_Error_611();
string Text_DOS_Error_612();
string Text_DOS_Error_613();
string Text_DOS_Error_614();
string Text_DOS_Error_615();
string Text_DOS_Error_616();
string Text_DOS_Error_617();
string Text_DOS_Error_618();
string Text_DOS_Error_619();
string Text_DOS_Error_620();
string Text_DOS_Error_621();
string Text_DOS_Error_622();
string Text_DOS_Error_623();
string Text_DOS_Error_624();
string Text_DOS_Error_625();
string Text_DOS_Error_626();
string Text_DOS_Error_627();
string Text_DOS_Error_628();
string Text_DOS_Error_629();
string Text_DOS_Error_630();
string Text_DOS_Error_631();
string Text_DOS_Error_632();
string Text_DOS_Error_633();
string Text_DOS_Error_634();
string Text_DOS_Error_635();
string Text_DOS_Error_636();
string Text_DOS_Error_637();
string Text_DOS_Error_638();
string Text_DOS_Error_639();
string Text_DOS_Error_640();
string Text_DOS_Error_641();
string Text_DOS_Error_642();
string Text_DOS_Error_643();
string Text_DOS_Error_644();
string Text_DOS_Error_645();
string Text_DOS_Error_646();
string Text_DOS_Error_647();
string Text_DOS_Error_648();
string Text_DOS_Error_649();
string Text_DOS_Error_650();
string Text_DOS_Error_651();
string Text_DOS_Error_652();
string Text_DOS_Error_653();
string Text_DOS_Error_654();
string Text_DOS_Error_655();
string Text_DOS_Error_656();
string Text_DOS_Error_657();
string Text_DOS_Error_658();
string Text_DOS_Error_659();
string Text_DOS_Error_660();
string Text_DOS_Error_661();
string Text_DOS_Error_662();
string Text_DOS_Error_663();
string Text_DOS_Error_664();
string Text_DOS_Error_665();
string Text_DOS_Error_666();
string Text_DOS_Error_667();
string Text_DOS_Error_668();
string Text_DOS_Error_669();
string Text_DOS_Error_670();
string Text_DOS_Error_671();
string Text_DOS_Error_672();
string Text_DOS_Error_673();
string Text_DOS_Error_674();
string Text_DOS_Error_675();
string Text_DOS_Error_676();
string Text_DOS_Error_677();
string Text_DOS_Error_678();
string Text_DOS_Error_679();
string Text_DOS_Error_680();
string Text_DOS_Error_681();
string Text_DOS_Error_682();
string Text_DOS_Error_683();
string Text_DOS_Error_684();
string Text_DOS_Error_685();
string Text_DOS_Error_686();
string Text_DOS_Error_687();
string Text_DOS_Error_688();
string Text_DOS_Error_689();
string Text_DOS_Error_690();
string Text_DOS_Error_691();
string Text_DOS_Error_692();
string Text_DOS_Error_693();
string Text_DOS_Error_694();
string Text_DOS_Error_695();
string Text_DOS_Error_696();
string Text_DOS_Error_697();
string Text_DOS_Error_698();
string Text_DOS_Error_699();
string Text_DOS_Error_700();
string Text_DOS_Error_701();
string Text_DOS_Error_702();
string Text_DOS_Error_703();
string Text_DOS_Error_704();
string Text_DOS_Error_705();
string Text_DOS_Error_706();
string Text_DOS_Error_707();
string Text_DOS_Error_708();
string Text_DOS_Error_709();
string Text_DOS_Error_710();
string Text_DOS_Error_711();
string Text_DOS_Error_712();
string Text_DOS_Error_713();
string Text_DOS_Error_714();
string Text_DOS_Error_715();
string Text_DOS_Error_716();
string Text_DOS_Error_717();
string Text_DOS_Error_718();
string Text_DOS_Error_719();
string Text_DOS_Error_720();
string Text_DOS_Error_721();
string Text_DOS_Error_722();
string Text_DOS_Error_723();
string Text_DOS_Error_724();
string Text_DOS_Error_725();
string Text_DOS_Error_726();
string Text_DOS_Error_727();
string Text_DOS_Error_728();
string Text_DOS_Error_729();
string Text_DOS_Error_730();
string Text_DOS_Error_731();
string Text_DOS_Error_732();
string Text_DOS_Error_733();
string Text_DOS_Error_734();
string Text_DOS_Error_735();
string Text_DOS_Error_736();
string Text_DOS_Error_737();
string Text_DOS_Error_738();
string Text_DOS_Error_739();
string Text_DOS_Error_740();
string Text_DOS_Error_741();
string Text_DOS_Error_742();
string Text_DOS_Error_743();
string Text_DOS_Error_744();
string Text_DOS_Error_752();
string Text_Error_Unused_Error_Number();
string Text_Express_Error_Expected_Comma();
string Text_Express_Error_Syntax_Error();
string Text_Express_Error_Illegal_Symbol();
string Text_Express_Error_Expected_Left_Parenthesis();
string Text_Express_Error_Division_By_Zero();
string Text_Express_Error_Illegal_Number_for_factorial();
string Text_Express_Error_Floating_point_error();
string Text_Express_Error_Illegal_Number();
string Text_Express_Error_Illegal_Argument();
string Text_Express_Error_Imaginary_Number();
string Text_Express_Error_Illegal_Argument_in_LOG();
string Text_Express_Error_Argument_Too_large_in_EXP();
string Text_Express_Error_Missing_Right_Parenthesis();
string Text_Error_Invalid_Key_Size();
string Text_Files_Unit_Was_Not_Compiled_Correctly();
string Text_Error_FiP_Is_A_Singleton_Object();
string Text_Prompt_Enter_A_Filename();
string Text_Error_Filesys_Unit_Was_Not_Compiled_Correctly();
string Text_Error_Invalid_Syntax();
string Text_Error_Object_Is_Missing_A_Name();
string Text_Error_Expected_Colon();
string Text_Error_Object_Is_Missing_Type();
string Text_Error_Expected_Equal();
string Text_FSErr_FileNotOpen();
string Text_FSErr_EndOfFile();
string Text_FSErr_FileNotFound();
string Text_FSErr_FileNameLength();
string Text_FSErr_FileName();
string Text_FSErr_DirectoryNotFound();
string Text_FSErr_InvalidPath();
string Text_FSErr_NoRoomOnDevice();
string Text_FSErr_ProtectionViolation();
string Text_FSErr_DirectoryExists();
string Text_FSErr_FileNotEmpty();
string Text_FSErr_DirectoryNotEmpty();
string Text_FSErr_CorruptedFileStructure();
string Text_FSErr_FileExists();
string Text_FSErr_IllegalOperationType();
string Text_FSErr_LineTooLong();
string Text_FSErr_InvalidDevice();
string Text_FSErr_Internal_Duplicate();
string Text_FSErr_Invalid_Open_Mode();
string Text_FSErr_Unsupported_Operation();
string Text_FSErr_Device_In_Use();
string Text_FSErr_Unknown_Device_Type();
string Text_FSErr_Internal_Error_On_Add();
string Text_FSErr_Invalid_Record_Size();
string Text_FSErr_Internal_Corruption();
string Text_FSErr_Timeout();
string Text_FSErr_Invalid_Handle();
string Text_FSErr_Data_Format_Error();
string Text_FSErr_Read_Only();
string Text_FHErr_No_Room_On_Device();
string Text_FHErr_Corrupted_File_Structure();
string Text_FHErr_Invalid_Pointer_Operation();
string Text_FHErr_Deallocation_Error();
string Text_FHErr_Size_Mismatch();
string Text_FHErr_Read_Out_Of_Range();
string Text_FHErr_Read_Size_Error();
string Text_FHErr_Write_Out_Of_Range();
string Text_FHErr_Write_Size_Error();
string Text_FHErr_Bad_Minimum();
string Text_Error_Heap_Deallocation_Error();
string Text_Error_Heap_Access_Error();
string Text_Error_Illegal_Resolution_Size();
string Text_Error_Invalid_Address();
string Text_Prompt_Press_Any_Key_To_Continue();
string Text_Further_Help_Is_Available_On();
string Text_Sorry_No_Help_For_x_Found_At_This_Level();
string Text_Warning_Nesting_Exceeds_40_Levels();
string Text_Prompt_Topic();
string Text_Error_Help_Not_Available();
string Text_Error_HTML_No_Content();
string Text_Error_HTML_Moved_Permanently();
string Text_Error_HTML_Moved_Temporarily();
string Text_Error_HTML_Bad_Request();
string Text_Error_HTML_Unauthorized();
string Text_Error_HTML_Payment_Required();
string Text_Error_HTML_Forbidden();
string Text_Error_HTML_Not_Found();
string Text_Error_HTML_Method_Not_Allowed();
string Text_Error_HTML_Proxy_Authentication_Required();
string Text_Error_HTML_Request_Timeout();
string Text_Error_HTML_Conflict();
string Text_Error_HTML_Gone();
string Text_Error_HTML_Bad_Gateway();
string Text_Error_HTML_Service_Unavailable();
string Text_Error_HTML_Gateway_Timeout();
string Text_LibErr_Invalid_Library_File_Format();
string Text_LibErr_Module_Not_Found();
string Text_LibErr_Module_Already_Exists();
string Text_LibErr_Illegal_Module_Format();
string Text_Error_Imaginary_Number();
string Text_Error_Store_Overwrite();
string Text_Keystroke_Abort();
string Text_Keystroke_Cancel();
string Text_Keystroke_Ignore();
string Text_Keystroke_No();
string Text_Keystroke_OK();
string Text_Keystroke_Retry();
string Text_Keystroke_Yes();
string Text_Prompt_Abort();
string Text_Prompt_Cancel();
string Text_Prompt_Ignore();
string Text_Prompt_No();
string Text_Prompt_OK();
string Text_Prompt_Retry();
string Text_Prompt_Yes();
string Text_Prompt_Attempt_To_Delete_Alarm_For_Software_Configuration_Key();
string Text_Prompt_Attempt_To_Delete_Software_Configuration_Key();
string Text_Prompt_Attempt_To_Change_Alarm_For_Software_Configuration_Key();
string Text_Prompt_Attempt_To_Change_Software_Configuration_Key();
string Text_Prompt_Attempt_To_Read_Software_Configuration_Key();
string Text_Error_SMU_Error();
string Text_Error_Too_Many_Windows();
string Text_Error_Window_Too_Large();
string Text_Warning_Window_Collision();
string Text_Pascal_Err_String_100();
string Text_Pascal_Err_String_101();
string Text_Pascal_Err_String_102();
string Text_Pascal_Err_String_103();
string Text_Pascal_Err_String_104();
string Text_Pascal_Err_String_105();
string Text_Pascal_Err_String_106();
string Text_Pascal_Err_String_162();
string Text_Pascal_Err_String_200();
string Text_Pascal_Err_String_201();
string Text_Pascal_Err_String_202();
string Text_Pascal_Err_String_203();
string Text_Pascal_Err_String_204();
string Text_Pascal_Err_String_205();
string Text_Pascal_Err_String_206();
string Text_Pascal_Err_String_207();
string Text_Pascal_Err_String_208();
string Text_Pascal_Err_String_209();
string Text_Pascal_Err_String_210();
string Text_Pascal_Err_String_211();
string Text_Pascal_Err_String_212();
string Text_Pascal_Err_String_213();
string Text_Pascal_Err_String_214();
string Text_Pascal_Err_String_215();
string Text_Pascal_Err_String_216();
string Text_Pascal_Err_String_217();
string Text_Pascal_Err_String_218();
string Text_Pascal_Err_String_219();
string Text_Pascal_Err_String_220();
string Text_Pascal_Err_String_221();
string Text_Pascal_Err_String_222();
string Text_Pascal_Err_String_223();
string Text_Pascal_Err_String_224();
string Text_Pascal_Err_String_225();
string Text_Pascal_Err_String_226();
string Text_Pascal_Err_String_227();
string Text_Pascal_Err_String_228();
string Text_Pascal_Err_String_229();
string Text_Pascal_Err_String_230();
string Text_Pascal_Err_String_231();
string Text_Pascal_Err_String_232();
string Text_Error_Invalid_List_Index();
string Text_SHErr_No_Room_On_Device();
string Text_SHErr_Corrupted_File_Structure();
string Text_SHErr_Invalid_Pointer_Operation();
string Text_SHErr_Deallocation_Error();
string Text_SHErr_Size_Mismatch();
string Text_SHErr_Read_Out_Of_Range();
string Text_SHErr_Read_Size_Error();
string Text_SHErr_Write_Out_Of_Range();
string Text_SHErr_Write_Size_Error();
string Text_SHErr_Bad_Minimum();
string Text_Template_Illegally_Referenced();
string Text_Object_Cannot_Call_Routine();
string Text_Objects_In_Arrays_Must_Be_Size_4();
string Text_Maximum_Size_Of_Array_Object_Data_Exceeded();
string Text_Error_Subscript_Out_Of_Range_In();
string Text_Error_Static_Array_Is_Invalid();
string Text_Error_Maximum_EMS_Array_Element_Size_IS_16384();
string Text_Error_Expanded_Memory_Device_Not_Responding();
string Text_Error_Expanded_Memory_Device_Not_Present();
string Text_Error_Incompatible_Version_Of_Expanded_Memory_Driver();
string Text_Error_Requested_Array_Size_Is_Zero_Pages();
string Text_Error_Insufficient_Expanded_Memory_Available_For_Array();
string Text_Error_Static_EMS_Array_Is_Invalid();
string Text_Error_Maximum_Stack_Size_Is_Exceeded();
string Text_Stack_Overflow_In();
string Text_Error_Stack_Is_Empty_In();
string Text_Error_Dynamic_Array_Is_Invalid();
string Text_Error_Maximum_Dynamic_Stack_Size_Is_Exceeded();
string Text_Error_While_Opening_Virtual_Array_Image_File();
string Text_Error_Virtual_Array_Is_Invalid();
string Text_Error_Maximum_Virtual_Stack_Size_Is_Exceeded();
string Text_Error_Maximum_Size_Of_List_Object_Data_Is_Exceeded();
string Text_Error_Objects_In_Lists_Must_Be_Size_4();
string Text_Error_End_Of_List_In();
string Text_Error_No_Context_In();
string Text_Error_Begnning_Of_List_In();
string Text_Error_Empty_List_In();
string Text_Error_Queue_Is_Empty_In();
string Text_Error_Maximum_Size_Of_Array_Object_Data_Is_Exceeded();
string Text_Error_Objects_In_Trees_Must_Be_Size_4();
string Text_Error_Maximum_Size_Of_B_Tree_Object_Data_Is_Exceeded();
string Text_Error_Maximum_Size_Of_B_Tree_Bucket_Is_Exceeded();
string Text_Error_Illegal_Record_Context();
string Text_Dynamic_Stack();
string Text_Virtual_Stack();
string Text_List_Stack();
string Text_Sparse_Array();
string Text_Error_Key_Size_Cannot_Exceed_Total_Tree_Object_Data_Size();
string Text_Error_Maximum_Size_Of_Tree_Object_Data_Is_Exceeded();
string Text_Error_Duplicate_Items_Encountered_In_Tree();
string Text_Error_Tree_Error();
string Text_Error_Tree_is_Empty_In();
string Text_Error_End_Of_Tree_In();
string Text_Error_While_Padding_Virtual_Array_Image_File();
string Text_Invalid_Symbol_Name();
string Text_Reserved_Name();
string Text_Multiply_Defined_Symbol();
string Text_Undefined_Reference();
string Text_No_More_Matches();
string Text_Unknown_Symbol_Error();
string Text_Error_TEU_Not_Enough_Memory();
string Text_Error_TEU_Backup_Past_Beginning_Of_Buffer();
string Text_Error_TEU_Advance_Beyond_End_Of_Buffer();
string Text_Error_TEU_Line_Length_Exceeds_255_Characters();
string Text_Error_TEU_Text_Not_Found();
string Text_Error_TEU_Nothing_Selected();
string Text_Error_TEU_Selection_In_Progress();
string Text_Error_Maximum_Memory_Exceeded();
string Text_Error_Opening();
string Text_Warning_Some_Lines_Too_Long();
string Text_More();
string Text_Press_Enter_To_Continue1();
string Text_Searching_For();
string Text_Enter_Keystroke_Whose_Definition_You_Wish_To_Save();
string Text_Store_Aborted();
string Text_Modifications_Will_No_Be_Saved_Continue_Quitting_NO();
string Text_1_Line();
string Text_n_Lines();
string Text_Error_Illegal_Command();
string Text_Missing_Parameter();
string Text_Error_Missing_Operand();
string Text_Error_Invalid_Line_Number();
string Text_Text_To_Search_For();
string Text_Error_Nested_Key_Definitions_Are_Not_Allowed();
string Text_Line();
string Text_Column();
string Text_Error_No_Keystrokes_Are_Being_Recorded();
string Text_Error_No_Keystrokes_Were_Recorded();
string Text_Press_The_Key_To_Which_To_Assign_The_Keystrokes();
string Text_Keystrokes_Remembered();
string Text_Error_Previous_Key_Macro_Recording_Must_Be_Finished();
string Text_Enter_The_Keystrokes_To_Record();
string Text_Command();
string Text_Control_C_Ignored();
string Text_Modified();
string Text_File();
string Text_n_Bytes_Available();
string Text_Line_Column();
string Text_Editing_File_x_Confirm();
string Text_Parameters_Are_Not_Allowed_On();
string Text_Recover_And_Read_Only_Are_Incompatible_Switches();
string Text_Invalid_Switch();
string Text_Error_While_Opening_Journal_File_Cant_Recover();
string Text_Error_Input_File_Does_Not_Exist();
string Text_Sun();
string Text_Mon();
string Text_Tue();
string Text_Wed();
string Text_Thu();
string Text_Fri();
string Text_Sat();
string Text_Address();
string Text_Data();
string Text_Caption_Modify_Memory();
string Text_Literal_Text();
string Text_Caption_Size();
string Text_Byte1();
string Text_Word1();
string Text_Long1();
string Text_Button_Caption_OK();
string Text_Button_Caption_Cancel();
string Text_Button_Caption_Help();
string Text_New();
string Text_Button_Caption_Delete();
string Text_Button_Caption_New_Folder();
string Text_Caption_Internals();
string Text_Persistant_Selection_Blocks();
string Text_Bounded_Caret();
string Text_Inactive_Selection();
string Text_Tab_Processing();
string Text_Sub_Window();
string Text_Auto_Indent();
string Text_Wrap_Caret();
string Text_Menu_Caption_Edit_Amp();
string Text_Menu_Caption_Undo_Amp();
string Text_Menu_Undo_Hint();
string Text_Menu_Caption_Cut_Amp();
string Text_Menu_Cut_Hint();
string Text_Menu_Caption_Copy_Amp();
string Text_Menu_Copy_Hint();
string Text_Menu_Caption_Paste_Amp();
string Text_Menu_Paste_Hint();
string Text_Menu_Caption_Delete_Amp();
string Text_Menu_Delete_Hint();
string Text_Menu_Caption_Include_Amp();
string Text_Menu_Include_Hint();
string Text_Menu_Caption_Search_Amp();
string Text_Menu_Caption_Find_Amp();
string Text_Menu_Find_Hint();
string Text_Menu_Caption_Replace_Amp();
string Text_Menu_Replace_Hint();
string Text_Menu_Caption_Find_Next_Amp();
string Text_Menu_Find_Next_Hint();
string Text_Menu_Caption_Goto_Amp();
string Text_Caption_Include_File();
string Text_Caption_Find_Data();
string Text_Search_For();
string Text_Search_Options();
string Text_Bytes();
string Text_Case_Sensitive();
string Text_Little_Endian();
string Text_Caption_Editor_Preferences();
string Text_Caption_Enter_Numeric_Value();
string Text_Enter_The_Value();
string Text_ASCII();
string Text_EBCDIC();
string Text_Other();
string Text_Caption_Goto_Address();
string Text_Enter_New_Address();
string Text_Button_Caption_Abort();
string Text_Caption_Go_To_Line_Number();
string Text_Enter_New_Line_Number_Amp();
string Text_Caption_Outline_Editor();
string Text_Button_Caption_Rename();
string Text_Button_Caption_Add();
string Text_Button_Caption_Create_Sub();
string Text_Button_Caption_Move();
string Text_Caption_Choose_Radix();
string Text_Choose_The_Radix_For_Numeric_Display();
string Text_Button_Caption_Help_Amp();
string Text_Caption_File_Has_Changed();
string Text_Save_Changes_To1();
string Text_Button_Caption_Yes();
string Text_Button_Caption_No();
string Text_Text_To_Substitute();
string Text_Scope();
string Text_Search_From_Current_Position();
string Text_Search_Entire_File();
string Text_Button_Caption_Replace();
string Text_Prompt_On_Replace();
string Text_Search();
#endif
