unit TypeDefs ;

{
        Unit Name    : TypeDefs
        Package Name : Subroutine Library - Layer 0
        Purpose      : General Pascal types
        Institution  : Conroy & Conroy Co.
        Date Written : 2000
        Written By   : Alan Conroy
        Version      : 1.0C

        Copyright (c) 2000-2007 by Alan Conroy.  Released to the Public Domain.
        
        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

         19-Nov-2002    EAC         Moved int64 and smallint here from Compatib.

         21-Nov-2002    EAC         Added tChar_Array and PChar_Array.

         14-Oct-2007    EAC         Added set_of_*

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          This module defines simple generic Pascal types.
}

interface

{$I EDEFINES.INC}

uses { Pascal... }
{$IFDEF FMX}
     System.Types, { TRectF }
{$ELSE}
  {$IFDEF MSWINDOWS}
     Windows, { TRect }
  {$ELSE}
    {$IFNDEF WINDOWS}
uses DOS,
    {$ENDIF}
  {$ENDIF}
{$ENDIF}
     _Types ;


{ Common types... }
type TComparison = ( LessThan, EqualTo, GreaterThan, LessThanOrEqual, GreaterThanorEqual, NotEqualTo ) ;
     TTri_State = ( TS_False, TS_True, TS_Dont_Care ) ;

const Set_Of_Digits = [ '0', '1', '2', '3', '4', '5', '6', '7', '8', '9' ] ;
      Set_Of_Alpha = [ 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K',
                       'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V',
                       'W', 'X', 'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f', 'g',
                       'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r',
                       's', 't', 'u', 'v', 'w', 'x', 'y', 'z' ] ;
      Set_Of_AlphaNum = [ 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K',
                          'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V',
                          'W', 'X', 'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f', 'g',
                          'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r',
                          's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '0', '1', '2',
                          '3', '4', '5', '6', '7', '8', '9' ] ;
      Set_Of_Quotes = [ '"', #39 ] ;

{$IFDEF MSWINDOWS}
type { Events... }
     TClick_Notify_Event = procedure( Sender : TObject ; Point : TSmallPoint ) of object ;
     TCommand_Event = procedure( Sender : TObject ; Command : integer ) of object ;
     TPaint_Notify_Event = procedure( Sender : TObject ; Beginning : Boolean ) of object ;
     TRequest_Data_Event = procedure( Sender : TObject ; Top : Boolean ) of object ;
  {$IFDEF FMX}
     TNotify_Blink_Event = procedure( Rect : TRectF ) of object ;
  {$ELSE}
     TNotify_Blink_Event = procedure( Rect : TRect ) of object ;
  {$ENDIF}
  {$IFDEF DYNAMIC_ARRAYS}
     TArrayOfInteger = array of integer; { A delphi dynamic array }
  {$ENDIF}
{$ENDIF}

{ Various constants... }
{$IFDEF _16BIT}
const Zero64 : int64 = 0.0 ;
{$ELSE}
const Zero64 : int64 = 0 ;
{$ENDIF}
const Max_Structure_Size = $3FFFFFFF ;
{$IFDEF _64BIT}
const Max_Memory = $3FFFFFFFFFFFFFFF ;
const Max_String_Length = Max_Memory ;

type TRecord_Size = int64 ;
{$ENDIF}
{$IFDEF _32BIT}
const Max_Memory = $3FFFFFFF ;
const Max_String_Length = Max_Memory ;

type TRecord_Size = integer ;
{$ENDIF}
{$IFDEF _16BIT}
const Max_Memory = 65528 ;
const Max_String_Length = 255 ;

type TRecord_Size = word ;
{$ENDIF}

{$IFNDEF FPC}
  {$IFDEF _32BIT}
type PtrInt = longint ;
type PtrUInt = cardinal ;
  {$ENDIF}
  {$IFDEF _64BIT}
type PtrInt = int64 ;
type PtrUInt = int64 ;
  {$ENDIF}
{$ENDIF}

type
{$IFNDEF FPC}
     pByte = ^byte ;
{$ENDIF}
     tByte_Array = array[ 0..Max_Structure_Size div sizeof( byte ) - 1 ] of byte ;
     pByte_Array = ^tByte_Array ;

{$IFNDEF FPC}
     pShortInt = ^ShortInt ;
{$ENDIF}
     tShortInt_Array = array[ 0..Max_Structure_Size div sizeOf( ShortInt ) - 1 ] of ShortInt ;
     pShortInt_Array = ^TShortInt_Array ;

{$IFNDEF FPC}
     pWord = ^Word ;
{$ENDIF}
     tWord_Array = array[ 0..Max_Structure_Size div sizeof( word ) - 1 ] of word ;
     pWord_Array = ^tWord_Array ;

{$IFNDEF FPC}
     pInteger = ^Integer ;
{$ENDIF}
     tInteger_Array = array[ 0..Max_Structure_Size div sizeof( Integer ) - 1 ] of integer ;
     pInteger_Array = ^tInteger_Array ;

{$IFNDEF FPC}
     pLongint = ^Longint ;
{$ENDIF}
     tLongint_Array = array[ 0..Max_Structure_Size div sizeof( longint ) - 1 ] of longint ;
     pLongint_Array = ^tLongint_Array ;

     pReal = ^Real ;
     tReal_Array = array[ 0..Max_Structure_Size div sizeof( Real ) - 1 ] of Real ;
     pReal_Array = ^TReal_Array ;

{$IFNDEF FPC}
     pSingle = ^Single ;
{$ENDIF}
     tSingle_Array = array[ 0..Max_Structure_Size div sizeof( Single ) - 1 ] of Single ;
     pSingle_Array = ^TSingle_Array ;

{$IFNDEF FPC}
     pDouble = ^Double ;
{$ENDIF}
     tDouble_Array = array[ 0..Max_Structure_Size div sizeof( Double ) - 1 ] of Double ;
     pDouble_Array = ^TDouble_Array ;

     tExtended_Array = array[ 0..Max_Structure_Size div sizeof( Extended ) - 1 ] of Extended ;
     pExtended_Array = ^TExtended_Array ;

{$IFNDEF FPC}
     pComp = ^Comp ;
{$ENDIF}
     tComp_Array = array[ 0..Max_Structure_Size div sizeof( Comp ) - 1 ] of Comp ;
     pComp_Array = ^tComp_Array ;

{$IFNDEF FPC}
     pPointer = ^Pointer ;
{$ENDIF}
     tPointer_Array = array[ 0..Max_Structure_Size div sizeof( pointer ) - 1 ] of pointer ;
     pPointer_Array = ^tPointer_Array ;

     tPChar_Array = array[ 0..Max_Structure_Size div sizeof( PChar ) - 1 ] of PChar ;
     pPChar_Array = ^tPChar_Array ;

     tChar_Array = array[ 0..Max_Structure_Size div sizeof( Char ) - 1 ] of Char ;
     pChar_Array = ^tChar_Array ;

     tAnsiChar_Array = array[ 0..Max_Structure_Size div sizeof( AnsiChar ) - 1 ] of AnsiChar ;
     pAnsiChar_Array = ^tAnsiChar_Array ;

     pFile = ^File ;
     tFile_Array = array[ 0..Max_Structure_Size div sizeof( File ) - 1 ] of File ;
     pFile_Array = ^tFile_Array ;

{$IFNDEF FPC}
     pText = ^Text ;
{$ENDIF}
     tText_Array = array[ 0..Max_Structure_Size div sizeof( Text ) - 1 ] of Text ;
     pText_Array = ^tText_Array ;

{$IFDEF _32BIT}
     pString = string ;
{$ELSE}
     pExtended = ^Extended ;
     pString = ^string ;
     Real48 = Real ;
//     AnsiChar = Char ;
     TextFile = Text ;
     pByteArray = pByte_Array ;
     pWordArray = pWord_Array ;
{$ENDIF}
     tString_Array = array[ 0..Max_Structure_Size div sizeof( pString ) - 1 ] of pString ;
     pString_Array = ^tString_Array ;

{ Compatibility types }
{$IFDEF _32BIT}
  {$IFDEF DELPHI2}
     longword = cardinal ;
  {$ENDIF}
  {$IFNDEF FPC}
     pLongword = ^Longword ;
  {$ENDIF}
     tLongword_Array = array[ 0..Max_Structure_Size div sizeof( Longword ) - 1 ] of Longword ;
     pLongword_Array = ^tLongword_Array ;

  {$IFNDEF FPC}
     pCardinal = ^Cardinal ;
  {$ENDIF}
     tCardinal_Array = array[ 0..Max_Structure_Size div sizeof( Cardinal ) - 1 ] of Cardinal ;
     pCardinal_Array = ^tCardinal_Array ;

  {$IFNDEF FPC}
     pInt64 = ^Int64 ;
  {$ENDIF}

     tCurrency_Array = array[ 0..Max_Structure_Size div sizeof( Currency ) - 1 ] of Currency ;
     pCurrency_Array = ^tCurrency_Array ;

     tANSIString_Array = array[ 0..Max_Structure_Size div sizeof( ANSIString ) - 1 ] of ANSIString ;
     pANSIString_Array = ^tANSIString_Array ;

  {$IFNDEF FPC}
     pWideChar = ^WideChar ;
  {$ENDIF}
     tWideChar_Array = array[ 0..Max_Structure_Size div sizeof( WideChar ) - 1 ] of WideChar ;
     pWideChar_Array = ^tWideChar_Array ;

  {$IFDEF WIDESTRINGS}
     tWideString_Array = array[ 0..Max_Structure_Size div sizeof( WideString ) - 1 ] of WideString ;
     pWideString_Array = ^tWideString_Array ;
  {$ENDIF}

     tVariant_Array = array[ 0..Max_Structure_Size div sizeof( Variant ) - 1 ] of Variant ;
     pVariant_Array = ^tVariant_Array ;

  {$IFDEF OLEVARIANT}
     tOLEVariant_Array = array[ 0..Max_Structure_Size div sizeof( OLEVariant ) - 1 ] of OLEVariant ;
     pOLEVariant_Array = ^tOLEVariant_Array ;
  {$ENDIF}
{$ENDIF}
     tInt64_Array = array[ 0..Max_Structure_Size div sizeof( Int64 ) - 1 ] of Int64 ;
     pInt64_Array = ^tInt64_Array ;

     pSmall_String = ^Small_String ;
     tSmall_String_Array = array[ 0..Max_Structure_Size div sizeof( pSmall_String ) - 1 ] of pSmall_String ;
     pSmall_String_Array = ^tSmall_String_Array ;

     pBoolean = ^Boolean ;
     tBoolean_Array = array[ 0..Max_Structure_Size div sizeOf( boolean ) - 1 ] of boolean ;
     pBoolean_Array = ^TBoolean_Array ;

     pByteBool = ^ByteBool ;
     tByteBool_Array = array[ 0..Max_Structure_Size div sizeOf( ByteBool ) - 1 ] of ByteBool ;
     pByteBool_Array = ^TByteBool_Array ;

{$IFNDEF FPC}
     pWordBool = ^WordBool ;
{$ENDIF}
     tWordBool_Array = array[ 0..Max_Structure_Size div sizeOf( WordBool ) - 1 ] of WordBool ;
     pWordBool_Array = ^TWordBool_Array ;

{$IFNDEF FPC}
     pLongBool = ^LongBool ;
{$ENDIF}
     tLongBool_Array = array[ 0..Max_Structure_Size div sizeOf( LongBool ) - 1 ] of LongBool ;
     pLongBool_Array = ^TLongBool_Array ;

{$IFNDEF REAL48}
     Real48 = Real ;
{$ENDIF}
     pReal48 = ^Real48 ;
     tReal48_Array = array[ 0..Max_Structure_Size div sizeof( Real48 ) - 1 ] of Real48 ;
     pReal48_Array = ^tReal48_Array ;


implementation

end.
