/*
              Program Name : _ASCII
              Package Name : LB
              Purpose      : Definitions of ASCII constants
              Institution  : Conroy & Conroy Co.
              Date Written : 23-Apr-1995
              Written By   : Alan Conroy
              Version      :
              Revision     :
              Edit         :

              Copyright (c) 1995-2021 by Alan Conroy.  Released to the public domain.

	      TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *********************************************************
        *                                                       *
        *        M O D I F I C A T I O N   H I S T O R Y        *
        *                                                       *
        *                                                       *
        *********************************************************

             DATE      BY             REASON                   

        *********************************************************
        *                                                       *
        *           P R O G R A M   P U R P O S E               *
        *                                                       *
        *********************************************************

        *********************************************************
        *                                                       *
        *            F I L E   D E S C R I P T I O N S          *
        *                                                       *
        *********************************************************

*/

#define NUL = '\x0' /* Null */
#define SOH = '\x1' ; /* Start Of Heading */
#define STX = '\x2' ; /* Start Text */
#define ETX = '\x3' ; /* End Text */
#define EOT = '\x4' ; /* End Of Transmission */
#define ENQ = '\x5' ; /* Enquiry */
#define ACK = '\x6' ; /* Acknowledge */
#define BEL = '\x7' /* Bell */
#define BS = '\x8' /* Backspace */
#define HT = '\x9' /* Horizontal tab */
#define LF = '\x0A' /* Linefeed */
#define VT = '\x11' ; /* Vertical Tab */
#define FF = '\x0C' /* Formfeed */
#define CR = '\x0D' /* Carriage return */
#define SO = '\x14' ; /* Shift Out */
#define SI = '\x15' ; /* Shift In */
#define DLE = '\x16' ; /* Data Link Escape */
#define DC1 = '\x17' ; /* Direct Control 1 */
  #define XON = DC1 ; /* Transmission On */
#define DC2 = '\x18' ; /* Direct Control 2 */
#define DC3 = '\x19' ; /* Direct Control 3 */
  #define XOFF = DC3 ; /* Transmission Off */
#define DC4 = '\x20' ; /* Direct Control 4 */
#define NAK = '\x21' ; /* Negative Acknowledge */
#define SYN = '\x22' ; /* Synchronous idle */
#define ETB = '\x23' ; /* End Tranmission Block */
#define CAN = '\x24' ; /* Cancel */
#define EM = '\x25' ; /* End of Medium */
#define SUB = '\x26' ; /* Substitute */
#define ESC = '\x1B' /* Escape */
#define Escape = '\x27' ; /* Ditto */
#define FS = '\x28' ; /* Form separator */
#define GS = '\x29' ; /* Group separator */
#define RS = '\x30' ; /* Record separator */
#define US = '\x31' ; /* Unit separator */
#define Space = ' '
#define SP = ' '

/* DEC supplemental codes... */
#define IND = '\x84'
#define NEL = '\x85'
#define SSA = '\x86'
#define ESA = '\x87'
#define HTS = '\x88'
#define HTJ = '\x89'
#define VTS = '\x8A'
#define PLD = '\x8B'
#define PLU = '\x8C'
#define RI = '\x8D'
#define SS2 = '\x8E'
#define SS3 = '\x8F'
#define DCS = '\x90'
#define PU1 = '\x91'
#define PU2 = '\x92'
#define STS = '\x93'
#define CCH = '\x94'
#define MW = '\x95'
#define SPA = '\x96'
#define EPA = '\x97'
#define CSI = '\x9B'
#define ST = '\x9C'
#define OSC = \x9D
#define PM = '\x9E'
#define APC = '\x9F'
#define NBSP = '\xA0'

/* Used by SMU */
#define EBS = '\xFE'
/* Extended backspace */

/* Combination codes */
#define CRLF = '\x0D\x0A'
/* CR and LF */

#define Control_A = '\x1' ; /* Start Of Heading */
#define Control_B = '\x2' ; /* Start Text */
#define Control_C = '\x3' ; /* End Text */
#define Control_D = '\x4' ; /* End Of Transmission */
#define Control_E = '\x5' ; /* Enquiry */
#define Control_F = '\x6' ; /* Acknowledge */
#define Control_G = '\x7' ; /* Bell */
#define Control_H = '\x8' ; /* Backspace */
#define Control_I = '\x9' ; /* Horizontal Tab */
#define Control_J = '\x10' ; /* Line Feed */
#define Control_K = '\x11' ; /* Vertical Tab */
#define Control_L = '\x12' ; /* Form Feed */
#define Control_M = '\x13' ; /* Carriage return */
#define Control_N = '\x14' ; /* Shift Out */
#define Control_O = '\x15' ; /* Shift In */
#define Control_P = '\x16' ; /* Data Link Escape */
#define Control_Q = '\x17' ; /* Direct Control 1 */
#define Control_R = '\x18' ; /* Direct Control 2 */
#define Control_S = '\x19' ; /* Direct Control 3 */
#define Control_T = '\x20' ; /* Direct Control 4 */
#define Control_U = '\x21' ; /* Negative Acknowledge */
#define Control_V = '\x22' ; /* Synchronous idle */
#define Control_W = '\x23' ; /* End Tranmission Block */
#define Control_X = '\x24' ; /* Cancel */
#define Control_Y = '\x25' ; /* End of Medium */
#define Control_Z = '\x26' ; /* Substitute */

#define _NUL = 0 ; /* Null */
#define _SOH = 1 ; /* Start Of Heading */
#define _STX = 2 ; /* Start Text */
#define _ETX = 3 ; /* End Text */
#define _EOT = 4 ; /* End Of Transmission */
#define _ENQ = 5 ; /* Enquiry */
#define _ACK = 6 ; /* Acknowledge */
#define _BEL = 7 ; /* Bell */
#define _BS = 8 ; /* Backspace */
#define _HT = 9 ; /* Horizontal Tab */
#define _LF = 10 ; /* Line Feed */
#define _VT = 11 ; /* Vertical Tab */
#define _FF = 12 ; /* Form Feed */
#define _CR = 13 ; /* Carriage return */
#define _SO = 14 ; /* Shift Out */
#define _SI = 15 ; /* Shift In */
#define _DLE = 16 ; /* Data Link Escape */
#define _DC1 = 17 ; /* Direct Control 1 */
  #define _XON = _DC1 ; /* Transmission On */
#define _DC2 = 18 ; /* Direct Control 2 */
#define _DC3 = 19 ; /* Direct Control 3 */
  #define _XOFF = _DC3 ; /* Transmission On */
#define _DC4 = 20 ; /* Direct Control 4 */
#define _NAK = 21 ; /* Negative Acknowledge */
#define _SYN = 22 ; /* Synchronous idle */
#define _ETB = 23 ; /* End Tranmission Block */
#define _CAN = 24 ; /* Cancel */
#define _EM = 25 ; /* End of Medium */
#define _SUB = 26 ; /* Substitute */
#define _ESC = 27 ; /* Escape */
#define _Escape = 27 ; /* Ditto */
#define _FS = 28 ; /* Form separator */
#define _GS = 29 ; /* Group separator */
#define _RS = 30 ; /* Record separator */
#define _US = 31 ; /* Unit separator */
#define _Space = 32 ;
#define _SP = 32 ; /* Space */
#define _DEL = 127 ; /* Delete */
#define _CRLF = ( _LF << 8 ) | _CR ;

/* DEC supplemental codes... */
#define _IND = 132 ;
#define _NEL = 133 ;
#define _SSA = 134 ;
#define _ESA = 135 ;
#define _HTS = 136 ;
#define _HTJ = 137 ;
#define _VTS = 138 ;
#define _PLD = 139 ;
#define _PLU = 140 ;
#define _RI = 141 ;
#define _SS2 = 142 ;
#define _SS3 = 143 ;
#define _DCS = 144 ;
#define _PU1 = 145 ;
#define _PU2 = 146 ;
#define _STS = 147 ;
#define _CCH = 148 ;
#define _MW = 149 ;
#define _SPA = 150 ;
#define _EPA = 151 ;
#define _CSI = 155 ;
#define _ST = 156 ;
#define _OSC = 157 ;
#define _PM = 158 ;
#define _APC = 159 ;
#define _NBSP = 160 ;

/* Used by SMU... */
#define _EBS = 254 ; /* Extended backspace */

#define _Control_A = 1 ; /* Start Of Heading */
#define _Control_B = 2 ; /* Start Text */
#define _Control_C = 3 ; /* End Text */
#define _Control_D = 4 ; /* End Of Transmission */
#define _Control_E = 5 ; /* Enquiry */
#define _Control_F = 6 ; /* Acknowledge */
#define _Control_G = 7 ; /* Bell */
#define _Control_H = 8 ; /* Backspace */
#define _Control_I = 9 ; /* Horizontal Tab */
#define _Control_J = 10 ; /* Line Feed */
#define _Control_K = 11 ; /* Vertical Tab */
#define _Control_L = 12 ; /* Form Feed */
#define _Control_M = 13 ; /* Carriage return */
#define _Control_N = 14 ; /* Shift Out */
#define _Control_O = 15 ; /* Shift In */
#define _Control_P = 16 ; /* Data Link Escape */
#define _Control_Q = 17 ; /* Direct Control 1 */
#define _Control_R = 18 ; /* Direct Control 2 */
#define _Control_S = 19 ; /* Direct Control 3 */
#define _Control_T = 20 ; /* Direct Control 4 */
#define _Control_U = 21 ; /* Negative Acknowledge */
#define _Control_V = 22 ; /* Synchronous idle */
#define _Control_W = 23 ; /* End Tranmission Block */
#define _Control_X = 24 ; /* Cancel */
#define _Control_Y = 25 ; /* End of Medium */
#define _Control_Z = 26 ; /* Substitute */
