<?php
/*
              Program Name : _ASCII
              Package Name : Subroutine Library - layer 0
              Purpose      : Definitions of ASCII constants
              Institution  : Conroy & Conroy Co.
              Date Written : 23-Apr-1995
              Written By   : Alan Conroy
              Version      : 1.0A

              Copyright (c) 1995-2017 by Alan Conroy.  Released to the public domain.

	      TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *********************************************************
        *                                                       *
        *        M O D I F I C A T I O N   H I S T O R Y        *
        *                                                       *
        *********************************************************

             DATE      BY             REASON

        19-Nov-2015    EAC            Added additional constants.

        *********************************************************
        *                                                       *
        *           P R O G R A M   P U R P O S E               *
        *                                                       *
        *********************************************************

        Support for ASCII values, including character and numeric constants.

        *********************************************************
        *                                                       *
        *            F I L E   D E S C R I P T I O N S          *
        *                                                       *
        *********************************************************

*/

define('NUL','\x00') ; // Null
define('SOH','\cA') ; // Start Of Heading
define('STX','\cB') ; // Start Text
define('ETX','\cC') ; // End Text
define('EOT','\cD') ; // End Of Transmission
define('ENQ','\cE') ; // Enquiry
define('ACK','\cF') ; // Acknowledge
define('BEL','\cG') ; // Bell
define('BS','\cH') ; // Backspace
define('HT','\cI') ; // Horizontal Tab
define('LF','\cJ') ; // Line Feed
define('VT','\cK') ; // Vertical Tab
define('FF','\cL') ; // Form Feed
define('CR','\cM') ; // Carriage return
define('SO','\cN') ; // Shift Out
define('SI','\cO') ; // Shift In
define('DLE','\cP') ; // Data Link Escape
define('DC1','\cQ') ; // Direct Control 1
define('DC2','\cR') ; // Direct Control 2
define('DC3','\cS') ; // Direct Control 3
define('DC4','\cT') ; // Direct Control 4
define('NAK','\cU') ; // Negative Acknowledge
define('SYN','\cV') ; // Synchronous idle
define('ETB','\cW') ; // End Tranmission Block
define('CAN','\cX') ; // Cancel
define('EM','\cY') ; // End of Medium
define('SUB','\cZ') ; // Substitute
define('ESC','\x1B') ; // Escape
define('Escape','x1B') ; // Ditto
define('FS','\x1C') ; // Form separator
define('GS','\x1D') ; // Group separator
define('RS','\x1E') ; // Record separator
define('US','\x1F') ; // Unit separator
define('Space',' ') ;
define('SP',' ') ; // Space
define('DEL','\x7F') ; // Delete

// DEC supplemental codes...
define('IND','\x84') ;
define('NEL','\x85') ;
define('SSA','\x86') ;
define('ESA','\x87') ;
define('HTS','\x88') ;
define('HTJ','\x89') ;
define('VTS','\x8A') ;
define('PLD','\x8B') ;
define('PLU','\x8C') ;
define('RI','\x8D') ;
define('SS2','\x8E') ;
define('SS3','\x8F') ;
define('DCS','\x90') ;
define('PU1','\x91') ;
define('PU2','\x92') ;
define('STS','\x93') ;
define('CCH','\x94') ;
define('MW','\x95') ;
define('SPA','\x96') ;
define('EPA','\x97') ;
define('CSI','\x9B') ;
define('ST','\x9C') ;
define('OSC','\x9D') ;
define('PM','\x9E') ;
define('APC','\x9F') ;
define('NBSP','\xA0') ;

// Used by SMU...
define('EBS','\xFE') ; // Extended backspace

// Combination codes...
define('CRLF','\r\n') ; // CR and LF

define('Control_A','\cA') ; // Start Of Heading
define('Control_B','\cB') ; // Start Text
define('Control_C','\cC') ; // End Text
define('Control_D','\cD') ; // End Of Transmission
define('Control_E','\cE') ; // Enquiry
define('Control_F','\cF') ; // Acknowledge
define('Control_G','\cG') ; // Bell
define('Control_H','\cH') ; // Backspace
define('Control_I','\cI') ; // Horizontal Tab
define('Control_J','\cJ') ; // Line Feed
define('Control_K','\cK') ; // Vertical Tab
define('Control_L','\cL') ; // Form Feed
define('Control_M','\cM') ; // Carriage return
define('Control_N','\cN') ; // Shift Out
define('Control_O','\cO') ; // Shift In
define('Control_P','\cP') ; // Data Link Escape
define('Control_Q','\cQ') ; // Direct Control 1
define('Control_R','\cR') ; // Direct Control 2
define('Control_S','\cS') ; // Direct Control 3
define('Control_T','\cT') ; // Direct Control 4
define('Control_U','\cU') ; // Negative Acknowledge
define('Control_V','\cV') ; // Synchronous idle
define('Control_W','\cW') ; // End Tranmission Block
define('Control_X','\cX') ; // Cancel
define('Control_Y','\cY') ; // End of Medium
define('Control_Z','\cZ') ; // Substitute

define('_NUL',0) ; // Null
define('_SOH',1) ; // Start Of Heading
define('_STX',2) ; // Start Text
define('_ETX',3) ; // End Text
define('_EOT',4) ; // End Of Transmission
define('_ENQ',5) ; // Enquiry
define('_ACK',6) ; // Acknowledge
define('_BEL',7) ; // Bell
define('_BS',8) ; // Backspace
define('_HT',9) ; // Horizontal Tab
define('_LF',10) ; // Line Feed
define('_VT',11) ; // Vertical Tab
define('_FF',12) ; // Form Feed
define('_CR',13) ; // Carriage return
define('_SO',14) ; // Shift Out
define('_SI',15) ; // Shift In
define('_DLE',16) ; // Data Link Escape
define('_DC1',17) ; // Direct Control 1
define('_DC2',18) ; // Direct Control 2
define('_DC3',19) ; // Direct Control 3
define('_DC4',20) ; // Direct Control 4
define('_NAK',21) ; // Negative Acknowledge
define('_SYN',22) ; // Synchronous idle
define('_ETB',23) ; // End Tranmission Block
define('_CAN',24) ; // Cancel
define('_EM',25) ; // End of Medium
define('_SUB',26) ; // Substitute
define('_ESC',27) ; // Escape
define('_Escape',27) ; // Ditto
define('_FS',28) ; // Form separator
define('_GS',29) ; // Group separator
define('_RS',30) ; // Record separator
define('_US',31) ; // Unit separator
define('_Space',32) ;
define('_SP',32) ; // Space
define('_DEL',127) ; // Delete

// DEC supplemental codes...
define('_IND',132) ;
define('_NEL',133) ;
define('_SSA',134) ;
define('_ESA',135) ;
define('_HTS',136) ;
define('_HTJ',137) ;
define('_VTS',138) ;
define('_PLD',139) ;
define('_PLU',140) ;
define('_RI',141) ;
define('_SS2',142) ;
define('_SS3',143) ;
define('_DCS',144) ;
define('_PU1',145) ;
define('_PU2',146) ;
define('_STS',147) ;
define('_CCH',148) ;
define('_MW',149) ;
define('_SPA',150) ;
define('_EPA',151) ;
define('_CSI',155) ;
define('_ST',156) ;
define('_OSC',157) ;
define('_PM',158) ;
define('_APC',159) ;
define('_NBSP',160) ;

// Used by SMU...
define('_EBS',254) ; // Extended backspace

define('_Control_A',1) ; // Start Of Heading
define('_Control_B',2) ; // Start Text
define('_Control_C',3) ; // End Text
define('_Control_D',4) ; // End Of Transmission
define('_Control_E',5) ; // Enquiry
define('_Control_F',6) ; // Acknowledge
define('_Control_G',7) ; // Bell
define('_Control_H',8) ; // Backspace
define('_Control_I',9) ; // Horizontal Tab
define('_Control_J',10) ; // Line Feed
define('_Control_K',11) ; // Vertical Tab
define('_Control_L',12) ; // Form Feed
define('_Control_M',13) ; // Carriage return
define('_Control_N',14) ; // Shift Out
define('_Control_O',15) ; // Shift In
define('_Control_P',16) ; // Data Link Escape
define('_Control_Q',17) ; // Direct Control 1
define('_Control_R',18) ; // Direct Control 2
define('_Control_S',19) ; // Direct Control 3
define('_Control_T',20) ; // Direct Control 4
define('_Control_U',21) ; // Negative Acknowledge
define('_Control_V',22) ; // Synchronous idle
define('_Control_W',23) ; // End Tranmission Block
define('_Control_X',24) ; // Cancel
define('_Control_Y',25) ; // End of Medium
define('_Control_Z',26) ; // Substitute
?>
