#              Program Name : _ASCII
#              Package Name : Subroutine Library - layer 0
#              Purpose      : Definitions of ASCII constants
#              Institution  : Conroy & Conroy Co.
#              Date Written : 23-Apr-1995
#              Written By   : Alan Conroy
#              Version      : 1.0A
#
#              Copyright (c) 1995-2020 by Alan Conroy.  Released to the public domain.
#
#	      TO THE GLORY OF GOD THROUGH JESUS CHRIST
#
#        *********************************************************
#        *                                                       *
#        *        M O D I F I C A T I O N   H I S T O R Y        *
#        *                                                       *
#        *********************************************************
#
#             DATE      BY             REASON
#
#        19-Nov-2015    EAC            Added additional constants.
#
#        *********************************************************
#        *                                                       *
#        *           P R O G R A M   P U R P O S E               *
#        *                                                       *
#        *********************************************************
#
#        Support for ASCII values, including character and numeric constants.
#
#        *********************************************************
#        *                                                       *
#        *            F I L E   D E S C R I P T I O N S          *
#        *                                                       *
#        *********************************************************

NUL = chr( 0 ) # Null
SOH = chr( 1 ) # Start Of Heading
STX = chr( 2 ) # Start Text
ETX = chr( 3 ) # End Text
EOT = chr( 4 ) # End Of Transmission
ENQ = chr( 5 ) # Enquiry
ACK = chr( 6 ) # Acknowledge
BEL = chr( 7 ) # Bell
BS = chr( 8 ) # Backspace
HT = chr( 9 ) # Horizontal Tab
LF = chr( 10 ) # Line Feed
VT = chr( 11 ) # Vertical Tab
FF = chr( 12 ) # Form Feed
CR = chr( 13 ) # Carriage return
SO = chr( 14 ) # Shift Out
SI = chr( 15 ) # Shift In
DLE = chr( 16 ) # Data Link Escape
DC1 = chr( 17 ) # Direct Control 1
XON = DC1 # Transmission On
DC2 = chr( 18 ) # Direct Control 2
DC3 = chr( 19 ) # Direct Control 3
XOFF = DC3 # Transmission Off
DC4 = chr( 20 ) # Direct Control 4
NAK = chr( 21 ) # Negative Acknowledge
SYN = chr( 22 ) # Synchronous idle
ETB = chr( 23 ) # End Tranmission Block
CAN = chr( 24 ) # Cancel
EM = chr( 25 ) # End of Medium
SUB = chr( 26 ) # Substitute
ESC = chr( 27 ) # Escape
Escape = chr( 27 ) # Ditto
FS = chr( 28 ) # Form separator
GS = chr( 29 ) # Group separator
RS = chr( 30 ) # Record separator
US = chr( 31 ) # Unit separator
Space = chr( 32 )
SP = chr( 32 ) # Space
DEL = chr( 127 ) # Delete

# DEC supplemental codes...
IND = chr( 132 )
NEL = chr( 133 )
SSA = chr( 134 )
ESA = chr( 135 )
HTS = chr( 136 )
HTJ = chr( 137 )
VTS = chr( 138 )
PLD = chr( 139 )
PLU = chr( 140 )
RI = chr( 141 )
SS2 = chr( 142 )
SS3 = chr( 143 )
DCS = chr( 144 )
PU1 = chr( 145 )
PU2 = chr( 146 )
STS = chr( 147 )
CCH = chr( 148 )
MW = chr( 149 )
SPA = chr( 150 )
EPA = chr( 151 )
CSI = chr( 155 )
ST = chr( 156 )
OSC = chr( 157 )
PM = chr( 158 )
APC = chr( 159 )
NBSP = chr( 160 )

# Used by SMU...
EBS = chr( 254 ) # Extended backspace

# Combination codes...
CRLF = chr( 13 ) + chr( 10 ) # CR and LF

Control_A = chr( 1 ) # Start Of Heading
Control_B = chr( 2 ) # Start Text
Control_C = chr( 3 ) # End Text
Control_D = chr( 4 ) # End Of Transmission
Control_E = chr( 5 ) # Enquiry
Control_F = chr( 6 ) # Acknowledge
Control_G = chr( 7 ) # Bell
Control_H = chr( 8 ) # Backspace
Control_I = chr( 9 ) # Horizontal Tab
Control_J = chr( 10 ) # Line Feed
Control_K = chr( 11 ) # Vertical Tab
Control_L = chr( 12 ) # Form Feed
Control_M = chr( 13 ) # Carriage return
Control_N = chr( 14 ) # Shift Out
Control_O = chr( 15 ) # Shift In
Control_P = chr( 16 ) # Data Link Escape
Control_Q = chr( 17 ) # Direct Control 1
Control_R = chr( 18 ) # Direct Control 2
Control_S = chr( 19 ) # Direct Control 3
Control_T = chr( 20 ) # Direct Control 4
Control_U = chr( 21 ) # Negative Acknowledge
Control_V = chr( 22 ) # Synchronous idle
Control_W = chr( 23 ) # End Tranmission Block
Control_X = chr( 24 ) # Cancel
Control_Y = chr( 25 ) # End of Medium
Control_Z = chr( 26 ) # Substitute

_NUL = 0 # Null
_SOH = 1 # Start Of Heading
_STX = 2 # Start Text
_ETX = 3 # End Text
_EOT = 4 # End Of Transmission
_ENQ = 5 # Enquiry
_ACK = 6 # Acknowledge
_BEL = 7 # Bell
_BS = 8 # Backspace
_HT = 9 # Horizontal Tab
_LF = 10 # Line Feed
_VT = 11 # Vertical Tab
_FF = 12 # Form Feed
_CR = 13 # Carriage return
_SO = 14 # Shift Out
_SI = 15 # Shift In
_DLE = 16 # Data Link Escape
_DC1 = 17 # Direct Control 1
_XON = _DC1 # Transmission On
_DC2 = 18 # Direct Control 2
_DC3 = 19 # Direct Control 3
_XOFF = _DC3 # Transmission On
_DC4 = 20 # Direct Control 4
_NAK = 21 # Negative Acknowledge
_SYN = 22 # Synchronous idle
_ETB = 23 # End Tranmission Block
_CAN = 24 # Cancel
_EM = 25 # End of Medium
_SUB = 26 # Substitute
_ESC = 27 # Escape
_Escape = 27 # Ditto
_FS = 28 # Form separator
_GS = 29 # Group separator
_RS = 30 # Record separator
_US = 31 # Unit separator
_Space = 32
_SP = 32 # Space
_DEL = 127 # Delete
_CRLF = ( _LF << 8 ) | _CR

# DEC supplemental codes...
_IND = 132
_NEL = 133
_SSA = 134
_ESA = 135
_HTS = 136
_HTJ = 137
_VTS = 138
_PLD = 139
_PLU = 140
_RI = 141
_SS2 = 142
_SS3 = 143
_DCS = 144
_PU1 = 145
_PU2 = 146
_STS = 147
_CCH = 148
_MW = 149
_SPA = 150
_EPA = 151
_CSI = 155
_ST = 156
_OSC = 157
_PM = 158
_APC = 159
_NBSP = 160

# Used by SMU...
_EBS = 254 # Extended backspace

_Control_A = 1 # Start Of Heading
_Control_B = 2 # Start Text
_Control_C = 3 # End Text
_Control_D = 4 # End Of Transmission
_Control_E = 5 # Enquiry
_Control_F = 6 # Acknowledge
_Control_G = 7 # Bell
_Control_H = 8 # Backspace
_Control_I = 9 # Horizontal Tab
_Control_J = 10 # Line Feed
_Control_K = 11 # Vertical Tab
_Control_L = 12 # Form Feed
_Control_M = 13 # Carriage return
_Control_N = 14 # Shift Out
_Control_O = 15 # Shift In
_Control_P = 16 # Data Link Escape
_Control_Q = 17 # Direct Control 1
_Control_R = 18 # Direct Control 2
_Control_S = 19 # Direct Control 3
_Control_T = 20 # Direct Control 4
_Control_U = 21 # Negative Acknowledge
_Control_V = 22 # Synchronous idle
_Control_W = 23 # End Tranmission Block
_Control_X = 24 # Cancel
_Control_Y = 25 # End of Medium
_Control_Z = 26 # Substitute
