{
        Program Name : _Applic
        Package Name : Subroutine Library - Layer 1
        Purpose      : Global application interface definition
        Institution  : Conroy & Conroy Co.
        Date Written : 31-January-2003
        Written By   : Alan Conroy
        Version      : 1.0

	    Copyright (C) 2003-2006 by Alan Conroy.  Released to the Public Domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON                         

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          The classes in this unit are used to provide an OOP application
        interface.
}

unit _Applic ;

interface

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

{$I EDEFINES.INC}

uses { Layer 0... }
     _AEL, { PSApplication_Event_Logger }
     _APM, { PSApplication_Performance_Monitor }
{$IFNDEF MOBILE}
     _DebugIn, { PSDebug_Interface }
{$ENDIF}
     ComInter, { TCommon_COM_Interface }
     _Types, { Ansistring }

     { Layer 1... }
     CommBase, { TBase_Object }
     _DebugMa, { PSDebug_Manager }
     _FacMan, { PSFacility_Manager }
     _ObjectM, { PSObject_Manager }
     _TestMa, { TTest_Manager }
     MStores ; { PSManaged_Store }

type TSIdle_Consumer = object
                           S : Ansistring ; { To prevent compiler blowup }
                       end ;
     PSIdle_Consumer = ^TSIdle_Consumer ;

{$IFDEF DYNAMIC_OBJECTS}
     TIdle_Consumer = class
                          S : Ansistring ; { To prevent compiler blowup }
                      end ;

     TCOM_Idle_Consumer = class( TCommon_COM_Interface )
                              S : Ansistring ; { To prevent compiler blowup }
                          end ;
{$ENDIF}

     TSApplication_Manager = object( TBase_Object )
                                public { API... }
                                    { Status... }
                                    function Get_In_Shut_Down : boolean ;
                                        virtual ;

                                    procedure Set_In_Shut_Down( Value : boolean ) ;
                                        virtual ;

                                    function Get_Halting : boolean ;
                                        virtual ;

                                    procedure Set_Halting( Value : boolean ) ;
                                        virtual ;

                                    { Debugging... }
                                    function Get_Debug_Manager : PSDebug_Manager ;
                                        virtual ;

                                    procedure Set_Debug_Manager( Value : PSDebug_Manager ) ;
                                        virtual ;

                                    function Get_Test_Manager : PSTest_Manager ;
                                        virtual ;

                                    procedure Set_Test_Manager( Value : PSTest_Manager ) ;
                                        virtual ;

{$IFNDEF MOBILE}
                                    function Application_Debugger : PSDebug_Interface ;
                                        virtual ;

                                    function Debugger : PSDebug_Interface ;
                                        virtual ;
{$ENDIF}

                                    function Object_Manager : PSObject_Manager ;
                                        virtual ;

                                    { Idle processing... }
                                    procedure Do_Idle ; virtual ;

                                    procedure Add_Idle_Delegation( Value : PSIdle_Consumer ) ;
                                        virtual ;

                                    procedure Remove_Idle_Delegation( Value : PSIdle_Consumer ) ;
                                        virtual ;

                                    { Event logging... }
                                    function Get_Event_Logger : PSApplication_Event_Logger ;
                                        virtual ;

                                    procedure Set_Event_Logger( EV : PSApplication_Event_Logger ) ;
                                        virtual ;

                                    { Performance... }
                                    function Get_Performance_Monitor : PSApplication_Performance_Monitor ;
                                        virtual ;

                                    procedure Set_Performance_Monitor( PM : PSApplication_Performance_Monitor ) ;
                                        virtual ;

                                    { Other... }
                                    procedure Fatal_Exception( const S : Ansistring ) ;
                                        virtual ;

                                    procedure Popup_Message( S : Ansistring ) ;
                                        virtual ;

                                    function Get_Heap : PSManaged_Store ; virtual ;

                                    procedure Set_Heap( Value : PSManaged_Store ) ;
                                        virtual ;

                                    function Get_Name : Ansistring ; virtual ;

                                    procedure Set_Name( const Value : Ansistring ) ;
                                        virtual ;

                                    function Get_Serial_Number( Pool : longint ) : longint ;
                                        virtual ;

                                    function Get_Clipboard( const Path : Ansistring ) : Ansistring ;
                                        virtual ;

                                    procedure Set_Clipboard( const Path, Value : Ansistring ) ;
                                        virtual ;

                                    { Full version string including "V"... }
                                    function Get_Version : Ansistring ; virtual ;

                                    procedure Set_Version( const Value : Ansistring ) ;
                                        virtual ;

{$IFDEF PROPERTIES}
                                    property Debug_Manager : PSDebug_Manager
                                        read Get_Debug_Manager
                                        write Set_Debug_Manager ;

                                    property Event_Logger : PSApplication_Event_Logger
                                        read Get_Event_Logger
                                        write Set_Event_Logger ;

                                    property Test_Manager : PSTest_Manager
                                        read Get_Test_Manager
                                        write Set_Test_Manager ;

                                    property Performance_Monitor : PSApplication_Performance_Monitor
                                        read Get_Performance_Monitor
                                        write Set_Performance_Monitor ;

                                    property Halting : boolean
                                        read Get_Halting
                                        write Set_Halting ;

                                    property Heap : PSManaged_Store
                                        read Get_Heap
                                        write Set_Heap ;

                                    property In_Shut_Down : boolean
                                        read Get_In_Shut_Down
                                        write Set_In_Shut_Down ;

                                    property Name : Ansistring
                                        read Get_Name
                                        write Set_Name ;

                                    property Version : Ansistring
                                        read Get_Version
                                        write Set_Version ;
{$ENDIF}
                             end ; { TSApplication_Manager }
     PSApplication_Manager = ^TSApplication_Manager ;

{$IFDEF DYNAMIC_OBJECTS}
     TApplication_Manager = class
                                public { API... }
                                    { Status... }
                                    function Get_In_Shut_Down : boolean ;
                                        virtual ; abstract ;

                                    procedure Set_In_Shut_Down( Value : boolean ) ;
                                        virtual ; abstract ;

                                    function Get_Halting : boolean ;
                                        virtual ; abstract ;

                                    procedure Set_Halting( Value : boolean ) ;
                                        virtual ; abstract ;

                                    { Debugging and testing... }
                                    function Get_Debug_Manager : TDebug_Manager ;
                                        virtual ; abstract ;

                                    procedure Set_Debug_Manager( Value : TDebug_Manager ) ;
                                        virtual ; abstract ;

                                    property Debug_Manager : TDebug_Manager
                                        read Get_Debug_Manager
                                        write Set_Debug_Manager ;

                                    function Get_Test_Manager : TTest_Manager ;
                                        virtual ; abstract ;

                                    procedure Set_Test_Manager( Value : TTest_Manager ) ;
                                        virtual ; abstract ;

                                    property TEst_Manager : TTest_Manager
                                        read Get_Test_Manager
                                        write Set_Test_Manager ;

{$IFNDEF MOBILE}
                                    function Application_Debugger : TDebug_Interface ;
                                        virtual ; abstract ;

                                    function Debugger : TDebug_Interface ;
                                        virtual ; abstract ;
{$ENDIF}

                                    function Object_Manager : TObject_Manager ;
                                        virtual ; abstract ;

                                    { Idle processing... }
                                    procedure Do_Idle ; virtual ; abstract ;

                                    procedure Add_Idle_Delegation( Value : TIdle_Consumer ) ;
                                        virtual ; abstract ;

                                    procedure Remove_Idle_Delegation( Value : TIdle_Consumer ) ;
                                        virtual ; abstract ;

                                    { Event logging... }
                                    function Get_Event_Logger : TApplication_Event_Logger ;
                                        virtual ; abstract ;

                                    procedure Set_Event_Logger( EV : TApplication_Event_Logger ) ;
                                        virtual ; abstract ;

                                    property Event_Logger : TApplication_Event_Logger
                                        read Get_Event_Logger
                                        write Set_Event_Logger ;

                                    { Performance... }
                                    function Get_Performance_Monitor : TApplication_Performance_Monitor ;
                                        virtual ; abstract ;

                                    procedure Set_Performance_Monitor( PM : TApplication_Performance_Monitor ) ;
                                        virtual ; abstract ;

                                    property Performance_Monitor : TApplication_Performance_Monitor
                                        read Get_Performance_Monitor
                                        write Set_Performance_Monitor ;

                                    { Other... }
                                    procedure Fatal_Exception( const S : Ansistring ) ;
                                        virtual ; abstract ;

                                    procedure Popup_Message( const S : Ansistring ) ;
                                        virtual ; abstract ;

                                    property Halting : boolean
                                        read Get_Halting
                                        write Set_Halting ;

                                    property In_Shut_Down : boolean
                                        read Get_In_Shut_Down
                                        write Set_In_Shut_Down ;

                                    function Get_Heap : TManaged_Store ;
                                        virtual ; abstract ;

                                    procedure Set_Heap( Value : TManaged_Store ) ;
                                        virtual ; abstract ;

                                    property Heap : TManaged_Store
                                        read Get_Heap
                                        write Set_Heap ;

                                    function Get_Name : Ansistring ;
                                        virtual ; abstract ;

                                    procedure Set_Name( const Value : Ansistring ) ;
                                        virtual ; abstract ;

                                    function Get_Serial_Number( Pool : longint ) : longint ;
                                        virtual ; abstract ;

                                    function Get_Clipboard( const Path : Ansistring ) : Ansistring ;
                                        virtual ; abstract ;

                                    procedure Set_Clipboard( const Path, Value : Ansistring ) ;
                                        virtual ; abstract ;

                                    property Name : Ansistring
                                        read Get_Name
                                        write Set_Name ;

                                    { Full version string including "V" }
                                    function Get_Version : Ansistring ;
                                        virtual ; abstract ;

                                    procedure Set_Version( const Value : Ansistring ) ;
                                        virtual ; abstract ;

                                    property Version : Ansistring
                                        read Get_Version
                                        write Set_Version ;
                            end ;

     TCOM_Application_Manager = class( TCommon_COM_Interface )
                                    public { API... }
                                        { Status... }
                                        function Get_In_Shut_Down : boolean ;
                                            virtual ; stdcall ; abstract ;

                                        procedure Set_In_Shut_Down( Value : boolean ) ;
                                            virtual ; stdcall ; abstract ;

                                        function Get_Halting : boolean ;
                                            virtual ; stdcall ; abstract ;

                                        procedure Set_Halting( Value : boolean ) ;
                                            virtual ; stdcall ; abstract ;

                                        { Debugging... }
                                        function Get_Debug_Manager : TCOM_Debug_Manager ;
                                            virtual ; stdcall ; abstract ;

                                        procedure Set_Debug_Manager( Value : TCOM_Debug_Manager ) ;
                                            virtual ; stdcall ; abstract ;

                                        property Debug_Manager : TCOM_Debug_Manager
                                            read Get_Debug_Manager
                                            write Set_Debug_Manager ;

                                        function Get_Test_Manager : TCOM_Test_Manager ;
                                            virtual ; stdcall ; abstract ;

                                        procedure Set_Test_Manager( Value : TCOM_Test_Manager ) ;
                                            virtual ; stdcall ; abstract ;

                                        property Test_Manager : TCOM_Test_Manager
                                            read Get_Test_Manager
                                            write Set_Test_Manager ;

{$IFNDEF MOBILE}
                                        function Application_Debugger : PSDebug_Interface ;
                                            virtual ; stdcall ; abstract ;
{$ENDIF}

                                        function Object_Manager : TCOM_Object_Manager ;
                                            virtual ; stdcall ; abstract ;

                                        { Idle processing... }
                                        procedure Do_Idle ;
                                            virtual ; stdcall ; abstract ;

                                        procedure Add_Idle_Delegation( Value : TIdle_Consumer ) ;
                                            virtual ; stdcall ; abstract ;

                                        procedure Remove_Idle_Delegation( Value : TIdle_Consumer ) ;
                                            virtual ; stdcall ; abstract ;

                                        { Event logging... }
                                        function Get_Event_Logger : TCOM_Application_Event_Logger ;
                                            virtual ; stdcall ; abstract ;

                                        procedure Set_Event_Logger( EV : TCOM_Application_Event_Logger ) ;
                                            virtual ; stdcall ; abstract ;

                                        property Event_Logger : TCOM_Application_Event_Logger
                                            read Get_Event_Logger
                                            write Set_Event_Logger ;

                                        { Performance... }
                                        function Get_Performance_Monitor : TCOM_Application_Performance_Monitor ;
                                            virtual ; stdcall ; abstract ;

                                        procedure Set_Performance_Monitor( EV : TCOM_Application_Performance_Monitor ) ;
                                            virtual ; stdcall ; abstract ;

                                        property Performance_Monitor : TCOM_Application_Performance_Monitor
                                            read Get_Performance_Monitor
                                            write Set_Performance_Monitor ;

                                        { Other... }
                                        procedure Fatal_Exception( S : PAnsiChar ) ;
                                            virtual ; stdcall ; abstract ;

                                        procedure Popup_Message( S : PAnsiChar ) ;
                                            virtual ; stdcall ; abstract ;

                                        property Halting : boolean
                                            read Get_Halting
                                            write Set_Halting ;

                                        property In_Shut_Down : boolean
                                            read Get_In_Shut_Down
                                            write Set_In_Shut_Down ;

                                        function Get_Heap : TCOM_Managed_Store ;
                                            virtual ; stdcall ; abstract ;

                                        procedure Set_Heap( Value : TCOM_Managed_Store ) ;
                                            virtual ; stdcall ; abstract ;

                                        property Heap : TCOM_Managed_Store
                                            read Get_Heap
                                            write Set_Heap ;

                                        function Get_Name : PAnsiChar ;
                                            virtual ; stdcall ; abstract ;

                                        procedure Set_Name( Value : PAnsiChar ) ;
                                            virtual ; stdcall ; abstract ;

                                        function Get_Serial_Number( Pool : longint ) : longint ;
                                            virtual ; stdcall ; abstract ;

                                        function Get_Clipboard( Path : PAnsiChar ;
                                            var Len : longint ) : PAnsiChar ;
                                            virtual ; stdcall ; abstract ;

                                        procedure Set_Clipboard( Path, Value : PAnsiChar ;
                                            var Len : longint ) ;
                                            virtual ; stdcall ; abstract ;

                                        property Name : PAnsiChar
                                            read Get_Name
                                            write Set_Name ;

                                        { Full version string including "V" }
                                        function Get_Version : PAnsiChar ;
                                            virtual ; stdcall ; abstract ;

                                        procedure Set_Version( Value : PAnsiChar ) ;
                                            virtual ; stdcall ; abstract ;

                                        property Version : PAnsiChar
                                            read Get_Version
                                            write Set_Version ;
                                end ; { TCOM_Application_Manager }
{$ENDIF}

{$IFDEF DYNAMIC_OBJECTS}
var Delphi_Application_Manager : TApplication_Manager = nil ;

function Static_COM_Application_Manager_Wrapper( AM : PSApplication_Manager ) : TCOM_Application_Manager ;
function COM_Static_Object_Manager( Value : PSObject_Manager ) : TCOM_Object_Manager ;
{$ENDIF}

var Application_Manager : PSApplication_Manager
{$IFDEF VARIABLE_DECLARATION_ASSIGN}
    = nil
{$ENDIF}
    ;

{$IFDEF CC_Regression_Test}
procedure Test_Unit ;
{$ENDIF}

function Get_Serial_Number : longint ;


implementation

uses { Layer 0... }
     _Common, { Abstract_Error }
     _Streams { TStream }

     { Layer 1... }
{$IFNDEF MOBILE}
     ,DebugInt { Delphi_Debug_Wrapper }
{$ENDIF}
     ;

{ Unit API... }

function Get_Serial_Number : longint ;

begin
    if( Application_Manager <> nil ) then
    begin
        Get_Serial_Number := Application_Manager^.Get_Serial_Number( 0 ) ;
    end else
    begin
        Get_Serial_Number := 0 ;
    end ;
end ;



{ TSApplication_Manager methods... }

{ API... }

function TSApplication_Manager.Get_In_Shut_Down : boolean ;

begin
    Get_In_Shut_Down := False ;
    Abstract_Error ;
end ;


procedure TSApplication_Manager.Set_In_Shut_Down( Value : boolean ) ;

begin
    Abstract_Error ;
end ;


function TSApplication_Manager.Get_Halting : boolean ;

begin
    Get_Halting := False ;
    Abstract_Error ;
end ;


procedure TSApplication_Manager.Set_Halting( Value : boolean ) ;

begin
    Abstract_Error ;
end ;


function TSApplication_Manager.Get_Debug_Manager : PSDebug_Manager ;

begin
    Get_Debug_Manager := nil ;
    Abstract_Error ;
end ;


procedure TSApplication_Manager.Set_Debug_Manager( Value : PSDebug_Manager ) ;

begin
    Abstract_Error ;
end ;


function TSApplication_Manager.Get_Test_Manager : PSTest_Manager ;

begin
    Get_Test_Manager := nil ;
    Abstract_Error ;
end ;


procedure TSApplication_Manager.Set_Test_Manager( Value : PSTest_Manager ) ;

begin
    Abstract_Error ;
end ;


{$IFNDEF MOBILE}
function TSApplication_Manager.Application_Debugger : PSDebug_Interface ;

begin
    Application_Debugger := nil ;
    Abstract_Error ;
end ;


function TSApplication_Manager.Debugger : PSDebug_Interface ;

begin
    Debugger := nil ;
    Abstract_Error ;
end ;
{$ENDIF}


function TSApplication_Manager.Object_Manager : PSObject_Manager ;

begin
    Object_Manager := nil ;
    Abstract_Error ;
end ;


procedure TSApplication_Manager.Do_Idle ;

begin
    Abstract_Error ;
end ;


procedure TSApplication_Manager.Add_Idle_Delegation( Value : PSIdle_Consumer ) ;

begin
    Abstract_Error ;
end ;


procedure TSApplication_Manager.Remove_Idle_Delegation( Value : PSIdle_Consumer ) ;

begin
    Abstract_Error ;
end ;


function TSApplication_Manager.Get_Clipboard( const Path : Ansistring ) : Ansistring ;

begin
    Get_Clipboard := '' ;
    Abstract_Error ;
end ;


function TSApplication_Manager.Get_Event_Logger : PSApplication_Event_Logger ;

begin
    Get_Event_Logger := nil ;
    Abstract_Error ;
end ;


procedure TSApplication_Manager.Set_Event_Logger( EV : PSApplication_Event_Logger ) ;

begin
    Abstract_Error ;
end ;


{ Performance... }

function TSApplication_Manager.Get_Performance_Monitor : PSApplication_Performance_Monitor ;

begin
    Get_Performance_Monitor := nil ;
    Abstract_Error ;
end ;


procedure TSApplication_Manager.Set_Performance_Monitor( PM : PSApplication_Performance_Monitor ) ;

begin
    Abstract_Error ;
end ;


{ Other... }

procedure TSApplication_Manager.Fatal_Exception( const S : Ansistring ) ;

begin
    Abstract_Error ;
end ;


procedure TSApplication_Manager.Popup_Message( S : Ansistring ) ;

begin
    Abstract_Error ;
end ;


function TSApplication_Manager.Get_Heap : PSManaged_Store ;

begin
    Get_Heap := nil ;
    Abstract_Error ;
end ;


procedure TSApplication_Manager.Set_Heap( Value : PSManaged_Store ) ;

begin
    Abstract_Error ;
end ;


function TSApplication_Manager.Get_Name : Ansistring ;

begin
    Get_Name := '' ;
    Abstract_Error ;
end ;


procedure TSApplication_Manager.Set_Name( const Value : Ansistring ) ;

begin
    Abstract_Error ;
end ;


function TSApplication_Manager.Get_Serial_Number( Pool : longint ) : longint ;

begin
    Get_Serial_Number := 0 ;
    Abstract_Error ;
end ;


procedure TSApplication_Manager.Set_Clipboard( const Path, Value : Ansistring ) ;

begin
    Abstract_Error ;
end ;


function TSApplication_Manager.Get_Version : Ansistring ;

begin
    Get_Version := '' ;
    Abstract_Error ;
end ;


procedure TSApplication_Manager.Set_Version( const Value : Ansistring ) ;

begin
    Abstract_Error ;
end ;


{$IFDEF DYNAMIC_OBJECTS}
type TStatic_COM_Application_Manager_Wrapper = class( TCOM_Application_Manager )
                                                  private
                                                      AM : PSApplication_Manager ;

                                                  private { Cached data... }
                                                      OM : TCOM_Object_Manager ;
                                                      Temp_Get_Name : Ansistring ;
                                                      Temp_Get_Version : Ansistring ;
                                                      Temp_Get_Clipboard : Ansistring ;

                                                  public
                                                    function Is_Class( Name : PAnsiChar ) : boolean ;
                                                        override ;

{$IFNDEF MOBILE}
                                                    function Debugger : TDebug_Interface ;
                                                        override ;
{$ENDIF}

                                                    function Get_In_Shut_Down : boolean ;
                                                        override ;

                                                    procedure Set_In_Shut_Down( Value : boolean ) ;
                                                        override ;

                                                    function Get_Halting : boolean ;
                                                        override ;

                                                    procedure Set_Halting( Value : boolean ) ;
                                                        override ;

                                                    { Debugging and testing... }
                                                    function Get_Debug_Manager : TCOM_Debug_Manager ;
                                                        override ;

                                                    procedure Set_Debug_Manager( Value : TCOM_Debug_Manager ) ;
                                                        override ;

                                                    function Get_Test_Manager : TCOM_Test_Manager ;
                                                        override ;

                                                    procedure Set_Test_Manager( Value : TCOM_Test_Manager ) ;
                                                        override ;

{$IFNDEF MOBILE}
                                                    function Application_Debugger : PSDebug_Interface ;
                                                        override ;
{$ENDIF}

                                                    function Object_Manager : TCOM_Object_Manager ;
                                                        override ;

                                                    { Idle processing... }
                                                    procedure Do_Idle ;
                                                        override ;

                                                    procedure Add_Idle_Delegation( Value : TIdle_Consumer ) ;
                                                        override ;

                                                    procedure Remove_Idle_Delegation( Value : TIdle_Consumer ) ;
                                                        override ;

                                                    { Event logging... }
                                                    function Get_Event_Logger : TCOM_Application_Event_Logger ;
                                                        override ;

                                                    procedure Set_Event_Logger( EV : TCOM_Application_Event_Logger ) ;
                                                        override ;

                                                    { Performance... }
                                                    function Get_Performance_Monitor : TCOM_Application_Performance_Monitor ;
                                                        override ;

                                                    procedure Set_Performance_Monitor( PM : 
                                                        TCOM_Application_Performance_Monitor ) ;
                                                        override ;

                                                    { Other... }
                                                    procedure Fatal_Exception( S : PAnsiChar ) ;
                                                        override ;

                                                    procedure Popup_Message( S : PAnsiChar ) ;
                                                        override ;

                                                    function Get_Heap : TCOM_Managed_Store ;
                                                        override ;

                                                    procedure Set_Heap( Value : TCOM_Managed_Store ) ;
                                                        override ;

                                                    function Get_Name : PAnsiChar ;
                                                        override ;

                                                    procedure Set_Name( Value : PAnsiChar ) ;
                                                        override ;

                                                    function Get_Serial_Number( Pool : longint ) : longint ;
                                                        override ;

                                                    function Get_Clipboard( Path : PAnsiChar ;
                                                        var Len : longint ) : PAnsiChar ;
                                                        override ;

                                                    procedure Set_Clipboard( Path, Value : PAnsiChar ;
                                                        var Len : longint ) ;
                                                        override ;

                                                    { Full version string including "V" }
                                                    function Get_Version : PAnsiChar ;
                                                        override ;

                                                    procedure Set_Version( Value : PAnsiChar ) ;
                                                        override ;
                                              end ; { TStatic_COM_Application_Manager_Wrapper }

function TStatic_COM_Application_Manager_Wrapper.Is_Class( Name : PAnsiChar ) : boolean ; stdcall ;

begin
    Is_Class := AM^.Is_Class( Name ) ;
end ;


{$IFNDEF MOBILE}
function TStatic_COM_Application_Manager_Wrapper.Debugger : TDebug_Interface ; stdcall ;

begin
    Debugger := Delphi_Debug_Wrapper( AM^.Debugger ) ;
end ;
{$ENDIF}


function TStatic_COM_Application_Manager_Wrapper.Get_In_Shut_Down : boolean ; stdcall ;

begin
    Result := AM^.In_Shut_Down ;
end ;


procedure TStatic_COM_Application_Manager_Wrapper.Set_In_Shut_Down( Value : boolean ) ; stdcall ;

begin
    AM^.In_Shut_Down := Value ;
end ;


function TStatic_COM_Application_Manager_Wrapper.Get_Halting : boolean ; stdcall ;

begin
    Result := AM^.Halting ;
end ;


procedure TStatic_COM_Application_Manager_Wrapper.Set_Halting( Value : boolean ) ; stdcall ;

begin
    AM^.Halting := Value ;
end ;


function TStatic_COM_Application_Manager_Wrapper.Get_Debug_Manager : TCOM_Debug_Manager ; stdcall ;

begin
    Result := nil ;
end ;


procedure TStatic_COM_Application_Manager_Wrapper.Set_Debug_Manager( Value : TCOM_Debug_Manager ) ; stdcall ;

begin
    {TODO: Not yet implemented}
end ;


function TStatic_COM_Application_Manager_Wrapper.Get_Test_Manager : TCOM_Test_Manager ; stdcall ;

begin
    Result := nil ;
end ;


procedure TStatic_COM_Application_Manager_Wrapper.Set_Test_Manager( Value : TCOM_Test_Manager ) ; stdcall ;

begin
    {TODO: Not yet implemented}
end ;


{$IFNDEF MOBILE}
function TStatic_COM_Application_Manager_Wrapper.Application_Debugger : PSDebug_Interface ; stdcall ;

begin
    Result := nil ;
end ;
{$ENDIF}


function TStatic_COM_Application_Manager_Wrapper.Object_Manager : TCOM_Object_Manager ; stdcall ;

begin
    if( OM = nil ) then
    begin
        OM := COM_Static_Object_Manager( AM^.Object_Manager ) ;
    end ;
    Result := OM ;
end ;


procedure TStatic_COM_Application_Manager_Wrapper.Do_Idle ; stdcall ;

begin
    AM^.Do_Idle ;
end ;


procedure TStatic_COM_Application_Manager_Wrapper.Add_Idle_Delegation( Value : TIdle_Consumer ) ; stdcall ;

begin
end ;


procedure TStatic_COM_Application_Manager_Wrapper.Remove_Idle_Delegation( Value : TIdle_Consumer ) ; stdcall ;

begin
end ;


function TStatic_COM_Application_Manager_Wrapper.Get_Event_Logger : TCOM_Application_Event_Logger ; stdcall ;

begin
    Result := nil ;
end ;


procedure TStatic_COM_Application_Manager_Wrapper.Set_Event_Logger( EV : TCOM_Application_Event_Logger ) ; stdcall ;

begin
end ;


{ Performance... }

function TStatic_COM_Application_Manager_Wrapper.Get_Performance_Monitor : TCOM_Application_Performance_Monitor ; stdcall ;

begin
    Get_Performance_Monitor := nil ;
end ;


procedure TStatic_COM_Application_Manager_Wrapper.Set_Performance_Monitor( PM : TCOM_Application_Performance_Monitor ) ; stdcall ;

begin
end ;


procedure TStatic_COM_Application_Manager_Wrapper.Fatal_Exception( S : PAnsiChar ) ; stdcall ;

begin
    AM^.Fatal_Exception( Ansistring( S ) ) ;
end ;


procedure TStatic_COM_Application_Manager_Wrapper.Popup_Message( S : PAnsiChar ) ; stdcall ;

begin
    AM^.Popup_Message( Ansistring( S ) ) ;
end ;


function TStatic_COM_Application_Manager_Wrapper.Get_Heap : TCOM_Managed_Store ; stdcall ;

begin
    Result := nil ;
end ;


procedure TStatic_COM_Application_Manager_Wrapper.Set_Heap( Value : TCOM_Managed_Store ) ; stdcall ;

begin
end ;


function TStatic_COM_Application_Manager_Wrapper.Get_Name : PAnsiChar ; stdcall ;

begin
    Temp_Get_Name := AM^.Get_Name ;
    Result := PAnsiChar( Temp_Get_Name ) ;
end ;


procedure TStatic_COM_Application_Manager_Wrapper.Set_Name( Value : PAnsiChar ) ;

begin
    AM^.Set_Name( Ansistring( Value ) ) ;
end ;


function TStatic_COM_Application_Manager_Wrapper.Get_Serial_Number( Pool : longint ) : longint ;

begin
    Result := AM^.Get_Serial_Number( Pool ) ;
end ;


function TStatic_COM_Application_Manager_Wrapper.Get_Clipboard( Path : PAnsiChar ;
    var Len : longint ) : PAnsiChar ;

var Temp : longint ;

begin
    Temp_Get_Clipboard := AM^.Get_Clipboard( Ansistring( Path ) ) ;
    Temp := length( Temp_Get_Clipboard ) ;
    if( Len = 0 ) then
    begin
        Len := Temp ;
        Result := nil ;
        exit ;
    end ;
    if( Len > Temp ) then
    begin
        Len := Temp ;
    end ;
    if( Len < Temp ) then
    begin
{$IFDEF _32BIT}
        SetLength( Temp_Get_Clipboard, Len ) ;
{$ELSE}
  {$IFDEF _64BIT}
        SetLength( Temp_Get_Clipboard, Len ) ;
  {$ELSE}
        if( Len > 255 ) then
        begin
            Len := 255 ;
        end ;
        Temp_Get_Clipboard[ 0 ] := chr( Len ) ;
  {$ENDIF}
{$ENDIF}
    end ;
    Result := PAnsiChar( Temp_Get_Clipboard ) ;
end ;


procedure TStatic_COM_Application_Manager_Wrapper.Set_Clipboard( Path, Value : PAnsiChar ;
    var Len : longint ) ;

var Temp : Ansistring ;

begin
    setlength( Temp, Len ) ;
    move( Value[ 0 ], Temp[ 1 ], Len ) ;
    AM^.Set_Clipboard( Ansistring( Path ), Temp ) ;
end ;


function TStatic_COM_Application_Manager_Wrapper.Get_Version : PAnsiChar ;

begin
    Temp_Get_Version := AM^.Get_Version ;
    Result := PAnsiChar( Temp_Get_Version ) ;
end ;


procedure TStatic_COM_Application_Manager_Wrapper.Set_Version( Value : PAnsiChar ) ;

begin
    AM^.Set_Version( Ansistring( Value ) ) ;
end ;


function Static_COM_Application_Manager_Wrapper( AM : PSApplication_Manager ) : TCOM_Application_Manager ;

begin
    Result := TStatic_COM_Application_Manager_Wrapper.Create ;
    TStatic_COM_Application_Manager_Wrapper( Result ).AM := AM ;
end ;


type TCOM_Static_Object_Manager = class( TCOM_Object_Manager )
                                      private
                                          OM : PSObject_Manager ;

                                      public
                                          function Is_Class( Name : PAnsiChar ) : boolean ;
                                              override ;

{$IFNDEF MOBILE}
                                          function Debugger : TDebug_Interface ;
                                              override ;
{$ENDIF}

                                          procedure Add_Object( O : pointer ;
                                              Facility : integer ;
                                              Context : pointer ) ;
                                              override ;

                                          { Return True if specified object is registered }
                                          function Find_Object( O : pointer ;
                                              Facility : integer ) : boolean ;
                                              override ;

                                          function Get_Context( Index : integer ) : pointer ;
                                              override ;

                                          { Get facility associated with index }
                                          function Get_Facility( Index : integer ) : integer ;
                                              override ;

                                          { Get object associated with index }
                                          function Get_Object( Index : integer ) : pointer ;
                                              override ;

                                          { Remove a registered object }
                                          procedure Remove_Object( O : pointer ;
                                              Facility : longint ) ;
                                              override ;

                                          { Returns count of registered obejcts }
                                          function Object_Count : longint ;
                                              override ;

                                           { Construct an instance of a facility }
                                           function Construct( Stream : TCOM_Stream ) : pointer ;
                                              override ;

                                           procedure Register_Facility( Facility_Manager : TCOM_Facility_Manager ) ;
                                               override ;

                                           { Remove a registered facility }
                                           procedure Remove_Facility( Facility_Manager : TCOM_Facility_Manager ) ;
                                               override ;

                                           { Get facility manager at an index }
                                           function Get_Facility_Manager( Index : longint ) : TCOM_Facility_Manager ;
                                               override ;
                                  end ;

function TCOM_Static_Object_Manager.Is_Class( Name : PAnsiChar ) : boolean ;

begin
    Is_Class := OM.Is_Class( Name ) ;
end ;


{$IFNDEF MOBILE}
function TCOM_Static_Object_Manager.Debugger : TDebug_Interface ;

begin
    Debugger := Delphi_Debug_Wrapper( OM.Debugger ) ;
end ;
{$ENDIF}


procedure TCOM_Static_Object_Manager.Add_Object( O : pointer ;
    Facility : integer ; Context : pointer ) ;

begin
    OM.Add_Object( O, Facility, Context ) ;
end ;


function TCOM_Static_Object_Manager.Find_Object( O : pointer ;
    Facility : integer ) : boolean ;

begin
    Result := OM.Find_Object( O, Facility ) ;
end ;


function TCOM_Static_Object_Manager.Get_Context( Index : integer ) : pointer ;

begin
    Result := OM.Get_Context( Index ) ;
end ;


function TCOM_Static_Object_Manager.Get_Facility( Index : integer ) : integer ;

begin
    Result := OM.Get_Facility( Index ) ;
end ;


function TCOM_Static_Object_Manager.Get_Object( Index : integer ) : pointer ;

begin
    Result := OM.Get_Object( Index ) ;
end ;


procedure TCOM_Static_Object_Manager.Remove_Object( O : pointer ;
    Facility : longint ) ;

begin
    OM.Remove_Object( O, Facility ) ;
end ;


function TCOM_Static_Object_Manager.Object_Count : longint ;

begin
    Result := OM.Object_Count ;
end ;


function TCOM_Static_Object_Manager.Construct( Stream : TCOM_Stream ) : pointer ;

begin
    Result := nil ;
end ;


procedure TCOM_Static_Object_Manager.Register_Facility( Facility_Manager : TCOM_Facility_Manager ) ;

begin
end ;


procedure TCOM_Static_Object_Manager.Remove_Facility( Facility_Manager : TCOM_Facility_Manager ) ;

begin
end ;


function TCOM_Static_Object_Manager.Get_Facility_Manager( Index : longint ) : TCOM_Facility_Manager ;

begin
    Result := nil ;
end ;


function COM_Static_Object_Manager( Value : PSObject_Manager ) : TCOM_Object_Manager ;

begin
    Result := TCOM_Static_Object_Manager.Create ;
    TCOM_Static_Object_Manager( Result ).OM := Value ;
end ;
{$ENDIF}



{$IFDEF CC_Regression_Test}
type Test_Object_Manager = object( TSObject_Manager )
                               public
                                   Last_Routine : Ansistring ;

                                   procedure Add_Object( O : pointer ;
                                       Facility : integer ;
                                       Context : pointer ) ; virtual ;

                                   { Return a debugger }
                                   function Debugger : PSDebug_Interface ;
                                       virtual ;

                                   { Return True if specified object is registered }
                                   function Find_Object( O : pointer ;
                                       Facility : integer ) : boolean ;
                                       virtual ;

                                   function Get_Context( Index : integer ) : pointer ;
                                       virtual ;

                                   { Get facility associated with index }
                                   function Get_Facility( Index : integer ) : integer ;
                                       virtual ;

                                   { Get object associated with index }
                                   function Get_Object( Index : integer ) : pointer ;
                                       virtual ;

                                   { Remove a registered object }
                                   procedure Remove_Object( O : pointer ;
                                       Facility : longint ) ; virtual ;

                                   { Returns count of registered obejcts }
                                   function Object_Count : longint ;
                                       virtual ;

                                   { Register a facility }
                                   procedure Register_Facility( Facility_Manager : PSFacility_Manager ) ;
                                       virtual ;

                                   { Remove a registered facility }
                                   procedure Remove_Facility( Facility_Manager : PSFacility_Manager ) ;
                                       virtual ;

                                   { Get facility manager at an index }
                                   function Get_Facility_Manager( Index : longint ) : PSFacility_Manager ;
                                       virtual ;

                                   { Construct an instance of a facility }
                                   function Construct( Stream : PSStream ) : pointer ;
                                       virtual ;
                            end ;
     PTest_Object_Manager = ^Test_Object_Manager ;

procedure Test_Object_Manager.Add_Object( O : pointer ; Facility : integer ;
    Context : pointer ) ;

begin
    Last_Routine := 'Add_Object' ;
end ;


function Test_Object_Manager.Debugger : PSDebug_Interface ;

begin
    Last_Routine := 'Debugger' ;
    Result := nil ;
end ;


function Test_Object_Manager.Find_Object( O : pointer ;
    Facility : integer ) : boolean ;

begin
    Last_Routine := 'Find_Object' ;
    Result := False ;
end ;


function Test_Object_Manager.Get_Context( Index : integer ) : pointer ;

begin
    Last_Routine := 'Get_Context' ;
    Result := nil ;
end ;


function Test_Object_Manager.Get_Facility( Index : integer ) : integer ;

begin
    Last_Routine := 'Get_Facility' ;
    Result := -1 ;
end ;


function Test_Object_Manager.Get_Object( Index : integer ) : pointer ;

begin
    Last_Routine := 'Get_Object' ;
    Result := nil ;
end ;


procedure Test_Object_Manager.Remove_Object( O : pointer ;
    Facility : longint ) ;

begin
    Last_Routine := 'Remove_Object' ;
end ;


function Test_Object_Manager.Object_Count : longint ;

begin
    Last_Routine := 'Object_Count' ;
    Result := 0 ;
end ;


procedure Test_Object_Manager.Register_Facility( Facility_Manager : PSFacility_Manager ) ;

begin
    Last_Routine := 'Register_Facility' ;
end ;


procedure Test_Object_Manager.Remove_Facility( Facility_Manager : PSFacility_Manager ) ;

begin
    Last_Routine := 'Remove_Facility' ;
end ;


function Test_Object_Manager.Get_Facility_Manager( Index : longint ) : PSFacility_Manager ;

begin
    Last_Routine := 'Get_Facility_Manager' ;
    Result := nil ;
end ;


function Test_Object_Manager.Construct( Stream : PSStream ) : pointer ;

begin
    Last_Routine := 'Construct' ;
    Result := nil ;
end ;



type Test_Application_Manager = object( TSApplication_Manager )
                                    public { API... }
                                        Last_Routine : Ansistring ;

                                        function Get_In_Shut_Down : boolean ;
                                            virtual ;

                                        procedure Set_In_Shut_Down( Value : boolean ) ;
                                            virtual ;

                                        function Get_Halting : boolean ;
                                            virtual ;

                                        procedure Set_Halting( Value : boolean ) ;
                                            virtual ;

                                        { Debugging... }
                                        function Get_Debug_Manager : PSDebug_Manager ;
                                            virtual ;

                                        procedure Set_Debug_Manager( Value : PSDebug_Manager ) ;
                                            virtual ;

                                        function Application_Debugger : PSDebug_Interface ;
                                            virtual ;

                                        function Debugger : PSDebug_Interface ;
                                            virtual ;

                                        function Object_Manager : PSObject_Manager ;
                                            virtual ;

                                        { Idle processing... }
                                        procedure Do_Idle ; virtual ;

                                        procedure Add_Idle_Delegation( Value : PSIdle_Consumer ) ;
                                            virtual ;

                                        procedure Remove_Idle_Delegation( Value : PSIdle_Consumer ) ;
                                            virtual ;

                                        { Event logging... }
                                        function Get_Event_Logger : PSApplication_Event_Logger ;
                                            virtual ;

                                        procedure Set_Event_Logger( EV : PSApplication_Event_Logger ) ;
                                            virtual ;

                                        { Performance... }
                                        function Get_Performance_Monitor : PSApplication_Performance_Monitor ;
                                            virtual ;

                                        procedure Set_Performance_Monitor( PM : PSApplication_Performance_Monitor ) ;
                                            virtual ;

                                        { Other... }
                                        procedure Fatal_Exception( const S : Ansistring ) ;
                                            virtual ;

                                        procedure Popup_Message( S : Ansistring ) ;
                                            virtual ;

                                        function Get_Heap : PSManaged_Store ; virtual ;

                                        procedure Set_Heap( Value : PSManaged_Store ) ;
                                            virtual ;

                                        function Get_Name : Ansistring ; virtual ;

                                        procedure Set_Name( const Value : Ansistring ) ;
                                            virtual ;

                                        { Full version string including "V" }
                                        function Get_Version : Ansistring ; virtual ;

                                        procedure Set_Version( const Value : Ansistring ) ;
                                            virtual ;
                                end ;
     PTest_Application_Manager = ^Test_Application_Manager ;


function Test_Application_Manager.Get_In_Shut_Down : boolean ;

begin
    Last_Routine := 'Get_In_Shut_Down' ;
    Result := False ;
end ;


procedure Test_Application_Manager.Set_In_Shut_Down( Value : boolean ) ;

begin
    Last_Routine := 'Set_In_Shut_Down' ;
end ;


function Test_Application_Manager.Get_Halting : boolean ;

begin
    Last_Routine := 'Get_Halting' ;
    Result := False ;
end ;


procedure Test_Application_Manager.Set_Halting( Value : boolean ) ;

begin
    Last_Routine := 'Set_Halting' ;
end ;


function Test_Application_Manager.Get_Debug_Manager : PSDebug_Manager ;

begin
    Last_Routine := 'Get_Debug_Manager' ;
    Result := nil ;
end ;


procedure Test_Application_Manager.Set_Debug_Manager( Value : PSDebug_Manager ) ;

begin
    Last_Routine := 'Set_Debug_Manager' ;
end ;


function Test_Application_Manager.Application_Debugger : PSDebug_Interface ;

begin
    Last_Routine := 'Application_Debugger' ;
    Result := nil ;
end ;


function Test_Application_Manager.Debugger : PSDebug_Interface ;

begin
    Last_Routine := 'Debugger' ;
    Result := nil ;
end ;


function Test_Application_Manager.Object_Manager : PSObject_Manager ;

begin
    Last_Routine := 'Object_Manager' ;
    Result := nil ;
end ;


procedure Test_Application_Manager.Do_Idle ;

begin
    Last_Routine := 'Do_Idle' ;
end ;


procedure Test_Application_Manager.Add_Idle_Delegation( Value : PSIdle_Consumer ) ;

begin
    Last_Routine := 'Add_Idle_Delegation' ;
end ;


procedure Test_Application_Manager.Remove_Idle_Delegation( Value : PSIdle_Consumer ) ;

begin
    Last_Routine := 'Remove_Idle_Delegation' ;
end ;


function Test_Application_Manager.Get_Event_Logger : PSApplication_Event_Logger ;

begin
    Last_Routine := 'Get_Event_Logger' ;
    Get_Event_Logger := nil ;
end ;


procedure Test_Application_Manager.Set_Event_Logger( EV : PSApplication_Event_Logger ) ;

begin
    Last_Routine := 'Set_Event_Logger' ;
end ;


function Test_Application_Manager.Get_Performance_Monitor : PSApplication_Performance_Monitor ;

begin
    Last_Routine := 'Get_Performance_Monitor' ;
    Get_Performance_Monitor := nil ;
end ;


procedure Test_Application_Manager.Set_Performance_Monitor( PM : PSApplication_Performance_Monitor ) ;

begin
    Last_Routine := 'Set_Performance_Monitor' ;
end ;


procedure Test_Application_Manager.Fatal_Exception( const S : Ansistring ) ;

begin
    Last_Routine := 'Fatal_Exception' ;
end ;


procedure Test_Application_Manager.Popup_Message( S : Ansistring ) ;

begin
    Last_Routine := 'Popup_Message' ;
end ;


function Test_Application_Manager.Get_Heap : PSManaged_Store ;

begin
    Last_Routine := 'Get_Heap' ;
    Result := nil ;
end ;


procedure Test_Application_Manager.Set_Heap( Value : PSManaged_Store ) ;

begin
    Last_Routine := 'Set_Heap' ;
end ;


function Test_Application_Manager.Get_Name : Ansistring ;

begin
    Last_Routine := 'Get_Name' ;
    Result := '' ;
end ;


procedure Test_Application_Manager.Set_Name( const Value : Ansistring ) ;

begin
    Last_Routine := 'Set_Name' ;
end ;


function Test_Application_Manager.Get_Version : Ansistring ;

begin
    Last_Routine := 'Get_Version' ;
    Result := '' ;
end ;


procedure Test_Application_Manager.Set_Version( const Value : Ansistring ) ;

begin
    Last_Routine := 'Set_Version' ;
end ;



procedure Error ;

begin
    writeln( 'Error' ) ;
    halt ;
end ;


procedure Test_AM_Wrapper ;

var S : Ansistring ;
    Test_Static : PTest_Application_Manager ;
    Test : TCOM_Application_Manager ;

begin
    Test_Static := new( PTest_Application_Manager, Init ) ;
    Test := Static_COM_Application_Manager_Wrapper( Test_Static ) ;

    if( Test.In_Shut_Down ) then
    begin
        Error ;
    end ;
    if( Test_Static.Last_Routine <> 'Get_In_Shut_Down' ) then
    begin
        Error ;
    end ;
    Test.In_Shut_Down := True ;
    if( Test_Static.Last_Routine <> 'Set_In_Shut_Down' ) then
    begin
        Error ;
    end ;
    if( Test.Halting ) then
    begin
        Error ;
    end ;
    if( Test_Static.Last_Routine <> 'Get_Halting' ) then
    begin
        Error ;
    end ;
    Test.Halting := True ;
    if( Test_Static.Last_Routine <> 'Set_Halting' ) then
    begin
        Error ;
    end ;
    if( Test.Debug_Manager <> nil ) then
    begin
        Error ;
    end ;
    Test.Debug_Manager := nil ;
    if( Test.Application_Debugger <> nil ) then
    begin
        Error ;
    end ;
    if( Test.Debugger <> nil ) then
    begin
        Error ;
    end ;
    if( Test_Static.Last_Routine <> 'Debugger' ) then
    begin
        Error ;
    end ;
    Test.Object_Manager ;
    if( Test_Static.Last_Routine <> 'Object_Manager' ) then
    begin
        Error ;
    end ;
    Test.Object_Manager ;
    Test.Do_Idle ;
    if( Test_Static.Last_Routine <> 'Do_Idle' ) then
    begin
        Error ;
    end ;
    Test.Add_Idle_Delegation( nil ) ;
    Test.Remove_Idle_Delegation( nil ) ;
    if( Test.Event_Logger <> nil ) then
    begin
        Error ;
    end ;
    Test.Event_Logger := nil ;
    if( Test.Performance_Monitor <> nil ) then
    begin
        Error ;
    end ;
    Test.Performance_Monitor := nil ;
    Test.Fatal_Exception( '' ) ;
    if( Test_Static.Last_Routine <> 'Fatal_Exception' ) then
    begin
        Error ;
    end ;
    Test.Popup_Message( '' ) ;
    if( Test_Static.Last_Routine <> 'Popup_Message' ) then
    begin
        Error ;
    end ;
    if( Test.Get_Heap <> nil ) then
    begin
        Error ;
    end ;
    Test.Heap := nil ;
    S := Test.Name ;
    if( S <> '' ) then
    begin
        Error ;
    end ;
    if( Test_Static.Last_Routine <> 'Get_Name' ) then
    begin
        Error ;
    end ;
    Test.Name := '' ;
    if( Test_Static.Last_Routine <> 'Set_Name' ) then
    begin
        Error ;
    end ;
    S := Test.Version ;
    if( S <> '' ) then
    begin
        Error ;
    end ;
    if( Test_Static.Last_Routine <> 'Get_Version' ) then
    begin
        Error ;
    end ;
    Test.Version := nil ;
    if( Test_Static.Last_Routine <> 'Set_Version' ) then
    begin
        Error ;
    end ;

    Test.Free ;
    dispose( Test_Static, Done ) ;
end ;


procedure Test_OM_Wrapper ;

var Test_Static : PTest_Object_Manager ;
    Test : TCOM_Object_Manager ;

begin
    Test_Static := new( PTest_Object_Manager, Init ) ;
    Test := COM_Static_Object_Manager( Test_Static ) ;

    Test.Add_Object( nil, -1, nil ) ;
    if( Test_Static.Last_Routine <> 'Add_Object' ) then
    begin
        Error ;
    end ;
    if( Test.Debugger <> nil ) then
    begin
        Error ;
    end ;
    if( Test_Static.Last_Routine <> 'Debugger' ) then
    begin
        Error ;
    end ;
    if( Test.Find_Object( nil, -1 ) ) then
    begin
        Error ;
    end ;
    if( Test_Static.Last_Routine <> 'Find_Object' ) then
    begin
        Error ;
    end ;
    if( Test.Get_Context( 0 ) <> nil ) then
    begin
        Error ;
    end ;
    if( Test_Static.Last_Routine <> 'Get_Context' ) then
    begin
        Error ;
    end ;
    if( Test.Get_Facility( 0 ) <> -1 ) then
    begin
        Error ;
    end ;
    if( Test_Static.Last_Routine <> 'Get_Facility' ) then
    begin
        Error ;
    end ;
    if( Test.Get_Object( 0 ) <> nil ) then
    begin
        Error ;
    end ;
    if( Test_Static.Last_Routine <> 'Get_Object' ) then
    begin
        Error ;
    end ;
    Test.Remove_Object( nil, -11 ) ;
    if( Test_Static.Last_Routine <> 'Remove_Object' ) then
    begin
        Error ;
    end ;
    if( Test.Object_Count <> 0 ) then
    begin
        Error ;
    end ;
    if( Test_Static.Last_Routine <> 'Object_Count' ) then
    begin
        Error ;
    end ;
    Test.Register_Facility( nil ) ;
    Test.Remove_Facility( nil ) ;
    if( Test.Get_Facility_Manager( 0 ) <> nil ) then
    begin
        Error ;
    end ;
    if( Test.Construct( nil ) <> nil ) then
    begin
        Error ;
    end ;

    Test.Free ;
    dispose( Test_Static, Done ) ;
end ;


procedure Test_Unit ;

begin
    Test_AM_Wrapper ;
    Test_OM_Wrapper ;
end ;
{$ENDIF}



{$IFNDEF VARIABLE_DECLARATION_ASSIGN}
begin
    Application_Manager := nil ;
{$ENDIF}
end.
