;              Program Name : _BIOS
;              Package Name : LB
;              Purpose      : Definitions of BIOS constants
;              Institution  : Conroy & Conroy Co.
;              Date Written : 23-Apr-2020
;              Written By   : Alan Conroy
;              Version      : 1.0
;
;              Copyright (c) 1995 by Alan Conroy.  Released to the public domain.
;
;	       TO THE GLORY OF GOD THROUGH JESUS CHRIST
;
;        *********************************************************
;        *                                                       *
;        *        M O D I F I C A T I O N   H I S T O R Y        *
;        *                                                       *
;        *********************************************************
;
;        *     DATE      BY             REASON                   *
;
;        *********************************************************
;        *                                                       *
;        *           P R O G R A M   P U R P O S E               *
;        *                                                       *
;        *********************************************************
;

; BIOS constants

        ; Extended key codes...
	EKC_Shift_Tab EQU 15
	EKC_Alt_Q EQU 16
	EKC_Alt_W EQU 17
	EKC_Alt_E EQU 18
	EKC_Alt_R EQU 19
	EKC_Alt_T EQU 20
	EKC_Alt_Y EQU 21
	EKC_Alt_U EQU 22
	EKC_Alt_I EQU 23
	EKC_Alt_O EQU 24
	EKC_Alt_P EQU 25
	EKC_Alt_A EQU 30
	EKC_Alt_S EQU 31
	EKC_Alt_D EQU 32
	EKC_Alt_F EQU 33
	EKC_Alt_G EQU 34
	EKC_Alt_H EQU 35
	EKC_Alt_J EQU 36
	EKC_Alt_K EQU 37
	EKC_Alt_L EQU 38
	EKC_Alt_Z EQU 44
	EKC_Alt_X EQU 45
	EKC_Alt_C EQU 46
	EKC_Alt_V EQU 47
	EKC_Alt_B EQU 48
	EKC_Alt_N EQU 49
	EKC_Alt_M EQU 50
	EKC_F1 EQU 59
	EKC_F2 EQU 60
	EKC_F3 EQU 61
	EKC_F4 EQU 62
	EKC_F5 EQU 63
	EKC_F6 EQU 64
	EKC_F7 EQU 65
	EKC_F8 EQU 66
	EKC_F9 EQU 67
	EKC_F10 EQU 68
	EKC_Home EQU 71
	EKC_Up EQU 72
	EKC_Page_Up EQU 73
	EKC_Left EQU 75
	EKC_Right EQU 77
	EKC_Down EQU 80
	EKC_Page_Down EQU 81
	EKC_Insert EQU 82
	EKC_Delete EQU 83
	EKC_Shift_F1 EQU 84
	EKC_Shift_F2 EQU 85
	EKC_Shift_F3 EQU 86
	EKC_Shift_F4 EQU 87
	EKC_Shift_F5 EQU 88
	EKC_Shift_F6 EQU 89
	EKC_Shift_F7 EQU 90
	EKC_Shift_F8 EQU 91
	EKC_Shift_F9 EQU 92
	EKC_Shift_F10 EQU 93
	EKC_Control_F1 EQU 94
	EKC_Control_F2 EQU 95
	EKC_Control_F3 EQU 96
	EKC_Control_F4 EQU 97
	EKC_Control_F5 EQU 98
	EKC_Control_F6 EQU 99
	EKC_Control_F7 EQU 100
	EKC_Control_F8 EQU 101
	EKC_Control_F9 EQU 102
	EKC_Control_F10 EQU 103
	EKC_Alt_F1 EQU 104
	EKC_Alt_F2 EQU 105
	EKC_Alt_F3 EQU 106
	EKC_Alt_F4 EQU 107
	EKC_Alt_F5 EQU 108
	EKC_Alt_F6 EQU 109
	EKC_Alt_F7 EQU 110
	EKC_Alt_F8 EQU 111
	EKC_Alt_F9 EQU 112
	EKC_Alt_F10 EQU 113
	EKC_Control_Left EQU 115
	EKC_Control_Right EQU 116
	EKC_Control_End EQU 117
	EKC_Alt_Page_Down EQU 118
	EKC_Alt_Home EQU 119
	EKC_Alt_1 EQU 120
	EKC_Alt_2 EQU 121
	EKC_Alt_3 EQU 122
	EKC_Alt_4 EQU 123
	EKC_Alt_5 EQU 124
	EKC_Alt_6 EQU 125
	EKC_Alt_7 EQU 126
	EKC_Alt_8 EQU 127
	EKC_Alt_9 EQU 128
	EKC_Alt_0 EQU 129
	EKC_Alt1 EQU 130
	EKC_Alt2 EQU 131

	EKC_F11 EQU 85H
	EKC_F12 EQU 86H
	EKC_Shift_F11 EQU 87H
	EKC_Shift_F12 EQU 88H
	EKC_Control_F11 EQU 89H
	EKC_Control_F12 EQU 8AH
	EKC_Alt_F11 EQU 8BH
	EKC_Alt_F12 EQU 8CH
	EKC_Control_Up EQU 8DH
	EKC_Control_Down EQU 91H
	EKC_Control_Insert EQU 92H
	EKC_Control_Delete EQU 93H
	EKC_Alt_Up EQU 98H
	EKC_Alt_Page_Up EQU 99H
	EKC_Alt_Left EQU 9BH
	EKC_Alt_Right EQU 9DH
	EKC_Alt_End EQU 9FH
	EKC_Alt_Down EQU 0A0H
	EKC_Alt_Insert EQU 0A2H
	EKC_Alt_Delete EQU 0A3H
	EKC_Control_Gray_Slash EQU 95H
	EKC_Control_Gray_Asterisk EQU 96H
	EKC_Control_Gray_Dash EQU 8EH
	EKC_Control_Gray_Plus EQU 90H
	EKC_Alt_Gray_Slash EQU 0A4H
	EKC_Alt_Gray_Asterisk EQU 37H
	EKC_Alt_Gray_Dash EQU 4AH
	EKC_Alt_Gray_Plus EQU 90H
	EKC_Alt_Gray_Enter EQU 0A6H
	EKC_Control_Tab EQU 94H
	EKC_Control_5 EQU 8FH
	EKC_Alt_Escape EQU 1
	EKC_Alt_Backspace EQU 0EH
	EKC_Alt_Tab EQU 0A5H
	EKC_Alt_Left_Bracket EQU 1AH
	EKC_Alt_Right_Bracket EQU 1BH
	EKC_Alt_Enter EQU 1CH
	EKC_Alt_Semicolon EQU 27H
	EKC_Alt_Apostrophe EQU 28H
	EKC_Alt_Accent EQU 29H
	EKC_Alt_Backslash EQU 2BH
	EKC_Alt_Comma EQU 33H
	EKC_Alt_Period EQU 34H
	EKC_Alt_Slash EQU 35H

	END
