/*
              Program Name : _BIOS
              Package Name : Subroutine Library - Layer 0
              Purpose      : Support for BIOS
              Institution  : Conroy & Conroy Co.
              Date Written : 21-Jan-2020
              Written By   : Alan Conroy
              Version      : 2.1B

              Copyright (C) 1992-2021 by Alan Conroy. 

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *********************************************************
        *                                                       *
        *        M O D I F I C A T I O N   H I S T O R Y        *
        *                                                       *
        *********************************************************

             DATE      BY             REASON

        *********************************************************
        *                                                       *
        *           P R O G R A M   P U R P O S E               *
        *                                                       *
        *********************************************************

          These constants are for support of BIOS.
*/

/* BIOS constants */

      /* Extended key codes... */
const int EKC_Shift_Tab = 15 ;
const int EKC_Alt_Q = 16 ;
const int EKC_Alt_W = 17 ;
const int EKC_Alt_E = 18 ;
const int EKC_Alt_R = 19 ;
const int EKC_Alt_T = 20 ;
const int EKC_Alt_Y = 21 ;
const int EKC_Alt_U = 22 ;
const int EKC_Alt_I = 23 ;
const int EKC_Alt_O = 24 ;
const int EKC_Alt_P = 25 ;
const int EKC_Alt_A = 30 ;
const int EKC_Alt_S = 31 ;
const int EKC_Alt_D = 32 ;
const int EKC_Alt_F = 33 ;
const int EKC_Alt_G = 34 ;
const int EKC_Alt_H = 35 ;
const int EKC_Alt_J = 36 ;
const int EKC_Alt_K = 37 ;
const int EKC_Alt_L = 38 ;
const int EKC_Alt_Z = 44 ;
const int EKC_Alt_X = 45 ;
const int EKC_Alt_C = 46 ;
const int EKC_Alt_V = 47 ;
const int EKC_Alt_B = 48 ;
const int EKC_Alt_N = 49 ;
const int EKC_Alt_M = 50 ;
const int EKC_F1 = 59 ;
const int EKC_F2 = 60 ;
const int EKC_F3 = 61 ;
const int EKC_F4 = 62 ;
const int EKC_F5 = 63 ;
const int EKC_F6 = 64 ;
const int EKC_F7 = 65 ;
const int EKC_F8 = 66 ;
const int EKC_F9 = 67 ;
const int EKC_F10 = 68 ;
const int EKC_Home = 71 ;
const int EKC_Up = 72 ;
const int EKC_Page_Up = 73 ;
const int EKC_Left = 75 ;
const int EKC_Right = 77 ;
const int EKC_Down = 80 ;
const int EKC_Page_Down = 81 ;
const int EKC_Insert = 82 ;
const int EKC_Delete = 83 ;
const int EKC_Shift_F1 = 84 ;
const int EKC_Shift_F2 = 85 ;
const int EKC_Shift_F3 = 86 ;
const int EKC_Shift_F4 = 87 ;
const int EKC_Shift_F5 = 88 ;
const int EKC_Shift_F6 = 89 ;
const int EKC_Shift_F7 = 90 ;
const int EKC_Shift_F8 = 91 ;
const int EKC_Shift_F9 = 92 ;
const int EKC_Shift_F10 = 93 ;
const int EKC_Control_F1 = 94 ;
const int EKC_Control_F2 = 95 ;
const int EKC_Control_F3 = 96 ;
const int EKC_Control_F4 = 97 ;
const int EKC_Control_F5 = 98 ;
const int EKC_Control_F6 = 99 ;
const int EKC_Control_F7 = 100 ;
const int EKC_Control_F8 = 101 ;
const int EKC_Control_F9 = 102 ;
const int EKC_Control_F10 = 103 ;
const int EKC_Alt_F1 = 104 ;
const int EKC_Alt_F2 = 105 ;
const int EKC_Alt_F3 = 106 ;
const int EKC_Alt_F4 = 107 ;
const int EKC_Alt_F5 = 108 ;
const int EKC_Alt_F6 = 109 ;
const int EKC_Alt_F7 = 110 ;
const int EKC_Alt_F8 = 111 ;
const int EKC_Alt_F9 = 112 ;
const int EKC_Alt_F10 = 113 ;
const int EKC_Control_Left = 115 ;
const int EKC_Control_Right = 116 ;
const int EKC_Control_End = 117 ;
const int EKC_Alt_Page_Down = 118 ;
const int EKC_Alt_Home = 119 ;
const int EKC_Alt_1 = 120 ;
const int EKC_Alt_2 = 121 ;
const int EKC_Alt_3 = 122 ;
const int EKC_Alt_4 = 123 ;
const int EKC_Alt_5 = 124 ;
const int EKC_Alt_6 = 125 ;
const int EKC_Alt_7 = 126 ;
const int EKC_Alt_8 = 127 ;
const int EKC_Alt_9 = 128 ;
const int EKC_Alt_0 = 129 ;
const int EKC_Alt1 = 130 ;
const int EKC_Alt2 = 131 ;

const int EKC_F11 = 0x85 ;
const int EKC_F12 = 0x86 ;
const int EKC_Shift_F11 = 0x87 ;
const int EKC_Shift_F12 = 0x88 ;
const int EKC_Control_F11 = 0x89 ;
const int EKC_Control_F12 = 0x8A ;
const int EKC_Alt_F11 = 0x8B ;
const int EKC_Alt_F12 = 0x8C ;
const int EKC_Control_Up = 0x8D ;
const int EKC_Control_Down = 0x91 ;
const int EKC_Control_Insert = 0x92 ;
const int EKC_Control_Delete = 0x93 ;
const int EKC_Alt_Up = 0x98 ;
const int EKC_Alt_Page_Up = 0x99 ;
const int EKC_Alt_Left = 0x9B ;
const int EKC_Alt_Right = 0x9D ;
const int EKC_Alt_End = 0x9F ;
const int EKC_Alt_Down = 0xA0 ;
const int EKC_Alt_Insert = 0xA2 ;
const int EKC_Alt_Delete = 0xA3 ;
const int EKC_Control_Gray_Slash = 0x95 ;
const int EKC_Control_Gray_Asterisk = 0x96 ;
const int EKC_Control_Gray_Dash = 0x8E ;
const int EKC_Control_Gray_Plus = 0x90 ;
const int EKC_Alt_Gray_Slash = 0xA4 ;
const int EKC_Alt_Gray_Asterisk = 0x37 ;
const int EKC_Alt_Gray_Dash = 0x4A ;
const int EKC_Alt_Gray_Plus = 0x90 ;
const int EKC_Alt_Gray_Enter = 0xA6 ;
const int EKC_Control_Tab = 0x94 ;
const int EKC_Control_5 = 0x8F ;
const int EKC_Alt_Escape = 1 ;
const int EKC_Alt_Backspace = 0xE ;
const int EKC_Alt_Tab = 0xA5 ;
const int EKC_Alt_Left_Bracket = 0x1A ;
const int EKC_Alt_Right_Bracket = 0x1B ;
const int EKC_Alt_Enter = 0x1C ;
const int EKC_Alt_Semicolon = 0x27 ;
const int EKC_Alt_Apostrophe = 0x28 ;
const int EKC_Alt_Accent = 0x29 ;
const int EKC_Alt_Backslash = 0x2B ;
const int EKC_Alt_Comma = 0x33 ;
const int EKC_Alt_Period = 0x34 ;
const int EKC_Alt_Slash = 0x35 ;
