{$D-}
{
              Program Name : _BIOS
              Package Name : Subroutine Library - Layer 0
              Purpose      : Support for BIOS
              Institution  : Conroy & Conroy Co.
              Date Written : 21-Jan-2020
              Written By   : Alan Conroy
              Version      : 2.1B

              Copyright (C) 1992-2021 by Alan Conroy.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *********************************************************
        *                                                       *
        *        M O D I F I C A T I O N   H I S T O R Y        *
        *                                                       *
        *********************************************************

             DATE      BY             REASON

        *********************************************************
        *                                                       *
        *           P R O G R A M   P U R P O S E               *
        *                                                       *
        *********************************************************

          These constants are for support of PC BIOS.

}

unit _BIOS ;

interface

{$I EDEFINES.INC}

{ BIOS constants }

      { Extended key codes... }
const EKC_Shift_Tab = 15 ;
const EKC_Alt_Q = 16 ;
const EKC_Alt_W = 17 ;
const EKC_Alt_E = 18 ;
const EKC_Alt_R = 19 ;
const EKC_Alt_T = 20 ;
const EKC_Alt_Y = 21 ;
const EKC_Alt_U = 22 ;
const EKC_Alt_I = 23 ;
const EKC_Alt_O = 24 ;
const EKC_Alt_P = 25 ;
const EKC_Alt_A = 30 ;
const EKC_Alt_S = 31 ;
const EKC_Alt_D = 32 ;
const EKC_Alt_F = 33 ;
const EKC_Alt_G = 34 ;
const EKC_Alt_H = 35 ;
const EKC_Alt_J = 36 ;
const EKC_Alt_K = 37 ;
const EKC_Alt_L = 38 ;
const EKC_Alt_Z = 44 ;
const EKC_Alt_X = 45 ;
const EKC_Alt_C = 46 ;
const EKC_Alt_V = 47 ;
const EKC_Alt_B = 48 ;
const EKC_Alt_N = 49 ;
const EKC_Alt_M = 50 ;
const EKC_F1 = 59 ;
const EKC_F2 = 60 ;
const EKC_F3 = 61 ;
const EKC_F4 = 62 ;
const EKC_F5 = 63 ;
const EKC_F6 = 64 ;
const EKC_F7 = 65 ;
const EKC_F8 = 66 ;
const EKC_F9 = 67 ;
const EKC_F10 = 68 ;
const EKC_Home = 71 ;
const EKC_Up = 72 ;
const EKC_Page_Up = 73 ;
const EKC_Left = 75 ;
const EKC_Right = 77 ;
const EKC_Down = 80 ;
const EKC_Page_Down = 81 ;
const EKC_Insert = 82 ;
const EKC_Delete = 83 ;
const EKC_Shift_F1 = 84 ;
const EKC_Shift_F2 = 85 ;
const EKC_Shift_F3 = 86 ;
const EKC_Shift_F4 = 87 ;
const EKC_Shift_F5 = 88 ;
const EKC_Shift_F6 = 89 ;
const EKC_Shift_F7 = 90 ;
const EKC_Shift_F8 = 91 ;
const EKC_Shift_F9 = 92 ;
const EKC_Shift_F10 = 93 ;
const EKC_Control_F1 = 94 ;
const EKC_Control_F2 = 95 ;
const EKC_Control_F3 = 96 ;
const EKC_Control_F4 = 97 ;
const EKC_Control_F5 = 98 ;
const EKC_Control_F6 = 99 ;
const EKC_Control_F7 = 100 ;
const EKC_Control_F8 = 101 ;
const EKC_Control_F9 = 102 ;
const EKC_Control_F10 = 103 ;
const EKC_Alt_F1 = 104 ;
const EKC_Alt_F2 = 105 ;
const EKC_Alt_F3 = 106 ;
const EKC_Alt_F4 = 107 ;
const EKC_Alt_F5 = 108 ;
const EKC_Alt_F6 = 109 ;
const EKC_Alt_F7 = 110 ;
const EKC_Alt_F8 = 111 ;
const EKC_Alt_F9 = 112 ;
const EKC_Alt_F10 = 113 ;
const EKC_Control_Left = 115 ;
const EKC_Control_Right = 116 ;
const EKC_Control_End = 117 ;
const EKC_Alt_Page_Down = 118 ;
const EKC_Alt_Home = 119 ;
const EKC_Alt_1 = 120 ;
const EKC_Alt_2 = 121 ;
const EKC_Alt_3 = 122 ;
const EKC_Alt_4 = 123 ;
const EKC_Alt_5 = 124 ;
const EKC_Alt_6 = 125 ;
const EKC_Alt_7 = 126 ;
const EKC_Alt_8 = 127 ;
const EKC_Alt_9 = 128 ;
const EKC_Alt_0 = 129 ;
const EKC_Alt1 = 130 ;
const EKC_Alt2 = 131 ;

const EKC_F11 = $85 ;
const EKC_F12 = $86 ;
const EKC_Shift_F11 = $87 ;
const EKC_Shift_F12 = $88 ;
const EKC_Control_F11 = $89 ;
const EKC_Control_F12 = $8A ;
const EKC_Alt_F11 = $8B ;
const EKC_Alt_F12 = $8C ;
const EKC_Control_Up = $8D ;
const EKC_Control_Down = $91 ;
const EKC_Control_Insert = $92 ;
const EKC_Control_Delete = $93 ;
const EKC_Alt_Up = $98 ;
const EKC_Alt_Page_Up = $99 ;
const EKC_Alt_Left = $9B ;
const EKC_Alt_Right = $9D ;
const EKC_Alt_End = $9F ;
const EKC_Alt_Down = $A0 ;
const EKC_Alt_Insert = $A2 ;
const EKC_Alt_Delete = $A3 ;
const EKC_Control_Gray_Slash = $95 ;
const EKC_Control_Gray_Asterisk = $96 ;
const EKC_Control_Gray_Dash = $8E ;
const EKC_Control_Gray_Plus = $90 ;
const EKC_Alt_Gray_Slash = $A4 ;
const EKC_Alt_Gray_Asterisk = $37 ;
const EKC_Alt_Gray_Dash = $4A ;
const EKC_Alt_Gray_Plus = $90 ;
const EKC_Alt_Gray_Enter = $A6 ;
const EKC_Control_Tab = $94 ;
const EKC_Control_5 = $8F ;
const EKC_Alt_Escape = 1 ;
const EKC_Alt_Backspace = $E ;
const EKC_Alt_Tab = $A5 ;
const EKC_Alt_Left_Bracket = $1A ;
const EKC_Alt_Right_Bracket = $1B ;
const EKC_Alt_Enter = $1C ;
const EKC_Alt_Semicolon = $27 ;
const EKC_Alt_Apostrophe = $28 ;
const EKC_Alt_Accent = $29 ;
const EKC_Alt_Backslash = $2B ;
const EKC_Alt_Comma = $33 ;
const EKC_Alt_Period = $34 ;
const EKC_Alt_Slash = $35 ;

implementation

end.
