#        Program Name : _Common
#        Package Name : Subroutine Library - Layer 0
#        Purpose      : Common base objects (TObject and TDelphi_Object)
#        Institution  : Conroy & Conroy Co.
#        Date Written : 19-Mar-2002
#        Written By   : Alan Conroy
#        Version      : 1.0
#
#        Copyright (C) 2005 by Alan Conroy.  Released to the public domain.
#
#        TO THE GLORY OF GOD THROUGH JESUS CHRIST
#
#        *************************************************************
#        *                                                           *
#        *        M O D I F I C A T I O N   H I S T O R Y            *
#        *                                                           *
#        *************************************************************
#
#           DATE        BY          REASON                         
#
#        1-Nov-2002     EAC         Removed pointless overrides of
#                                   TObject methods in BP.  Added
#                                   reference counting support.
#
#        *************************************************************
#        *                                                           *
#        *        P R O G R A M   P U R P O S E                      *
#        *                                                           *
#        *************************************************************

import sys

MT_Unknown = 0 # Don't know
MT_Heap = 1 # Allocated on heap
MT_Data = 2 # "Global" data
MT_Stack = 3 # "Local" data
MT_Code = 4 # executable                    


# Unit API...

def Abstract_Error():
    print( 'Call to abstract method' )
    sys.exit()

# TObject methods...

class TObject:
    # API...
    def Attach():
        Abstract_Error()
        
    def Detach():
        Abstract_Error()
        
    def Classname():
        return 'TObject'
    
    def Is_Class( Name ):
        return ( Name == Classname() )
    
    def Get_Memory_Type():
        return MT_Unknown
