/*
        Program Name : _DebugIn
        Package Name : Subroutine Library - Layer 0
        Purpose      : Debugger Interface definitions
        Institution  : Conroy & Conroy Co.
        Date Written : 11-Jan-2001
        Written By   : Alan Conroy
        Version      : 1.0

	    Copyright (C) 2001-2021 by Alan Conroy.  Released to the public domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          TDebug_Interface is used when debugging code by providing a way of
        examining the internals of the software component at run-time (for
        production versions of software, this is often not supported).  The
        interface assumes a hierarchical form with the root of a component
        returning children representing internal objects.  Each of those objects
        may have children, and so forth.
*/

#include "_DebugIn.hpp"

// TDebug_Interface methods...

bool TSDebug_Interface::Has_Children()
{
    Abstract_Error() ;
    return false;
} ;


// API...

int32 TSDebug_Interface::Count()
{
    Abstract_Error() ;
    return 0;
} ;


char* TSDebug_Interface::Get_Title()
{
    Abstract_Error() ;
    return NULL;
} ;


void TSDebug_Interface::Set_Title( char* Value )
{
    Abstract_Error ;
} ;


void TSDebug_Interface::Activate()
{
    Abstract_Error() ;
} ;


bool TSDebug_Interface::Can_Change()
{
    Abstract_Error() ;
    return false;
} ;


TSDebug_Interface *TSDebug_Interface::Child( int32 Ordinal )
{
    Abstract_Error() ;
    return NULL;
} ;


void TSDebug_Interface::Kill()
{
    Abstract_Error() ;
} ;


char* TSDebug_Interface::Modify( char* Data, int Size )
{
    Abstract_Error() ;
    return NULL;
} ;


int32 TSDebug_Interface::Get_Context()
{
    Abstract_Error() ;
    return 0;
} ;


void TSDebug_Interface::Set_Context( int32 Value )
{
    Abstract_Error() ;
} ;


bool TSDebug_Interface::Recursive()
{
    Abstract_Error() ;
    return false ;
} ;


bool TSDebug_Interface::Arbitrary_Length()
{
    Abstract_Error() ;
    return false;
} ;
