<?php
 /*
        Program Name : _DebugIn
        Package Name : Subroutine Library - Layer 0
        Purpose      : Debugger Interface definitions
        Institution  : Conroy & Conroy Co.
        Date Written : 11-Jan-2001
        Written By   : Alan Conroy
        Version      : 1.0

	    Copyright (C) 2001-2021 by Alan Conroy.  Released to the public domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          TDebug_Interface is used when debugging code by providing a way of
        examining the internals of the software component at run-time (for
        production versions of software, this is often not supported).  The
        interface assumes a hierarchical form with the root of a component
        returning children representing internal objects.  Each of those objects
        may have children, and so forth.
*/

include_once "_Common.php";

// TSDebug_Interface methods...
class TSDebug_Interface extends TObject
{
	var $Context=0;
	var $Title='' ;

	function Has_Children()
	{
	    Abstract_Error() ;
	    return false;
	}


	// API...

	function Count()
	{
	    Abstract_Error() ;
	    return 0;
	}


	function Get_Title()
	{
    	return self::$Title;
	}


	function Set_Title( $Value )
	{
	    self::$Title=$Value;
	}


	function Activate()
	{
	    Abstract_Error() ;
	}


	function Can_Change()
	{
	    Abstract_Error() ;
	    return false;
	}


	function Child( $Ordinal )
	{
	    Abstract_Error() ;
	    return NULL;
	}


	function Kill()
	{
	    Abstract_Error() ;
	}


	function Modify( $Data, $Size )
	{
	    Abstract_Error() ;
	    return NULL;
	}


	function Get_Context()
	{
 	   return self::$Context;
	}


	function Set_Context( $Value )
	{
	    self::$Context=$Value;
	}


	function Recursive()
	{
	    Abstract_Error() ;
	    return false ;
	}


	function Arbitrary_Length()
	{
	    Abstract_Error() ;
	    return false;
	}
} ; // TSDebug_Interface


class TDebug_Interface extends TSDebug_Interface
{	
};


class PDebug_Interface extends TDebug_Interface
{	
};


class PSDebug_Interface extends PDebug_Interface
{
};


class TCOM_Debug_Interface extends PSDebug_Interface
{	
};
