#        Program Name : _DebugIn
#        Package Name : Subroutine Library - Layer 0
#        Purpose      : Debugger Interface definitions
#        Institution  : Conroy & Conroy Co.
#        Date Written : 11-Jan-2001
#        Written By   : Alan Conroy
#        Version      : 1.0
#
#	    Copyright (C) 2001-2021 by Alan Conroy.  Released to the public domain.
#
#       TO THE GLORY OF GOD THROUGH JESUS CHRIST
#
#        *************************************************************
#        *                                                           *
#        *        M O D I F I C A T I O N   H I S T O R Y            *
#        *                                                           *
#        *************************************************************
#
#            DATE        BY          REASON
#
#        *************************************************************
#        *                                                           *
#        *        P R O G R A M   P U R P O S E                      *
#        *                                                           *
#        *************************************************************
#
#          TDebug_Interface is used when debugging code by providing a way of
#        examining the internals of the software component at run-time (for
#        production versions of software, this is often not supported).  The
#        interface assumes a hierarchical form with the root of a component
#        returning children representing internal objects.  Each of those objects
#        may have children, and so forth.

import _Common.php

# TSDebug_Interface methods...
class TSDebug_Interface(TObject):
        Context=0
        Title=''

        def Has_Children():
            Abstract_Error()
            return False


	# API...

        def Count():
            Abstract_Error()
            return 0

        def Get_Title():
            return self.Title


        def Set_Title( Value ):
            self.Title=Value


        def Activate():
            Abstract_Error()


        def Can_Change():
            Abstract_Error()
            return False


        def Child( Ordinal ):
            Abstract_Error() 


        def Kill():
            Abstract_Error()


        def Modify( Data, Size ):
            Abstract_Error()


        def Get_Context():
            return self.Context


        def Set_Context( Value ):
            self.Context=Value


        def Recursive():
            Abstract_Error()
            return False


        def Arbitrary_Length():
            Abstract_Error()
            return False


class TDebug_Interface(TSDebug_Interface):
    TDebug_Interface=0


class PDebug_Interface(TDebug_Interface):
    PDebug_Interface=0


class PSDebug_Interface(PDebug_Interface):
    _PSDebug_Interface=0
    

class TCOM_Debug_Interface(PSDebug_Interface):
    _TCOM_Debug_Interface=0
        
