{
        Program Name : _Deferred
        Package Name : Subroutine Library
        Purpose      : Deferred execution support
        Institution  : Conroy & Conroy Co.
        Date Written : 20-Jun-2015
        Written By   : Alan Conroy
        Version      : 1.0

	    Copyright (C) 2015 by Alan Conroy.  All rights reserved.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

        DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

        The TDeferred_Execution class is used to queue up "packets" of code for
        later execution.
}

unit _Deferred ;

interface

type TDeferred_Execution = class
                               public // API...
                                   procedure Execute( Context : pointer ) ;
                                       virtual ; abstract ;
                           end ;

type TDeferred_Manager = class
                             public // API...
                                 procedure Add( Item : TDeferred_Execution ;
                                     Context : pointer ) ; virtual ; abstract ;
                                 procedure Remove( Item : TDeferred_Execution ;
                                     Context : pointer ) ; virtual ; abstract ;
                                 procedure Remove_All( Item : TDeferred_Execution ) ;
                                     virtual ; abstract ;
                                 procedure Execute_Next ; virtual ; abstract ;
                                 function Index_Of( Item : TDeferred_Execution ;
                                     Context : pointer ) : integer ;
                                     virtual ; abstract ;
                                 function Index_Of_First( Item : TDeferred_Execution ) : integer ;
                                     virtual ; abstract ;
                                 function Empty : boolean ; virtual ; abstract ;
                         end ;

var Deferred_Manager : TDeferred_Manager = nil ;

implementation

end.

