/*
        Program Name : _GenVal
        Package Name : Subroutine Library - Layer 0
        Purpose      : Generic Value class definitions.
        Institution  : Conroy & Conroy Co.
        Date Written : 14-February-2005
        Written By   : Alan Conroy
        Version      : 1.0

        Copyright (C) 2005-2021 by Alan Conroy.  Released to the Public Domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          TGeneric_Value is a class that provides a generic value (ie variant).
        There are three intended uses for this (and associated) classes:
          1) RTTI support
          2) Compiler/debugger symbol support
          3) Uber-variant
*/

#include "_GenVal.hpp"

// TSGeneric_Parameter methods...

PSGeneric_Value TSGeneric_Parameter::Typ()
{
   	Abstract_Error() ;
    return NULL;
} ;


bool TSGeneric_Parameter::Output()
{
    Abstract_Error() ;
    return false;
} ;


bool TSGeneric_Parameter::Constant()
{
    Abstract_Error() ;
    return true;
} ;


TCall_Mechanism TSGeneric_Parameter::Mechanism()
{
    Abstract_Error() ;
    return CM_By_Value;
} ;


PSGeneric_Value TSGeneric_Parameter::_Default()
{
    Abstract_Error() ;
    return NULL;
} ;



// TSGeneric_Number methods...

bool TSGeneric_Number::Fixed()
{
    Abstract_Error() ;
    return true;
} ;


bool TSGeneric_Number::Signed()
{
    Abstract_Error() ;
    return true;
} ;


int32 TSGeneric_Number::Mantissa_Size()
{
    Abstract_Error() ;
    return 0;
} ;


int32 TSGeneric_Number::Exponent_Size()
{
    Abstract_Error() ;
    return 0;
} ;


int32 TSGeneric_Number::Fractional_Size()
{
    Abstract_Error() ;
    return 0;
} ;



// TSGeneric_Character methods...

int32 TSGeneric_Character::Max_Length()
{
    Abstract_Error() ;
    return 0;
} ;


bool TSGeneric_Character::Fixed()
{
    Abstract_Error() ;
    return true;
} ;


int32 TSGeneric_Character::Length()
{
    Abstract_Error() ;
    return 0;
} ;


int32 TSGeneric_Character::Logical_Length()
{
    Abstract_Error() ;
    return 0;
} ;



// TSGeneric_Collection methods...

bool TSGeneric_Collection::Fixed()
{
    Abstract_Error() ;
    return true;
} ;


bool TSGeneric_Collection::Sparse()
{
    Abstract_Error() ;
    return false;
} ;


int32 TSGeneric_Collection::Subscripts()
{
    Abstract_Error() ;
    return 0;
} ;


PSGeneric_Value TSGeneric_Collection::High_Bound( int32 Subscript )
{
    Abstract_Error() ;
    return NULL;
} ;


PSGeneric_Value TSGeneric_Collection::Low_Bound( int32 Subscript ) 
{
    Abstract_Error() ;
    return NULL;
} ;


PSGeneric_Value TSGeneric_Collection::Get_Subscript( int32 Address ) 
{
    Abstract_Error() ;
    return NULL;
} ;


bool TSGeneric_Collection::Row_Major()
{
    Abstract_Error() ;
    return true;
} ;



// TSGeneric_Composite methods...

TSGeneric_Value* TSGeneric_Composite::Ancestor( int32 index )
{
    Abstract_Error() ;
    return NULL;
} ;


int32 TSGeneric_Composite::Ancestor_Count()
{
    Abstract_Error() ;
    return 0;
} ;


TMethod_Class TSGeneric_Composite::Ancestor_Class( int32 Index )
{
    Abstract_Error() ;
    return MC_Private;
} ;


int32 TSGeneric_Composite::Count()
{
    Abstract_Error() ;
    return 0;
} ;


PSGeneric_Value TSGeneric_Composite::Get_Item( int32 Index ) 
{
    Abstract_Error() ;
    return NULL;
} ;



// TSGeneric_Method methods...

bool TSGeneric_Method::Is_Abstract()
{
    Abstract_Error() ;
    return false;
} ;


bool TSGeneric_Method::Is_Constructor()
{
    Abstract_Error() ;
    return false;
} ;


bool TSGeneric_Method::Is_Destructor()
{
    Abstract_Error() ;
    return false;
} ;


bool TSGeneric_Method::Is_Virtual()
{
    Abstract_Error() ;
    return false;
} ;


bool TSGeneric_Method::Static()
{
    Abstract_Error() ;
    return false;
} ;


bool TSGeneric_Method::C_Order()
{
    Abstract_Error() ;
    return false;
} ;


bool TSGeneric_Method::Standard()
{
    Abstract_Error() ;
    return true;
} ;


TSGeneric_Method* TSGeneric_Method::Execute( TSGeneric_Method* Parameters ) 
{
    Abstract_Error() ;
    return NULL;
} ;


bool TSGeneric_Method::Compile_Time()
{
    Abstract_Error() ;
    return false;
} ;


int32 TSGeneric_Method::Count()
{
    Abstract_Error() ;
    return 0;
} ;


int32 TSGeneric_Method::Max_Count()
{
    Abstract_Error() ;
    return 0;
} ;


PSGeneric_Value TSGeneric_Method::Parameter( int Index )
{
    Abstract_Error() ;
    return NULL;
} ;


bool TSGeneric_Method::Target()
{
    Abstract_Error() ;
    return false;
} ;


TMethod_Class TSGeneric_Method::Method_Class()
{
    Abstract_Error();
	return MC_Public;
} ;



// TSProperty_Information methods...

PSGeneric_Value TSProperty_Information::Getter()
{
    Abstract_Error() ;
    return NULL;
} ;


PSGeneric_Value TSProperty_Information::Setter()
{
    Abstract_Error() ;
    return NULL;
} ;


bool TSProperty_Information::_Default()
{
    Abstract_Error() ;
    return false;
} ;



// TSType_Information methods...

bool TSType_Information::Is_Composite()
{
    Abstract_Error() ;
    return false;
} ;


bool TSType_Information::Is_Collection()
{
    Abstract_Error() ;
    return false;
} ;


TMemory_Type TSType_Information::Memory_Type()
{
    Abstract_Error() ;
    return MT_Unknown;
} ;


PSGeneric_Parameter TSType_Information::Parameter()
{
    Abstract_Error() ;
    return NULL;
} ;


PSGeneric_Number TSType_Information::Numeric_Information()
{
    Abstract_Error() ;
    return NULL;
} ;


PSGeneric_Character TSType_Information::Character_Information()
{
    Abstract_Error() ;
    return NULL;
} ;


PSGeneric_Composite TSType_Information::Composite_Information()
{
    Abstract_Error() ;
    return NULL;
} ;


PSGeneric_Collection TSType_Information::Collection_Information()
{
    Abstract_Error() ;
    return NULL;
} ;


PSGeneric_Method TSType_Information::Method()
{
    Abstract_Error() ;
    return NULL;
} ;


PSProperty_Information TSType_Information::_Property()
{
    Abstract_Error() ;
    return NULL;
} ;


int32 TSType_Information::Address()
{
    Abstract_Error() ;
    return 0;
} ;


bool TSType_Information::Range_Limited()
{
    Abstract_Error() ;
    return false;
} ;


PSGeneric_Value TSType_Information::Low_Range()
{
    Abstract_Error() ;
    return NULL;
} ;


PSGeneric_Value TSType_Information::High_Range()
{
    Abstract_Error() ;
    return NULL;
} ;


string TSType_Information::Value_Name( int32 Value )
{
    Abstract_Error() ;
    string s = "";
	return s;
} ;



// TSGeneric_Value methods...

TData_Type_Family TSGeneric_Value::Family() 
{
    Abstract_Error() ;
    return DTF_Unknown;
} ;


TValue_Data_Type TSGeneric_Value::Data_Type()
{
    Abstract_Error() ;
    return VDT_Unknown;
} ;


string TSGeneric_Value::User_Data_Type_Name()
{
    Abstract_Error() ;
    string s = "";
    return s;
} ;


string TSGeneric_Value::Name() // Variable, type, method, or parameter name
{
    Abstract_Error() ;
    string s = "";
    return s;
} ;


PSType_Information TSGeneric_Value::Type_Information()
{
    Abstract_Error() ;
    return NULL;
} ;


bool TSGeneric_Value::Constant()
{
    Abstract_Error() ;
    return true;
} ;


int32 TSGeneric_Value::Size() // Size in bytes
{
    Abstract_Error() ;
    return 0;
} ;


int32 TSGeneric_Value::Total_Size()
{
    Abstract_Error() ;
    return 0;
} ;


PSGeneric_Value TSGeneric_Value::Dereference()
{
    Abstract_Error() ;
	return NULL;
} ;


bool TSGeneric_Value::Can_Convert( TValue_Data_Type Typ )
{
    Abstract_Error() ;
    return false;
} ;


PSGeneric_Value TSGeneric_Value::Convert( PSGeneric_Value Class_Type,
    bool &Loss )
{
    Abstract_Error() ;
    return NULL;
} ;


PSGeneric_Value TSGeneric_Value::_Clone()
{
    Abstract_Error() ;
    return NULL;
} ;


void TSGeneric_Value::Simple_Cast( TValue_Data_Type Typ )
{
    Abstract_Error() ;
} ;


void TSGeneric_Value::Cast( PSGeneric_Value Typ )
{
    Abstract_Error() ;
} ;


void TSGeneric_Value::Deserialize( char* Value )
{
    Abstract_Error() ;
} ;


char* TSGeneric_Value::Serialize()
{
    Abstract_Error() ;
    return NULL;
} ;


void TSGeneric_Value::Set_Null()
{
    Abstract_Error() ;
} ;


void TSGeneric_Value::Get_Undefined( void* Buffer, int32 Len )
{
    Abstract_Error() ;
} ;


void TSGeneric_Value::Set_Undefined( void* Buffer, int32 Len )
{
    Abstract_Error() ;
} ;


bool TSGeneric_Value::Get_Boolean()
{
    Abstract_Error() ;
    return false;
} ;


void TSGeneric_Value::Set_Boolean( bool B )
{
    Abstract_Error() ;
} ;


ByteBool TSGeneric_Value::Get_ByteBool()
{
    Abstract_Error() ;
    return false;
} ;


void TSGeneric_Value::Set_ByteBool( ByteBool B )
{
    Abstract_Error() ;
} ;


WordBool TSGeneric_Value::Get_WordBool()
{
    Abstract_Error() ;
    return false;
} ;


void TSGeneric_Value::Set_WordBool( WordBool B )
{
    Abstract_Error() ;
} ;


BOOL TSGeneric_Value::Get_LongBool()
{
    Abstract_Error() ;
    return false;
} ;


void TSGeneric_Value::Set_LongBool( BOOL B )
{
    Abstract_Error() ;
} ;


char TSGeneric_Value::Get_Char()
{
    Abstract_Error() ;
    return '\0';
} ;


void TSGeneric_Value::Set_Char( char C )
{
    Abstract_Error() ;
} ;


string TSGeneric_Value::Get_String()
{
    Abstract_Error() ;
    string s = "";
    return s;
} ;


void TSGeneric_Value::Set_String( const string S )
{
   	Abstract_Error() ;
} ;


char* TSGeneric_Value::Get_PChar()
{
   	Abstract_Error() ;
   	return NULL;
} ;


void TSGeneric_Value::Set_PChar( char* P )
{
    Abstract_Error() ;
} ;


int8 TSGeneric_Value::Get_Integer8()
{
    Abstract_Error() ;
    return 0;
} ;


void TSGeneric_Value::Set_Integer8( int8 I )
{
    Abstract_Error() ;
} ;


int16 TSGeneric_Value::Get_Integer16()
{
    Abstract_Error() ;
    return 0;
} ;


void TSGeneric_Value::Set_Integer16( int16 I )
{
    Abstract_Error() ;
} ;


int32 TSGeneric_Value::Get_Integer32()
{
    Abstract_Error() ;
    return 0;
} ;


void TSGeneric_Value::Set_Integer32( int32 I )
{
    Abstract_Error() ;
} ;


int64 TSGeneric_Value::Get_Integer64()
{
    Abstract_Error() ;
    return 0;
} ;


void TSGeneric_Value::Set_Integer64( int64 I )
{
    Abstract_Error() ;
} ;


uint8 TSGeneric_Value::Get_Unsigned_Integer8()
{
   	Abstract_Error() ;
   	return 0;
} ;


void TSGeneric_Value::Set_Unsigned_Integer8( uint8 I )
{
    Abstract_Error() ;
} ;


uint16 TSGeneric_Value::Get_Unsigned_Integer16()
{
    Abstract_Error() ;
    return 0;
} ;


void TSGeneric_Value::Set_Unsigned_Integer16( uint16 I )
{
    Abstract_Error() ;
} ;


uint32 TSGeneric_Value::Get_Unsigned_Integer32()
{
    Abstract_Error() ;
    return 0;
} ;


void TSGeneric_Value::Set_Unsigned_Integer32( uint32 I )
{
    Abstract_Error() ;
} ;


float TSGeneric_Value::Get_Single()
{
   	Abstract_Error() ;
    return 0.0;
} ;


void TSGeneric_Value::Set_Single( float S )
{
    Abstract_Error() ;
} ;


double TSGeneric_Value::Get_Double()
{
    Abstract_Error() ;
    return 0.0;
} ;


void TSGeneric_Value::Set_Double( double D )
{
    Abstract_Error() ;
} ;


long double TSGeneric_Value::Get_Extended()
{
    Abstract_Error() ;
    return 0.0;
} ;


void TSGeneric_Value::Set_Extended( long double E )
{
    Abstract_Error() ;
} ;
