{
        Program Name : _ObjectF
        Package Name : Subroutine Library - Layer 0
        Purpose      : Abstract Object Factory class
        Institution  : Conroy & Conroy Co.
        Date Written : 19-Feb-2005
        Written By   : Alan Conroy
        Version      : 1.0

        Copyright (C) 2005 by Alan Conroy.  Released to the public domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          TSObject_Factory is an abstract base class for classes which provide
        an indirect way of creating certain "standard" Subroutine Library
        classes.
}

unit _ObjectF ;

interface

{$I EDEFINES.INC}

uses { Subroutine library... }
     _Common, { TObject }
     _GenVal, { TGeneric_Value }
     _NameVal, { TNamned_Values }
     _Propert ; { PSDynamic_Properties }

type TSObject_Factory = object( TObject )
                            public
                                function Static_Dynamic_Properties : PSDynamic_Properties ;
                                    virtual ;
                                function Static_Generic_Value : PSGeneric_Value ;
                                    virtual ;
                                function Static_Named_Values : PSNamed_Values ;
                                    virtual ;
{$IFDEF DYNAMIC_OBJECTS}
                                function COM_Dynamic_Properties : TCOM_Dynamic_Properties ;
                                    virtual ;
                                function Dynamic_Properties : TDynamic_Properties ;
                                    virtual ;

                                function COM_Named_Values( Set_Name : string ;
                                    Create : boolean ) : TCOM_Named_Values ;
                                    virtual ;
                                function Named_Values( Set_Name : string ;
                                    Create : boolean ) : TNamed_Values ;
                                    virtual ;

                                function COM_Generic_Value : TCOM_Generic_Value ;
                                    virtual ;
                                function Generic_Value : TGeneric_Value ;
                                    virtual ;
{$ENDIF}
                        end ;
     PSObject_Factory = ^TSObject_Factory ;

var Object_Factory : PSObject_Factory
{$IFDEF VARIABLE_DECLARATION_ASSIGN}
    = nil
{$ENDIF}
    ;

implementation

{ PSObject_Factory methods... }

function TSObject_Factory.Static_Dynamic_Properties : PSDynamic_Properties ;

begin
    Static_Dynamic_Properties := nil ;
    Abstract_Error ;
end ;


{$IFDEF DYNAMIC_OBJECTS}
function TSObject_Factory.COM_Dynamic_Properties : TCOM_Dynamic_Properties ;

begin
    COM_Dynamic_Properties := nil ;
    Abstract_Error ;
end ;


function TSObject_Factory.Dynamic_Properties : TDynamic_Properties ;

begin
    Dynamic_Properties := nil ;
    Abstract_Error ;
end ;
{$ENDIF}


function TSObject_Factory.Static_Generic_Value : PSGeneric_Value ;

begin
    Static_Generic_Value := nil ;
    Abstract_Error ;
end ;


function TSObject_Factory.Static_Named_Values : PSNamed_Values ;

begin
    Static_Named_Values := nil ;
    Abstract_Error ;
end ;


{$IFDEF DYNAMIC_OBJECTS}
function TSObject_Factory.COM_Generic_Value : TCOM_Generic_Value ;

begin
    COM_Generic_Value := nil ;
    Abstract_Error ;
end ;


function TSObject_Factory.Generic_Value : TGeneric_Value ;

begin
    Generic_Value := nil ;
    Abstract_Error ;
end ;


function TSObject_Factory.COM_Named_Values( Set_Name : string ; Create : boolean ) : TCOM_Named_Values ;

begin
    COM_Named_Values := nil ;
    Abstract_Error ;
end ;


function TSObject_Factory.Named_Values( Set_Name : string ; Create : boolean ) : TNamed_Values ;

begin
    Named_Values := nil ;
    Abstract_Error ;
end ;
{$ENDIF}



{$IFNDEF VARIABLE_DECLARATION_ASSIGN}
begin
    Object_Factory := nil ;
{$ENDIF}
end.
