{
        Program Name : _RPG_Character
        Package Name :
        Purpose      : Generic RPG abstract character object
        Institution  : Conroy & Conroy Co.
        Date Written : 01-Aug-1999
        Written By   : Alan Conroy
        Version      : 1.0

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

	  This unit defines the TCharacter and related classes.
}

unit _RPG_Character ;

interface

uses // Borland...
     Classes, // TStringList
     Windows, // HBitmap

     // C&C Subroutine Library - Layer 0...
     COMInter ; // TCommon_COM_Interface

type TString_List = class( TStringList )
                        private // Instance data...
                            Reference_Count : cardinal ;

                        public // API...
                            procedure Attach ; virtual ; stdcall ;
                            procedure Detach ; virtual ; stdcall ;
                    end ;

type TCharacteristic = class( TCommon_COM_Interface )
                           public // API...
                               function Name : PAnsiChar ;
                                   virtual ; stdcall ; abstract ;
                               function Get_Value : PAnsiChar ;
                                   virtual ; stdcall ; abstract ;
                               procedure Set_Value( Value : PAnsiChar ) ;
                                   virtual ; stdcall ; abstract ;
                               function Length : integer ;
                                   virtual ; stdcall ; abstract ;
                               function Flags : cardinal ;
                                   virtual ; stdcall ; abstract ;
                               function Get_List : TString_List ;
                                   virtual ; stdcall ; abstract ;
                               procedure Set_List( Value : TString_List ) ;
                                   virtual ; stdcall ; abstract ;
                               function Get_Index : integer ;
                                   virtual ; stdcall ; abstract ;
                               procedure Set_Index( Value : integer ) ;
                                   virtual ; stdcall ; abstract ;
                               function Serialize : PAnsiChar ;
                                   virtual ; stdcall ; abstract ;
                               procedure Deserialize( Buffer : PAnsiChar ) ;
                                   virtual ; stdcall ; abstract ;

                           public // Properties...
                               property _Index : integer
                                   read Get_Index
                                   write Set_Index ;
                               property List : TString_List
                                   read Get_List
                                   write Set_List ;
                               property Value : PAnsiChar
                                   read Get_Value
                                   write Set_Value ;
                       end ; // TCharacteristic

     TCharacter = class ;
     TItem = class
                 public
                     function Get_Name : PAnsiChar ; virtual ; stdcall ; abstract ;
                     procedure Set_Name( Value : PAnsiChar ) ;
                         virtual ; stdcall ; abstract ;
                     function Serialize : PAnsiChar ;
                         virtual ; stdcall ; abstract ;
                     procedure Deserialize( Buffer : PAnsiChar ) ;
                         virtual ; stdcall ; abstract ;

                     property Name : PAnsiChar
                         read Get_Name
                         write Set_Name ;
             end ;
     TEffect = class( TCommon_COM_Interface )
                   public
                       function Get_Name : PAnsiChar ; virtual ; stdcall ; abstract ;
                       procedure Set_Name( Value : PAnsiChar ) ;
                           virtual ; stdcall ; abstract ;
                       function Serialize : PAnsiChar ;
                           virtual ; stdcall ; abstract ;
                       procedure Deserialize( Buffer : PAnsiChar ) ;
                           virtual ; stdcall ; abstract ;
                       function Advance( Time_Index : int64 ;
                           C : TCharacter ) : boolean ;
                           virtual ; stdcall ; abstract ;

                       property Name : PAnsiChar
                           read Get_Name
                           write Set_Name ;
               end ;
               
     TGender = ( Gender_Male, Gender_Female ) ;

     TItem_Manager = class( TCommon_COM_Interface )
                         public
                             procedure Clear ;
                                 virtual ; stdcall ; abstract ;
                             function Count : longint ;
                                 virtual ; stdcall ; abstract ;
                             function Get_Item( Index : integer ) : TItem ;
                                 virtual ; stdcall ; abstract ;
                             procedure Set_Item( Index : integer ; Value : TItem ) ;
                                 virtual ; stdcall ; abstract ;
                             function Add( Item : TItem ) : longint ; overload ;
                                 virtual ; stdcall ; abstract ;
                             function Add( Name : PAnsiChar ) : longint ; overload ;
                                 virtual ; stdcall ; abstract ;
                             procedure Remove( Name : PAnsiChar ) ;
                                 virtual ; stdcall ; abstract ;
                             function Serialize : PAnsiChar ;
                                 virtual ; stdcall ; abstract ;
                             procedure Deserialize( Buffer : PAnsiChar ) ;
                                 virtual ; stdcall ; abstract ;
                             function Create_Item( Name : PAnsiChar ) : TItem ;
                                 virtual ; stdcall ; abstract ;

                             property Items[ Index : integer ] : TItem
                                 read Get_Item
                                 write Set_Item ;
                     end ;

     TEffect_Manager = class( TCommon_COM_Interface )
                           public
                               procedure Clear ; virtual ; stdcall ; abstract ;
                               function Count : longint ;
                                   virtual ; stdcall ; abstract ;
                               function Get_Effect( Index : integer ) : TEffect ;
                                   virtual ; stdcall ; abstract ;
                               procedure Set_Effect( Index : integer ; Value : TEffect ) ;
                                   virtual ; stdcall ; abstract ;
                               function Add_Effect( Effect : TEffect ) : longint ;
                                   virtual ; stdcall ; abstract ;
                               function Add_Name( Name : PAnsiChar ) : longint ;
                                   virtual ; stdcall ; abstract ;
                               procedure Advance( Target : TCharacter ) ;
                                   virtual ; stdcall ; abstract ;
                               procedure Remove( Name : PAnsiChar ) ;
                                   virtual ; stdcall ; abstract ;
                               function Serialize : PAnsiChar ;
                                   virtual ; stdcall ; abstract ;
                               procedure Deserialize( Buffer : PAnsiChar ) ;
                                   virtual ; stdcall ; abstract ;
                               function Get_Effect_Library : TString_List ;
                                   virtual ; stdcall ; abstract ;
                               function Create_Effect( Name : PAnsiChar ) : TEffect ;
                                   virtual ; stdcall ; abstract ;

                               property Effects[ Index : integer ] : TEffect
                                   read Get_Effect
                                   write Set_Effect ;
                       end ;

     TCharacter_Object = class ;

     TCharacter = class( TCommon_COM_Interface ) // All reality character types descend from this
         public
             function Get_Bitmap : HBitmap ; virtual ; stdcall ; abstract ;
             procedure Set_Bitmap( Value : HBitmap ) ;
                 virtual ; stdcall ; abstract ;
             function Get_Object : TCharacter_Object ;
                 virtual ; stdcall ; abstract ;
             procedure Set_Object( Value : TCharacter_Object ) ;
                 virtual ; stdcall ; abstract ;

             procedure Assign( Instance : TCharacter ) ;
                 virtual ; stdcall ; abstract ;
             function Name_Matches( X : PAnsiChar ) : boolean ;
                 virtual ; stdcall ; abstract ;
             function Serialize : PAnsiChar ; virtual ; stdcall ; abstract ;
             procedure Deserialize( Buffer : PAnsiChar ) ;
                 virtual ; stdcall ; abstract ;
             function Get_Gender : TGender ; virtual ; stdcall ; abstract ;
             procedure Set_Gender( Value : TGender ) ;
                 virtual ; stdcall ; abstract ;
             function Get_Name : PAnsiChar ; virtual ; stdcall ; abstract ;
             procedure Set_Name( Value : PAnsiChar ) ; virtual ; stdcall ; abstract ;
             function Description : PAnsiChar ; virtual ; stdcall ; abstract ;
             function Status : PAnsiChar ; virtual ; stdcall ; abstract ;
             function Item_Manager : TItem_Manager ;
                 virtual ; stdcall ; abstract ;
             function Effect_Manager : TEffect_Manager ;
                 virtual ; stdcall ; abstract ;

         public // Characteristics...
             function Get_Characteristic_By_Name( Name : PAnsiCHar ) : TCharacteristic ;
                 virtual ; stdcall ; abstract ;
             // Return a characteristic by matching Name (nil if not found)

             function Get_Characteristic( Index : integer ) : TCharacteristic ;
                 virtual ; stdcall ; abstract ;
             // Get characteric by index. Returns nil if Index is out of range

             function Add_Characteristic( Value : TCharacteristic ) : integer ;
                 virtual ; stdcall ; abstract ;
             // Add a custom characteristic,  Returns index of inserted
             // characteristic.  Returns -1 if already have a matching
             // characteristic name

             function Set_Characteristic( Index : integer ; Value : PAnsiChar ;
                 Length : integer ) : integer ; virtual ; stdcall ; abstract ;
             // Set Value of a characteristic.  Returns 0 on success,
             // <>0 on validation error

             function Set_Characteristic_List( Index : integer ;
                 List : TString_List ) : integer ; virtual ; stdcall ; abstract ;
             // Assign list type characteristic values

         public // Properties...
             property Bitmap : HBITMAP
                 read Get_Bitmap
                 write Set_Bitmap ;
             property Name : PAnsiChar
                 read Get_Name
                 write Set_Name ;
             property _Object : TCharacter_Object
                 read Get_Object
                 write Set_Object ;
             property Gender : TGender
                 read Get_Gender
                 write Set_Gender ;
     end ; // TCharacter

     TCharacter_Object = class
                             protected // Property handlers...
                                 function Get_Data : PAnsiChar ;
                                     virtual ; stdcall ; abstract ;
                                 function Get_Is_Party_Member : boolean ;
                                     virtual ; stdcall ; abstract ;
                                 procedure Set_Data( Value : PAnsiChar ) ;
                                     virtual ; stdcall ; abstract ;
                                 procedure Set_Is_Party_Member( Value : boolean ) ;
                                     virtual ; stdcall ; abstract ;
                                 function Get_Character : TCharacter ;
                                     virtual ; stdcall ; abstract ;
                                 procedure Set_Character( Value : TCharacter ) ;
                                     virtual ; stdcall ; abstract ;

                             public // API...
                                 property Character : TCharacter
                                     read Get_Character
                                     write Set_Character ;
                                 property Data : PAnsiChar
                                     read Get_Data
                                     write Set_Data ;

                                 procedure Terminate ;
                                     virtual ; stdcall ; abstract ;
                        end ;

// Characteristic flags...
const CF_Type_Mask = 7 ;

const CFT_NA = 0 ; // Unused/not applicable/ignore
      CFT_Group = 1 ; // Value = # objects in group
      CFT_String = 2 ;
      CFT_Integer = 3 ;
      CFT_Ordinal = 4 ; // Value from List
      CFT_List = 5 ; // The value is the List
      CFT_Real = 6 ; // Floating-point number
      CFT_Reserved = 7 ; // Reserved for future use

const CF_Custom = 8 ; // Should be set for anything user adds
      CF_Next = 16 ; // Next characteristic is "part" of this characterstic (like 18/00 strength)


implementation

procedure TString_List.Attach ;

begin
    inc( Reference_Count ) ;
end ;


procedure TString_List.Detach ;

begin
    dec( Reference_Count ) ;
    if( Reference_Count <= 0 ) then
    begin
        Free ;
    end ;
end ;



end.
