/*
        Program Name : _UE
        Package Name : Subroutine Library - Layer 0
        Purpose      : UE definitions
        Institution  : Conroy & Conroy Co.
        Date Written : 9-Feb-2013
        Last Modified:
        Written By   : Alan Conroy
        Version      : 1.0

        Copyright (C) 2013-2021 by Alan Conroy.  Released to the public domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

	  This unit provides definitions for UE (Unified Exceptions).
*/

#ifndef _UE_HPP
	#define _UE_HPP
	
#include "_DebugIn.hpp"
#include <string>

using namespace std;

class tUnified_Exception
{
	public:
		virtual TDebug_Interface __stdcall *Initialize() = 0 ;
		virtual void __stdcall Terminate() = 0 ;
		virtual void __stdcall Attach() = 0 ;
		virtual void __stdcall Detach() = 0 ;
		virtual bool __stdcall Is_Class( char* Name ) = 0 ;
		virtual long __stdcall Interface_Version() = 0 ;
		virtual long __stdcall Get_Facility() = 0 ;
		virtual long __stdcall Get_Facility_Version() = 0 ;
		virtual long __stdcall Version() = 0 ;
		virtual TDebug_Interface __stdcall *Debugger() = 0 ;
		virtual long __stdcall Severity() = 0 ;
		virtual char* __stdcall Error_Text( long &Size, long &Typ ) = 0 ;
		virtual long __stdcall Get_Error() = 0 ;
		virtual TDebug_Interface __stdcall *Get_Previous() = 0 ;
		virtual void __stdcall Free() = 0;
		long __stdcall Facility() {return Get_Facility();} ;
		long __stdcall Facility_Version() {return Get_Facility_Version();} ;
		long __stdcall Code() {return Get_Error();}
} ; // TUnified_Exception

class tSUnified_Exception
{
	public:
		virtual TDebug_Interface *Initialize() = 0 ;
		virtual void Terminate() = 0 ;
		virtual void Attach() = 0 ;
		virtual void Detach() = 0 ;
		virtual bool Is_Class( char* Name ) = 0 ;
		virtual long Interface_Version() = 0 ;
		virtual long Get_Facility() = 0 ;
		virtual long Get_Facility_Version() = 0 ;
		virtual long Version() = 0 ;
		virtual TDebug_Interface *Debugger() = 0 ;
		virtual long Severity() = 0 ;
		virtual string Error_Text( long &Size, long &Typ ) = 0 ;
		virtual long Get_Error() = 0 ;
		virtual TDebug_Interface *Get_Previous() = 0 ;
		virtual void Free() = 0;
		long Facility() {return Get_Facility();} ;
		long Facility_Version() {return Get_Facility_Version();} ;
		long Code() {return Get_Error();}
} ; // TUnified_Exception

void Fatal_Error(tUnified_Exception *E);
#endif
