<?php
/*
        Program Name : _UE
        Package Name : Subroutine Library - Layer 0
        Purpose      : UE definitions
        Institution  : Conroy & Conroy Co.
        Date Written : 9-Feb-2013
        Last Modified:
        Written By   : Alan Conroy
        Version      : 1.0

        Copyright (C) 2014 by Alan Conroy.  Released to the public domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

	  This unit provides definitions for UE (Unified Exceptions).
*/

require_once('EDEFINES.INC');
require_once('_common.php');

define('UE_Success',0) ;
define('UE_Informational',1) ;
define('UE_Warning',2) ;
define('UE_Error',3) ;
define('UE_Fatal',4) ;


// Log a fatal error - for cases where a non-class function has an exception
function Fatal_Error( $E )
{
    $S = $E->Error_Text( $_S, $_T ) ;
    throw new Exception( $S ) ;
}



// tError_Interface methods...
class tUnified_Exception extends TObject
{
	public function Get_Facility()
	{
	    self::Abstract_Error() ;
	}


	public function Get_Facility_Version()
	{
	    self::Abstract_Error() ;
	}


	public function Version()
	{
	    return 10 ; // Complies with 1.0 of the Unified Exception specification
	}


	public function Severity()
	{
	    self::Abstract_Error() ;
	}


	public function Error_Text( &$Size, &$Typ )
	{
	    self::Abstract_Error() ;
	}


	public function Get_Error()
	{
	    self::Abstract_Error() ;
	}


	public function Get_Previous()
	{
	    return '';
	}


	public function Terminate()
	{
	    // Does nothing.  Exists solely for overrides.
	}


	public function Free()
	{
	    self::Terminate() ;
	}


	public function Facility()
	{
		return Get_Facility();
	}


	public function Facility_Version()
	{
		return Get_Facility_Version();
	}


	public function Code()
	{
		return Get_Error();
	}
} // tUnified_Exception


class tsUnified_Exception extends tUnified_Exception {};
