{
        Program Name : _Unicode
        Package Name : Subroutine Library
        Purpose      : Unicode support routines
        Institution  : Conroy & Conroy Co.
        Date Written : 2-Jan-2016
        Written By   : Alan Conroy
        Version      : 1.0

    	Copyright (C) 2016 by Alan Conroy.  All rights reserved.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

        DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

        Unicode support...
}

unit _Unicode ;

interface

// Text types
const TT_ASCII7 = 0 ; // ASCII, 7 bit
const TT_ASCII8 = 1 ; // ASCII, 8 bit
const TT_Unicode16 = 2 ; // Unicode-16
const TT_UTF8 = 3 ; // Unicode UTF8
const TT_Unicode32 = 4 ; // Unicode-32

const Foldings : array[ 0..1320, 0..3 ] of cardinal =
      (
        ( $41, $61, 0, 0 ), // 65 "A"
        ( $42, $62, 0, 0 ),
        ( $43, $63, 0, 0 ),
        ( $44, $64, 0, 0 ),
        ( $45, $65, 0, 0 ),
        ( $46, $66, 0, 0 ),
        ( $47, $67, 0, 0 ),
        ( $48, $68, 0, 0 ),
        ( $49, $69, 0, 0 ),
        ( $4A, $6A, 0, 0 ),
        ( $4B, $6B, 0, 0 ),
        ( $4C, $6C, 0, 0 ),
        ( $4D, $6D, 0, 0 ),
        ( $4E, $6E, 0, 0 ),
        ( $4F, $6F, 0, 0 ),
        ( $50, $70, 0, 0 ),
        ( $51, $71, 0, 0 ),
        ( $52, $72, 0, 0 ),
        ( $53, $73, 0, 0 ),
        ( $54, $74, 0, 0 ),
        ( $55, $75, 0, 0 ),
        ( $56, $76, 0, 0 ),
        ( $57, $77, 0, 0 ),
        ( $58, $78, 0, 0 ),
        ( $59, $79, 0, 0 ),
        ( $5A, $7A, 0, 0 ), // "Z"
        ( $B5, $3BC, 0, 0 ),
        ( $C0, $E0, 0, 0 ),
        ( $C1, $E1, 0, 0 ),
        ( $C2, $E2, 0, 0 ),
        ( $C3, $E3, 0, 0 ),
        ( $C4, $E4, 0, 0 ),
        ( $C5, $E5, 0, 0 ),
        ( $C6, $E6, 0, 0 ),
        ( $C7, $E7, 0, 0 ),
        ( $C8, $E8, 0, 0 ),
        ( $C9, $E9, 0, 0 ),
        ( $CA, $EA, 0, 0 ),
        ( $CB, $EB, 0, 0 ),
        ( $CC, $EC, 0, 0 ),
        ( $CD, $ED, 0, 0 ),
        ( $CE, $EE, 0, 0 ),
        ( $CF, $EF, 0, 0 ),
        ( $D0, $F0, 0, 0 ),
        ( $D1, $F1, 0, 0 ),
        ( $D2, $F2, 0, 0 ),
        ( $D3, $F3, 0, 0 ),
        ( $D4, $F4, 0, 0 ),
        ( $D5, $F5, 0, 0 ),
        ( $D6, $F6, 0, 0 ),
        ( $D8, $F8, 0, 0 ),
        ( $D9, $F9, 0, 0 ),
        ( $DA, $FA, 0, 0 ),
        ( $DB, $FB, 0, 0 ),
        ( $DC, $FC, 0, 0 ),
        ( $DD, $FD, 0, 0 ),
        ( $DE, $FE, 0, 0 ),
        ( $DF, $73, $73, 0 ),
        ( $100, $101, 0, 0 ),
        ( $102, $103, 0, 0 ),
        ( $104, $105, 0, 0 ),
        ( $106, $107, 0, 0 ),
        ( $108, $109, 0, 0 ),
        ( $10A, $10B, 0, 0 ),
        ( $10C, $10D, 0, 0 ),
        ( $10E, $10F, 0, 0 ),
        ( $110, $111, 0, 0 ),
        ( $112, $113, 0, 0 ),
        ( $114, $115, 0, 0 ),
        ( $116, $117, 0, 0 ),
        ( $118, $119, 0, 0 ),
        ( $11A, $11B, 0, 0 ),
        ( $11C, $11D, 0, 0 ),
        ( $11E, $11F, 0, 0 ),
        ( $120, $121, 0, 0 ),
        ( $122, $123, 0, 0 ),
        ( $124, $125, 0, 0 ),
        ( $126, $127, 0, 0 ),
        ( $128, $129, 0, 0 ),
        ( $12A, $12B, 0, 0 ),
        ( $12C, $12D, 0, 0 ),
        ( $12E, $12F, 0, 0 ),
        ( $130, $69, $307, 0 ),
        ( $132, $133, 0, 0 ),
        ( $134, $135, 0, 0 ),
        ( $136, $137, 0, 0 ),
        ( $139, $13A, 0, 0 ),
        ( $13B, $13C, 0, 0 ),
        ( $13D, $13E, 0, 0 ),
        ( $13F, $140, 0, 0 ),
        ( $141, $142, 0, 0 ),
        ( $143, $144, 0, 0 ),
        ( $145, $146, 0, 0 ),
        ( $147, $148, 0, 0 ),
        ( $149, $2BC, $6E, 0 ),
        ( $14A, $14B, 0, 0 ),
        ( $14C, $14D, 0, 0 ),
        ( $14E, $14F, 0, 0 ),
        ( $150, $151, 0, 0 ),
        ( $152, $153, 0, 0 ),
        ( $154, $155, 0, 0 ),
        ( $156, $157, 0, 0 ),
        ( $158, $159, 0, 0 ),
        ( $15A, $15B, 0, 0 ),
        ( $15C, $15D, 0, 0 ),
        ( $15E, $15F, 0, 0 ),
        ( $160, $161, 0, 0 ),
        ( $162, $163, 0, 0 ),
        ( $164, $165, 0, 0 ),
        ( $166, $167, 0, 0 ),
        ( $168, $169, 0, 0 ),
        ( $16A, $16B, 0, 0 ),
        ( $16C, $16D, 0, 0 ),
        ( $16E, $16F, 0, 0 ),
        ( $170, $171, 0, 0 ),
        ( $172, $173, 0, 0 ),
        ( $174, $175, 0, 0 ),
        ( $176, $177, 0, 0 ),
        ( $178, $FF, 0, 0 ),
        ( $179, $17A, 0, 0 ),
        ( $17B, $17C, 0, 0 ),
        ( $17D, $17E, 0, 0 ),
        ( $17F, $73, 0, 0 ),
        ( $181, $253, 0, 0 ),
        ( $182, $183, 0, 0 ),
        ( $184, $185, 0, 0 ),
        ( $186, $254, 0, 0 ),
        ( $187, $188, 0, 0 ),
        ( $189, $256, 0, 0 ),
        ( $18A, $257, 0, 0 ),
        ( $18B, $18C, 0, 0 ),
        ( $18E, $1DD, 0, 0 ),
        ( $18F, $259, 0, 0 ),
        ( $190, $25B, 0, 0 ),
        ( $191, $192, 0, 0 ),
        ( $193, $260, 0, 0 ),
        ( $194, $263, 0, 0 ),
        ( $196, $269, 0, 0 ),
        ( $197, $268, 0, 0 ),
        ( $198, $199, 0, 0 ),
        ( $19C, $26F, 0, 0 ),
        ( $19D, $272, 0, 0 ),
        ( $19F, $275, 0, 0 ),
        ( $1A0, $1A1, 0, 0 ),
        ( $1A2, $1A3, 0, 0 ),
        ( $1A4, $1A5, 0, 0 ),
        ( $1A6, $280, 0, 0 ),
        ( $1A7, $1A8, 0, 0 ),
        ( $1A9, $283, 0, 0 ),
        ( $1AC, $1AD, 0, 0 ),
        ( $1AE, $288, 0, 0 ),
        ( $1AF, $1B0, 0, 0 ),
        ( $1B1, $28A, 0, 0 ),
        ( $1B2, $28B, 0, 0 ),
        ( $1B3, $1B4, 0, 0 ),
        ( $1B5, $1B6, 0, 0 ),
        ( $1B7, $292, 0, 0 ),
        ( $1B8, $1B9, 0, 0 ),
        ( $1BC, $1BD, 0, 0 ),
        ( $1C4, $1C6, 0, 0 ),
        ( $1C5, $1C6, 0, 0 ),
        ( $1C7, $1C9, 0, 0 ),
        ( $1C8, $1C9, 0, 0 ),
        ( $1CA, $1CC, 0, 0 ),
        ( $1CB, $1CC, 0, 0 ),
        ( $1CD, $1CE, 0, 0 ),
        ( $1CF, $1D0, 0, 0 ),
        ( $1D1, $1D2, 0, 0 ),
        ( $1D3, $1D4, 0, 0 ),
        ( $1D5, $1D6, 0, 0 ),
        ( $1D7, $1D8, 0, 0 ),
        ( $1D9, $1DA, 0, 0 ),
        ( $1DB, $1DC, 0, 0 ),
        ( $1DE, $1DF, 0, 0 ),
        ( $1E0, $1E1, 0, 0 ),
        ( $1E2, $1E3, 0, 0 ),
        ( $1E4, $1E5, 0, 0 ),
        ( $1E6, $1E7, 0, 0 ),
        ( $1E8, $1E9, 0, 0 ),
        ( $1EA, $1EB, 0, 0 ),
        ( $1EC, $1ED, 0, 0 ),
        ( $1EE, $1EF, 0, 0 ),
        ( $1F0, $6A, $30C, 0 ),
        ( $1F1, $1F3, 0, 0 ),
        ( $1F2, $1F3, 0, 0 ),
        ( $1F4, $1F5, 0, 0 ),
        ( $1F6, $195, 0, 0 ),
        ( $1F7, $1BF, 0, 0 ),
        ( $1F8, $1F9, 0, 0 ),
        ( $1FA, $1FB, 0, 0 ),
        ( $1FC, $1FD, 0, 0 ),
        ( $1FE, $1FF, 0, 0 ),
        ( $200, $201, 0, 0 ),
        ( $202, $203, 0, 0 ),
        ( $204, $205, 0, 0 ),
        ( $206, $207, 0, 0 ),
        ( $208, $209, 0, 0 ),
        ( $20A, $20B, 0, 0 ),
        ( $20C, $20D, 0, 0 ),
        ( $20E, $20F, 0, 0 ),
        ( $210, $211, 0, 0 ),
        ( $212, $213, 0, 0 ),
        ( $214, $215, 0, 0 ),
        ( $216, $217, 0, 0 ),
        ( $218, $219, 0, 0 ),
        ( $21A, $21B, 0, 0 ),
        ( $21C, $21D, 0, 0 ),
        ( $21E, $21F, 0, 0 ),
        ( $220, $19E, 0, 0 ),
        ( $222, $223, 0, 0 ),
        ( $224, $225, 0, 0 ),
        ( $226, $227, 0, 0 ),
        ( $228, $229, 0, 0 ),
        ( $22A, $22B, 0, 0 ),
        ( $22C, $22D, 0, 0 ),
        ( $22E, $22F, 0, 0 ),
        ( $230, $231, 0, 0 ),
        ( $232, $233, 0, 0 ),
        ( $23A, $2C65, 0, 0 ),
        ( $23B, $23C, 0, 0 ),
        ( $23D, $19A, 0, 0 ),
        ( $23E, $2C66, 0, 0 ),
        ( $241, $242, 0, 0 ),
        ( $243, $180, 0, 0 ),
        ( $244, $289, 0, 0 ),
        ( $245, $28C, 0, 0 ),
        ( $246, $247, 0, 0 ),
        ( $248, $249, 0, 0 ),
        ( $24A, $24B, 0, 0 ),
        ( $24C, $24D, 0, 0 ),
        ( $24E, $24F, 0, 0 ),
        ( $345, $3B9, 0, 0 ),
        ( $370, $371, 0, 0 ),
        ( $372, $373, 0, 0 ),
        ( $376, $377, 0, 0 ),
        ( $37F, $3F3, 0, 0 ),
        ( $386, $3AC, 0, 0 ),
        ( $388, $3AD, 0, 0 ),
        ( $389, $3AE, 0, 0 ),
        ( $38A, $3AF, 0, 0 ),
        ( $38C, $3CC, 0, 0 ),
        ( $38E, $3CD, 0, 0 ),
        ( $38F, $3CE, 0, 0 ),
        ( $390, $3B9, $308, $301 ),
        ( $391, $3B1, 0, 0 ),
        ( $392, $3B2, 0, 0 ),
        ( $393, $3B3, 0, 0 ),
        ( $394, $3B4, 0, 0 ),
        ( $395, $3B5, 0, 0 ),
        ( $396, $3B6, 0, 0 ),
        ( $397, $3B7, 0, 0 ),
        ( $398, $3B8, 0, 0 ),
        ( $399, $3B9, 0, 0 ),
        ( $39A, $3BA, 0, 0 ),
        ( $39B, $3BB, 0, 0 ),
        ( $39C, $3BC, 0, 0 ),
        ( $39D, $3BD, 0, 0 ),
        ( $39E, $3BE, 0, 0 ),
        ( $39F, $3BF, 0, 0 ),
        ( $3A0, $3C0, 0, 0 ),
        ( $3A1, $3C1, 0, 0 ),
        ( $3A3, $3C3, 0, 0 ),
        ( $3A4, $3C4, 0, 0 ),
        ( $3A5, $3C5, 0, 0 ),
        ( $3A6, $3C6, 0, 0 ),
        ( $3A7, $3C7, 0, 0 ),
        ( $3A8, $3C8, 0, 0 ),
        ( $3A9, $3C9, 0, 0 ),
        ( $3AA, $3CA, 0, 0 ),
        ( $3AB, $3CB, 0, 0 ),
        ( $3B0, $3C5, $308, $301 ),
        ( $3C2, $3C3, 0, 0 ),
        ( $3CF, $3D7, 0, 0 ),
        ( $3D0, $3B2, 0, 0 ),
        ( $3D1, $3B8, 0, 0 ),
        ( $3D5, $3C6, 0, 0 ),
        ( $3D6, $3C0, 0, 0 ),
        ( $3D8, $3D9, 0, 0 ),
        ( $3DA, $3DB, 0, 0 ),
        ( $3DC, $3DD, 0, 0 ),
        ( $3DE, $3DF, 0, 0 ),
        ( $3E0, $3E1, 0, 0 ),
        ( $3E2, $3E3, 0, 0 ),
        ( $3E4, $3E5, 0, 0 ),
        ( $3E6, $3E7, 0, 0 ),
        ( $3E8, $3E9, 0, 0 ),
        ( $3EA, $3EB, 0, 0 ),
        ( $3EC, $3ED, 0, 0 ),
        ( $3EE, $3EF, 0, 0 ),
        ( $3F0, $3BA, 0, 0 ),
        ( $3F1, $3C1, 0, 0 ),
        ( $3F4, $3B8, 0, 0 ),
        ( $3F5, $3B5, 0, 0 ),
        ( $3F7, $3F8, 0, 0 ),
        ( $3F9, $3F2, 0, 0 ),
        ( $3FA, $3FB, 0, 0 ),
        ( $3FD, $37B, 0, 0 ),
        ( $3FE, $37C, 0, 0 ),
        ( $3FF, $37D, 0, 0 ),
        ( $400, $450, 0, 0 ),
        ( $401, $451, 0, 0 ),
        ( $402, $452, 0, 0 ),
        ( $403, $453, 0, 0 ),
        ( $404, $454, 0, 0 ),
        ( $405, $455, 0, 0 ),
        ( $406, $456, 0, 0 ),
        ( $407, $457, 0, 0 ),
        ( $408, $458, 0, 0 ),
        ( $409, $459, 0, 0 ),
        ( $40A, $45A, 0, 0 ),
        ( $40B, $45B, 0, 0 ),
        ( $40C, $45C, 0, 0 ),
        ( $40D, $45D, 0, 0 ),
        ( $40E, $45E, 0, 0 ),
        ( $40F, $45F, 0, 0 ),
        ( $410, $430, 0, 0 ),
        ( $411, $431, 0, 0 ),
        ( $412, $432, 0, 0 ),
        ( $413, $433, 0, 0 ),
        ( $414, $434, 0, 0 ),
        ( $415, $435, 0, 0 ),
        ( $416, $436, 0, 0 ),
        ( $417, $437, 0, 0 ),
        ( $418, $438, 0, 0 ),
        ( $419, $439, 0, 0 ),
        ( $41A, $43A, 0, 0 ),
        ( $41B, $43B, 0, 0 ),
        ( $41C, $43C, 0, 0 ),
        ( $41D, $43D, 0, 0 ),
        ( $41E, $43E, 0, 0 ),
        ( $41F, $43F, 0, 0 ),
        ( $420, $440, 0, 0 ),
        ( $421, $441, 0, 0 ),
        ( $422, $442, 0, 0 ),
        ( $423, $443, 0, 0 ),
        ( $424, $444, 0, 0 ),
        ( $425, $445, 0, 0 ),
        ( $426, $446, 0, 0 ),
        ( $427, $447, 0, 0 ),
        ( $428, $448, 0, 0 ),
        ( $429, $449, 0, 0 ),
        ( $42A, $44A, 0, 0 ),
        ( $42B, $44B, 0, 0 ),
        ( $42C, $44C, 0, 0 ),
        ( $42D, $44D, 0, 0 ),
        ( $42E, $44E, 0, 0 ),
        ( $42F, $44F, 0, 0 ),
        ( $460, $461, 0, 0 ),
        ( $462, $463, 0, 0 ),
        ( $464, $465, 0, 0 ),
        ( $466, $467, 0, 0 ),
        ( $468, $469, 0, 0 ),
        ( $46A, $46B, 0, 0 ),
        ( $46C, $46D, 0, 0 ),
        ( $46E, $46F, 0, 0 ),
        ( $470, $471, 0, 0 ),
        ( $472, $473, 0, 0 ),
        ( $474, $475, 0, 0 ),
        ( $476, $477, 0, 0 ),
        ( $478, $479, 0, 0 ),
        ( $47A, $47B, 0, 0 ),
        ( $47C, $47D, 0, 0 ),
        ( $47E, $47F, 0, 0 ),
        ( $480, $481, 0, 0 ),
        ( $48A, $48B, 0, 0 ),
        ( $48C, $48D, 0, 0 ),
        ( $48E, $48F, 0, 0 ),
        ( $490, $491, 0, 0 ),
        ( $492, $493, 0, 0 ),
        ( $494, $495, 0, 0 ),
        ( $496, $497, 0, 0 ),
        ( $498, $499, 0, 0 ),
        ( $49A, $49B, 0, 0 ),
        ( $49C, $49D, 0, 0 ),
        ( $49E, $49F, 0, 0 ),
        ( $4A0, $4A1, 0, 0 ),
        ( $4A2, $4A3, 0, 0 ),
        ( $4A4, $4A5, 0, 0 ),
        ( $4A6, $4A7, 0, 0 ),
        ( $4A8, $4A9, 0, 0 ),
        ( $4AA, $4AB, 0, 0 ),
        ( $4AC, $4AD, 0, 0 ),
        ( $4AE, $4AF, 0, 0 ),
        ( $4B0, $4B1, 0, 0 ),
        ( $4B2, $4B3, 0, 0 ),
        ( $4B4, $4B5, 0, 0 ),
        ( $4B6, $4B7, 0, 0 ),
        ( $4B8, $4B9, 0, 0 ),
        ( $4BA, $4BB, 0, 0 ),
        ( $4BC, $4BD, 0, 0 ),
        ( $4BE, $4BF, 0, 0 ),
        ( $4C0, $4CF, 0, 0 ),
        ( $4C1, $4C2, 0, 0 ),
        ( $4C3, $4C4, 0, 0 ),
        ( $4C5, $4C6, 0, 0 ),
        ( $4C7, $4C8, 0, 0 ),
        ( $4C9, $4CA, 0, 0 ),
        ( $4CB, $4CC, 0, 0 ),
        ( $4CD, $4CE, 0, 0 ),
        ( $4D0, $4D1, 0, 0 ),
        ( $4D2, $4D3, 0, 0 ),
        ( $4D4, $4D5, 0, 0 ),
        ( $4D6, $4D7, 0, 0 ),
        ( $4D8, $4D9, 0, 0 ),
        ( $4DA, $4DB, 0, 0 ),
        ( $4DC, $4DD, 0, 0 ),
        ( $4DE, $4DF, 0, 0 ),
        ( $4E0, $4E1, 0, 0 ),
        ( $4E2, $4E3, 0, 0 ),
        ( $4E4, $4E5, 0, 0 ),
        ( $4E6, $4E7, 0, 0 ),
        ( $4E8, $4E9, 0, 0 ),
        ( $4EA, $4EB, 0, 0 ),
        ( $4EC, $4ED, 0, 0 ),
        ( $4EE, $4EF, 0, 0 ),
        ( $4F0, $4F1, 0, 0 ),
        ( $4F2, $4F3, 0, 0 ),
        ( $4F4, $4F5, 0, 0 ),
        ( $4F6, $4F7, 0, 0 ),
        ( $4F8, $4F9, 0, 0 ),
        ( $4FA, $4FB, 0, 0 ),
        ( $4FC, $4FD, 0, 0 ),
        ( $4FE, $4FF, 0, 0 ),
        ( $500, $501, 0, 0 ),
        ( $502, $503, 0, 0 ),
        ( $504, $505, 0, 0 ),
        ( $506, $507, 0, 0 ),
        ( $508, $509, 0, 0 ),
        ( $50A, $50B, 0, 0 ),
        ( $50C, $50D, 0, 0 ),
        ( $50E, $50F, 0, 0 ),
        ( $510, $511, 0, 0 ),
        ( $512, $513, 0, 0 ),
        ( $514, $515, 0, 0 ),
        ( $516, $517, 0, 0 ),
        ( $518, $519, 0, 0 ),
        ( $51A, $51B, 0, 0 ),
        ( $51C, $51D, 0, 0 ),
        ( $51E, $51F, 0, 0 ),
        ( $520, $521, 0, 0 ),
        ( $522, $523, 0, 0 ),
        ( $524, $525, 0, 0 ),
        ( $526, $527, 0, 0 ),
        ( $528, $529, 0, 0 ),
        ( $52A, $52B, 0, 0 ),
        ( $52C, $52D, 0, 0 ),
        ( $52E, $52F, 0, 0 ),
        ( $531, $561, 0, 0 ),
        ( $532, $562, 0, 0 ),
        ( $533, $563, 0, 0 ),
        ( $534, $564, 0, 0 ),
        ( $535, $565, 0, 0 ),
        ( $536, $566, 0, 0 ),
        ( $537, $567, 0, 0 ),
        ( $538, $568, 0, 0 ),
        ( $539, $569, 0, 0 ),
        ( $53A, $56A, 0, 0 ),
        ( $53B, $56B, 0, 0 ),
        ( $53C, $56C, 0, 0 ),
        ( $53D, $56D, 0, 0 ),
        ( $53E, $56E, 0, 0 ),
        ( $53F, $56F, 0, 0 ),
        ( $540, $570, 0, 0 ),
        ( $541, $571, 0, 0 ),
        ( $542, $572, 0, 0 ),
        ( $543, $573, 0, 0 ),
        ( $544, $574, 0, 0 ),
        ( $545, $575, 0, 0 ),
        ( $546, $576, 0, 0 ),
        ( $547, $577, 0, 0 ),
        ( $548, $578, 0, 0 ),
        ( $549, $579, 0, 0 ),
        ( $54A, $57A, 0, 0 ),
        ( $54B, $57B, 0, 0 ),
        ( $54C, $57C, 0, 0 ),
        ( $54D, $57D, 0, 0 ),
        ( $54E, $57E, 0, 0 ),
        ( $54F, $57F, 0, 0 ),
        ( $550, $580, 0, 0 ),
        ( $551, $581, 0, 0 ),
        ( $552, $582, 0, 0 ),
        ( $553, $583, 0, 0 ),
        ( $554, $584, 0, 0 ),
        ( $555, $585, 0, 0 ),
        ( $556, $586, 0, 0 ),
        ( $587, $565, $582, 0 ),
        ( $10A0, $2D00, 0, 0 ),
        ( $10A1, $2D01, 0, 0 ),
        ( $10A2, $2D02, 0, 0 ),
        ( $10A3, $2D03, 0, 0 ),
        ( $10A4, $2D04, 0, 0 ),
        ( $10A5, $2D05, 0, 0 ),
        ( $10A6, $2D06, 0, 0 ),
        ( $10A7, $2D07, 0, 0 ),
        ( $10A8, $2D08, 0, 0 ),
        ( $10A9, $2D09, 0, 0 ),
        ( $10AA, $2D0A, 0, 0 ),
        ( $10AB, $2D0B, 0, 0 ),
        ( $10AC, $2D0C, 0, 0 ),
        ( $10AD, $2D0D, 0, 0 ),
        ( $10AE, $2D0E, 0, 0 ),
        ( $10AF, $2D0F, 0, 0 ),
        ( $10B0, $2D10, 0, 0 ),
        ( $10B1, $2D11, 0, 0 ),
        ( $10B2, $2D12, 0, 0 ),
        ( $10B3, $2D13, 0, 0 ),
        ( $10B4, $2D14, 0, 0 ),
        ( $10B5, $2D15, 0, 0 ),
        ( $10B6, $2D16, 0, 0 ),
        ( $10B7, $2D17, 0, 0 ),
        ( $10B8, $2D18, 0, 0 ),
        ( $10B9, $2D19, 0, 0 ),
        ( $10BA, $2D1A, 0, 0 ),
        ( $10BB, $2D1B, 0, 0 ),
        ( $10BC, $2D1C, 0, 0 ),
        ( $10BD, $2D1D, 0, 0 ),
        ( $10BE, $2D1E, 0, 0 ),
        ( $10BF, $2D1F, 0, 0 ),
        ( $10C0, $2D20, 0, 0 ),
        ( $10C1, $2D21, 0, 0 ),
        ( $10C2, $2D22, 0, 0 ),
        ( $10C3, $2D23, 0, 0 ),
        ( $10C4, $2D24, 0, 0 ),
        ( $10C5, $2D25, 0, 0 ),
        ( $10C7, $2D27, 0, 0 ),
        ( $10CD, $2D2D, 0, 0 ),
        ( $13F8, $13F0, 0, 0 ),
        ( $13F9, $13F1, 0, 0 ),
        ( $13FA, $13F2, 0, 0 ),
        ( $13FB, $13F3, 0, 0 ),
        ( $13FC, $13F4, 0, 0 ),
        ( $13FD, $13F5, 0, 0 ),
        ( $1E00, $1E01, 0, 0 ),
        ( $1E02, $1E03, 0, 0 ),
        ( $1E04, $1E05, 0, 0 ),
        ( $1E06, $1E07, 0, 0 ),
        ( $1E08, $1E09, 0, 0 ),
        ( $1E0A, $1E0B, 0, 0 ),
        ( $1E0C, $1E0D, 0, 0 ),
        ( $1E0E, $1E0F, 0, 0 ),
        ( $1E10, $1E11, 0, 0 ),
        ( $1E12, $1E13, 0, 0 ),
        ( $1E14, $1E15, 0, 0 ),
        ( $1E16, $1E17, 0, 0 ),
        ( $1E18, $1E19, 0, 0 ),
        ( $1E1A, $1E1B, 0, 0 ),
        ( $1E1C, $1E1D, 0, 0 ),
        ( $1E1E, $1E1F, 0, 0 ),
        ( $1E20, $1E21, 0, 0 ),
        ( $1E22, $1E23, 0, 0 ),
        ( $1E24, $1E25, 0, 0 ),
        ( $1E26, $1E27, 0, 0 ),
        ( $1E28, $1E29, 0, 0 ),
        ( $1E2A, $1E2B, 0, 0 ),
        ( $1E2C, $1E2D, 0, 0 ),
        ( $1E2E, $1E2F, 0, 0 ),
        ( $1E30, $1E31, 0, 0 ),
        ( $1E32, $1E33, 0, 0 ),
        ( $1E34, $1E35, 0, 0 ),
        ( $1E36, $1E37, 0, 0 ),
        ( $1E38, $1E39, 0, 0 ),
        ( $1E3A, $1E3B, 0, 0 ),
        ( $1E3C, $1E3D, 0, 0 ),
        ( $1E3E, $1E3F, 0, 0 ),
        ( $1E40, $1E41, 0, 0 ),
        ( $1E42, $1E43, 0, 0 ),
        ( $1E44, $1E45, 0, 0 ),
        ( $1E46, $1E47, 0, 0 ),
        ( $1E48, $1E49, 0, 0 ),
        ( $1E4A, $1E4B, 0, 0 ),
        ( $1E4C, $1E4D, 0, 0 ),
        ( $1E4E, $1E4F, 0, 0 ),
        ( $1E50, $1E51, 0, 0 ),
        ( $1E52, $1E53, 0, 0 ),
        ( $1E54, $1E55, 0, 0 ),
        ( $1E56, $1E57, 0, 0 ),
        ( $1E58, $1E59, 0, 0 ),
        ( $1E5A, $1E5B, 0, 0 ),
        ( $1E5C, $1E5D, 0, 0 ),
        ( $1E5E, $1E5F, 0, 0 ),
        ( $1E60, $1E61, 0, 0 ),
        ( $1E62, $1E63, 0, 0 ),
        ( $1E64, $1E65, 0, 0 ),
        ( $1E66, $1E67, 0, 0 ),
        ( $1E68, $1E69, 0, 0 ),
        ( $1E6A, $1E6B, 0, 0 ),
        ( $1E6C, $1E6D, 0, 0 ),
        ( $1E6E, $1E6F, 0, 0 ),
        ( $1E70, $1E71, 0, 0 ),
        ( $1E72, $1E73, 0, 0 ),
        ( $1E74, $1E75, 0, 0 ),
        ( $1E76, $1E77, 0, 0 ),
        ( $1E78, $1E79, 0, 0 ),
        ( $1E7A, $1E7B, 0, 0 ),
        ( $1E7C, $1E7D, 0, 0 ),
        ( $1E7E, $1E7F, 0, 0 ),
        ( $1E80, $1E81, 0, 0 ),
        ( $1E82, $1E83, 0, 0 ),
        ( $1E84, $1E85, 0, 0 ),
        ( $1E86, $1E87, 0, 0 ),
        ( $1E88, $1E89, 0, 0 ),
        ( $1E8A, $1E8B, 0, 0 ),
        ( $1E8C, $1E8D, 0, 0 ),
        ( $1E8E, $1E8F, 0, 0 ),
        ( $1E90, $1E91, 0, 0 ),
        ( $1E92, $1E93, 0, 0 ),
        ( $1E94, $1E95, 0, 0 ),
        ( $1E96, $68, $331, 0 ),
        ( $1E97, $74, $308, 0 ),
        ( $1E98, $77, $30A, 0 ),
        ( $1E99, $79, $30A, 0 ),
        ( $1E9A, $61, $2BE, 0 ),
        ( $1E9B, $1E61, 0, 0 ),
        ( $1E9E, $73, $73, 0 ),
        ( $1EA0, $1EA1, 0, 0 ),
        ( $1EA2, $1EA3, 0, 0 ),
        ( $1EA4, $1EA5, 0, 0 ),
        ( $1EA6, $1EA7, 0, 0 ),
        ( $1EA8, $1EA9, 0, 0 ),
        ( $1EAA, $1EAB, 0, 0 ),
        ( $1EAC, $1EAD, 0, 0 ),
        ( $1EAE, $1EAF, 0, 0 ),
        ( $1EB0, $1EB1, 0, 0 ),
        ( $1EB2, $1EB3, 0, 0 ),
        ( $1EB4, $1EB5, 0, 0 ),
        ( $1EB6, $1EB7, 0, 0 ),
        ( $1EB8, $1EB9, 0, 0 ),
        ( $1EBA, $1EBB, 0, 0 ),
        ( $1EBC, $1EBD, 0, 0 ),
        ( $1EBE, $1EBF, 0, 0 ),
        ( $1EC0, $1EC1, 0, 0 ),
        ( $1EC2, $1EC3, 0, 0 ),
        ( $1EC4, $1EC5, 0, 0 ),
        ( $1EC6, $1EC7, 0, 0 ),
        ( $1EC8, $1EC9, 0, 0 ),
        ( $1ECA, $1ECB, 0, 0 ),
        ( $1ECC, $1ECD, 0, 0 ),
        ( $1ECE, $1ECF, 0, 0 ),
        ( $1ED0, $1ED1, 0, 0 ),
        ( $1ED2, $1ED3, 0, 0 ),
        ( $1ED4, $1ED5, 0, 0 ),
        ( $1ED6, $1ED7, 0, 0 ),
        ( $1ED8, $1ED9, 0, 0 ),
        ( $1EDA, $1EDB, 0, 0 ),
        ( $1EDC, $1EDD, 0, 0 ),
        ( $1EDE, $1EDF, 0, 0 ),
        ( $1EE0, $1EE1, 0, 0 ),
        ( $1EE2, $1EE3, 0, 0 ),
        ( $1EE4, $1EE5, 0, 0 ),
        ( $1EE6, $1EE7, 0, 0 ),
        ( $1EE8, $1EE9, 0, 0 ),
        ( $1EEA, $1EEB, 0, 0 ),
        ( $1EEC, $1EED, 0, 0 ),
        ( $1EEE, $1EEF, 0, 0 ),
        ( $1EF0, $1EF1, 0, 0 ),
        ( $1EF2, $1EF3, 0, 0 ),
        ( $1EF4, $1EF5, 0, 0 ),
        ( $1EF6, $1EF7, 0, 0 ),
        ( $1EF8, $1EF9, 0, 0 ),
        ( $1EFA, $1EFB, 0, 0 ),
        ( $1EFC, $1EFD, 0, 0 ),
        ( $1EFE, $1EFF, 0, 0 ),
        ( $1F08, $1F00, 0, 0 ),
        ( $1F09, $1F01, 0, 0 ),
        ( $1F0A, $1F02, 0, 0 ),
        ( $1F0B, $1F03, 0, 0 ),
        ( $1F0C, $1F04, 0, 0 ),
        ( $1F0D, $1F05, 0, 0 ),
        ( $1F0E, $1F06, 0, 0 ),
        ( $1F0F, $1F07, 0, 0 ),
        ( $1F18, $1F10, 0, 0 ),
        ( $1F19, $1F11, 0, 0 ),
        ( $1F1A, $1F12, 0, 0 ),
        ( $1F1B, $1F13, 0, 0 ),
        ( $1F1C, $1F14, 0, 0 ),
        ( $1F1D, $1F15, 0, 0 ),
        ( $1F28, $1F20, 0, 0 ),
        ( $1F29, $1F21, 0, 0 ),
        ( $1F2A, $1F22, 0, 0 ),
        ( $1F2B, $1F23, 0, 0 ),
        ( $1F2C, $1F24, 0, 0 ),
        ( $1F2D, $1F25, 0, 0 ),
        ( $1F2E, $1F26, 0, 0 ),
        ( $1F2F, $1F27, 0, 0 ),
        ( $1F38, $1F30, 0, 0 ),
        ( $1F39, $1F31, 0, 0 ),
        ( $1F3A, $1F32, 0, 0 ),
        ( $1F3B, $1F33, 0, 0 ),
        ( $1F3C, $1F34, 0, 0 ),
        ( $1F3D, $1F35, 0, 0 ),
        ( $1F3E, $1F36, 0, 0 ),
        ( $1F3F, $1F37, 0, 0 ),
        ( $1F48, $1F40, 0, 0 ),
        ( $1F49, $1F41, 0, 0 ),
        ( $1F4A, $1F42, 0, 0 ),
        ( $1F4B, $1F43, 0, 0 ),
        ( $1F4C, $1F44, 0, 0 ),
        ( $1F4D, $1F45, 0, 0 ),
        ( $1F50, $3C5, 0, 0 ),
        ( $1F52, $3C5, $313, $300 ),
        ( $1F54, $3C5, $313, $301 ),
        ( $1F56, $3C5, $313, $342 ),
        ( $1F59, $1F51, 0, 0 ),
        ( $1F5B, $1F53, 0, 0 ),
        ( $1F5D, $1F55, 0, 0 ),
        ( $1F5F, $1F57, 0, 0 ),
        ( $1F68, $1F60, 0, 0 ),
        ( $1F69, $1F61, 0, 0 ),
        ( $1F6A, $1F62, 0, 0 ),
        ( $1F6B, $1F63, 0, 0 ),
        ( $1F6C, $1F64, 0, 0 ),
        ( $1F6D, $1F65, 0, 0 ),
        ( $1F6E, $1F66, 0, 0 ),
        ( $1F6F, $1F67, 0, 0 ),
        ( $1F80, $1F00, $3B9, 0 ),
        ( $1F81, $1F01, $3B9, 0 ),
        ( $1F82, $1F02, $3B9, 0 ),
        ( $1F83, $1F03, $3B9, 0 ),
        ( $1F84, $1F04, $3B9, 0 ),
        ( $1F85, $1F05, $3B9, 0 ),
        ( $1F86, $1F06, $3B9, 0 ),
        ( $1F87, $1F07, $3B9, 0 ),
        ( $1F88, $1F00, $3B9, 0 ),
        ( $1F89, $1F01, $3B9, 0 ),
        ( $1F8A, $1F02, $3B9, 0 ),
        ( $1F8B, $1F03, $3B9, 0 ),
        ( $1F8C, $1F04, $3B9, 0 ),
        ( $1F8D, $1F05, $3B9, 0 ),
        ( $1F8E, $1F06, $3B9, 0 ),
        ( $1F8F, $1F07, $3B9, 0 ),
        ( $1F90, $1F20, $3B9, 0 ),
        ( $1F91, $1F21, $3B9, 0 ),
        ( $1F92, $1F22, $3B9, 0 ),
        ( $1F93, $1F23, $3B9, 0 ),
        ( $1F94, $1F24, $3B9, 0 ),
        ( $1F95, $1F25, $3B9, 0 ),
        ( $1F96, $1F26, $3B9, 0 ),
        ( $1F97, $1F27, $3B9, 0 ),
        ( $1F98, $1F20, $3B9, 0 ),
        ( $1F99, $1F21, $3B9, 0 ),
        ( $1F9A, $1F22, $3B9, 0 ),
        ( $1F9B, $1F23, $3B9, 0 ),
        ( $1F9C, $1F24, $3B9, 0 ),
        ( $1F9D, $1F25, $3B9, 0 ),
        ( $1F9E, $1F26, $3B9, 0 ),
        ( $1F9F, $1F27, $3B9, 0 ),
        ( $1FA0, $1F60, $3B9, 0 ),
        ( $1FA1, $1F61, $3B9, 0 ),
        ( $1FA2, $1F62, $3B9, 0 ),
        ( $1FA3, $1F63, $3B9, 0 ),
        ( $1FA4, $1F64, $3B9, 0 ),
        ( $1FA5, $1F65, $3B9, 0 ),
        ( $1FA6, $1F66, $3B9, 0 ),
        ( $1FA7, $1F67, $3B9, 0 ),
        ( $1FA8, $1F60, $3B9, 0 ),
        ( $1FA9, $1F61, $3B9, 0 ),
        ( $1FAA, $1F62, $3B9, 0 ),
        ( $1FAB, $1F63, $3B9, 0 ),
        ( $1FAC, $1F64, $3B9, 0 ),
        ( $1FAD, $1F65, $3B9, 0 ),
        ( $1FAE, $1F66, $3B9, 0 ),
        ( $1FAF, $1F67, $3B9, 0 ),
        ( $1FB2, $1F70, $3B9, 0 ),
        ( $1FB3, $3B1, $3B9, 0 ),
        ( $1FB4, $3AC, $3B9, 0 ),
        ( $1FB6, $3B1, $342, 0 ),
        ( $1FB7, $3B1, $342, $3B9 ),
        ( $1FB8, $1FB0, 0, 0 ),
        ( $1FB9, $1FB1, 0, 0 ),
        ( $1FBA, $1F70, 0, 0 ),
        ( $1FBB, $1F71, 0, 0 ),
        ( $1FBC, $3B1, $3B9, 0 ),
        ( $1FBE, $3B9, 0, 0 ),
        ( $1FC2, $1F74, $3B9, 0 ),
        ( $1FC3, $3B7, $3B9, 0 ),
        ( $1FC4, $3AE, $3B9, 0 ),
        ( $1FC6, $3B7, $342, 0 ),
        ( $1FC7, $3B7, $342, $3B9 ),
        ( $1FC8, $1F72, 0, 0 ),
        ( $1FC9, $1F73, 0, 0 ),
        ( $1FCA, $1F74, 0, 0 ),
        ( $1FCB, $1F75, 0, 0 ),
        ( $1FCC, $3B7, $3B9, 0 ),
        ( $1FD2, $3B9, $308, $300 ),
        ( $1FD3, $3B9, $308, $301 ),
        ( $1FD6, $3B9, $342, 0 ),
        ( $1FD7, $3B9, $308, $342 ),
        ( $1FD8, $1FD0, 0, 0 ),
        ( $1FD9, $1FD1, 0, 0 ),
        ( $1FDA, $1F76, 0, 0 ),
        ( $1FDB, $1F77, 0, 0 ),
        ( $1FE2, $3C5, $308, $300 ),
        ( $1FE3, $3C5, $308, $301 ),
        ( $1FE4, $3C1, $313, 0 ),
        ( $1FE6, $3C5, $342, 0 ),
        ( $1FE7, $3C5, $308, $342 ),
        ( $1FE8, $1FE0, 0, 0 ),
        ( $1FE9, $1FE1, 0, 0 ),
        ( $1FEA, $1F7A, 0, 0 ),
        ( $1FEB, $1F7B, 0, 0 ),
        ( $1FEC, $1FE5, 0, 0 ),
        ( $1FF2, $1F7C, $3B9, 0 ),
        ( $1FF3, $3C9, $3B9, 0 ),
        ( $1FF4, $3CE, $3B9, 0 ),
        ( $1FF6, $3C9, $342, 0 ),
        ( $1FF7, $3C9, $342, $3B9 ),
        ( $1FF8, $1F78, 0, 0 ),
        ( $1FF9, $1F79, 0, 0 ),
        ( $1FFA, $1F7C, 0, 0 ),
        ( $1FFB, $1F7D, 0, 0 ),
        ( $1FFC, $3C9, $3B9, 0 ),
        ( $2126, $3C9, 0, 0 ),
        ( $212A, $6B, 0, 0 ),
        ( $212B, $E5, 0, 0 ),
        ( $2132, $214E, 0, 0 ),
        ( $2160, $2170, 0, 0 ),
        ( $2161, $2171, 0, 0 ),
        ( $2162, $2172, 0, 0 ),
        ( $2163, $2173, 0, 0 ),
        ( $2164, $2174, 0, 0 ),
        ( $2165, $2175, 0, 0 ),
        ( $2166, $2176, 0, 0 ),
        ( $2167, $2177, 0, 0 ),
        ( $2168, $2178, 0, 0 ),
        ( $2169, $2179, 0, 0 ),
        ( $216A, $217A, 0, 0 ),
        ( $216B, $217B, 0, 0 ),
        ( $216C, $217C, 0, 0 ),
        ( $216D, $217D, 0, 0 ),
        ( $216E, $217E, 0, 0 ),
        ( $216F, $217F, 0, 0 ),
        ( $2183, $2184, 0, 0 ),
        ( $24B6, $24D0, 0, 0 ),
        ( $24B7, $24D1, 0, 0 ),
        ( $24B8, $24D2, 0, 0 ),
        ( $24B9, $24D3, 0, 0 ),
        ( $24BA, $24D4, 0, 0 ),
        ( $24BB, $24D5, 0, 0 ),
        ( $24BC, $24D6, 0, 0 ),
        ( $24BD, $24D7, 0, 0 ),
        ( $24BE, $24D8, 0, 0 ),
        ( $24BF, $24D9, 0, 0 ),
        ( $24C0, $24DA, 0, 0 ),
        ( $24C1, $24DB, 0, 0 ),
        ( $24C2, $24DC, 0, 0 ),
        ( $24C3, $24DD, 0, 0 ),
        ( $24C4, $24DE, 0, 0 ),
        ( $24C5, $24DF, 0, 0 ),
        ( $24C6, $24E0, 0, 0 ),
        ( $24C7, $24E1, 0, 0 ),
        ( $24C8, $24E2, 0, 0 ),
        ( $24C9, $24E3, 0, 0 ),
        ( $24CA, $24E4, 0, 0 ),
        ( $24CB, $24E5, 0, 0 ),
        ( $24CC, $24E6, 0, 0 ),
        ( $24CD, $24E7, 0, 0 ),
        ( $24CE, $24E8, 0, 0 ),
        ( $24CF, $24E9, 0, 0 ),
        ( $2C00, $2C30, 0, 0 ),
        ( $2C01, $2C31, 0, 0 ),
        ( $2C02, $2C32, 0, 0 ),
        ( $2C03, $2C33, 0, 0 ),
        ( $2C04, $2C34, 0, 0 ),
        ( $2C05, $2C35, 0, 0 ),
        ( $2C06, $2C36, 0, 0 ),
        ( $2C07, $2C37, 0, 0 ),
        ( $2C08, $2C38, 0, 0 ),
        ( $2C09, $2C39, 0, 0 ),
        ( $2C0A, $2C3A, 0, 0 ),
        ( $2C0B, $2C3B, 0, 0 ),
        ( $2C0C, $2C3C, 0, 0 ),
        ( $2C0D, $2C3D, 0, 0 ),
        ( $2C0E, $2C3E, 0, 0 ),
        ( $2C0F, $2C3F, 0, 0 ),
        ( $2C10, $2C40, 0, 0 ),
        ( $2C11, $2C41, 0, 0 ),
        ( $2C12, $2C42, 0, 0 ),
        ( $2C13, $2C43, 0, 0 ),
        ( $2C14, $2C44, 0, 0 ),
        ( $2C15, $2C45, 0, 0 ),
        ( $2C16, $2C46, 0, 0 ),
        ( $2C17, $2C47, 0, 0 ),
        ( $2C18, $2C48, 0, 0 ),
        ( $2C19, $2C49, 0, 0 ),
        ( $2C1A, $2C4A, 0, 0 ),
        ( $2C1B, $2C4B, 0, 0 ),
        ( $2C1C, $2C4C, 0, 0 ),
        ( $2C1D, $2C4D, 0, 0 ),
        ( $2C1E, $2C4E, 0, 0 ),
        ( $2C1F, $2C4F, 0, 0 ),
        ( $2C20, $2C50, 0, 0 ),
        ( $2C21, $2C51, 0, 0 ),
        ( $2C22, $2C52, 0, 0 ),
        ( $2C23, $2C53, 0, 0 ),
        ( $2C24, $2C54, 0, 0 ),
        ( $2C25, $2C55, 0, 0 ),
        ( $2C26, $2C56, 0, 0 ),
        ( $2C27, $2C57, 0, 0 ),
        ( $2C28, $2C58, 0, 0 ),
        ( $2C29, $2C59, 0, 0 ),
        ( $2C2A, $2C5A, 0, 0 ),
        ( $2C2B, $2C5B, 0, 0 ),
        ( $2C2C, $2C5C, 0, 0 ),
        ( $2C2D, $2C5D, 0, 0 ),
        ( $2C2E, $2C5E, 0, 0 ),
        ( $2C60, $2C61, 0, 0 ),
        ( $2C62, $26B, 0, 0 ),
        ( $2C63, $1D7D, 0, 0 ),
        ( $2C64, $27D, 0, 0 ),
        ( $2C67, $2C68, 0, 0 ),
        ( $2C69, $2C6A, 0, 0 ),
        ( $2C6B, $2C6C, 0, 0 ),
        ( $2C6D, $251, 0, 0 ),
        ( $2C6E, $271, 0, 0 ),
        ( $2C6F, $250, 0, 0 ),
        ( $2C70, $252, 0, 0 ),
        ( $2C72, $2C73, 0, 0 ),
        ( $2C75, $2C76, 0, 0 ),
        ( $2C7E, $23F, 0, 0 ),
        ( $2C7F, $240, 0, 0 ),
        ( $2C80, $2C81, 0, 0 ),
        ( $2C82, $2C83, 0, 0 ),
        ( $2C84, $2C85, 0, 0 ),
        ( $2C86, $2C87, 0, 0 ),
        ( $2C88, $2C89, 0, 0 ),
        ( $2C8A, $2C8B, 0, 0 ),
        ( $2C8C, $2C8D, 0, 0 ),
        ( $2C8E, $2C8F, 0, 0 ),
        ( $2C90, $2C91, 0, 0 ),
        ( $2C92, $2C93, 0, 0 ),
        ( $2C94, $2C95, 0, 0 ),
        ( $2C96, $2C97, 0, 0 ),
        ( $2C98, $2C99, 0, 0 ),
        ( $2C9A, $2C9B, 0, 0 ),
        ( $2C9C, $2C9D, 0, 0 ),
        ( $2C9E, $2C9F, 0, 0 ),
        ( $2CA0, $2CA1, 0, 0 ),
        ( $2CA2, $2CA3, 0, 0 ),
        ( $2CA4, $2CA5, 0, 0 ),
        ( $2CA6, $2CA7, 0, 0 ),
        ( $2CA8, $2CA9, 0, 0 ),
        ( $2CAA, $2CAB, 0, 0 ),
        ( $2CAC, $2CAD, 0, 0 ),
        ( $2CAE, $2CAF, 0, 0 ),
        ( $2CB0, $2CB1, 0, 0 ),
        ( $2CB2, $2CB3, 0, 0 ),
        ( $2CB4, $2CB5, 0, 0 ),
        ( $2CB6, $2CB7, 0, 0 ),
        ( $2CB8, $2CB9, 0, 0 ),
        ( $2CBA, $2CBB, 0, 0 ),
        ( $2CBC, $2CBD, 0, 0 ),
        ( $2CBE, $2CBF, 0, 0 ),
        ( $2CC0, $2CC1, 0, 0 ),
        ( $2CC2, $2CC3, 0, 0 ),
        ( $2CC4, $2CC5, 0, 0 ),
        ( $2CC6, $2CC7, 0, 0 ),
        ( $2CC8, $2CC9, 0, 0 ),
        ( $2CCA, $2CCB, 0, 0 ),
        ( $2CCC, $2CCD, 0, 0 ),
        ( $2CCE, $2CCF, 0, 0 ),
        ( $2CD0, $2CD1, 0, 0 ),
        ( $2CD2, $2CD3, 0, 0 ),
        ( $2CD4, $2CD5, 0, 0 ),
        ( $2CD6, $2CD7, 0, 0 ),
        ( $2CD8, $2CD9, 0, 0 ),
        ( $2CDA, $2CDB, 0, 0 ),
        ( $2CDC, $2CDD, 0, 0 ),
        ( $2CDE, $2CDF, 0, 0 ),
        ( $2CE0, $2CE1, 0, 0 ),
        ( $2CE2, $2CE3, 0, 0 ),
        ( $2CEB, $2CEC, 0, 0 ),
        ( $2CED, $2CEE, 0, 0 ),
        ( $2CF2, $2CF3, 0, 0 ),
        ( $A640, $A641, 0, 0 ),
        ( $A642, $A643, 0, 0 ),
        ( $A644, $A645, 0, 0 ),
        ( $A646, $A647, 0, 0 ),
        ( $A648, $A649, 0, 0 ),
        ( $A64A, $A64B, 0, 0 ),
        ( $A64C, $A64D, 0, 0 ),
        ( $A64E, $A64F, 0, 0 ),
        ( $A650, $A651, 0, 0 ),
        ( $A652, $A653, 0, 0 ),
        ( $A654, $A655, 0, 0 ),
        ( $A656, $A657, 0, 0 ),
        ( $A658, $A659, 0, 0 ),
        ( $A65A, $A65B, 0, 0 ),
        ( $A65C, $A65D, 0, 0 ),
        ( $A65E, $A65F, 0, 0 ),
        ( $A660, $A661, 0, 0 ),
        ( $A662, $A663, 0, 0 ),
        ( $A664, $A665, 0, 0 ),
        ( $A666, $A667, 0, 0 ),
        ( $A668, $A669, 0, 0 ),
        ( $A66A, $A66B, 0, 0 ),
        ( $A66C, $A66D, 0, 0 ),
        ( $A680, $A681, 0, 0 ),
        ( $A682, $A683, 0, 0 ),
        ( $A684, $A685, 0, 0 ),
        ( $A686, $A687, 0, 0 ),
        ( $A688, $A689, 0, 0 ),
        ( $A68A, $A68B, 0, 0 ),
        ( $A68C, $A68D, 0, 0 ),
        ( $A68E, $A68F, 0, 0 ),
        ( $A690, $A691, 0, 0 ),
        ( $A692, $A693, 0, 0 ),
        ( $A694, $A695, 0, 0 ),
        ( $A696, $A697, 0, 0 ),
        ( $A698, $A699, 0, 0 ),
        ( $A69A, $A69B, 0, 0 ),
        ( $A722, $A723, 0, 0 ),
        ( $A724, $A725, 0, 0 ),
        ( $A726, $A727, 0, 0 ),
        ( $A728, $A729, 0, 0 ),
        ( $A72A, $A72B, 0, 0 ),
        ( $A72C, $A72D, 0, 0 ),
        ( $A72E, $A72F, 0, 0 ),
        ( $A732, $A733, 0, 0 ),
        ( $A734, $A735, 0, 0 ),
        ( $A736, $A737, 0, 0 ),
        ( $A738, $A739, 0, 0 ),
        ( $A73A, $A73B, 0, 0 ),
        ( $A73C, $A73D, 0, 0 ),
        ( $A73E, $A73F, 0, 0 ),
        ( $A740, $A741, 0, 0 ),
        ( $A742, $A743, 0, 0 ),
        ( $A744, $A745, 0, 0 ),
        ( $A746, $A747, 0, 0 ),
        ( $A748, $A749, 0, 0 ),
        ( $A74A, $A74B, 0, 0 ),
        ( $A74C, $A74D, 0, 0 ),
        ( $A74E, $A74F, 0, 0 ),
        ( $A750, $A751, 0, 0 ),
        ( $A752, $A753, 0, 0 ),
        ( $A754, $A755, 0, 0 ),
        ( $A756, $A757, 0, 0 ),
        ( $A758, $A759, 0, 0 ),
        ( $A75A, $A75B, 0, 0 ),
        ( $A75C, $A75D, 0, 0 ),
        ( $A75E, $A75F, 0, 0 ),
        ( $A760, $A761, 0, 0 ),
        ( $A762, $A763, 0, 0 ),
        ( $A764, $A765, 0, 0 ),
        ( $A766, $A767, 0, 0 ),
        ( $A768, $A769, 0, 0 ),
        ( $A76A, $A76B, 0, 0 ),
        ( $A76C, $A76D, 0, 0 ),
        ( $A76E, $A76F, 0, 0 ),
        ( $A779, $A77A, 0, 0 ),
        ( $A77B, $A77C, 0, 0 ),
        ( $A77D, $1D79, 0, 0 ),
        ( $A77E, $A77F, 0, 0 ),
        ( $A780, $A781, 0, 0 ),
        ( $A782, $A783, 0, 0 ),
        ( $A784, $A785, 0, 0 ),
        ( $A786, $A787, 0, 0 ),
        ( $A78B, $A78C, 0, 0 ),
        ( $A78D, $265, 0, 0 ),
        ( $A790, $A791, 0, 0 ),
        ( $A792, $A793, 0, 0 ),
        ( $A796, $A797, 0, 0 ),
        ( $A798, $A799, 0, 0 ),
        ( $A79A, $A79B, 0, 0 ),
        ( $A79C, $A79D, 0, 0 ),
        ( $A79E, $A79F, 0, 0 ),
        ( $A7A0, $A7A1, 0, 0 ),
        ( $A7A2, $A7A3, 0, 0 ),
        ( $A7A4, $A7A5, 0, 0 ),
        ( $A7A6, $A7A7, 0, 0 ),
        ( $A7A8, $A7A9, 0, 0 ),
        ( $A7AA, $266, 0, 0 ),
        ( $A7AB, $25C, 0, 0 ),
        ( $A7AC, $261, 0, 0 ),
        ( $A7AD, $26C, 0, 0 ),
        ( $A7B0, $29E, 0, 0 ),
        ( $A7B1, $287, 0, 0 ),
        ( $A7B2, $29D, 0, 0 ),
        ( $A7B3, $AB53, 0, 0 ),
        ( $A7B4, $A7B5, 0, 0 ),
        ( $A7B6, $A7B7, 0, 0 ),
        ( $AB70, $13A0, 0, 0 ),
        ( $AB71, $13A1, 0, 0 ),
        ( $AB72, $13A2, 0, 0 ),
        ( $AB73, $13A3, 0, 0 ),
        ( $AB74, $13A4, 0, 0 ),
        ( $AB75, $13A5, 0, 0 ),
        ( $AB76, $13A6, 0, 0 ),
        ( $AB77, $13A7, 0, 0 ),
        ( $AB78, $13A8, 0, 0 ),
        ( $AB79, $13A9, 0, 0 ),
        ( $AB7A, $13AA, 0, 0 ),
        ( $AB7B, $13AB, 0, 0 ),
        ( $AB7C, $13AC, 0, 0 ),
        ( $AB7D, $13AD, 0, 0 ),
        ( $AB7E, $13AE, 0, 0 ),
        ( $AB7F, $13AF, 0, 0 ),
        ( $AB80, $13B0, 0, 0 ),
        ( $AB81, $13B1, 0, 0 ),
        ( $AB82, $13B2, 0, 0 ),
        ( $AB83, $13B3, 0, 0 ),
        ( $AB84, $13B4, 0, 0 ),
        ( $AB85, $13B5, 0, 0 ),
        ( $AB86, $13B6, 0, 0 ),
        ( $AB87, $13B7, 0, 0 ),
        ( $AB88, $13B8, 0, 0 ),
        ( $AB89, $13B9, 0, 0 ),
        ( $AB8A, $13BA, 0, 0 ),
        ( $AB8B, $13BB, 0, 0 ),
        ( $AB8C, $13BC, 0, 0 ),
        ( $AB8D, $13BD, 0, 0 ),
        ( $AB8E, $13BE, 0, 0 ),
        ( $AB8F, $13BF, 0, 0 ),
        ( $AB90, $13C0, 0, 0 ),
        ( $AB91, $13C1, 0, 0 ),
        ( $AB92, $13C2, 0, 0 ),
        ( $AB93, $13C3, 0, 0 ),
        ( $AB94, $13C4, 0, 0 ),
        ( $AB95, $13C5, 0, 0 ),
        ( $AB96, $13C6, 0, 0 ),
        ( $AB97, $13C7, 0, 0 ),
        ( $AB98, $13C8, 0, 0 ),
        ( $AB99, $13C9, 0, 0 ),
        ( $AB9A, $13CA, 0, 0 ),
        ( $AB9B, $13CB, 0, 0 ),
        ( $AB9C, $13CC, 0, 0 ),
        ( $AB9D, $13CD, 0, 0 ),
        ( $AB9E, $13CE, 0, 0 ),
        ( $AB9F, $13CF, 0, 0 ),
        ( $ABA0, $13D0, 0, 0 ),
        ( $ABA1, $13D1, 0, 0 ),
        ( $ABA2, $13D2, 0, 0 ),
        ( $ABA3, $13D3, 0, 0 ),
        ( $ABA4, $13D4, 0, 0 ),
        ( $ABA5, $13D5, 0, 0 ),
        ( $ABA6, $13D6, 0, 0 ),
        ( $ABA7, $13D7, 0, 0 ),
        ( $ABA8, $13D8, 0, 0 ),
        ( $ABA9, $13D9, 0, 0 ),
        ( $ABAA, $13DA, 0, 0 ),
        ( $ABAB, $13DB, 0, 0 ),
        ( $ABAC, $13DC, 0, 0 ),
        ( $ABAD, $13DD, 0, 0 ),
        ( $ABAE, $13DE, 0, 0 ),
        ( $ABAF, $13DF, 0, 0 ),
        ( $ABB0, $13E0, 0, 0 ),
        ( $ABB1, $13E1, 0, 0 ),
        ( $ABB2, $13E2, 0, 0 ),
        ( $ABB3, $13E3, 0, 0 ),
        ( $ABB4, $13E4, 0, 0 ),
        ( $ABB5, $13E5, 0, 0 ),
        ( $ABB6, $13E6, 0, 0 ),
        ( $ABB7, $13E7, 0, 0 ),
        ( $ABB8, $13E8, 0, 0 ),
        ( $ABB9, $13E9, 0, 0 ),
        ( $ABBA, $13EA, 0, 0 ),
        ( $ABBB, $13EB, 0, 0 ),
        ( $ABBC, $13EC, 0, 0 ),
        ( $ABBD, $13ED, 0, 0 ),
        ( $ABBE, $13EE, 0, 0 ),
        ( $ABBF, $13EF, 0, 0 ),
        ( $FB00, $66, $66, 0 ),
        ( $FB01, $66, $69, 0 ),
        ( $FB02, $66, $6C, 0 ),
        ( $FB03, $66, $66, $69 ),
        ( $FB04, $66, $66, $6C ),
        ( $FB05, $73, $74, 0 ),
        ( $FB06, $73, $74, 0 ),
        ( $FB13, $574, $576, 0 ),
        ( $FB14, $574, $565, 0 ),
        ( $FB15, $574, $56B, 0 ),
        ( $FB16, $57E, $576, 0 ),
        ( $FB17, $574, $56D, 0 ),
        ( $FF21, $FF41, 0, 0 ),
        ( $FF22, $FF42, 0, 0 ),
        ( $FF23, $FF43, 0, 0 ),
        ( $FF24, $FF44, 0, 0 ),
        ( $FF25, $FF45, 0, 0 ),
        ( $FF26, $FF46, 0, 0 ),
        ( $FF27, $FF47, 0, 0 ),
        ( $FF28, $FF48, 0, 0 ),
        ( $FF29, $FF49, 0, 0 ),
        ( $FF2A, $FF4A, 0, 0 ),
        ( $FF2B, $FF4B, 0, 0 ),
        ( $FF2C, $FF4C, 0, 0 ),
        ( $FF2D, $FF4D, 0, 0 ),
        ( $FF2E, $FF4E, 0, 0 ),
        ( $FF2F, $FF4F, 0, 0 ),
        ( $FF30, $FF50, 0, 0 ),
        ( $FF31, $FF51, 0, 0 ),
        ( $FF32, $FF52, 0, 0 ),
        ( $FF33, $FF53, 0, 0 ),
        ( $FF34, $FF54, 0, 0 ),
        ( $FF35, $FF55, 0, 0 ),
        ( $FF36, $FF56, 0, 0 ),
        ( $FF37, $FF57, 0, 0 ),
        ( $FF38, $FF58, 0, 0 ),
        ( $FF39, $FF59, 0, 0 ),
        ( $FF3A, $FF5A, 0, 0 ),
        ( $10400, $10428, 0, 0 ),
        ( $10401, $10429, 0, 0 ),
        ( $10402, $1042A, 0, 0 ),
        ( $10403, $1042B, 0, 0 ),
        ( $10404, $1042C, 0, 0 ),
        ( $10405, $1042D, 0, 0 ),
        ( $10406, $1042E, 0, 0 ),
        ( $10407, $1042F, 0, 0 ),
        ( $10408, $10430, 0, 0 ),
        ( $10409, $10431, 0, 0 ),
        ( $1040A, $10432, 0, 0 ),
        ( $1040B, $10433, 0, 0 ),
        ( $1040C, $10434, 0, 0 ),
        ( $1040D, $10435, 0, 0 ),
        ( $1040E, $10436, 0, 0 ),
        ( $1040F, $10437, 0, 0 ),
        ( $10410, $10438, 0, 0 ),
        ( $10411, $10439, 0, 0 ),
        ( $10412, $1043A, 0, 0 ),
        ( $10413, $1043B, 0, 0 ),
        ( $10414, $1043C, 0, 0 ),
        ( $10415, $1043D, 0, 0 ),
        ( $10416, $1043E, 0, 0 ),
        ( $10417, $1043F, 0, 0 ),
        ( $10418, $10440, 0, 0 ),
        ( $10419, $10441, 0, 0 ),
        ( $1041A, $10442, 0, 0 ),
        ( $1041B, $10443, 0, 0 ),
        ( $1041C, $10444, 0, 0 ),
        ( $1041D, $10445, 0, 0 ),
        ( $1041E, $10446, 0, 0 ),
        ( $1041F, $10447, 0, 0 ),
        ( $10420, $10448, 0, 0 ),
        ( $10421, $10449, 0, 0 ),
        ( $10422, $1044A, 0, 0 ),
        ( $10423, $1044B, 0, 0 ),
        ( $10424, $1044C, 0, 0 ),
        ( $10425, $1044D, 0, 0 ),
        ( $10426, $1044E, 0, 0 ),
        ( $10427, $1044F, 0, 0 ),
        ( $10C80, $10CC0, 0, 0 ),
        ( $10C81, $10CC1, 0, 0 ),
        ( $10C82, $10CC2, 0, 0 ),
        ( $10C83, $10CC3, 0, 0 ),
        ( $10C84, $10CC4, 0, 0 ),
        ( $10C85, $10CC5, 0, 0 ),
        ( $10C86, $10CC6, 0, 0 ),
        ( $10C87, $10CC7, 0, 0 ),
        ( $10C88, $10CC8, 0, 0 ),
        ( $10C89, $10CC9, 0, 0 ),
        ( $10C8A, $10CCA, 0, 0 ),
        ( $10C8B, $10CCB, 0, 0 ),
        ( $10C8C, $10CCC, 0, 0 ),
        ( $10C8D, $10CCD, 0, 0 ),
        ( $10C8E, $10CCE, 0, 0 ),
        ( $10C8F, $10CCF, 0, 0 ),
        ( $10C90, $10CD0, 0, 0 ),
        ( $10C91, $10CD1, 0, 0 ),
        ( $10C92, $10CD2, 0, 0 ),
        ( $10C93, $10CD3, 0, 0 ),
        ( $10C94, $10CD4, 0, 0 ),
        ( $10C95, $10CD5, 0, 0 ),
        ( $10C96, $10CD6, 0, 0 ),
        ( $10C97, $10CD7, 0, 0 ),
        ( $10C98, $10CD8, 0, 0 ),
        ( $10C99, $10CD9, 0, 0 ),
        ( $10C9A, $10CDA, 0, 0 ),
        ( $10C9B, $10CDB, 0, 0 ),
        ( $10C9C, $10CDC, 0, 0 ),
        ( $10C9D, $10CDD, 0, 0 ),
        ( $10C9E, $10CDE, 0, 0 ),
        ( $10C9F, $10CDF, 0, 0 ),
        ( $10CA0, $10CE0, 0, 0 ),
        ( $10CA1, $10CE1, 0, 0 ),
        ( $10CA2, $10CE2, 0, 0 ),
        ( $10CA3, $10CE3, 0, 0 ),
        ( $10CA4, $10CE4, 0, 0 ),
        ( $10CA5, $10CE5, 0, 0 ),
        ( $10CA6, $10CE6, 0, 0 ),
        ( $10CA7, $10CE7, 0, 0 ),
        ( $10CA8, $10CE8, 0, 0 ),
        ( $10CA9, $10CE9, 0, 0 ),
        ( $10CAA, $10CEA, 0, 0 ),
        ( $10CAB, $10CEB, 0, 0 ),
        ( $10CAC, $10CEC, 0, 0 ),
        ( $10CAD, $10CED, 0, 0 ),
        ( $10CAE, $10CEE, 0, 0 ),
        ( $10CAF, $10CEF, 0, 0 ),
        ( $10CB0, $10CF0, 0, 0 ),
        ( $10CB1, $10CF1, 0, 0 ),
        ( $10CB2, $10CF2, 0, 0 ),
        ( $118A0, $118C0, 0, 0 ),
        ( $118A1, $118C1, 0, 0 ),
        ( $118A2, $118C2, 0, 0 ),
        ( $118A3, $118C3, 0, 0 ),
        ( $118A4, $118C4, 0, 0 ),
        ( $118A5, $118C5, 0, 0 ),
        ( $118A6, $118C6, 0, 0 ),
        ( $118A7, $118C7, 0, 0 ),
        ( $118A8, $118C8, 0, 0 ),
        ( $118A9, $118C9, 0, 0 ),
        ( $118AA, $118CA, 0, 0 ),
        ( $118AB, $118CB, 0, 0 ),
        ( $118AC, $118CC, 0, 0 ),
        ( $118AD, $118CD, 0, 0 ),
        ( $118AE, $118CE, 0, 0 ),
        ( $118AF, $118CF, 0, 0 ),
        ( $118B0, $118D0, 0, 0 ),
        ( $118B1, $118D1, 0, 0 ),
        ( $118B2, $118D2, 0, 0 ),
        ( $118B3, $118D3, 0, 0 ),
        ( $118B4, $118D4, 0, 0 ),
        ( $118B5, $118D5, 0, 0 ),
        ( $118B6, $118D6, 0, 0 ),
        ( $118B7, $118D7, 0, 0 ),
        ( $118B8, $118D8, 0, 0 ),
        ( $118B9, $118D9, 0, 0 ),
        ( $118BA, $118DA, 0, 0 ),
        ( $118BB, $118DB, 0, 0 ),
        ( $118BC, $118DC, 0, 0 ),
        ( $118BD, $118DD, 0, 0 ),
        ( $118BE, $118DE, 0, 0 ),
        ( $118BF, $118DF, 0, 0 )
      ) ;

implementation

end.

