{
        Program Name : _Images
        Package Name : C&C Subroutine Library
        Purpose      : Image-related definitions
        Institution  : Conroy & Conroy Co.
        Date Written : 4-Dec-2017
        Written By   : Alan Conroy
        Version      : 1.0

	      Copyright (C) 2017 by Alan Conroy.  All rights reserved.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

        DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          TImage is the abstract base class for all descendant image types.
}

unit _Images ;

interface

{$I EDEFINES.INC}

type TImage = class
                  public { API... }
                          function Get_Pixel( Index : cardinal ) : int64 ;
                              virtual ; stdcall ; abstract ;
                          procedure Set_Pixel( Index : cardinal ; Value : int64 ) ;
                              virtual ; stdcall ; abstract ;
                          function Get_Width : cardinal ;
                              virtual ; stdcall ; abstract ;
                          procedure Set_Width( Value : cardinal ) ;
                              virtual ; stdcall ; abstract ;
                          function Get_Height : cardinal ;
                              virtual ; stdcall ; abstract ;
                          procedure Set_Height( Value : cardinal ) ;
                              virtual ; stdcall ; abstract ;

{$IFDEF PROPERTIES}
                  public { Properties... }
                      property Height : cardinal
                          read Get_Height
                          write Set_Height ;
                      property Width : cardinal
                          read Get_Width
                          write Set_Width ;
                      property Pixel[ X, Y : cardinal ] : int64
                          read Get_Pixel
                          write Set_Pixel ;
{$ENDIF}
              end ; { TImage }

implementation

end.

