{$D-}
{
              Program Name : _TSRS
              Package Name : Subroutine Library - Layer 0
              Purpose      : Support for Windows and DOS structures
              Institution  : Conroy & Conroy Co.
              Date Written : 21-Jan-1992
              Written By   : Alan Conroy
              Version      : 2.1B

              Copyright (C) 1992 by Alan Conroy. 

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *********************************************************
        *                                                       *
        *        M O D I F I C A T I O N   H I S T O R Y        *
        *                                                       *
        *********************************************************

             DATE      BY             REASON

        *********************************************************
        *                                                       *
        *           P R O G R A M   P U R P O S E               *
        *                                                       *
        *********************************************************

          These strutures are for support of Windows and DOS.

}

unit _TSRS ;

interface

{$I EDEFINES.INC}

{ DOS structure definitions }
type { VESA subfunction 0 buffer }
     TVESA_0 = packed record
                  Signature : array[ 0..3 ] of char ;
                  Major_Version : byte ;
                  Minor_Version : byte ;
                  Manufacturer : PChar ;
                  Flags : longint ;
                  Code_Numbers : pointer ;
              end ;

     { VESA subfunction 0 buffer }
     TVESA_1 = packed record
                  Mode : word ;
                  Flags : array[ 0..1 ] of byte ;
                  Granularity : word ;
                  Size : word ;
                  Segments : array[ 0..1 ] of word ;
                  Routine : pointer ;
                  Line_Bytes : byte ;
                  X_Resolution : word ;
                  Y_Resolution : word ;
                  Pixel_Width : byte ;
                  Pixel_Height : byte ;
                  Bitplanes : byte ;
                  Bits_Per_Pixel : byte ;
                  Blocks : byte ;
                  Model : byte ;
                  Block_Size : byte ;
              end ;

     { Find packed record }
     TDOS_Find_Record = packed record
                            Reserved : array[ 0..20 ] of byte ;
                            Attributes : byte ;
                            Time : word ;
                            Date : word ;
                            Size : longint ;
                            Name : array[ 0..12 ] of char ;
                        end ;

     { DPE (Disk Partition Entry) }
     TDPE = packed record
                Status : byte ; { 0 = inactive, $80 = boot partition }
                Start_Head : byte ;
                Start_Sector_Cylinder : word ; { 0:4 = sector, 8:15,6:7 = cylinder }
                Partition_Type : byte ;
                { 0 = entry not allocated
                  1 = Primary DOS (FAT12)
                  2 = XENIX
                  3 = XENIX
                  4 = Primary DOS (FAT16)
                  5 = Extended DOS (DOS 3.3)
                  6 = DOS 4.0 partition with >32 Mb
                  $DB = Concurrent DOS
                }
                End_Head : byte ;
                End_Sector_Cylinder : word ; { 0:4 = sector, 8:15,6:7 = cylinder }
                Boot_Sector : longint ;
                Sectors : longint ;
           end ;

     { DPS ( Disk Partition Sector) }
     TDPS = packed record
                Code : array[ 0..$1BD ] of byte ;
                Partitions : array[ 0..3 ] of TDPE ;
                ID : word ; { $AA55 (indicates a disk partition sector ) }
           end ;

     { EXE File Header }
     TEXE_Header = packed record
                        ID : word ; { $5A4D }               {e_magic}
                        Length : longint ;                  {e_cblp, e_cp}
                        Segment_Address_Count : word ;      {e_crlc}
                        Header_Size : word ;                {e_cparhdr}
                        Min_Paragraphs : word ;             {e_minalloc}
                        Max_Paragraphs : word ;              {e_maxalloc}
                        SS_Displacement : word ;            {e_ss}
                        Starting_SP : word ;                {e_sp}
                        Checksum : word ;                   {e_csum}
                        Starting_IP : word ;                {e_ip}
                        CS_Offset : word ;                  {e_cs}
                        RT_Address : word ;                 {e_lfarlc}
                        Overlay : word ;                    {e_ovno}
                        Reserved : array[ 0..3 ] of word ;  {e_res}
                        OEM_ID : word ;                     {e_oemid}
                        OEM_Information : word ;            {e_oeminfo}
                        Reserved1 : array[ 0..9 ] of word ; {e_res2}
                        Offset : longint ; {Pointer to NE_Header} {e_lfanew}
                   end ;

     { NE Header }
     TNE_Header = packed record
                      ID : word ; {'NE'}                         {ne_magic}
                      Linker_Version : byte ;                    {ne_ver}
                      Linker_Revision : byte ;                   {ne_rev}
                      Entry_Table_Offset : word ;                {ne_enttab}
                      Entry_Table_Length : word ;                {ne_cbenttab}
                      Checksum : longint ;                       {ne_crc}
                      Flags : word ;                             {ne_flags}
                      Automatic_DS_Number : word ;               {ne_autodata}
                      Local_Heap_Size : word ; {initial}         {ne_heap}
                      Stack_Size : word ; {initial}              {ne_stack}
                      Starting_CSIP : longint ;                  {ne_csip}
                      Starting_SSSP : longint ;                  {ne_sssp}
                      Segment_Table_Entries : word ;             {ne_cseg}
                      Module_Ref_Entries : word ;                {ne_cmod}
                      Nonresident_Name_Table_Size : word ;       {ne_cbnrestab}
                      Segment_Table_Offset : word ;              {ne_segtab}
                      Resource_Table_Offset : word ;             {ne_rsrctab}
                      Resident_Name_Table_Offset : word ;        {ne_restab}
                      Module_Ref_Table_Offset : word ;           {ne_modtab}
                      Imported_Name_Table_Offset : word ;        {ne_imptab}
                      Nonresident_Name_Table_Offset : longint ;  {ne_nrestab}
                      Movable_Entry_Points : word ;              {ne_cmovent}
                      Logical_Sector_Alignment_Shift : word ;    {ne_align}
                      Resource_Segment_Count : word ;            {ne_cres}
                      Target_OS : byte ;                         {ne_exetyp}
                      Additional_Flags : byte ;                  {ne_flagsothers}
                      Return_Thunks_Offset : word ;              {ne_pretthunks}
                      Segment_Ref_Bytes_Offset : word ;          {ne_psegrefbytes}
                      Reserved : word ;                          {ne_swaparea}
                      Expected_Windows_Version_Number : word ;   {ne_expver}
                  end ;

     { PE Header }
     TPE_Header_With_Optional = packed record
                                    Signature : longint ; { "PE"#0#0 }
                                    Machine : word ;
                                    NumberOfSections : word ;
                                    TimeDateStamp : longint ;
                                    PointerToSymbolTable : longint ;
                                    NumberOfSymbols : longint ;
                                    SizeOfOptionalHeader : word ;
                                    Characteristics : word ;
                                    Magic : word ;
                                    MajorLinkerVersion : byte ;
                                    MinorLinkerVersion : byte ;
                                    SizeOfCode : longint ;
                                    SizeOfInitializedData : longint ;
                                    SizeOfUninitializedData : longint ;
                                    AddressOfEntryPoint : longint ;
                                    BaseOfCode : longint ;
                                    BaseOfData : longint ;
                                    ImageBase : longint ;
                                    SectionAlignment : longint ;
                                    FileAlignment : longint ;
                                    MajorOperatingSystemVersion : word ;
                                    MinorOperatingSystemVersion : word ;
                                    MajorImageVersion : word ;
                                    MinorImageVersion : word ;
                                    MajorSubsystemVersion : word ;
                                    MinorSubsystemVersion : word ;
                                    Win32VersionValue : longint ;
                                    SizeOfImage : longint ;
                                    SizeOfHeaders : longint ;
                                    CheckSum : longint ;
                                    Subsystem : word ;
                                    DllCharacteristics : word ;
                                    SizeOfStackReserve : longint ;
                                    SizeOfStackCommit : longint ;
                                    SizeOfHeapReserve : longint ;
                                    SizeOfHeapCommit : longint ;
                                    LoaderFlags : longint ;
                                    NumberOfRvaAndSizes : longint ;
                                end ;

     TImage_Data_Directory = packed record
                                 VirtualAddress : longint ;
                                 Size : longint ;
                             end ;

     TData_Directory = array[ 0..1023 ] of TImage_Data_Directory ;

     TImage_Import_Descriptor = packed record
                                    Characteristics : longint ;
                                    TimeDateStamp : longint ;
                                    ForwarderChain : longint ;
                                    Name : longint ;
                                end ;

     { FCB (File Control Block) for V1.n }
     TDOS_FCBv1 = packed record
                    Extended : Byte ; { FFH if extended, offset -7 }
                    Filler : array[ 0..4 ] of Byte ;
                    Extended_Attribute : Byte ; { Offset -1 }
                    Drive_Number : Byte ; { Offset 0 }
                    File_Name : array[ 0..10 ] of Char ;
                    Current_Block : Word ;
                    Record_Size : Word ;
                    File_Size : Longint ;
                    Date : Word ;
                    Time : Word ;
                    Flags : Byte ;
                    Absolute_Cluster : Word ;
                    Starting_Cluster : Word ;
                    Relative_Cluster : Word ;
                    Filler1 : Byte ;
                    Current_Record : Byte ;
                    Record_Number : Longint
                  end ;

     { FCB (File Control Block) for V2.n }
     TDOS_FCBv2 = packed record
                    Extended : Byte ; {FFH if extended, offset -7}
                    Filler : array[ 0..4 ] of Byte ;
                    Extended_Attribute : Byte ; {Offset -1}
                    Drive_Number : Byte ; {Offset 0}
                    File_Name : array[ 0..10 ] of Char ;
                    Current_Block : Word ;
                    Record_Size : Word ;
                    File_Size : Longint ;
                    Date : Word ;
                    Time : Word ;
                    Flags : Byte ;
                    Starting_Cluster : Word ;
                    Filler1 : array[ 0..4 ] of Byte ;
                    Current_Record : Byte ;
                    Record_Number : Longint
                end ;

     { FCB (File Control Block) for V3.n, SHARE loaded, local file }
     TDOS_FCB_Local = packed record
                    Extended : Byte ; {FFH if extended, offset -7}
                    Filler : array[ 0..4 ] of Byte ;
                    Extended_Attribute : Byte ; {Offset -1}
                    Drive_Number : Byte ; {Offset 0}
                    File_Name : array[ 0..10 ] of Char ;
                    Current_Block : Word ;
                    Record_Size : Word ;
                    File_Size : Longint ;
                    Date : Word ;
                    Time : Word ;
                    SFT_Number : Byte ;
                    Flags : Byte ;
                    Starting_Cluster : Word ;
                    SHARE_Offset : Word ;
                    Attributes : Byte ;
                    Filler1 : Byte ;
                    Current_Record : Byte ;
                    Record_Number : Longint
                end ;

     { FCB (File Control Block) for V3.n, SHARE loaded, remote file }
     TDOS_FCB_Remote = packed record
                    Extended : Byte ; {FFH if extended, offset -7}
                    Filler : array[ 0..4 ] of Byte ;
                    Extended_Attribute : Byte ; {Offset -1}
                    Drive_Number : Byte ; {Offset 0}
                    File_Name : array[ 0..10 ] of Char ;
                    Current_Block : Word ;
                    Record_Size : Word ;
                    File_Size : Longint ;
                    Date : Word ;
                    Time : Word ;
                    Directory_Sector : Word ;
                    Relative_Cluster : Word ;
                    Absolute_Cluster : Word ;
                    Current_Record : Byte ;
                    Record_Number : Longint
                end ;

     { FCB (File Control Block) for V3.n, SHARE not loaded }
     TDOS_FCBv3 = packed record
                    Extended : Byte ; {FFH if extended, offset -7}
                    Filler : array[ 0..4 ] of Byte ;
                    Extended_Attribute : Byte ; {Offset -1}
                    Drive_Number : Byte ; {Offset 0}
                    File_Name : array[ 0..10 ] of Char ;
                    Current_Block : Word ;
                    Record_Size : Word ;
                    File_Size : Longint ;
                    Date : Word ;
                    Time : Word ;
                    Flags : Byte ;
                    Starting_Cluster : Word ;
                    Directory_Sector : Word ;
                    Directory_Entry : Byte ;
                    Current_Record : Byte ;
                    Record_Number : Longint
                end ;

     { PSP (Program Segment Prefix }
     pPSP = ^tPSP ;
     tPSP =	packed record
                    Int_20H : word ;
                    Size : Word ;
                    Reserved : Byte ;
                    FAR_Jump : array[ 0..4 ] of Byte ;
                    Int_22H : Longint ;
                    Int_23H : Longint ;
                    Int_24H : Longint ;
                    Parent : Word ;
                    Files : array[ 0..19 ] of Byte ;
                    Environment : Word ;
                    Ss_Sp : Longint ;
                    Max_Files : Word ;
                    File_Table : Pointer ;
                    Previous_PSP : Pointer ;
                    Filler1 : array[ 0..19 ] of Byte ;
                    Dispatch : array[ 0..2 ] of Byte ;
                    Filler2 : array[ 0..8 ] of Byte ;
                    Fcb1 : array[ 0..15 ] of Byte ;
                    Fcb2 : array[ 0..19 ] of Byte ;
                    Command_Tail : string[ 127 ] ;
                end ;

     { DPB (Drive Parameter Block) For DOS V1.n }
     TDOS_DPBv1 = packed record
                    Drive : Byte ;
                    Unit_Number : Byte ;
                    Bytes_Per_Sector : Word ;
                    Largest_Sector : Byte ;
                    Shift_Count : Byte ;
                    Reserved_Sectors : Word ;
                    FAT_Copies : Byte ;
                    Root_Directory_Entries : Word ;
                    First_Data_Sector : Word ;
                    Max_Cluster : Word
                end ;

     { DPB (Drive Parameter Block) For DOS V2.n }
     TDOS_DPBv2 = packed record
                    Drive : Byte ;
                    Unit_Number : Byte ;
                    Bytes_Per_Sector : Word ;
                    Largest_Sector : Byte ;
                    Shift_Count : Byte ;
                    Reserved_Sectors : Word ;
                    FAT_Copies : Byte ;
                    Root_Directory_Entries : Word ;
                    First_Data_Sector : Word ;
                    Max_Cluster : Word ;
                    FAT_Sectors : Byte ;
                    Root_Sector : Word ;
                    Driver : Pointer ;
                    Media_ID : Byte ;
                    Rebuild : Byte ;
                    Next_Driver : Pointer ;
                    Current_Directory_Cluster : Word ;
                    Current_Path : array[ 0..63 ] of Char
                end ;

     { DPB (Drive Parameter Block) For DOS V3.n }
     TDOS_DPBv3 = packed record
                    Drive : Byte ;
                    Unit_Number : Byte ;
                    Bytes_Per_Sector : Word ;
                    Largest_Sector : Byte ;
                    Shift_Count : Byte ;
                    Reserved_Sectors : Word ;
                    FAT_Copies : Byte ;
                    Root_Directory_Entries : Word ;
                    First_Data_Sector : Word ;
                    Max_Cluster : Word ;
                    FAT_Sectors : Byte ;
                    Root_Sector : Word ;
                    Driver : Pointer ;
                    Media_ID : Byte ;
                    Rebuild : Byte ;
                    Next_Driver : Pointer ;
                    Search_Start : Word ;
                    Free_Clusters : Word
                end ;

     { DPB (Drive Parameter Block) For DOS V4.n }
     TDOS_DPBv4 = packed record
                    Drive : Byte ;
                    Unit_Number : Byte ;
                    Bytes_Per_Sector : Word ;
                    Largest_Sector : Byte ;
                    Shift_Count : Byte ;
                    Reserved_Sectors : Word ;
                    FAT_Copies : Byte ;
                    Root_Directory_Entries : Word ;
                    First_Data_Sector : Word ;
                    Max_Cluster : Word ;
                    FAT_Sectors : Word ;
                    Root_Sector : Word ;
                    Driver : Pointer ;
                    Media_ID : Byte ;
                    Rebuild : Byte ;
                    Next_Driver : Pointer ;
                    Search_Start : Word ;
                    Free_Clusters : Word
                end ;

     { BPB (BIOS Parameter Block), DOS V2.n and V3.n }
     { As it appears on disks without 8 sectors/track, in sector 0 }
     TBPBv2 =	packed record
                    Jump : array[ 0..2 ] of Byte ; { Jump instruction }
                    System_ID : array[ 0..7 ] of Char ; { Manufacturer name/version }
                    Bytes_Per_Sector : Word ;
                    Sectors_Per_Cluster : Byte ;
                    Reserved_Sectors : Word ;
                    FAT_Count : Byte ;
                    Root_Directory_Entries : Word ;
                    Total_Sectors : Word ;
                    Media_ID : Byte ; { Media descriptor:
                                                F0 = 3.5" FDD, 2 sides, 80 tracks, 18 sectors/track
                                                F8 = HDD
                                                F9 = 5.25" FDD, 2 sides, 80 tracks, 15 sectors/track
                                                     3.5" FDD, 2 sides, 80 tracks, 9 sectors/track
                                                FA = FDD, 1 side, 80 tracks, 8 sectors/track
                                                FB = FDD, 2 sides, 80 tracks, 8 sectors/track
                                                FC = FDD, 1 side, 40 tracks, 9 sectors/track
                                                FD = FDD, 2 sides, 40 tracks, 9 sectors/track
                                                FE = FDD, 1 side, 40 tracks, 8 sectors/track
                                                FF = FDD, 2 sides, 40 tracks, 8 sectors/track
                                        }
                    FAT_Sectors : Word ;
                    Sectors_Per_Track : Word ;
                    Heads : Word ;
                    Hidden_Sectors : Longint ;
                    { Data after this is bootstrap code in FAT12/FAT16 }
                    { FAT32 fields: }
                    Total_Sectors_High : longint ;
                    FAT_Sectors_High : longint ;
                    Flags : word ;
                    Version : word ;
                    Root_Start_Cluster : longint ;
                    FS_Info_Sec : word ;
                    Backup_Boot_Sec : word ;
                    Reserved : word ;
                end ;

     { BPB (BIOS Parameter Block), DOS V4.n }
     TBPBv4 =	packed record
                    Jump : array[ 0..2 ] of Byte ;
                    System_ID : array[ 0..7 ] of Char ;
                    Bytes_Per_Sector : Word ;
                    Sectors_Per_Cluster : Byte ;
                    Reserved_Sectors : Word ;
                    FAT_Count : Byte ;
                    Root_Directory_Entries : Word ;
                    Total_Sectors : Word ;
                    Media_ID : Byte ;
                    FAT_Sectors : Word ;
                    Extended_Total_Sectors : Longint ;
                    Filler : array[ 0..5 ] of Byte ;
                    Cylinders : Word ;
                    Device_Type : Byte ;
                    Attributes : Word
                end ;

     { BPB (BIOS Parameter Block), Special - for DDT entries }
     TBPB =	packed record
                    Bytes_Per_Sector : Word ;
                    Sectors_Per_Cluster : Byte ;
                    Reserved_Sectors : Word ;
                    FAT_Count : Byte ;
                    Root_Directory_Entries : Word ;
                    Total_Sectors : Word ;
                    Media_ID : Byte ;
                    FAT_Sectors : Word ;
                    Sectors_Per_Track : Word ;
                    Heads : Word ;
                    Hidden_Sectors : Word
                end ;

     { DDT (Drive Data Table), DOS V3.3 }
     TDOS_DDTv3 = packed record
                    Next : Pointer ;
                    Unit_Number : Byte ;
                    Drive_Number : Byte ;
                    Bios_Pb : TBPB ;
                    Filler : Byte ;
                    Open : Word ;
                    Volume_Label : array[ 0..10 ] of Char ;
                    Null : Byte ;
                    Device_Type : Byte ;
                    Flags : Word ;
                    Cylinders : Word ;
                    Max_Capacity : TBPB ;
                    Filler1 : array[ 0..2 ] of Byte ;
                    File_System : array[ 0..8 ] of Char ;
                    Null1 : Byte ;
                    Last_Access : Longint ;
                end ;

     { DDT (Drive Data Table), DOS V4.n }
     TDOS_DDTv4 = packed record
                    Next : Pointer ;
                    Unit_Number : Byte ;
                    Drive_Number : Byte ;
                    Bios_Pb : TBPB ;
                    Filler : array[ 0..8 ] of Byte ;
                    Device_Type : Byte ;
                    Flags : Word ;
                    Cylinders : Word ;
                    Max_Capacity : TBPB ;
                    Filler1 : array[ 0..12 ] of Byte ;
                    Last_Access : Longint ;
                    Volume_Label : array[ 0..10 ] of Char ;
                    Null : Byte ;
                    Serial_Number : Longint ;
                    File_System : array[ 0..7 ] of Char ;
                    Null1 : Byte ;
                end ;

     { DPL (DOS Parameter List) }
     TDPL =	packed record
                    case Integer of
                        0 : ( Ax, Bx, Cx, Dx, Si, Di, Ds, Es, Filler, Id, Process : Word ) ;
                        1 : ( Al, Ah, Bl, Bh, Cl, Ch, Dl, Dh : Byte ) ;
                end ;

     { Disk Serial Number packed record }
     TSN_Record = packed record
                      Level : Word ;
                      Serial_Number : Longint ;
                      Volume_Label : array[ 0..10 ] of Char ;
                      File_System : array[ 0..7 ] of Char ;
                  end ;

     { KEYB internal data, DOS V3.3 }
     TDOS_Keybv3 =packed record
                    Int_09 : Pointer ;
                    Int_2F : Pointer ;
                    Filler : array[ 0..5 ] of Byte ;
                    Flags : Word ;
                    Filler1 : array[ 0..5 ] of Byte ;
                    Country_ID : array[ 0..1 ] of Char ;
                    Current_Code_Page : Word ;
                    First : Word ;
                    Ptr : Word ;
                    Filler2 : array[ 0..1 ] of Byte ;
                    Xlate : Word ;
                    Last : Word ;
                    Filler3 : array[ 0..8 ] of Byte ;
                end ;

     { KEYB internal data, DOS V4.n }
     TDOS_Keybv4 = packed record
                    Int_09 : Pointer ;
                    Int_2F : Pointer ;
                    Filler : array[ 0..5 ] of Byte ;
                    Flags : Word ;
                    Filler1 : array[ 0..5 ] of Byte ;
                    Country_ID : array[ 0..1 ] of Char ;
                    Current_Code_Page : Word ;
                    Filler2 : array[ 0..1 ] of Byte ;
                    First : Word ;
                    Ptr : Word ;
                    Filler3 : array[ 0..1 ] of Byte ;
                    Xlate : Word ;
                    Last : Word ;
                    Filler4 : array[ 0..8 ] of Byte ;
                end ;

     { EXEC Parameter Block }
     TEPB =	packed record
                    Environment : Word ;
                    Command_Line : Pointer ;
                    Fcb1 : Pointer ;
                    Fcb2 : Pointer ;
                    Initial_SS_SP : Longint ;
                    Entry_Pointer : Longint ;
                end ;

     { SDB (Search Data Block) }
     TSDB =	packed record
                    Drive_Letter : Byte ;
                    Search_Template : array[ 0..10 ] of Char ;
                    Search_Attributes : Byte ;
                    Directory_Entry : Word ;
                    Parent_Cluster : Word ;
                    Filler : array[ 1..4 ] of Byte ;
                    Found_Attribute : Byte ;
                    Time : Word ;
                    Date : Word ;
                    Size : Longint ;
                    Name : array[ 0..12 ] of Char ;
                end ;

     { List of Lists (LOL), DOS V2.n }
     TDOS_LOLv2 = packed record
                    Filler : array[ 0..13 ] of Byte ; {Offset -16}
                    MCB : Word ; {Offset -2}
                    DPB : Pointer ; {Offset 0}
                    SFT : Pointer ;
                    CLOCK_Driver : Pointer ;
                    CON_Driver : Pointer ;
                    Last_Drive : Byte ; {Offset 10H}
                    Max_Bytes_Per_Block : Word ;
                    First_Disk_Buffer : Pointer ;
                    NUL_Driver_Header : array[ 0..17 ] of Byte
                end ;

     { List of Lists (LOL), DOS V3.0 }
     TDOS_LOLv30 =packed record
                    Filler : array[ 0..3 ] of Byte ; {Offset -16}
                    Retry_Count : Word ; {Offset -12}
                    Retry_Delay : Word ; {Offset -10}
                    Current_Disk_Buffer : Pointer ; {Offset -8}
                    CON_Input : Word ; {Offset -4}
                    Mcb : Word ; {Offset -2}
                    Dpb : Pointer ; {Offset 0}
                    Sft : Pointer ;
                    CLOCK_Driver : Pointer ;
                    CON_Driver : Pointer ;
                    Device_Count : Byte ; {Offset 10H}
                    Max_Bytes_Per_Block : Word ;
                    First_Disk_Buffer : Pointer ;
                    Cds : Pointer ;
                    Last_Drive : Byte ;
                    STRING_Workspace : Pointer ;
                    STRING_Size : Word ;
                    Fcb : Pointer ;
                    Protected_FCBs : Word ;
                    NUL_Driver_Header : array[ 0..17 ] of Byte ;
                end ;

     { List of Lists (LOL), DOS V3.1+ }
     TDOS_LOLv3 = packed record
                    Filler : array[ 0..3 ] of Byte ; {Offset -16}
                    Retry_Count : Word ; {Offset -12}
                    Retry_Delay : Word ; {Offset -10}
                    Current_Disk_Buffer : Pointer ; {Offset -8}
                    CON_Input : Word ; {Offset -4}
                    Mcb : Word ; {Offset -2}
                    Dpb : Pointer ; {Offset 0}
                    Sft : Pointer ;
                    CLOCK_Driver : Pointer ;
                    CON_Driver : Pointer ;
                    Max_Bytes_Per_Block : Word ; {Offset 10H}
                    First_Disk_Buffer : Pointer ;
                    Cds : Pointer ;
                    Fcb : Pointer ;
                    Protected_FCBs : Word ;
                    Device_Count : Byte ;
                    Last_Drive : Byte ;
                    NUL_Driver_Header : array[ 0..17 ] of Byte ;
                    JOIN_Count : Byte ;
                end ;

     { List of Lists (LOL), DOS V4.n }
     TDOS_LOLv4 = packed record
                    Filler : array[ 0..13 ] of Byte ; {Offset -16}
                    Mcb : Word ; {Offset -2}
                    Dpb : Pointer ; {Offset 0}
                    Sft : Pointer ;
                    CLOCK_Driver : Pointer ;
                    CON_Driver : Pointer ;
                    Max_Bytes_Per_Block : Word ; {Offset 10H}
                    Disk_Buffer : Pointer ; {12H}
                    Cds : Pointer ;         {16H}
                    Fcb : Pointer ;         {1AH}
                    Protected_FCBS : Word ; {1EH}
                    Device_Count : Byte ;   {20H}
                    Last_Drive : Byte ;     {21H}
                    NUL_Driver_Header : array[ 0..17 ] of Byte ; {22H}
                    JOIN_Count : Byte ;     {34H}
                    Program_Names : Word ;  {35H}
                    IFS_Resident : Pointer ; {37H}
                    IFS_Chain : Pointer ;   {3BH}
                    Buffers_X : Word ;      {3FH}
                    Buffers_Y : Word ;      {41H}
                    Boot_Drive : Byte ;     {43H}
                    Filler1 : Byte ;
                    Extended_RAM_Size : Word ;
                end ;

     { MCB (Memory Control Block) }
     TDOS_MCB =	packed record
                    Block_Type : Byte ;
                    Owner : Word ;
                    Size : Word ;
                    Filler : array[ 0..2 ] of Byte ;
                    Name : array[ 0..7 ] of Char ;
                end ;

     { SCB (Subsegment Control Block) }
     TSCB =	packed record
                    Subsegment_Type : Char ;
                    Start : Word ;
                    Size : Word ;
                    Filler : array[ 0..2 ] of Byte ;
                    Name : array[ 0..7 ] of Char ;
                end ;

     { STACKS Code Segment }
     TSCS =	packed record
                    Filler : Word ;
                    Stacks : Word ;
                    SCB_Size : Word ;
                    Stack_Size : Word ;
                    Data_Segment : Pointer ;
                    Scb : Word ;
                    Last : Word ;
                    Next : Word ;
                end ;

     { SAE (STACKS Array Elements) }
     TSAE =	packed record
                    Status : Byte ;
                    Filler : Byte ;
                    Previous_SP : Word ;
                    Previous_SS : Word ;
                    Top : Word ;
                end ;

     { Sharing packed record }
     TDOS_Sharing_Record =packed record
                            Flag : Byte ;
                            Size : Word ;
                            Checksum : Byte ;
                            Lock_Record : Word ;
                            Sft : Pointer ;
                            Sequence : Word ;
                            Pathname : Char ; { First byte of variable area }
                        end ;
     { Lock packed record }
     TDOS_Lock_Record =	packed record
                            Next : Word ;
                            Start : Longint ;
                            Ending : Longint ;
                            Sft : Pointer ;
                            Owner : Word ;
                        end ;

     { SFT (System File Table), DOS V2.n }
     TDOS_SFTv2 = packed record
                    case Integer of
                        0 :    ( Handle_Count : Byte ;
                                Open_Mode : Byte ;
                                Attributes : Byte ;
                                Drive : Byte ;
                                Name : array[ 0..10 ] of Char ;
                                Filler : array[ 0..1 ] of Word ;
                                Size : Longint ;
                                Date : Word ;
                                Time : Word ;
                                Device_Attribute : Byte ;
                                Driver : Pointer ;
                                Absolute_Cluster : Word ;
                                Filler1 : Word ;
                                Current_Position : Longint ;
                               ) ;
                        1 :    ( Filler2 : array[ 0..27 ] of Byte ;
                                Start : Word ;
                                Relative_Cluster : Word ;
                               ) ;
                end ;

     { SFT (System File Table), DOS V3.n }
     TDOS_SFTv3 = packed record
                    Handle_Count : Word ;
                    Open_Mode : Word ;
                    Attributes : Byte ;
                    Device_Info : Word ;
                    Driver : Pointer ;
                    Start_Cluster : Word ;
                    Time : Word ;
                    Date : Word ;
                    Size : Longint ;
                    Current_Position : Longint ;
                    Relative_Cluster : Word ;
                    Absolute_Cluster : Word ;
                    Dir_Sector : Word ;
                    Directory_Entry : Byte ;
                    Fcb_Fn : array[ 0..10 ] of Char ;
                    Previous_SFT : Pointer ;
                    Owner : Word ;
                    Sharing_Record : Word ;
                end ;

     { SFT (System File Table), DOS V4.n }
     TDOS_SFTv4 = packed record
                    case Integer of
                        0 :    ( Handle_Count : Word ;
                                Open_Mode : Word ;
                                Attributes : Byte ;
                                Device_Info : Word ;
                                Driver : Pointer ;
                                Start_Cluster : Word ;
                                Time : Word ;
                                Date : Word ;
                                Size : Longint ;
                                Redirifs : Pointer ;
                                Filler : array[ 0..2 ] of Byte ;
                                Fcb_Fn : array[ 0..10 ] of Char ;
                                Previous_SFT : Pointer ;
                                Machine_Number : Word ;
                                Owner : Word ;
                                Sharing_Record : Word ;
                                Absolute_Cluster : Word ;
                                IFS_Driver : Pointer ;
                               ) ;
                        1 :    ( Filler1 : array[ 0..24 ] of Byte ;
                                Relative_Cluster : Word ;
                                Directory_Sector : Word ;
                                Directory_Entry : Byte ;
                               ) ;
                end ;

     { CDS (Current Directory Structure), DOS 3.n }
     TDOS_CDSv3 = packed record
                    case Integer of
                        0 :    ( Curr_Path : array[ 0..66 ] of Char ;
                                Flags : Word ;
                                Dpb : Pointer ;
                                Redirifs : Pointer ;
                                Parameter : Word ;
                                Root_OFS : Word ;
                               ) ;
                        1 :    ( Filler : array[ 0..72 ] of Byte ;
                                Start : Word ;
                                Filler0 : Word ;
                               ) ;
                end ;

     { CDS (Current Directory Structure), DOS 4.n }
     TDOS_CDSv4 =	packed record
                    case Integer of
                        0 :    ( Curr_Path : array[ 0..66 ] of Char ;
                                Flags : Word ;
                                Dpb : Pointer ;
                                Rediris : Pointer ;
                                Parameter : Word ;
                                Root_OFS : Word ;
                                Filler1 : Byte ;
                                IFS_Driver : Pointer ;
                                Filler2 : Word ;
                               ) ;
                        1 :    ( Filler : array[ 0..72 ] of Byte ;
                                Start : Word ;
                                Filler0 : Word ;
                               ) ;
                end ;

     { DOS Directory entry }
     TDOS_Dir_Rec =	packed record
                        Name : array[ 0..10 ] of Char ;
                        { Special codes: first byte: 0 = Last directory entry
                                                     5 = First character of filename is $E5
                                                     2E = File applies to current dir
                                                     E5 = Deleted }
                        Attributes : Byte ;
                        { And 1 = read-only
                          And 2 = Hidden
                          And 4 = System
                          And 8 = Volume name/label
                          And 16 = directory
                          And 32 = Archive
                          And 64 = reserved
                        }
                        Reserved : array[ 0..9 ] of Byte ;
                        Update_Time : Word ; { 0:4 = seconds in 2-second increments
                                               5:10 = Minute
                                               11:15 = Hour }
                        Update_Date : Word ; { 0:4 = Day
                                               5:8 = Month
                                               9:15 = Year - 1980 }
                        Start_Cluster : Word ;
                        Size : Longint ;
                    end ;

     { FindFirst/Next data block for SDAs }
     TSDB_Rec =	packed record
                    Drive_Letter : Byte ;
                    Search_Template : array[ 0..10 ] of Char ;
                    Search_Attributes : Byte ;
                    Directory_Entry : Word ;
                    Parent_Cluster : Word ;
                    Filler : array[ 1..4 ] of Byte ;
                end ;

     { SDA (Swappable DOS Area), DOS 3.n }
     TSDAv3 =	packed record
                    Critical_Error_Flag : Byte ;
                    InDOS_Flag : Byte ;
                    Error_Drive : Byte ;
                    Error_Locus : Byte ;
                    Extended_Error_Code : Word ;
                    Suggested_Action : Byte ;
                    Error_Class : Byte ;
                    Error_ES_DI : Pointer ;
                    Current_DTA : Pointer ;
                    Current_PSP : Word ;
                    Stored_SP : Word ;
                    Return_Code : Word ;
                    Current_Drive : Byte ;
                    Break_Flag : Byte ;
                    { Swap following only if in DOS }
                    Stored_AX : Word ;
                    Sharing_PSP : Word ;
                    Sharing_Number : Word ;
                    First_MB : Word ;
                    Best_MB : Word ;
                    Last_MB : Word ;
                    Filler : array[ 0..9 ] of Byte ;
                    Dd : Byte ;
                    Mm : Byte ;
                    Yy_1980 : Word ;
                    Dd_1980 : Word ;
                    Day_Of_Week : Byte ;
                    Filler1 : array[ 0..2 ] of Byte ;
                    Driver_Request_Header : array[ 0..25 ] of Byte ;
                    Entry_Point : Pointer ;
                    Driver_Request_Header1 : array[ 0..21 ] of Byte ;
                    Driver_Request_Header2 : array[ 0..21 ] of Byte ;
                    PSP_Type : Byte ;
                    Filler2 : array[ 0..6 ] of Byte ;
                    CLOCK_Record : array[ 0..5 ] of Byte ;
                    Filler3 : array[ 0..1 ] of Byte ;
                    Fn1 : array[ 0..127 ] of Char ;
                    Fn2 : array[ 0..127 ] of Char ;
                    Sdb : TSDB_Rec ;
                    Found_File : TDOS_Dir_Rec ;
                    Drive_CDSCopy : TDOS_Cdsv3 ;
                    Fcb_Fn1 : array[ 0..10 ] of Char ;
                    Filler4 : Byte ;
                    Fcb_Fn2 : array[ 0..10 ] of Char ;
                    Filler5 : array[ 0..8 ] of Byte ;
                    Search_Attributes : Byte ;
                    FCB_Type : Byte ;
                    Extended_Attributes : Byte ;
                    Open_Mode : Byte ;
                    Filler6 : array[ 0..2 ] of Byte ;
                    DOS_Flag : Byte ;
                    Filler7 : array[ 0..8 ] of Byte ;
                    Termination_Type : Byte ;
                    Filler8 : Byte ;
                    Replace_Byte : Byte ;
                    Error_DPB : Pointer ;
                    Stack_Frame : Pointer ;
                    Stored_SP1 : Word ;
                    DPB_Ptr : Pointer ;
                    Filler9 : array[ 0..7 ] of Byte ;
                    Media_ID : Byte ;
                    Filler10 : array[ 0..4 ] of Byte ;
                    Current_SFT : Pointer ;
                    Drive_CDSPTR : Pointer ;
                    Caller_FCB : Pointer ;
                    Filler11 : Word ;
                    Temp : Word ;
                    Jft : Pointer ;
                    Fn1_Csofs : Word ;
                    Fn2_Csofs : Word ;
                    Filler12 : array[ 0..17 ] of Byte ;
                    Current_Offset : Longint ;
                    Filler13 : array[ 0..11 ] of Byte ;
                    Appended : Longint ;
                    Disk_Buffer : Pointer ;
                    Sft : Pointer ;
                    Stored_BX : Word ;
                    Stored_DS : Word ;
                    Temp1 : Word ;
                    Call_Frame : Pointer ;
                    Ren_SrcFile : TSDB_Rec ;
                    Ren_File : TDOS_Dir_Rec ;
                    Error_Stack : array[ 0..330 ] of Byte ;
                    Disk_Stack : array[ 0..383 ] of Byte ;
                    Char_Stack : array[ 0..383 ] of Byte ;
                end ;

     { SDA (Swappable DOS Area), DOS 3.3 }
     TSDAv33 =	packed record
                    Critical_Error_Flag : Byte ;
                    InDOS_Flag : Byte ;
                    Error_Drive : Byte ;
                    Error_Locus : Byte ;
                    Extended_Error_Code : Word ;
                    Suggested_Action : Byte ;
                    Error_Class : Byte ;
                    Error_ES_DI : Pointer ;
                    Current_DTA : Pointer ;
                    Current_PSP : Word ;
                    Stored_SP : Word ;
                    Return_Code : Word ;
                    Current_Drive : Byte ;
                    Break_Flag : Byte ;
                    {Swap following only if in DOS}
                    Stored_AX : Word ;
                    Sharing_PSP : Word ;
                    Sharing_Number : Word ;
                    First_MB : Word ;
                    Best_MB : Word ;
                    Last_MB : Word ;
                    Filler : array[ 0..9 ] of Byte ;
                    Dd : Byte ;
                    Mm : Byte ;
                    Yy_1980 : Word ;
                    Dd_1980 : Word ;
                    Day_Of_Week : Byte ;
                    Filler1 : array[ 0..2 ] of Byte ;
                    Driver_Request_Header : array[ 0..25 ] of Byte ;
                    Entry_Point : Pointer ;
                    Driver_Request_Header1 : array[ 0..21 ] of Byte ;
                    Driver_Request_Header2 : array[ 0..21 ] of Byte ;
                    PSP_Type : Byte ;
                    Filler2 : array[ 0..6 ] of Byte ;
                    CLOCK_Record : array[ 0..5 ] of Byte ;
                    Filler3 : array[ 0..1 ] of Byte ;
                    Fn1 : array[ 0..127 ] of Char ;
                    Fn2 : array[ 0..127 ] of Char ;
                    Sdb : TSDB_Rec ;
                    Found_File : TDOS_Dir_Rec ;
                    Drive_CDSCopy : TDOS_Cdsv3 ;
                    Fcb_Fn1 : array[ 0..10 ] of Char ;
                    Filler4 : Byte ;
                    Fcb_Fn2 : array[ 0..10 ] of Char ;
                    Filler5 : array[ 0..8 ] of Byte ;
                    Search_Attributes : Byte ;
                    FCB_Type : Byte ;
                    Extended_Attributes : Byte ;
                    Open_Mode : Byte ;
                    Filler6 : array[ 0..2 ] of Byte ;
                    DOS_Flag : Byte ;
                    Filler7 : array[ 0..8 ] of Byte ;
                    Termination_Type : Byte ;
                    Filler8 : Byte ;
                    Replace_Byte : Byte ;
                    Error_DPB : Pointer ;
                    Stack_Frame : Pointer ;
                    Stored_SP1 : Word ;
                    DPB_Ptr : Pointer ;
                    Filler9 : array[ 0..7 ] of Byte ;
                    Media_ID : Byte ;
                    Filler10 : array[ 0..4 ] of Byte ;
                    Current_SFT : Pointer ;
                    Drive_CDSPTR : Pointer ;
                    Caller_FCB : Pointer ;
                    Filler11 : Word ;
                    Temp : Word ;
                    Jft : Pointer ;
                    Fn1_Csofs : Word ;
                    Fn2_Csofs : Word ;
                    Filler12 : array[ 0..17 ] of Byte ;
                    Current_Offset : Longint ;
                    Filler13 : array[ 0..11 ] of Byte ;
                    Appended : Longint ;
                    Disk_Buffer : Pointer ;
                    Sft : Pointer ;
                    Stored_BX : Word ;
                    Stored_DS : Word ;
                    Temp1 : Word ;
                    Call_Frame : Pointer ;
                    Ren_SrcFile : TSDB_Rec ;
                    Ren_File : TDOS_Dir_Rec ;
                    Error_Stack : array[ 0..330 ] of Byte ;
                    Disk_Stack : array[ 0..383 ] of Byte ;
                    Char_Stack : array[ 0..383 ] of Byte ;
                    Flag : Byte ;
                    Drive : Byte ;
                    Filler14 : Word ;
                end ;

     { SDA (Swappable DOS Area), DOS 4.n }
     TSDAv4 =	packed record
                    Critical_Error_Flag : Byte ;
                    InDOS_Flag : Byte ;
                    Error_Drive : Byte ;
                    Error_Locus : Byte ;
                    Extended_Error_Code : Word ;
                    Suggested_Action : Byte ;
                    Error_Class : Byte ;
                    Error_ES_DI : Pointer ;
                    Current_DTA : Pointer ;
                    Current_PSP : Word ;
                    Stored_SP : Word ;
                    Return_Code : Word ;
                    Current_Drive : Byte ;
                    Break_Flag : Byte ;
                    Filler : array[ 0..1 ] of Byte ;
                    {Swap following only if in DOS}
                    Stored_AX : Word ;
                    Sharing_PSP : Word ;
                    Sharing_Number : Word ;
                    First_MB : Word ;
                    Best_MB : Word ;
                    Last_MB : Word ;
                    Filler1 : array[ 0..9 ] of Byte ;
                    Dd : Byte ;
                    Mm : Byte ;
                    Yy_1980 : Word ;
                    Dd_1980 : Word ;
                    Day_Of_Week : Byte ;
                    Filler2 : array[ 0..2 ] of Byte ;
                    Driver_Request_Header : array[ 0..29 ] of Byte ;
                    Entry_Point : Pointer ;
                    Driver_Request_Header1 : array[ 0..21 ] of Byte ;
                    Driver_Request_Header2 : array[ 0..29 ] of Byte ;
                    Filler3 : array[ 0..5 ] of Byte ;
                    CLOCK_Record : array[ 0..5 ] of Byte ;
                    Filler4 : array[ 0..1 ] of Byte ;
                    Fn1 : array[ 0..127 ] of Char ;
                    Fn2 : array[ 0..127 ] of Char ;
                    Sdb : TSDB_Rec ;
                    Found_File : TDOS_Dir_Rec ;
                    Drive_CDSCopy : TDOS_Cdsv4 ;
                    Fcb_Fn1 : array[ 0..10 ] of Char ;
                    Filler5 : Byte ;
                    Fcb_Fn2 : array[ 0..10 ] of Char ;
                    Filler6 : array[ 0..10 ] of Byte ;
                    Search_Attributes : Byte ;
                    Open_Mode : Byte ;
                    Filler7 : array[ 0..2 ] of Byte ;
                    DOS_Flag : Byte ;
                    Filler8 : array[ 0..8 ] of Byte ;
                    Termination_Type : Byte ;
                    Filler9 : array[ 0..2 ] of Byte ;
                    Error_DPB : Pointer ;
                    Stack_Frame : Pointer ;
                    Stored_SP1 : Word ;
                    DPB_Pointer : Pointer ;
                    Disk_Buffer : Word ;
                    Filler10 : array[ 0..7 ] of Byte ;
                    Media_ID : Byte ;
                    Filler11 : Byte ;
                    Filler12 : Pointer ;
                    Current_SFT : Pointer ;
                    Drive_CDSPTR : Pointer ;
                    Caller_FCB : Pointer ;
                    Filler13 : array[ 0..3 ] of Byte ;
                    Jft : Pointer ;
                    Fn1_Csofs : Word ;
                    Fn2_Csofs : Word ;
                    Filler14 : array[ 0..11 ] of Byte ;
                    Directory_Cluster : Word ;
                    Filler15 : array[ 0..9 ] of Byte ;
                    Offset : Longint ;
                    Filler16 : Word ;
                    Partial_Bytes : Word ;
                    Sectors : Word ;
                    Filler17 : array[ 0..5 ] of Byte ;
                    Appended_Bytes : Longint ;
                    Disk_Buffer1 : Pointer ;
                    Sft1 : Pointer ;
                    Store_BX : Word ;
                    Store_DS : Word ;
                    Temp : Word ;
                    Previous_Call_Frame : Pointer ;
                    Filler18 : array[ 0..4 ] of Byte ;
                    Filler19 : Pointer ;
                    Special_Open_Action : Word ;
                    SPop_Attr : Word ;
                    SPop_Mode : Word ;
                    Filler20 : array[ 1..9 ] of Byte ;
                    Save_DS : Word ;
                    Filler21 : array[ 0..4 ] of Byte ;
                    Filename : Pointer ;
                    Filler22 : Pointer ;
                    Ssve_SS : Word ;
                    Save_SP : Word ;
                    Stack_Switch : Byte ;
                    Ren_SrcFile : TSDB_Rec ;
                    Ren_File : TDOS_Dir_Rec ;
                    Error_Stack : array[ 0..330 ] of Byte ;
                    Disk_Stack : array[ 0..383 ] of Byte ;
                    Char_Stack : array[ 0..383 ] of Byte ;
                    AH_Flag : Byte ;
                    Drive : Byte ;
                    Flag : Byte ;
                    Filler23 : array[ 0..8 ] of Byte ;
                end ;

     TOfS =	packed record { Structure for manipulation of pointers }
                    Offset, Segment : Word
                end ;

     XRegisters =	packed record  { Extended Registers type }
                            case Integer of
                                0 : ( Bp, Es, Ds, Di, Si, Dx, Cx, Bx, Ax, Ss, Sp, Cs, Ip,
                                        Flags : Word ) ;
                                1 : ( Fill1a, Fill1b, Fill2a, Fill2b, Fill3a, Fill3b,
                                        Fill4a, Fill4b, Fill5a, Fill5b, Dl, Dh, Cl, Ch,
                                        Bl, Bh, Al, Ah : Byte ) ;
                        end ;

     { CTR (Clock Transfer packed record) }
     TDOS_CTR =	packed record
                    Dd_1980 : Word ;
                    Minutes : Byte ;
                    Hours : Byte ;
                    Hundreths : Byte ;
                    Seconds : Byte ;
                end ;

     { DDH (Device Driver Header) }
     TDOS_DDH =	packed record
                    case Integer of
                        0 :    ( Next : Pointer ;
                                Attributes : Word ;
                                Exit_Point : Word ;
                                Entry_Point : Word ;
                                Sub_Units : Byte ;
                                Filler : array[ 0..6 ] of Byte ;
                                Reserved : Word ;
                                Drive : Char ;
                                Units : Byte ;
                                Signature : array[ 0..5 ] of Byte
                               ) ;
                        1 :    ( Filler1 : array[ 0..9 ] of Byte ;
                                Name : array[ 0..7 ] of Char
                               ) ;
                end ;

     { DDB (DOS Disk Buffer), DOS V2.n }
     TDDBv2 =	packed record
                    Next : Pointer ;
                    Drive : Byte ;
                    Filler : array[ 0..2 ] of Byte ;
                    Sector : Word ;
                    Copies : Byte ;
                    Offset : Byte ;
                    Dpb : Pointer ;
                    Start : Byte ;
                end ;

     { DDB (DOS Disk Buffer), DOS V3.n }
     TDDBv3 =	packed record
                    Next : Pointer ;
                    Drive : Byte ;
                    Flags : Byte ;
                    Sector : Word ;
                    Copies : Byte ;
                    Offset : Byte ;
                    Dpb : Pointer ;
                    Filler : Word ;
                    Start : Byte
                end ;

     { DDB (DOS Disk Buffer), DOS V4.n }
     TDDBv4 =	packed record
                    Next : Word ;
                    Previous : Word ;
                    Drive : Byte ;
                    Flags : Byte ;
                    Sector : Longint ;
                    Copies : Byte ;
                    Offset : Word ;
                    Dpb : Pointer ;
                    Count : Word ;
                    Filler : Byte ;
                    Start : Byte ;
                end ;

     { DBHCH (Disk Buffer Hash Chain Head), DOS V4.n }
     TDOS_DBHCH =	packed record
                    Page : Word ;
                    Least_Used : Pointer ;
                    Dirty_Buffers : Byte ;
                    Filler : Byte ;
                end ;

     { DBI (Disk Buffer Info), DOS V4.0 }
     TDOS_DBIv40 =	packed record
                    Dbhch : Pointer ;
                    Chain_Count : Word ;
                    Lookahead : Pointer ;
                    Flag : Byte ;
                    Handle : Word ;
                    Page : Word ;
                    Filler : Word ;
                    Segment : Word ;
                    Filler1 : Word ;
                    Mapping : array[ 0..3 ] of Word ;
                end ;

     { DBI (Disk Buffer Info), DOS V4.01 }
     TDOS_DBIv41 = packed record
                      Dbhch : Pointer ;
                      Chain_Count : Word ;
                      Lookahead : Pointer ;
                      Lookahead_Count : Word ;
                      Flag : Byte ;
                      Segment : Word ;
                      Page : Word ;
                      Segment1 : Word ;
                      Page1 : Word ;
                      Frames : Byte ;
                      Workspace : Word ;
                      Handle : Word ;
                      Page2 : Word ;
                      Filler : Word ;
                      Frame : Word ;
                      Filler1 : Word ;
                      Flag1 : Byte ;
                   end ;

     { Module link list entry, Windows NT/2000/XP }
     PModule_Link_List_Entry = ^TModule_Link_List_Entry ;
     TModule_Link_List_Entry = packed record
                                   Next : PModule_Link_List_Entry ;
                                   Previous : PModule_Link_List_Entry ;
                                   Filler : longint ;
                                   Filler1 : longint ;
                                   Base_Address : longint ; { Base address of module }
                               end ;

     { Module Link List, Windows NT/2000/XP }
     TModule_Link_List = packed record
                             Filler : longint ;
                             Filler1 : longint ;
                             Filler2 : longint ;
                             List_Start : pointer ;
                             List_End : pointer ;
                             Memory_List_Start : PModule_Link_List_Entry ;
                             Memory_List_End : PModule_Link_List_Entry ;
                             Initialization_Order_List_Start : pointer ;
                             Initialization_Order_List_End : pointer ;
                         end ;
     PModule_Link_List = ^TModule_Link_List ;

     { PEB (Process Environment Block), Windows NT/2000/XP }
     TPEB = packed record
                Environment : longint ;
                Filler : longint ;
                Filler1 : longint ;
                Module_Link_List : PModule_Link_List ;
                Process_Parameters : longint ;
                Subsystem_Data : longint ;
                Process_Heap : longint ;
            end ;
     PPEB = ^TPEB ;

     TPE_Header = packed record
                      Machine : word ;
                      NumberOfSections : word ;
                      TimeDateStamp : longint ;
                      PointtoSymbolTable : longint ;
                      NumberofSymbols : longint ;
                      SizeOfOptionalHeader : word ;
                      Characteristics : word ;
                  end ;

     TPE_Optional_Header = packed record
                              Magic : word ; // Always appears to be set to 0x010B.
                              MajorLinkerVersion : byte ;
                              MinorLinkerVersion : byte ;
                              SizeOfCode : cardinal ;
                              SizeOfInitializedData : cardinal ;
                              SizeOfUninitializedData : cardinal ;
                              AddressOfEntryPoint : cardinal ;
                              BaseOfCode : cardinal ;
                              BaseOfData : cardinal ;
                              ImageBase : cardinal ;
                              SectionAlignment : cardinal ;
                              FileAlignment : cardinal ;
                              MajorOperatingSystemVersion : word ;
                              MinorOperatingSystemVersion : word ;
                              MajorImageVersion : word ;
                              MinorImageVersion : word ;
                              MajorSubsystemVersion : word ;
                              MinorSubsystemVersion : word ;
                              Reserved1 : cardinal ;
                              SizeOfImage : cardinal ;
                              SizeOfHeaders : cardinal ;
                              CheckSum : cardinal ;
                              Subsystem : word ;
                              DllCharacteristics : word ;
                              SizeOfStackReserve : cardinal ;
                              SizeOfStackCommit : cardinal ;
                              SizeOfHeapReserve : cardinal ;
                              SizeOfHeapCommit : cardinal ;
                              LoaderFlags : cardinal ;
                              NumberOfRvaAndSizes : cardinal ;
                           end ;

     TPE_Image_Section_Header = packed record
                                    Name : array[ 0..7 ] of char ;
                                    Misc : record
                                               case boolean of
                                                   True : ( PhysicalAddress : longint ) ;
                                                   False : ( VirtualSize : longint ) ;
                                           end ;
                                    VirtualAddress : longint ;
                                    SizeOfRawData : longint ;
                                    PointerToRawData : longint ;
                                    PointerToRelocations : longint ;
                                    PointerToLinenumbers : longint ;
                                    NumberOfRelocations : word ;
                                    NumberOfLinenumbers : word ;
                                    Characteristics : longint ;
                                end ;

implementation

end.
