<?php
/*
			  Program Name : Maths
              Package Name : LB
              Purpose      : Various math routines
              Institution  : Conroy & Conroy Company
              Original Vers: 01-Apr-1987
              Date Written : 25-Jan-2002
              Written By   : Alan Conroy
              Version      : 2.0C

              Copyright (C) 1987-2020 by Alan Conroy.  Released to the publicmain.

              TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *********************************************************
        *                                                       *
        *        M O D I F I C A T I O N   H I S T O R Y        *
        *                                                       *
        *********************************************************

             DATE      BY             REASON

        *********************************************************
        *                                                       *
        *           P R O G R A M   P U R P O S E               *
        *                                                       *
        *********************************************************

          These functions perform various math functions.
*/

// Subroutine Library...
////L10n, // Text_*

////     CommonUt //  Edit


function Max( $X, $Y )
{
    if( $X > $Y )
    {
        return $X ;
    } else
    {
        return $Y ;
    } ;
} ;


function Min( $X, $Y )
{
    if( $X < $Y )
    {
        return $X ;
    } else
    {
        return $Y ;
    } ;
} ;


function Round_Up( $Value, $Round )
{
    if( $Round == 0 )
    {
        return 0 ;
    } ;
    $Result = ( $Value + $Round - 1 ) / $Round ;
    return $Result * $Round ;
} ;


function Convert_Endian( $Value, $Size )
{
    Result = 0 ;
    move( Value, A, sizeof( Value ) ) ;
    for Loop = 0 to sizeof( A ) div 2  - 1
    {
        Z = A[ Loop ] ;
        A[ Loop ] = A[ sizeof( A ) - Loop - 1 ] ;
        A[ sizeof( A ) - Loop - 1 ] = Z ;
    } ;
    move( A[ 4 - Size ], Result, Size ) ;
} ;


function SuperFactorial( $X )
{
    $Y = $X ;
    while( $Y > 1 )
    {
        $X = $X * Factorial( $Y ) ;
        $Y = $Y - 1 ;
    } ;
    return $X ;
} ;


function Factorial( $X )
{
    $Y = $X - 1 ;
    if( $X == int( $X ) )
    {
        while( $Y > 1 )
        {
            $X = int( $X * $Y ) ;
            $Y = $Y - 1 ;
        } ;
    } else
    {
        while( $Y > 1 )
        {
            $X = $X * $Y ;
            $Y = $Y - 1 ;
        } ;
    } ;
    return $X ;
} ;


function E()
{
    return 2.718 ;
} ;


function Pi()
{
    return 3.1415926535897932385 ;
} ;


function Circle_Area( $Radius )
{
    return Pi() * SQR( $Radius ) ;
} ;


function Circle_Circumference( $Diameter )
{
    return Pi() * $Diameter ;
} ;


function Tan( $X ) // Return tangent of a value
{
    return Sin($X ) / Cos( $X )
} ;


function Log10( $X ) // Return logarithm, base 10
{
    return Ln( $X ) / Ln( 10 )
} ;


function Rad( $X ) // RAD - Degree to Radian conversion
{
    return $X / ( 180. / Pi() ) ;
} ;


function Deg( $X ) // DEG - Radian to Degree conversion
{
    return $X * ( 180. / Pi() ) ;
} ;


function CoT( $X ) // COT - Cotangent
{
    return 1 / Tan( $X ) ;
} ;


function CSc( $X ) // CSC - Cosecant
{
    return 1. / Sin( $X ) ;
} ;


function Sec( $X )  // SEC - Secant
{
    return 1. / Cos( $X ) ;
} ;


function Fib( $X ) // Fibonacci sequence
{
    $X = Int( Abs( $X ) ) ;
    if( $X < 2 )
    {
        return 1 ;
    }
    $A1 = 1 ;
    $A2 = 1 ;
	$X=Trunc($X);
    for( $Dummy = 2; $Dummy <=$X; $Dummy +=1 )
    {
        $A3 = $A2 ;
        $A2 = $A1 ;
        $A1 = $A2 + $A3 ;
    } ;
    return $A1 + $A2 ;
} ;


function GCD( $N, $D )
// Return greatest common divisor of passed numbers
{
    if( $N == $D )
    {
		return $D ;
    } ;
    if( $N < $D )
    {
		return 0 ; // Greatest common divisor is non-integer
    } ;
    $X = $N mod $D ;
    while( $X <> 0 )
    {
		$N = $D ;
		$D = $X ;
		$X = $N mod $D ;
    } ;
    return $D ;
} ;


function ArcCos( $X ) // Arc Cosine
{
    $Temp = Power( $X, 2, $E ) ;
    $Temp = 1 - $Temp ;
    return Arctan( Sqrt( $Temp ) / $X )
} ;


function ArcCoT( $X ) // Arc Cotangent
{
    return Arctan( 1. / X )
} ;


function ArcCSc( $X ) // Arc Cosecant
{
    return Arctan( 1. / Sqrt( $X ) ) ;
} ;


function ArcSec( $X ) // Arc Secant
{
    X = Power( X, 2, E ) - 1 ;
    return Arctan( Sqrt( X ) ) ;
} ;


function ArcSin( $X ) // Arc Sine
{
    Temp = Power( X, 2, E ) ;
    Temp = 1 - Temp ;
    return Arctan( X / Sqrt( Temp ) )
} ;


function HypCos( $X ) // Hyperbolic Cosine
{
    return ( Exp( X ) + Exp( - X ) ) / 2.
} ;


function HypCoT( $X ) // Hyperbolic Cotangent
{
    Temp = Exp( X ) - Exp( - X ) ;
    return ( Exp( X ) + Exp( -X ) ) / Temp ;
} ;


function HypCSc( $X ) // Hyperbolic Cosecant
{
    X = Exp( X ) - Exp( -X ) ;
    return 2. / X ;
} ;


function HypSec( $X ) // Hyperbolic secant
{
    $X = Exp( $X ) + Exp( -$X ) ;
    return 2. / $X ;
} ;


function HypSin( $X ) // Hyperbolic Sine
{
    HypSin = ( Exp( $X ) - Exp( -$X ) ) / 2.
} ;


function HypTan( $X ) // Hyperbolic Tangent
{
    Temp = Exp( X ) + Exp( -X ) ;
    return ( Exp( X ) - Exp( -X ) ) / Temp ;
} ;


function HypArcCos( $X ) // Hyperbolic Arc Cosine
{
    Temp = Power( X, 2, E ) ;
    Temp = Temp - 1 ;
    X = X + Sqrt( Temp ) ;
    return Ln( X )
} ;


function HypArcCoT( $X ) // Hyperbolic Arc Cotangent
{
    return ( Ln( X + 1 ) - Ln( X - 1 ) ) / X ;
} ;


function HypArcCsc( $X ) // Hyperbolic Arc Cosecant
{
    Temp = Power( X, 2, E ) ;
    return Ln( ( 1. / X ) + Sqrt( 1 / Temp + 1 ) )
} ;


function HypArcSec( $X ) // Hyperbolic Arc Secant
{
    Temp = Power( X, 2, E ) ;
    Temp = 1 / Temp - 1 ;
    return Ln( ( 1. / X ) + Sqrt( Temp ) ) ;
} ;


function HypArcSin( $X ) // Hyperbolic Arc Sine
{
    Temp = Power( X, 2, E ) + 1 ;
    X = X + Sqrt( Temp ) ;
    return Ln( X )
} ;


function HypArcTan( $X ) // Hyperbolic Arc Tangent
{
    return ( Ln( ( 1. + X ) / ( 1. - X ) ) ) / 2. ;
} ;


function Root( $X, $R )
// This function returns the Rth root of X.  For example, Root( 27, 3 ) returns 3.
{
    // Check invalid results
    if( X < 0 ) // Negative value
    {
        if( ( R and 1 ) == 0 ) // Even number
        {
            Application_Manager^.Fatal_Exception( Text_Error_Imaginary_Number ) ;
            // Cannot get a negative value from an even number of multiplies
        } ;
    } ;

    // Determine initial range
    High = R ;
    High = X / High ;
    if( High < 2 )
    {
	      High = 2 ;
    } ;
    Low = 1.0 ;
    Last = X ;

    // Bisearch for the solution
    while( Low <> High )
    {
        Mid = Low + ( ( High - Low ) / 2.0 ) ;
        if( ( Low == Mid ) or ( High == Mid ) )
        {
            break ;
        } ;
        Intermediate = Power( Mid, R, Dummy ) ;
        if( Intermediate == X ) // Match found
        {
            Low = Mid ;
            break ;
        } else
        {
            if( Intermediate < X )
            {
                Low = Mid ;
            } else
            {
                High = Mid ;
            } ;
        } ;
        if( Last == Intermediate ) // No further resolution available
        {
            Low = Mid ;
            break ;
        } ;
        Last = Intermediate ;
    } ; // while( Low <> High )

    // Return result
    return Low ;
} ; // Root


function Sgn( $X )
// This function emulates the BASIC-Plus SGN function.  It returns the following:
//           for SGN(n):
//              n<0 returns -1
//              n=0 returns 0
//              n>0 returns 1
{
    if($X == 0 )
    {
        return 0 ;
    }
    if( $X < 0 )
    {
        return -1 ;
    }
    return 1 ;
} ;


function ISgn( $X )
{
	return Sgn($X);
} ;


function Power( $X, $N, var $_Result )
// This function returns the result of one number to the power of another.
// Based on C code from Computer Language magazine.

var Size_X : Integer ;
    Temp : Small_string ;

    function Pwr( $N )
    {
        Pwr = -1 ; // Assume failure
        if( _Result <> 0 )
        {
            Pwr = 1 ;
            Exit
        } ;
        if( N == 1 )
        {
            Pwr = X ;
        } else
        {
            Temp1 = Pwr( N div 2 ) ;
            Str( Temp1 : 40 : 0, Temp ) ;
            Temp = Edit( Temp, 2 ) ;
            if( Odd( N ) )
            {
                if( Size_X + Length( Temp ) * 2 < 32 )
                {
                    Pwr = Sqr( Temp1 ) * X ;
                } else
                {
                    _Result = 7 ;
                    Exit ;
                end
            } else
            if( Length( Temp ) * 2 < 32 )
            {
                Pwr = Sqr( Temp1 ) ;
            } else
            {
                _Result = 7 ;
            } ;
        } ; // if( N == 1 )
    } ; // Power.Pwr

{ // Power
    _Result = 0 ;
    Power = 0 ;
    if( X <> 0 )
    {
        if( N == 0 )
        {
            Power = 1 ;
        } else
        if( Frac( N ) <> 0 )
        {
            if ( X < 0 )
            {
                _Result = 11 ;
                Exit ;
            } ;
            if ( N * Ln( X ) > 88 ) or ( N * Ln( X ) < -88 )
            {
                _Result = 12 ; // Error
                Exit ;
            } ;
            return Exp( N * Ln( X ) )
        } else
        {
            Str( X : 40 : 0, Temp ) ;
            Temp = Edit( Temp, 2 ) ;
            Size_X = Length( Temp ) ;
            if( ( N > 32767 ) or ( N < -32767 ) )
            {
                _Result = 7 ;
            } else
            if( N < 0 )
            {
                return 1 / Pwr( -Trunc( N ) ) ;
            } else
            {
                return Pwr( Trunc( N ) ) ;
            } ;
        } ; // if( Frac( N ) <> 0
    } ; // if( X <> 0 )
} ; // Power


function Slope( $X, $Y )
{
    return $Y / ( $X + 1.0 ) ;
} ;


function X_From_Slope( $S )
{
    return ( 1.0 - sqr( $S ) ) / ( 1.0 + sqr( $S ) ) ;
} ;


function Y_From_Slope( $S )

{
    return ( 2.0 * $S ) / ( 1.0 + sqr( $S ) ) ;
} ;


procedure Pythagorean_Triple( $Slope, var $a, $b, $c )
{
    p = Y_From_Slope( Slope ) ;
    q = X_From_Slope( Slope ) + 1.0 ;
    a = sqr( q ) - sqr( p ) ;
    b = 2.0 * p * q ;
    c = sqr( q ) + sqr( p ) ;
} ;


function Benford( $X )
{
    return Log10( 1 + 1 / $X ) ;
} ;


function Variance( $Values : array )
{
    Sum = 0.0 ;
    for I = low( Values ) to high( Values )
    {
        Sum = Sum + Values[ I ] ;
    } ;
    Mean = Sum / length( Values ) ;

    Total = 0.0 ;
    for I = low( Values ) to high( Values )
    {
        Total = Total + SQR( Values[ I ] - Mean ) ;
    } ;

    return Total / length( Values ) ;
} ;


function Standard_Deviation( $Values )
{
    return SQRT( Variance( $Values ) ) ;
} ;


function Sum( Values : array )  
{
    S = 0.0 ;
    for I = low( Values ) to high( Values )
    {
        S = S + Values[ I ] ;
    } ;
    return S ;
} ;


function Mean( $Values )
{
    return Sum( $Values ) / count($Values ) ;
} ;


function Coefficient_of_variation( $Values )
{
    return Standard_Deviation( $Values ) / Mean( $Values ) ;
} ;


// Probability of X within a normal (Gaussian) distribution
function Probability( $X, $Mean, $Standard_Deviation ) 
{
    return ( 1 / Standard_Deviation * SQRT( 2 * Pi ) ) * Power( E, SQR( X - Mean ) / SQR( 2 * Standard_Deviation ), Dummy ) ;
} ;


// Possibility of a number in the range of X to Y in a uniform (rectangular) distribution
function Range_Probability( $X, $Y,$Min, $Max )
{
    if( ( X < Min ) or ( Y > Max ) or ( Max == Min ) )
    {
        return 0 ;
    } ;
    return ( Y - X ) / ( Max - Min ) ;
} ;


// Binomial coefficient (n choose k)
function Choose( $N, $K )
{
    return Factorial( $N ) / ( Factorial( $K ) * Factorial( $N - $K ) )
} ;


// Chance of at least 1 collision after Tries tries in a set of Size length
function Collision_Probability( $Tries, $Size )
{
    N = Tries ;
    Res = 1.0 ;
    for I = 1 to Tries
    {
        Res = Res * ( ( N - I ) / N ) ;
    } ;
    return 1 - Res ;
} ;


function SEM( $std, $Sample_Size ) // Standard Error of the Mean

{
    return std / SQRT( Sample_Size ) ;
} ;


function Coefficient_of_Determination_Linear( $Observed, $Predicted : array )
{
    U = Mean( Observed ) ; // Mu
    I = length( Observed ) ;
    if( I > length( Predicted ) )
    {
        I = length( Predicted ) ;
    } ;
    Estimate_Error = 0.0 ;
    Variability = 0.0 ;
    while( I > 0 )
    {
        Estimate_Error = Estimate_Error + SQR( Observed[ I ] - Predicted[ I ] ) ;
        Variability = Variability + SQR( Observed[ I ] - U ) ;
    } ;
    return 1 - Estimate_Error / Variability ;
} ;


function Euclidean_Distance( $Point1, $Point2 : array )
{
    if( ( count( $Point1 ) <> count( $Point2 ) )
    {
        return 0 ; // arrays have different dimensions - cannot calculate
    } ;
    Sum = 0 ;
    for I = low( Point1 ) to high( Point1 )
    {
        Sum = Sum + trunc( SQR( abs( Point1[ I ] - Point2[ I ] ) ) ) ;
    } ;
    if( Sum == 0 )
    {
        return 0 ;
    } ;
    return SQRT( Sum ) ;
} ;


function Manhattan_Distance( $Point1, $Point2 )
{
    if( count( $Point1 ) <> count( $Point2 ) )
    {
        return 0 ; // arrays have different dimensions - cannot calculate
    } ;
    Sum = 0 ;
    for I = low( Point1 ) to high( Point1 )
    {
        Sum = Sum + trunc( abs( Point1[ I ] - Point2[ I ] ) ) ;
    } ;
    return Sum ;
} ;


function Sensitivity( $True_Positive, $False_Negative )

{
    return $True_Positive / ( $True_Positive + $False_Negative ) ;
} ;


function Specificity( $True_Negative, $False_Positive )

{
    return $True_Negative / ( $True_Negative + $False_Positive ) ;
} ;


function Predictive_Value( $True_Value, $False_Value )

{
    return $True_Value / ( $True_Value + $False_Value ) ;
} ;


function Odds( $Probability )

{
    return $Probability / ( 1 - $Probability ) ;
} ;


function Probability_From_Odds( $Odds )

{
    return $Odds / ( $Odds + 1 ) ;
} ;
