/*
        Unit Name    : TypeDefs
        Package Name : Subroutine Library - Layer 0
        Purpose      : General Pascal types
        Institution  : Conroy & Conroy Co.
        Date Written : 2000
        Written By   : Alan Conroy
        Version      : 1.0C

        Copyright (c) 2000-2021 by Alan Conroy.  Released to the Public Domain.
        
        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          This module defines simple generic types.
*/

#ifndef TYPEDEFSH
    #define TYPEDEFS

#include "eDefines.h"
#include "_Types.h"

// Common types...
enum TComparison { LessThan, EqualTo, GreaterThan, LessThanOrEqual, GreaterThanorEqual, NotEqualTo } ;
enum TTri_State { TS_False, TS_True, TS_Dont_Care } ;

const char Set_Of_Digits[ 10 ] = { '0', '1', '2', '3', '4', '5', '6', '7', '8', '9' } ;
const char Set_Of_Alpha[ 52 ] = { 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K',
                       'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V',
                       'W', 'X', 'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f', 'g',
                       'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r',
                       's', 't', 'u', 'v', 'w', 'x', 'y', 'z' } ;
const char Set_Of_AlphaNum[ 62 ] = { 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K',
                          'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V',
                          'W', 'X', 'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f', 'g',
                          'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r',
                          's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '0', '1', '2',
                          '3', '4', '5', '6', '7', '8', '9' } ;
const char Set_Of_Quotes[ 2 ] = { '"', '\'' } ;

#ifdef __BORLANDC__
typedef void(*TNotify_Event)(TWindow*)  ;
#endif

const int64 Zero64 = 0 ;

#ifdef _16BIT
const Max_Memory = 65528 ;
const Max_String_Length = 255 ;

typedef unsigned short int TRecord_Size ;
#else

  #ifdef _32BIT
const int Max_Memory = 0x03FFFFFFF ;
const int Max_String_Length = Max_Memory ;

typedef int TRecord_Size ;
typedef long int PtrInt ;
typedef unsigned long int PtrUInt ;
  #else

    #ifdef _64BIT
const int64 Max_Memory = 0x03FFFFFFFFFFFFFFF ;
const int64 Max_String_Length = Max_Memory ;

typedef int64 TRecord_Size ;
typedef int64 PtrInt ;
typedef int64 PtrUInt ;
    #endif
  #endif
#endif

#define pByte *unsigned char
typedef unsigned int tByte_Array[ Max_Memory / sizeof( unsigned char ) ] ;
#define pByte_Array *tByte_Array

#define pShortInt *short int
typedef short int tShortInt_Array[ Max_Memory / sizeof( short int ) ] ;
#define pShortInt_Array *TShortInt_Array

#define pWord *unsigned short int
typedef unsigned short int tWord_Array[ Max_Memory / sizeof( unsigned short int ) ] ;
#define pWord_Array *tWord_Array

#define pInteger *int
typedef int tInteger_Array[ Max_Memory / sizeof( int ) ] ;
#define pInteger_Array *tInteger_Array

#define pLongint *long int
typedef long int tLongint_Array[ Max_Memory / sizeof( long int ) ] ;
#define pLongint_Array *tLongint_Array

#define pSingle *float
typedef float tSingle_Array[ Max_Memory / sizeof( float ) ] ;
#define pSingle_Array *TSingle_Array

#define pDouble *double
typedef double tDouble_Array[ Max_Memory / sizeof( double ) ] ;
#define pDouble_Array *TDouble_Array

#define pExtended *long double
#define long double tExtended_Array [ Max_Memory / sizeof( long double ) ] ;
#define pExtended_Array *TExtended_Array

#define pPointer *void*
typedef void* tPointer_Array[ Max_Memory / sizeof( void* ) ] ;
#define pPointer_Array *tPointer_Array

typedef char* tPChar_Array[ Max_Memory / sizeof( char* ) ] ;
#define pPChar_Array *tPChar_Array

typedef char tChar_Array[ Max_Memory / sizeof( char ) ] ;
#define pChar_Array *tChar_Array

#define pBoolean *bool
typedef bool tBoolean_Array[ Max_Memory / sizeof( bool ) ] ;
#define pBoolean_Array *tBoolean_Array

#endif
