/*
        Program Name : L10n
        Package Name : LB
        Purpose      : Localization for LB
        Institution  : Conroy & Conroy Co.
        Date Written : 23-August-2010
        Written By   : Alan Conroy
        Version      : 1.0

        Copyright (C) 2010-2020 by Alan Conroy.  All rights reserved.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          This unit provides for localization of the text used in LB.

*/
#include <iostream>
#include <fstream>

#include "L10n.hpp" 

using namespace std;

const string _Text_Error_Adding_Existing_Object_Or_Failure_To_Delete_Old_Object =
    "Adding existing object or failure to delete old object" ;
const string _Text_Error_Allocation_Table_Load_Failure = "Allocation Table load failure" ;
const string _Text_Error_Attach_Failed = "Attach failed" ;
const string _Text_Error_Detach_Failed = "Detach failed" ;
const string _Text_Error_Execution_Exceeds_ms = "$1 execution exceeds $2 ms" ;
const string _Text_Error_Found_Object_Has_Facility_Mismatch = "Found object has facility mismatch" ;
const string _Text_Error_Facility_Out_Of_Range = "Facility out of range" ;
const string _Text_Error_Removing_Non_Existant_Object = "Removing non-existant object" ;
const string _Text_Error_Facility_Mismatch = "Facility mismatch" ;
const string _Text_Press_Enter_To_Continue = "... Press ENTER to continue" ;
const string _Text_Application = "Application" ;
const string _Text_Unsigned = "Unsigned" ;
const string _Text_Signed = "Signed" ;
const string _Text_Byte = "byte" ;
const string _Text_Word = "word" ;
const string _Text_Longint = "longword" ;
const string _Text_Binary = "Binary" ;
const string _Text_Octal = "Octal" ;
const string _Text_Decimal = "Decimal" ;
const string _Text_Hexadecimal = "Hexadecimal" ;
const string _Text_Radix_50 = "Radix-50" ;
const string _Text_Base_n = "Base $1" ;
const string _Text_Size_Amp = "&Size" ;
const string _Text_Base_Amp = "&Base" ;
const string _Text_Binary_Amp = "&Binary" ;
const string _Text_Octal_Amp = "&Octal" ;
const string _Text_Decimal_Amp = "&Decimal" ;
const string _Text_Hexadecimal_Amp = "&Hexadecimal" ;
const string _Text_Radix_50_Amp = "&Radix-50" ;
const string _Text_Err_Writing_To_Log_File = "$1 - writing to log file" ;
const string _Text_Volume_ID_Is = "Volume ID is $1" ;
const string _Text_Error_Invalid_Output_Drive = "Invalid output drive: $1" ;
const string _Text_Error_FAT_Is_Too_Big = "FAT is too big" ;
const string _Text_Initialization_Error_Correct_And_Press_Any_Key_To_Continue =
    "Initialization error.  Correct and press any key to continue" ;
const string _Text_Initialization_Error = "Initialization error" ;
const string _Text_Error_Unknown_Command_Or_Invalid_Drive = "Unknown command or invalid drvie" ;
const string _Text_Error_Bad_Address_Mark = "Bad address mark" ;
const string _Text_Error_Sector_Not_Found = "Sector not found" ;
const string _Text_Error_DMA_Failure = "DMA failure" ;
const string _Text_Error_Data_Error_CRC = "Data error (CRC)" ;
const string _Text_Error_Controller_Failure = "Controller failure" ;
const string _Text_Error_Seek_Failure = "Seek failure" ;
const string _Text_Error_Drive_Does_Not_Respond = "Drive does not respond" ;
const string _Text_Error_Drive_Is_Write_Locked = "Drive is write locked" ;
const string _Text_Error_Unknown_Unit = "Unknown unit" ;
const string _Text_Error_Drive_Not_Ready = "Drive not ready" ;
const string _Text_Error_Unknown_Command_In_Absolute_Sector_Write = "Unknown command in ABSOLUTE SECTOR WRITE" ;
const string _Text_Error_Bad_Request_Structure_Length = "Bad request structure length" ;
const string _Text_Error_Seek_Error = "Seek error" ;
const string _Text_Error_Unknown_Media_Type = "Unknown media type" ;
const string _Text_Error_Printer_Out_Of_Paper = "Printer out of paper" ;
const string _Text_Error_Write_Fault = "Write fault" ;
const string _Text_Error_Read_Fault = "Read fault" ;
const string _Text_Error_General_Failure = "General failure" ;
const string _Text_Error_Error_13_In_Absolute_Sector_Write = "Error 13 in ABSOLUTE SECTOR WRITE" ;
const string _Text_Error_Error_14_In_Absolute_Sector_Write = "Error 14 in ABSOLUTE SECTOR WRITE" ;
const string _Text_Error_Invalid_Disk_Change = "Invalid disk change" ;
const string _Text_Place_Saveset_Volume_Into_Drive_And_Press_Return = "Place saveset volume $1 into drive $2 and press RETURN" ;
const string _Text_Place_Saveset_Volume_Into_Drive = "Place saveset volume $1 into drive $2" ;
const string _Text_Success = "Success" ;
const string _Text_Error_No_Dictionary_Open = "No Data Dictionary is open" ;
const string _Text_Error_Already_Defined = "Already defined" ;
const string _Text_Error_Invalid_Syntax_Type = "Invalid syntax type" ;
const string _Text_Error_Not_Defined = "Item not defined" ;
const string _Text_True = "true" ;
const string _Text_False = "false" ;
const string _Text_Error_Invalid_Base = "Invalid base" ;
const string _Text_Error_Numeric_Error = "%Numeric error" ;
const string _Text_Error_Abstract_Method_Called = "Abstract method called: $1" ;
const string _Text_Other_Ellipse = "Other..." ;
const string _Text_Signed_Amp = "Si&gned" ;
const string _Text_Byte_Amp = "&Byte" ;
const string _Text_Word_Amp = "&Word" ;
const string _Text_Long_Amp = "&Long" ;
const string _Text_Quad_Amp = "&Quad" ;
const string _Text_EBCDIC_Amp = "&EBCDIC" ;
const string _Text_Goto_Address_Ellipse = "&Goto address..." ;
const string _Text_Find_Ellipse = "&Find..." ;
const string _Text_Modify_Ellipse = "&Modify..." ;
const string _Text_Nothing_Found = "Nothing found" ;
const string _Text_Month_Jan = "Jan" ;
const string _Text_Month_Feb = "Feb" ;
const string _Text_Month_Mar = "Mar" ;
const string _Text_Month_Apr = "Apr" ;
const string _Text_Month_May = "May" ;
const string _Text_Month_Jun = "Jun" ;
const string _Text_Month_Jul = "Jul" ;
const string _Text_Month_Aug = "Aug" ;
const string _Text_Month_Sep = "Sep" ;
const string _Text_Month_Oct = "Oct" ;
const string _Text_Month_Nov = "Nov" ;
const string _Text_Month_Dec = "Dec" ;
const string _Text_Month_January = "January" ;
const string _Text_Month_February = "February" ;
const string _Text_Month_March = "March" ;
const string _Text_Month_April = "April" ;
const string _Text_Month_June = "June" ;
const string _Text_Month_July = "July" ;
const string _Text_Month_August = "August" ;
const string _Text_Month_September = "September" ;
const string _Text_Month_October = "October" ;
const string _Text_Month_November = "November" ;
const string _Text_Month_December = "December" ;
const string _Text_ASCII_Amp = "&ASCII" ;
const string _Text_Day_Sunday = "Sunday" ;
const string _Text_Day_Monday = "Monday" ;
const string _Text_Day_Tuesday = "Tuesday" ;
const string _Text_Day_Wednesday = "Wednesday" ;
const string _Text_Day_Thursday = "Thursday" ;
const string _Text_Day_Friday = "Friday" ;
const string _Text_Day_Saturday = "Saturday" ;
const string _Text_Application_x = "Application = $1" ;
const string _Text_Operating_System_x = "Operating System = $1" ;
const string _Text_There_Is_No_Debugging_Information_Available =
    "There is no debugging information available" ;
const string _Text_Error_Opening_x = "$1 opening $2" ;
const string _Text_Search_String_Not_Found = "Search string \"$1\" not found" ;
const string _Text_Caption_Search = "Search" ;
const string _Text_Caption_Replace = "Replace" ;
const string _Text_Replace_This_Instance = "Replace this instance" ;
const string _Text_Save_Changes_To = "Save changes to $1?" ;
const string _Text_Noname = "Noname" ;
const string _Text_Unknown_Error_Code = "Unknown error code $1" ;
const string _Text_Facility_n_Error_n = "Facility $1 - Error $2" ;
const string _Text_Error_Severity_Success = "Success" ;
const string _Text_Error_Severity_Notification = "Notification " ;
const string _Text_Error_Severity_Warning = "Warning " ;
const string _Text_Error_Severity_Error = "Error " ;
const string _Text_Error_Severity_Fatal = "Fatal error " ;
const string _Text_DOS_Error_Success = "Success" ;
const string _Text_DOS_Error_1 = "Invalid function number" ;
const string _Text_DOS_Error_2 = "File not found" ;
const string _Text_DOS_Error_3 = "Path not found" ;
const string _Text_DOS_Error_4 = "Too many open files" ;
const string _Text_DOS_Error_5 = "File access denied" ;
const string _Text_DOS_Error_6 = "Invalid file handle" ;
const string _Text_DOS_Error_7 = "Memory blocks destroyed" ;
const string _Text_DOS_Error_8 = "Insufficient memory" ;
const string _Text_DOS_Error_9 = "Invalid memory block address" ;
const string _Text_DOS_Error_10 = "Invalid environment" ;
const string _Text_DOS_Error_11 = "Invalid format" ;
const string _Text_DOS_Error_12 = "Invalid file access code" ;
const string _Text_DOS_Error_13 = "Invalid data" ;
const string _Text_DOS_Error_14 = "Unknown unit" ;
const string _Text_DOS_Error_15 = "Invalid drive number" ;
const string _Text_DOS_Error_16 = "Cannot remove current directory" ;
const string _Text_DOS_Error_17 = "Cannot rename across drives" ;
const string _Text_DOS_Error_18 = "No more files" ;
const string _Text_DOS_Error_19 = "Disk is write-protected" ;
const string _Text_DOS_Error_20 = "Unknown unit" ;
const string _Text_DOS_Error_21 = "Drive not ready" ;
const string _Text_DOS_Error_22 = "Unknown command" ;
const string _Text_DOS_Error_23 = "CRC error in data" ;
const string _Text_DOS_Error_24 = "Bad request structure length" ;
const string _Text_DOS_Error_25 = "Disk seek error" ;
const string _Text_DOS_Error_26 = "Unknown media type" ;
const string _Text_DOS_Error_27 = "Sector not found" ;
const string _Text_DOS_Error_28 = "Printer out of paper" ;
const string _Text_DOS_Error_29 = "Device write fault" ;
const string _Text_DOS_Error_30 = "Device read fault" ;
const string _Text_DOS_Error_31 = "General failure" ;
const string _Text_DOS_Error_32 = "Sharing violation" ;
const string _Text_DOS_Error_33 = "Lock violation" ;
const string _Text_DOS_Error_34 = "Invalid disk change" ;
const string _Text_DOS_Error_35 = "FCB unavailable" ;
const string _Text_DOS_Error_36 = "Sharing buffer exceeded" ;
const string _Text_DOS_Error_38 = "Unable to complete file operation" ;
const string _Text_DOS_Error_50 = "Unsupported network request" ;
const string _Text_DOS_Error_51 = "Remote machine not listening" ;
const string _Text_DOS_Error_52 = "Duplicate name on network" ;
const string _Text_DOS_Error_53 = "Network name not found" ;
const string _Text_DOS_Error_54 = "Network busy" ;
const string _Text_DOS_Error_55 = "Device no longer exists on network" ;
const string _Text_DOS_Error_56 = "NetBIOS command limit exceeded" ;
const string _Text_DOS_Error_57 = "Error in network adapter hardware" ;
const string _Text_DOS_Error_58 = "Incorrect response from network" ;
const string _Text_DOS_Error_59 = "Unexpected network error" ;
const string _Text_DOS_Error_60 = "Remote adapter incompatible" ;
const string _Text_DOS_Error_61 = "Print queue full" ;
const string _Text_DOS_Error_62 = "Queue not full" ;
const string _Text_DOS_Error_63 = "Not enough room for print file" ;
const string _Text_DOS_Error_64 = "Network name deleted" ;
const string _Text_DOS_Error_65 = "Access denied" ;
const string _Text_DOS_Error_66 = "Incorrect network device type" ;
const string _Text_DOS_Error_67 = "Network name not found" ;
const string _Text_DOS_Error_68 = "Network name limit exceeded" ;
const string _Text_DOS_Error_69 = "netBIOS session limit exceeded" ;
const string _Text_DOS_Error_70 = "Temporary pause" ;
const string _Text_DOS_Error_71 = "Network request not accepted" ;
const string _Text_DOS_Error_72 = "Print or disk redirection paused" ;
const string _Text_DOS_Error_80 = "File already exists" ;
const string _Text_DOS_Error_81 = "Duplicate FCB" ;
const string _Text_DOS_Error_82 = "Cannot make directory" ;
const string _Text_DOS_Error_83 = "Fail on Int 24H (critical error)" ;
const string _Text_DOS_Error_84 = "Out of structures" ;
const string _Text_DOS_Error_85 = "Already assigned" ;
const string _Text_DOS_Error_86 = "Invalid password" ;
const string _Text_DOS_Error_87 = "Invalid parameter" ;
const string _Text_DOS_Error_88 = "Net write fault" ;
const string _Text_DOS_Error_89 = "No process slots available" ;
const string _Text_DOS_Error_90 = "Not frozen" ;
const string _Text_DOS_Error_91 = "Timer service table overflow" ;
const string _Text_DOS_Error_92 = "Timer service table duplicate" ;
const string _Text_DOS_Error_93 = "There were no items to operate upon" ;
const string _Text_DOS_Error_95 = "Interrupted system call" ;
const string _Text_DOS_Error_100 = "Too many semaphores" ;
const string _Text_DOS_Error_101 = "Exclusive semaphore already owned" ;
const string _Text_DOS_Error_102 = "Semaphore is set" ;
const string _Text_DOS_Error_103 = "Too many semaphore requests" ;
const string _Text_DOS_Error_104 = "Invalid at interrupt time" ;
const string _Text_DOS_Error_105 = "WaitSem found that Semaphore owner died" ;
const string _Text_DOS_Error_106 = "Too many processes have this semaphore" ;
const string _Text_DOS_Error_107 = "Insert disk B into drive A" ;
const string _Text_DOS_Error_108 = "Drive locked by another process" ;
const string _Text_DOS_Error_109 = "Write on pipe with no reader" ;
const string _Text_DOS_Error_110 = "Open/create failed" ;
const string _Text_DOS_Error_111 = "Buffer passed to system call" ;
const string _Text_DOS_Error_112 = "Not enough space on the disk" ;
const string _Text_DOS_Error_113 = "Cannot allocate another search" ;
const string _Text_DOS_Error_114 = "Target handle in DOSDUPHANDLE" ;
const string _Text_DOS_Error_115 = "Bad user virtual address" ;
const string _Text_DOS_Error_116 = "VIOKBD Request" ;
const string _Text_DOS_Error_117 = "Invalid category for DEVIOCTL" ;
const string _Text_DOS_Error_118 = "Invalid value for Verify switch" ;
const string _Text_DOS_Error_119 = "Bad driver level for DOSDEVIOCTL " ;
const string _Text_DOS_Error_120 = "Call not implemented" ;
const string _Text_DOS_Error_121 = "Semaphore timeout" ;
const string _Text_DOS_Error_122 = "Insufficient buffer" ;
const string _Text_DOS_Error_123 = "Illegal character or malformed name" ;
const string _Text_DOS_Error_124 = "Invalid level" ;
const string _Text_DOS_Error_125 = "No volume label" ;
const string _Text_DOS_Error_126 = "Module not found" ;
const string _Text_DOS_Error_127 = "Process not found" ;
const string _Text_DOS_Error_128 = "CWait found no children" ;
const string _Text_DOS_Error_129 = "CWait child not complete" ;
const string _Text_DOS_Error_130 = "Invalid handle operation" ;
const string _Text_DOS_Error_131 = "Negative seek" ;
const string _Text_DOS_Error_132 = "Seek error on device" ;
const string _Text_DOS_Error_133 = "Is join target" ;
const string _Text_DOS_Error_134 = "Is joined" ;
const string _Text_DOS_Error_135 = "Is substituted" ;
const string _Text_DOS_Error_136 = "Not joined" ;
const string _Text_DOS_Error_137 = "Not substituted" ;
const string _Text_DOS_Error_138 = "Join to join" ;
const string _Text_DOS_Error_139 = "Substitute to Substitute" ;
const string _Text_DOS_Error_140 = "Join to Substitute" ;
const string _Text_DOS_Error_141 = "Substitute to join" ;
const string _Text_DOS_Error_142 = "Drive busy" ;
const string _Text_DOS_Error_143 = "Same drive" ;
const string _Text_DOS_Error_144 = "Directory not root" ;
const string _Text_DOS_Error_145 = "Directory not empty" ;
const string _Text_DOS_Error_146 = "Is Substitute path" ;
const string _Text_DOS_Error_147 = "Is join path" ;
const string _Text_DOS_Error_148 = "Path busy" ;
const string _Text_DOS_Error_149 = "Is Substitute target" ;
const string _Text_DOS_Error_150 = "System trace error" ;
const string _Text_DOS_Error_151 = "DOSMUXSEMWAIT error" ;
const string _Text_DOS_Error_152 = "Too many MUXWAITERS " ;
const string _Text_DOS_Error_153 = "Invalid list format" ;
const string _Text_DOS_Error_154 = "Label too long" ;
const string _Text_DOS_Error_155 = "Too many TCBs" ;
const string _Text_DOS_Error_156 = "Signal refused" ;
const string _Text_DOS_Error_157 = "Discarded" ;
const string _Text_DOS_Error_158 = "Not locked" ;
const string _Text_DOS_Error_159 = "Bad ThreadID address" ;
const string _Text_DOS_Error_160 = "Bad arguments" ;
const string _Text_DOS_Error_161 = "Bad pathname" ;
const string _Text_DOS_Error_162 = "Signal pending" ;
const string _Text_DOS_Error_163 = "Uncetain media" ;
const string _Text_DOS_Error_164 = "Max threads reached" ;
const string _Text_DOS_Error_165 = "Monitors not supported" ;
const string _Text_DOS_Error_180 = "Invalid segment number" ;
const string _Text_DOS_Error_181 = "Invalid call gate" ;
const string _Text_DOS_Error_182 = "Invalid ordinal" ;
const string _Text_DOS_Error_183 = "Already exists" ;
const string _Text_DOS_Error_184 = "No child process" ;
const string _Text_DOS_Error_185 = "Child alive nowait" ;
const string _Text_DOS_Error_186 = "Invalid flag number" ;
const string _Text_DOS_Error_187 = "Semaphore not found" ;
const string _Text_DOS_Error_188 = "Invalid starting code segment" ;
const string _Text_DOS_Error_189 = "Invalid stack segment" ;
const string _Text_DOS_Error_190 = "Invalid module type" ;
const string _Text_DOS_Error_191 = "Invalid EXE signature" ;
const string _Text_DOS_Error_192 = "EXE marked invalid" ;
const string _Text_DOS_Error_193 = "Bad EXE format" ;
const string _Text_DOS_Error_194 = "Iterated data exceeds 64K" ;
const string _Text_DOS_Error_195 = "Invalid MINALLOCSIZE" ;
const string _Text_DOS_Error_196 = "DYNLINK from invalid ring" ;
const string _Text_DOS_Error_197 = "IOPL not enabled" ;
const string _Text_DOS_Error_198 = "Invalid SEGDPL" ;
const string _Text_DOS_Error_199 = "AUTODATASEG exceeds 64K" ;
const string _Text_DOS_Error_200 = "Ring2 segment must be movable" ;
const string _Text_DOS_Error_201 = "Relocation chain needs SEGLIM" ;
const string _Text_DOS_Error_202 = "Infinite loop in relocation chain" ;
const string _Text_DOS_Error_203 = "Environment variable not found" ;
const string _Text_DOS_Error_204 = "Not current country" ;
const string _Text_DOS_Error_205 = "No signal sent" ;
const string _Text_DOS_Error_206 = "Filename exceeded range" ;
const string _Text_DOS_Error_207 = "Ring2 stack in use" ;
const string _Text_DOS_Error_208 = "Meta expansion too long" ;
const string _Text_DOS_Error_209 = "Invalid signal number" ;
const string _Text_DOS_Error_210 = "Thread 1 inactive" ;
const string _Text_DOS_Error_211 = "Information not available" ;
const string _Text_DOS_Error_212 = "Locked" ;
const string _Text_DOS_Error_213 = "Bad Dynalink" ;
const string _Text_DOS_Error_214 = "Too many modules" ;
const string _Text_DOS_Error_215 = "Nesting not allowed" ;
const string _Text_DOS_Error_216 = "General Protection fault" ;
const string _Text_DOS_Error_600 = "An operation is pending." ;
const string _Text_DOS_Error_601 = "The port handle is invalid." ;
const string _Text_DOS_Error_602 = "The port is already open." ;
const string _Text_DOS_Error_603 = "Caller's buffer is too small." ;
const string _Text_DOS_Error_604 = "Wrong information specified." ;
const string _Text_DOS_Error_605 = "Cannot set port information." ;
const string _Text_DOS_Error_606 = "The port is not connected." ;
const string _Text_DOS_Error_607 = "The event is invalid." ;
const string _Text_DOS_Error_608 = "The device does not exist." ;
const string _Text_DOS_Error_609 = "The device type does not exist." ;
const string _Text_DOS_Error_610 = "The buffer is invalid." ;
const string _Text_DOS_Error_611 = "The route is not available." ;
const string _Text_DOS_Error_612 = "The route is not allocated." ;
const string _Text_DOS_Error_613 = "Invalid compression specified." ;
const string _Text_DOS_Error_614 = "Out of buffers." ;
const string _Text_DOS_Error_615 = "The port was not found." ;
const string _Text_DOS_Error_616 = "An asynchronous request is pending." ;
const string _Text_DOS_Error_617 = "The port or device is already disconnecting." ;
const string _Text_DOS_Error_618 = "The port is not open." ;
const string _Text_DOS_Error_619 = "The port is disconnected." ;
const string _Text_DOS_Error_620 = "There are no endpoints." ;
const string _Text_DOS_Error_621 = "Cannot open the phone book file." ;
const string _Text_DOS_Error_622 = "Cannot load the phone book file." ;
const string _Text_DOS_Error_623 = "Cannot find the phone book entry." ;
const string _Text_DOS_Error_624 = "Cannot write the phone book file." ;
const string _Text_DOS_Error_625 = "Invalid information found in the phone book." ;
const string _Text_DOS_Error_626 = "Cannot load a string." ;
const string _Text_DOS_Error_627 = "Cannot find key." ;
const string _Text_DOS_Error_628 = "The port was disconnected." ;
const string _Text_DOS_Error_629 = "The port was disconnected by the remote machine." ;
const string _Text_DOS_Error_630 = "The port was disconnected due to hardware failure." ;
const string _Text_DOS_Error_631 = "The port was disconnected by the user." ;
const string _Text_DOS_Error_632 = "The structure size is incorrect." ;
const string _Text_DOS_Error_633 = "The port is already in use or is not configured for Remote Access dialout." ;
const string _Text_DOS_Error_634 = "Cannot register your computer on the remote network." ;
const string _Text_DOS_Error_635 = "Unknown error." ;
const string _Text_DOS_Error_636 = "The wrong device is attached to the port." ;
const string _Text_DOS_Error_637 = "The string could not be converted." ;
const string _Text_DOS_Error_638 = "The request has timed out." ;
const string _Text_DOS_Error_639 = "No asynchronous net available." ;
const string _Text_DOS_Error_640 = "A NetBIOS error has occurred." ;
const string _Text_DOS_Error_641 = "The server cannot allocate NetBIOS resources needed to support the client." ;
const string _Text_DOS_Error_642 = "One of your NetBIOS names is already registered on the remote network." ;
const string _Text_DOS_Error_643 = "A network adapter at the server failed." ;
const string _Text_DOS_Error_644 = "You will not receive network message popups." ;
const string _Text_DOS_Error_645 = "Internal authentication error." ;
const string _Text_DOS_Error_646 = "The account is not permitted to log on at this time of day." ;
const string _Text_DOS_Error_647 = "The account is disabled." ;
const string _Text_DOS_Error_648 = "The password has expired." ;
const string _Text_DOS_Error_649 = "The account does not have Remote Access permission." ;
const string _Text_DOS_Error_650 = "The Remote Access server is not responding." ;
const string _Text_DOS_Error_651 = "Your modem (or other connecting device) has reported an error." ;
const string _Text_DOS_Error_652 = "Unrecognized response from the device." ;
const string _Text_DOS_Error_653 = "A macro required by the device was not found in the device .INF file section." ;
const string _Text_DOS_Error_654 = "A command or response in the device .INF file section refers to an undefined macro" ;
const string _Text_DOS_Error_655 = "The <message> macro was not found in the device .INF file section." ;
const string _Text_DOS_Error_656 = "The <defaultoff> macro in the device .INF file section contains an undefined macro" ;
const string _Text_DOS_Error_657 = "The device .INF file could not be opened." ;
const string _Text_DOS_Error_658 = "The device name in the device .INF or media .INI file is too long." ;
const string _Text_DOS_Error_659 = "The media .INI file refers to an unknown device name." ;
const string _Text_DOS_Error_660 = "The device .INF file contains no responses for the command." ;
const string _Text_DOS_Error_661 = "The device .INF file is missing a command." ;
const string _Text_DOS_Error_662 = "Attempted to set a macro not listed in device .INF file section." ;
const string _Text_DOS_Error_663 = "The media .INI file refers to an unknown device type." ;
const string _Text_DOS_Error_664 = "Cannot allocate memory." ;
const string _Text_DOS_Error_665 = "The port is not configured for Remote Access." ;
const string _Text_DOS_Error_666 = "Your modem (or other connecting device) is not functioning." ;
const string _Text_DOS_Error_667 = "Cannot read the media .INI file." ;
const string _Text_DOS_Error_668 = "The connection dropped." ;
const string _Text_DOS_Error_669 = "The usage parameter in the media .INI file is invalid." ;
const string _Text_DOS_Error_670 = "Cannot read the section name from the media .INI file." ;
const string _Text_DOS_Error_671 = "Cannot read the device type from the media .INI file." ;
const string _Text_DOS_Error_672 = "Cannot read the device name from the media .INI file." ;
const string _Text_DOS_Error_673 = "Cannot read the usage from the media .INI file." ;
const string _Text_DOS_Error_674 = "Cannot read the maximum connection BPS rate from the media .INI file." ;
const string _Text_DOS_Error_675 = "Cannot read the maximum carrier BPS rate from the media .INI file." ;
const string _Text_DOS_Error_676 = "The line is busy." ;
const string _Text_DOS_Error_677 = "A person answered instead of a modem." ;
const string _Text_DOS_Error_678 = "There is no answer." ;
const string _Text_DOS_Error_679 = "Cannot detect carrier." ;
const string _Text_DOS_Error_680 = "There is no dial tone." ;
const string _Text_DOS_Error_681 = "General error reported by device." ;
const string _Text_DOS_Error_682 = "ERROR WRITING SECTIONNAME" ;
const string _Text_DOS_Error_683 = "ERROR WRITING DEVICETYPE" ;
const string _Text_DOS_Error_684 = "ERROR WRITING DEVICENAME" ;
const string _Text_DOS_Error_685 = "ERROR WRITING MAXCONNECTBPS" ;
const string _Text_DOS_Error_686 = "ERROR WRITING MAXCARRIERBPS" ;
const string _Text_DOS_Error_687 = "ERROR WRITING USAGE" ;
const string _Text_DOS_Error_688 = "ERROR WRITING DEFAULTOFF" ;
const string _Text_DOS_Error_689 = "ERROR READING DEFAULTOFF" ;
const string _Text_DOS_Error_690 = "ERROR EMPTY INI FILE" ;
const string _Text_DOS_Error_691 = "Access denied because username and/or password is invalid on the domain." ;
const string _Text_DOS_Error_692 = "Hardware failure in port or attached device." ;
const string _Text_DOS_Error_693 = "ERROR NOT BINARY MACRO" ;
const string _Text_DOS_Error_694 = "ERROR DCB NOT FOUND" ;
const string _Text_DOS_Error_695 = "ERROR STATE MACHINES NOT STARTED" ;
const string _Text_DOS_Error_696 = "ERROR STATE MACHINES ALREADY STARTED" ;
const string _Text_DOS_Error_697 = "ERROR PARTIAL RESPONSE LOOPING" ;
const string _Text_DOS_Error_698 = "A response keyname in the device .INF file is not in the expected format." ;
const string _Text_DOS_Error_699 = "The device response caused buffer overflow." ;
const string _Text_DOS_Error_700 = "The expanded command in the device .INF file is too long." ;
const string _Text_DOS_Error_701 = "The device moved to a BPS rate not supported by the COM driver." ;
const string _Text_DOS_Error_702 = "Device response received when none expected." ;
const string _Text_DOS_Error_703 = "ERROR INTERACTIVE MODE" ;
const string _Text_DOS_Error_704 = "ERROR BAD CALLBACK NUMBER" ;
const string _Text_DOS_Error_705 = "ERROR INVALID AUTH STATE" ;
const string _Text_DOS_Error_706 = "ERROR WRITING INITBPS" ;
const string _Text_DOS_Error_707 = "X.25 diagnostic indication." ;
const string _Text_DOS_Error_708 = "The account has expired." ;
const string _Text_DOS_Error_709 = "Error changing password on domain." ;
const string _Text_DOS_Error_710 = "Serial overrun errors were detected while communicating with your modem." ;
const string _Text_DOS_Error_711 = "RasMan initialization failure. Check the event log." ;
const string _Text_DOS_Error_712 = "Biplex port is initializing. Wait a few seconds and redial." ;
const string _Text_DOS_Error_713 = "No active ISDN lines are available." ;
const string _Text_DOS_Error_714 = "Not enough ISDN channels are available to make the call." ;
const string _Text_DOS_Error_715 = "Too many errors occurred because of poor phone line quality." ;
const string _Text_DOS_Error_716 = "The Remote Access IP configuration is unusable." ;
const string _Text_DOS_Error_717 = "No IP addresses are available in the static pool of Remote Access IP addresses." ;
const string _Text_DOS_Error_718 = "PPP timeout." ;
const string _Text_DOS_Error_719 = "PPP terminated by remote machine." ;
const string _Text_DOS_Error_720 = "No PPP control protocols configured." ;
const string _Text_DOS_Error_721 = "Remote PPP peer is not responding." ;
const string _Text_DOS_Error_722 = "The PPP packet is invalid." ;
const string _Text_DOS_Error_723 = "The phone number, including prefix and suffix, is too long." ;
const string _Text_DOS_Error_724 = "The IPX protocol cannot dial-out on the port because the computer is an IPX router." ;
const string _Text_DOS_Error_725 = "The IPX protocol cannot dial-in on the port because the IPX router is not installed" ;
const string _Text_DOS_Error_726 = "The IPX protocol cannot be used for dial-out on more than one port at a time" ;
const string _Text_DOS_Error_727 = "Cannot access TCPCFG.DLL" ;
const string _Text_DOS_Error_728 = "Cannot find an IP adapter bound to Remote Access" ;
const string _Text_DOS_Error_729 = "SLIP cannot be used unless the IP protocol is installed" ;
const string _Text_DOS_Error_730 = "Computer registration is not complete" ;
const string _Text_DOS_Error_731 = "The protocol is not configured" ;
const string _Text_DOS_Error_732 = "The PPP negotiation is not converging" ;
const string _Text_DOS_Error_733 = "The PPP control protocol for this network protocol is not available on the server" ;
const string _Text_DOS_Error_734 = "The PPP link control protocol terminated" ;
const string _Text_DOS_Error_735 = "The requested address was rejected by the server" ;
const string _Text_DOS_Error_736 = "The remote computer terminated the control protocol" ;
const string _Text_DOS_Error_737 = "Loopback detected" ;
const string _Text_DOS_Error_738 = "The server did not assign an address" ;
const string _Text_DOS_Error_739 = "The remote server cannot use the Windows NT encrypted password" ;
const string _Text_DOS_Error_740 = "The TAPI devices configured for Remote Access failed to initialize or were not installed correctly" ;
const string _Text_DOS_Error_741 = "The local computer does not support encryption" ;
const string _Text_DOS_Error_742 = "The remote server does not support encryption" ;
const string _Text_DOS_Error_743 = "The remote server requires encryption" ;
const string _Text_DOS_Error_744 = "Cannot use the IPX net number assigned by the remote server. Check the event log" ;
const string _Text_DOS_Error_752 = "A syntax error was encountered while processing a script" ;
const string _Text_Error_Unused_Error_Number = "Unused error number $1" ;
const string _Text_Express_Error_Expected_Comma = "Expected comma" ;
const string _Text_Express_Error_Syntax_Error = "Syntax error" ;
const string _Text_Express_Error_Illegal_Symbol = "Illegal symbol" ;
const string _Text_Express_Error_Expected_Left_Parenthesis = "Expected left parenthesis" ;
const string _Text_Express_Error_Division_By_Zero = "Division by zero" ;
const string _Text_Express_Error_Illegal_Number_for_factorial = "Illegal number for factorial" ;
const string _Text_Express_Error_Floating_point_error = "Floating point error" ;
const string _Text_Express_Error_Illegal_Number = "Illegal number" ;
const string _Text_Express_Error_Illegal_Argument = "Illegal argument" ;
const string _Text_Express_Error_Imaginary_Number = "Imaginary number" ;
const string _Text_Express_Error_Illegal_Argument_in_LOG = "Illegal argument in LOG" ;
const string _Text_Express_Error_Argument_Too_large_in_EXP = "Argument too large in EXP" ;
const string _Text_Express_Error_Missing_Right_Parenthesis = "Missing right parenthesis" ;
const string _Text_Error_Invalid_Key_Size = "Invalid key size" ;
const string _Text_Files_Unit_Was_Not_Compiled_Correctly = "Files unit was not compiled correctly" ;
const string _Text_Error_FiP_Is_A_Singleton_Object = "TFile_Processor is a singleton object" ;
const string _Text_Prompt_Enter_A_Filename = "Enter a filename" ;
const string _Text_Error_Filesys_Unit_Was_Not_Compiled_Correctly = "Filesys unit was not compiled correctly" ;
const string _Text_Error_Invalid_Syntax = "Invalid syntax" ;
const string _Text_Error_Object_Is_Missing_A_Name = "Object is missing a name" ;
const string _Text_Error_Expected_Colon = "Expected colon" ;
const string _Text_Error_Object_Is_Missing_Type = "Object is missing type" ;
const string _Text_Error_Expected_Equal = "Expected equal" ;
const string _Text_FSErr_FileNotOpen = "I/O operation on unopened channel" ;
const string _Text_FSErr_EndOfFile = "Attempt to read past end of file" ;
const string _Text_FSErr_FileNotFound = "File lookup failed" ;
const string _Text_FSErr_FileNameLength = "Error in size of file name" ;
const string _Text_FSErr_FileName = "Error in file name contents" ;
const string _Text_FSErr_DirectoryNotFound = "Directory lookup failed" ;
const string _Text_FSErr_InvalidPath = "Path contained reference to non-directory" ;
const string _Text_FSErr_NoRoomOnDevice = "Device has no room" ;
const string _Text_FSErr_ProtectionViolation = "Protection violation" ;
const string _Text_FSErr_DirectoryExists = "Directory already exists" ;
const string _Text_FSErr_FileNotEmpty = "File is not empty" ;
const string _Text_FSErr_DirectoryNotEmpty = "Directory is not empty" ;
const string _Text_FSErr_CorruptedFileStructure = "File structure corruption found" ;
const string _Text_FSErr_FileExists = "File already exists" ;
const string _Text_FSErr_IllegalOperationType = "Illegal operation for file type" ;
const string _Text_FSErr_LineTooLong = "Text line is too long" ;
const string _Text_FSErr_InvalidDevice = "Invalid device" ;
const string _Text_FSErr_Internal_Duplicate = "Internal Duplicate" ;
const string _Text_FSErr_Invalid_Open_Mode = "Invalid Open Mode" ;
const string _Text_FSErr_Unsupported_Operation = "Unsupported File System" ;
const string _Text_FSErr_Device_In_Use = "Device In Use" ;
const string _Text_FSErr_Unknown_Device_Type = "Unknown Device Type" ;
const string _Text_FSErr_Internal_Error_On_Add = "Internal error on add" ;
const string _Text_FSErr_Invalid_Record_Size = "Invalid record size" ;
const string _Text_FSErr_Internal_Corruption = "Internal corruption" ;
const string _Text_FSErr_Timeout = "Timeout" ;
const string _Text_FSErr_Invalid_Handle = "Invalid handle" ;
const string _Text_FSErr_Data_Format_Error = "Data format error" ;
const string _Text_FSErr_Read_Only = "File system is read-only" ;
const string _Text_FHErr_No_Room_On_Device = "No Room On Device" ;
const string _Text_FHErr_Corrupted_File_Structure = "Corrupted File Structure" ;
const string _Text_FHErr_Invalid_Pointer_Operation = "Invalid Pointer Operation" ;
const string _Text_FHErr_Deallocation_Error = "Deallocation Error" ;
const string _Text_FHErr_Size_Mismatch = "Size Mismatch" ;
const string _Text_FHErr_Read_Out_Of_Range = "Read Out Of Range" ;
const string _Text_FHErr_Read_Size_Error = "Read Size Error" ;
const string _Text_FHErr_Write_Out_Of_Range = "Write Out Of Range" ;
const string _Text_FHErr_Write_Size_Error = "Write Size Error" ;
const string _Text_FHErr_Bad_Minimum = "Bad minimum" ;
const string _Text_Error_Heap_Deallocation_Error = "Heap deallocation error" ;
const string _Text_Error_Heap_Access_Error = "Heap access error" ;
const string _Text_Error_Illegal_Resolution_Size = "Illegal resolution size" ;
const string _Text_Error_Invalid_Address = "Invalid address" ;
const string _Text_Prompt_Press_Any_Key_To_Continue = "Press any key to continue..." ;
const string _Text_Further_Help_Is_Available_On = "Further help is available on:" ;
const string _Text_Sorry_No_Help_For_x_Found_At_This_Level = "Sorry, no help for $1 found at this level." ;
const string _Text_Warning_Nesting_Exceeds_40_Levels = "%Nesting exceeds 40 levels" ;
const string _Text_Prompt_Topic = "Topic? " ;
const string _Text_Error_Help_Not_Available = "Help not available" ;
const string _Text_Error_HTML_No_Content = "No Content" ;
const string _Text_Error_HTML_Moved_Permanently = "Moved Permanently" ;
const string _Text_Error_HTML_Moved_Temporarily = "Moved Temporarily" ;
const string _Text_Error_HTML_Bad_Request = "Bad Request" ;
const string _Text_Error_HTML_Unauthorized = "Unauthorized" ;
const string _Text_Error_HTML_Payment_Required = "Payment Required" ;
const string _Text_Error_HTML_Forbidden = "Forbidden" ;
const string _Text_Error_HTML_Not_Found = "Not Found" ;
const string _Text_Error_HTML_Method_Not_Allowed = "Method Not Allowed" ;
const string _Text_Error_HTML_Proxy_Authentication_Required = "Proxy Authentication Required" ;
const string _Text_Error_HTML_Request_Timeout = "Request Timeout" ;
const string _Text_Error_HTML_Conflict = "Conflict" ;
const string _Text_Error_HTML_Gone = "Gone" ;
const string _Text_Error_HTML_Bad_Gateway = "Bad Gateway" ;
const string _Text_Error_HTML_Service_Unavailable = "Service Unavailable" ;
const string _Text_Error_HTML_Gateway_Timeout = "Gateway Timeout" ;
const string _Text_LibErr_Invalid_Library_File_Format = "Invalid library file format" ;
const string _Text_LibErr_Module_Not_Found = "Module not found" ;
const string _Text_LibErr_Module_Already_Exists = "Module already exists" ;
const string _Text_LibErr_Illegal_Module_Format = "Illegal file format" ;
const string _Text_Error_Imaginary_Number = "?Imaginary number" ;
const string _Text_Error_Store_Overwrite = "Store overwrite" ;
const string _Text_Keystroke_Abort = "A" ;
const string _Text_Keystroke_Cancel = "C" ;
const string _Text_Keystroke_Ignore = "I" ;
const string _Text_Keystroke_No = "N" ;
const string _Text_Keystroke_OK = "O" ;
const string _Text_Keystroke_Retry = "R" ;
const string _Text_Keystroke_Yes = "Y" ;
const string _Text_Prompt_Abort = "Abort" ;
const string _Text_Prompt_Cancel = "Cancel" ;
const string _Text_Prompt_Ignore = "Ignore" ;
const string _Text_Prompt_No = "No" ;
const string _Text_Prompt_OK = "OK" ;
const string _Text_Prompt_Retry = "Retry" ;
const string _Text_Prompt_Yes = "Yes" ;
const string _Text_Prompt_Attempt_To_Delete_Alarm_For_Software_Configuration_Key =
    "Attempt to delete alarm for software configuration key: $1.  Allow deletion?" ;
const string _Text_Prompt_Attempt_To_Delete_Software_Configuration_Key =
    "Attempt to delete software configuration key: $1.  Allow deletion?" ;
const string _Text_Prompt_Attempt_To_Change_Alarm_For_Software_Configuration_Key =
    "Attempt to change alarm for software configuration key: $1.  Allow change?" ;
const string _Text_Prompt_Attempt_To_Change_Software_Configuration_Key =
    "Attempt to change software configuration key: $1.  Allow change?" ;
const string _Text_Prompt_Attempt_To_Read_Software_Configuration_Key =
    "Attempt to read software configuration key: $1.  Allow read?" ;
const string _Text_Error_SMU_Error = "SMU Error" ;
const string _Text_Error_Too_Many_Windows = "?Too many windows" ;
const string _Text_Error_Window_Too_Large = "?Window too large" ;
const string _Text_Warning_Window_Collision = "%Window collision" ;
const string _Text_Pascal_Err_String_100 = "Disk read error" ;
const string _Text_Pascal_Err_String_101 = "Disk write error" ;
const string _Text_Pascal_Err_String_102 = "File not assigned" ;
const string _Text_Pascal_Err_String_103 = "File not open" ;
const string _Text_Pascal_Err_String_104 = "File not open for input" ;
const string _Text_Pascal_Err_String_105 = "File not open for output" ;
const string _Text_Pascal_Err_String_106 = "Invalid numeric format" ;
const string _Text_Pascal_Err_String_162 = "Hardware failure" ;
const string _Text_Pascal_Err_String_200 = "Division by zero" ;
const string _Text_Pascal_Err_String_201 = "Range check error" ;
const string _Text_Pascal_Err_String_202 = "Stack overflow error" ;
const string _Text_Pascal_Err_String_203 = "Heap overflow error" ;
const string _Text_Pascal_Err_String_204 = "Invalid pointer operation" ;
const string _Text_Pascal_Err_String_205 = "Floating point overflow" ;
const string _Text_Pascal_Err_String_206 = "Floating point underflow" ;
const string _Text_Pascal_Err_String_207 = "Invalid floating point operation" ;
const string _Text_Pascal_Err_String_208 = "Overlay manager not installed" ;
const string _Text_Pascal_Err_String_209 = "Overlay file read error" ;
const string _Text_Pascal_Err_String_210 = "Object not initialized" ;
const string _Text_Pascal_Err_String_211 = "Call to abstract method" ;
const string _Text_Pascal_Err_String_212 = "Stream registration error" ;
const string _Text_Pascal_Err_String_213 = "Collection index out of range" ;
const string _Text_Pascal_Err_String_214 = "Collection overflow error" ;
const string _Text_Pascal_Err_String_215 = "Arithmetic overflow" ;
const string _Text_Pascal_Err_String_216 = "Access violation" ;
const string _Text_Pascal_Err_String_217 = "Control-C" ;
const string _Text_Pascal_Err_String_218 = "Privileged instruction" ;
const string _Text_Pascal_Err_String_219 = "Invalid typecast" ;
const string _Text_Pascal_Err_String_220 = "Invalid variant typecast" ;
const string _Text_Pascal_Err_String_221 = "Invalid variant operation" ;
const string _Text_Pascal_Err_String_222 = "No variant method call dispatcher" ;
const string _Text_Pascal_Err_String_223 = "Cannot create variant array" ;
const string _Text_Pascal_Err_String_224 = "Variant does not contain array" ;
const string _Text_Pascal_Err_String_225 = "Variant array bounds error" ;
const string _Text_Pascal_Err_String_226 = "TLS initialization error" ;
const string _Text_Pascal_Err_String_227 = "Assertion failed" ;
const string _Text_Pascal_Err_String_228 = "Interface Cast Error" ;
const string _Text_Pascal_Err_String_229 = "Safecall error" ;
const string _Text_Pascal_Err_String_230 = "Unhandled exception" ;
const string _Text_Pascal_Err_String_231 = "Too many nested exceptions" ;
const string _Text_Pascal_Err_String_232 = "Fatal signal raised on a non-Delphi thread" ;
const string _Text_Error_Invalid_List_Index = "Invalid list index" ;
const string _Text_SHErr_No_Room_On_Device = "No Room On Device" ;
const string _Text_SHErr_Corrupted_File_Structure = "Corrupted File Structure" ;
const string _Text_SHErr_Invalid_Pointer_Operation = "Invalid Pointer Operation" ;
const string _Text_SHErr_Deallocation_Error = "Deallocation Error" ;
const string _Text_SHErr_Size_Mismatch = "Size Mismatch" ;
const string _Text_SHErr_Read_Out_Of_Range = "Read Out Of Range" ;
const string _Text_SHErr_Read_Size_Error = "Read Size Error" ;
const string _Text_SHErr_Write_Out_Of_Range = "Write Out Of Range" ;
const string _Text_SHErr_Write_Size_Error = "Write Size Error" ;
const string _Text_SHErr_Bad_Minimum = "Bad minimum" ;
const string _Text_Template_Illegally_Referenced = "$1 template illegally referenced" ;
const string _Text_Object_Cannot_Call_Routine = "$1 object cannot call $2 routine" ;
const string _Text_Objects_In_Arrays_Must_Be_Size_4 = "Objects in arrays must be size 4" ;
const string _Text_Maximum_Size_Of_Array_Object_Data_Exceeded = "Maximum size of array object data exceeded" ;
const string _Text_Error_Subscript_Out_Of_Range_In = "Subscript out of range in $1" ;
const string _Text_Error_Static_Array_Is_Invalid = "Static array $1 is invalid" ;
const string _Text_Error_Maximum_EMS_Array_Element_Size_IS_16384 = "Maximum EMS array element size is 16384" ;
const string _Text_Error_Expanded_Memory_Device_Not_Responding = "Expanded memory device not responding" ;
const string _Text_Error_Expanded_Memory_Device_Not_Present = "Expanded memory device not present" ;
const string _Text_Error_Incompatible_Version_Of_Expanded_Memory_Driver = "Incompatible version of Expanded memory driver" ;
const string _Text_Error_Requested_Array_Size_Is_Zero_Pages = "Requested array size is zero pages" ;
const string _Text_Error_Insufficient_Expanded_Memory_Available_For_Array = "Insufficient Expanded Memory available for array" ;
const string _Text_Error_Static_EMS_Array_Is_Invalid = "Static EMS array $1 is invalid" ;
const string _Text_Error_Maximum_Stack_Size_Is_Exceeded = "Maximum stack size is exceeded" ;
const string _Text_Error_Stack_Is_Empty_In = "Stack is empty in $1" ;
const string _Text_Error_Dynamic_Array_Is_Invalid = "Dynamic array $1 is invalid" ;
const string _Text_Error_Maximum_Dynamic_Stack_Size_Is_Exceeded = "Maximum dynamic stack size is exceeded" ;
const string _Text_Error_While_Opening_Virtual_Array_Image_File = "$1 while opening virtual array image file $2" ;
const string _Text_Error_Virtual_Array_Is_Invalid = "virtual array $1 is invalid" ;
const string _Text_Error_Maximum_Virtual_Stack_Size_Is_Exceeded = "Maximum virtual stack size is exceeded" ;
const string _Text_Error_Maximum_Size_Of_List_Object_Data_Is_Exceeded = "Maximum size of list object data is exceeded" ;
const string _Text_Error_Objects_In_Lists_Must_Be_Size_4 = "Objects in lists must be size 4" ;
const string _Text_Error_End_Of_List_In = "End of list in $1" ;
const string _Text_Error_No_Context_In = "No context in $1" ;
const string _Text_Error_Beginning_Of_List_In = "Beginning of list in $1" ;
const string _Text_Error_Empty_List_In = "Empty list in $1" ;
const string _Text_Error_Queue_Is_Empty_In = "Queue is empty in $1" ;
const string _Text_Error_Maximum_Size_Of_Array_Object_Data_Is_Exceeded =
    "Maximum size of array object data is exceeded" ;
const string _Text_Error_Objects_In_Trees_Must_Be_Size_4 = "Objects in trees must be size 4" ;
const string _Text_Error_Maximum_Size_Of_B_Tree_Object_Data_Is_Exceeded =
    "Maximum size of B-tree object data is exceeded" ;
const string _Text_Error_Maximum_Size_Of_B_Tree_Bucket_Is_Exceeded =
    "Maximum size of B-tree bucket is exceeded" ;
const string _Text_Error_Illegal_Record_Context = "Illegal record context" ;
const string _Text_Dynamic_Stack = "Dynamic stack" ;
const string _Text_Virtual_Stack = "virtual stack" ;
const string _Text_List_Stack = "List Stack" ;
const string _Text_Sparse_Array = "Sparse array" ;
const string _Text_Error_Key_Size_Cannot_Exceed_Total_Tree_Object_Data_Size =
    "Key size cannot exceed total tree object data size" ;
const string _Text_Error_Maximum_Size_Of_Tree_Object_Data_Is_Exceeded =
    "Maximum size of tree object data is exceeded" ;
const string _Text_Error_Duplicate_Items_Encountered_In_Tree =
    "Duplicate items encountered in tree" ;
const string _Text_Error_Tree_Error = "Tree error $1" ;
const string _Text_Error_Tree_is_Empty_In = "Tree is empty in $1" ;
const string _Text_Error_End_Of_Tree_In = "end of tree in $1" ;
const string _Text_Stack_Overflow_In = "Stack overflow in $1" ;
const string _Text_Error_While_Padding_Virtual_Array_Image_File =
    " while padding virtual array image file" ;
const string _Text_Invalid_Symbol_Name = "?Invalid symbol name" ;
const string _Text_Reserved_Name = "?Reserved name" ;
const string _Text_Multiply_Defined_Symbol = "?Multiply defined symbol" ;
const string _Text_Undefined_Reference = "?Undefined reference" ;
const string _Text_No_More_Matches = "?No more matches" ;
const string _Text_Unknown_Symbol_Error = "?Unknown symbol error" ;
const string _Text_Error_TEU_Not_Enough_Memory = "Not enough memory" ;
const string _Text_Error_TEU_Backup_Past_Beginning_Of_Buffer = "Backup past beginning of buffer" ;
const string _Text_Error_TEU_Advance_Beyond_End_Of_Buffer = "Advance beyond end of buffer" ;
const string _Text_Error_TEU_Line_Length_Exceeds_255_Characters = "Line length exceeds 255 characters" ;
const string _Text_Error_TEU_Text_Not_Found = "Text not found" ;
const string _Text_Error_TEU_Nothing_Selected = "Nothing selected" ;
const string _Text_Error_TEU_Selection_In_Progress = "Selection in progress" ;
const string _Text_Error_Maximum_Memory_Exceeded = "?Maximum memory exceeded" ;
const string _Text_Error_Creating = "$1 - creating $2" ;
const string _Text_Error_Opening = "$1 - opening $2" ;
const string _Text_Warning_Some_Lines_Too_Long = "Some line(s) too long - split into multiple lines reading $1" ;
const string _Text_More = "More..." ;
const string _Text_Press_Enter_To_Continue1 = "Press ENTER to continue..." ;
const string _Text_Searching_For = "Searching for: $1" ;
const string _Text_Enter_Keystroke_whose_Definition_You_Wish_To_Save =
    "Enter keystroke whose definition you wish to save" ;
const string _Text_Store_Aborted = "Store aborted" ;
const string _Text_Modifications_Will_No_Be_Saved_Continue_Quitting_NO =
    "Modifications will not be saved - continue quitting <NO> ?" ;
const string _Text_1_Line = "1 line" ;
const string _Text_n_Lines = "$1 lines" ;
const string _Text_Error_Illegal_Command = "Illegal command" ;
const string _Text_Missing_Parameter = "Missing parameter" ;
const string _Text_Error_Missing_Operand = "Missing operand" ;
const string _Text_Error_Invalid_Line_Number = "Invalid line number" ;
const string _Text_Text_To_Search_For = "Text to search for: " ;
const string _Text_Error_Nested_Key_Definitions_Are_Not_Allowed = "Nested key definitions are not allowed" ;
const string _Text_Line = "Line: " ;
const string _Text_Column = "Column: " ;
const string _Text_Error_No_Keystrokes_Are_Being_Recorded = "No keystrokes are being recorded" ;
const string _Text_Error_No_Keystrokes_Were_Recorded = "No keystrokes were recorded" ;
const string _Text_Press_The_Key_To_Which_To_Assign_The_Keystrokes =
    "Press the key to which to assign the keystrokes" ;
const string _Text_Keystrokes_Remembered = "Keystrokes remembered" ;
const string _Text_Error_Previous_Key_Macro_Recording_Must_Be_Finished =
    "Previous key macro recording must be finished" ;
const string _Text_Enter_The_Keystrokes_To_Record =
    "Enter the keystrokes to record, and press control-R to end" ;
const string _Text_Command = "Command: " ;
const string _Text_Control_C_Ignored = "Control-C ignored" ;
const string _Text_Modified = "Modified" ;
const string _Text_File = "File: " ;
const string _Text_n_Bytes_Available = "$1 bytes available" ;
const string _Text_Line_Column = "Line,Column=" ;
const string _Text_Editing_File_x_Confirm = "Editing file: $1.  Confirm <YES> : " ;
const string _Text_Parameters_Are_Not_Allowed_On = "Parameters not allowed on $1" ;
const string _Text_Recover_And_Read_Only_Are_Incompatible_Switches = "/RECOVER and /READ_ONLY are incompatible switches" ;
const string _Text_Invalid_Switch = "Invalid switch: $1" ;
const string _Text_Error_Input_File_Does_Not_Exist = "Input file does not exist" ;
const string _Text_Error_While_Opening_Journal_File_Cant_Recover =
    "$1 - while opening journal file: $2.  Can't recover." ;
const string _Text_Sun = "Sun" ;
const string _Text_Mon = "Mon" ;
const string _Text_Tue = "Tue" ;
const string _Text_Wed = "Wed" ;
const string _Text_Thu = "Thu" ;
const string _Text_Fri = "Fri" ;
const string _Text_Sat = "Sat" ;
const string _Text_Address = "Address:" ;
const string _Text_Data = "Data:" ;
const string _Text_Caption_Modify_Memory = "Modify Memory" ;
const string _Text_Literal_Text = "Literal text" ;
const string _Text_Caption_Size = "Size" ;
const string _Text_Byte1 = "Byte" ;
const string _Text_Word1 = "Word" ;
const string _Text_Long1 = "Long" ;
const string _Text_Button_Caption_OK = "OK" ;
const string _Text_Button_Caption_Cancel = "Cancel" ;
const string _Text_Button_Caption_Help = "Help" ;
const string _Text_New = "New" ;
const string _Text_Button_Caption_Delete = "Delete" ;
const string _Text_Button_Caption_New_Folder = "New Folder" ;
const string _Text_Caption_Internals = "Internals" ;
const string _Text_Caption_Editor_Preferences = "Editor preferences" ;
const string _Text_Persistant_Selection_Blocks = "Persistant Selection Blocks" ;
const string _Text_Bounded_Caret = "Bounded Caret" ;
const string _Text_Inactive_Selection = "Inactive Selection" ;
const string _Text_Tab_Processing = "Tab Processing" ;
const string _Text_Sub_Window = "Sub-window" ;
const string _Text_Auto_Indent = "Auto Indentation" ;
const string _Text_Wrap_Caret = "Wrap Caret" ;
const string _Text_Menu_Caption_Edit_Amp = "&Edit" ;
const string _Text_Menu_Caption_Undo_Amp = "&Undo" ;
const string _Text_Menu_Undo_Hint = "Undo the previous operation" ;
const string _Text_Menu_Caption_Cut_Amp = "Cu&t" ;
const string _Text_Menu_Cut_Hint = "Copy selected text to clipboard and delete" ;
const string _Text_Menu_Caption_Copy_Amp = "&Copy" ;
const string _Text_Menu_Copy_Hint = "Copy selected text to clipboard" ;
const string _Text_Menu_Caption_Paste_Amp = "&Paste" ;
const string _Text_Menu_Paste_Hint = "Paste text from clipboard" ;
const string _Text_Menu_Caption_Delete_Amp = "&Delete" ;
const string _Text_Menu_Delete_Hint = "Delete selected text" ;
const string _Text_Menu_Caption_Include_Amp = "&Include File..." ;
const string _Text_Menu_Include_Hint = "Include a file" ;
const string _Text_Menu_Caption_Search_Amp = "&Search" ;
const string _Text_Menu_Caption_Find_Amp = "&Find..." ;
const string _Text_Menu_Find_Hint = "Find text in current window" ;
const string _Text_Menu_Caption_Replace_Amp = "&Replace..." ;
const string _Text_Menu_Replace_Hint = "Replace text" ;
const string _Text_Menu_Caption_Find_Next_Amp = "Find &Next" ;
const string _Text_Menu_Find_Next_Hint = "Find next item" ;
const string _Text_Menu_Caption_Goto_Amp = "&Go to Line Number..." ;
const string _Text_Caption_Include_File = "Include File" ;
const string _Text_Caption_Find_Data = "Find data" ;
const string _Text_Search_For = "Search for:" ;
const string _Text_Search_Options = "Search options" ;
const string _Text_Bytes = "Bytes" ;
const string _Text_Case_Sensitive = "Case sensitive" ;
const string _Text_Little_Endian = "Little endian" ;
const string _Text_Caption_Enter_Numeric_Value = "Enter numeric value" ;
const string _Text_Enter_The_Value = "Enter the value:" ;
const string _Text_ASCII = "ASCII" ;
const string _Text_EBCDIC = "EBCDIC" ;
const string _Text_Other = "Other:" ;
const string _Text_Caption_Goto_Address = "Goto Address" ;
const string _Text_Enter_New_Address = "Enter new address:" ;
const string _Text_Button_Caption_Abort = "Abort" ;
const string _Text_Caption_Go_To_Line_Number = "Go to Line Number" ;
const string _Text_Enter_New_Line_Number_Amp = "&Enter new line number" ;
const string _Text_Caption_Outline_Editor = "Outline_Editor" ;
const string _Text_Button_Caption_Rename = "Rename..." ;
const string _Text_Button_Caption_Add = "Add..." ;
const string _Text_Button_Caption_Create_Sub = "Create sub..." ;
const string _Text_Button_Caption_Move = "Move..." ;
const string _Text_Caption_Choose_Radix = "Choose radix" ;
const string _Text_Choose_The_Radix_For_Numeric_Display = "Choose the radix for numeric display (2-49):" ;
const string _Text_Button_Caption_Help_Amp = "&Help" ;
const string _Text_Caption_File_Has_Changed = "File has changed" ;
const string _Text_Save_Changes_To1 = "Save changes to " ;
const string _Text_Button_Caption_Yes = "Yes" ;
const string _Text_Button_Caption_No = "No" ;
const string _Text_Text_To_Substitute = "Text to substitute:" ;
const string _Text_Scope = "Scope" ;
const string _Text_Search_From_Current_Position = "Search from current position" ;
const string _Text_Search_Entire_File = "Search entire file" ;
const string _Text_Button_Caption_Replace = "Replace" ;
const string _Text_Prompt_On_Replace = "Prompt on replace" ;
const string _Text_Search = "Search" ;


const int ID_Text_Error_Allocation_Table_Load_Failure = 0 ;
const int ID_Text_Error_Execution_Exceeds_ms = 1 ;
const int ID_Text_Error_Adding_Existing_Object_Or_Failure_To_Delete_Old_Object = 2 ;
const int ID_Text_Error_Found_Object_Has_Facility_Mismatch = 3 ;
const int ID_Text_Error_Facility_Out_Of_Range = 4 ;
const int ID_Text_Error_Removing_Non_Existant_Object = 5 ;
const int ID_Text_Error_Facility_Mismatch = 6 ;
const int ID_Text_Press_Enter_To_Continue = 7 ;
const int ID_Text_Application = 8 ;
const int ID_Text_Unsigned = 9 ;
const int ID_Text_Signed = 10 ;
const int ID_Text_Byte = 11 ;
const int ID_Text_Word = 12 ;
const int ID_Text_Longint = 13 ;
const int ID_Text_Binary = 14 ;
const int ID_Text_Octal = 15 ;
const int ID_Text_Decimal = 16 ;
const int ID_Text_Hexadecimal = 17 ;
const int ID_Text_Radix_50 = 18 ;
const int ID_Text_Base_n = 19 ;
const int ID_Text_Size_Amp = 20 ;
const int ID_Text_Base_Amp = 21 ;
const int ID_Text_Binary_Amp = 22 ;
const int ID_Text_Octal_Amp = 23 ;
const int ID_Text_Decimal_Amp = 24 ;
const int ID_Text_Hexadecimal_Amp = 25 ;
const int ID_Text_Radix_50_Amp = 26 ;
const int ID_Text_Err_Writing_To_Log_File = 27 ;
const int ID_Text_Volume_ID_Is = 28 ;
const int ID_Text_Error_Invalid_Output_Drive = 29 ;
const int ID_Text_Error_FAT_Is_Too_Big = 30 ;
const int ID_Text_Initialization_Error_Correct_And_Press_Any_Key_To_Continue = 31 ;
const int ID_Text_Initialization_Error = 32 ;
const int ID_Text_Error_Unknown_Command_Or_Invalid_Drive = 33 ;
const int ID_Text_Error_Bad_Address_Mark = 34 ;
const int ID_Text_Error_Sector_Not_Found = 35 ;
const int ID_Text_Error_DMA_Failure = 36 ;
const int ID_Text_Error_Data_Error_CRC = 37 ;
const int ID_Text_Error_Controller_Failure = 38 ;
const int ID_Text_Error_Seek_Failure = 39 ;
const int ID_Text_Error_Drive_Does_Not_Respond = 40 ;
const int ID_Text_Error_Drive_Is_Write_Locked = 41 ;
const int ID_Text_Error_Unknown_Unit = 42 ;
const int ID_Text_Error_Drive_Not_Ready = 43 ;
const int ID_Text_Error_Unknown_Command_In_Absolute_Sector_Write = 44 ;
const int ID_Text_Error_Bad_Request_Structure_Length = 45 ;
const int ID_Text_Error_Seek_Error = 46 ;
const int ID_Text_Error_Unknown_Media_Type = 47 ;
const int ID_Text_Error_Printer_Out_Of_Paper = 48 ;
const int ID_Text_Error_Write_Fault = 49 ;
const int ID_Text_Error_Read_Fault = 50 ;
const int ID_Text_Error_General_Failure = 51 ;
const int ID_Text_Error_Error_13_In_Absolute_Sector_Write = 52 ;
const int ID_Text_Error_Error_14_In_Absolute_Sector_Write = 53 ;
const int ID_Text_Error_Invalid_Disk_Change = 54 ;
const int ID_Text_Place_Saveset_Volume_Into_Drive_And_Press_Return = 55 ;
const int ID_Text_Place_Saveset_Volume_Into_Drive = 56 ;
const int ID_Text_Success = 57 ;
const int ID_Text_Error_No_Dictionary_Open = 58 ;
const int ID_Text_Error_Already_Defined = 59 ;
const int ID_Text_Error_Invalid_Syntax_Type = 60 ;
const int ID_Text_Error_Not_Defined = 61 ;
const int ID_Text_Error_Attach_Failed = 62 ;
const int ID_Text_Error_Detach_Failed = 63 ;
const int ID_Text_True = 64 ;
const int ID_Text_False = 65 ;
const int ID_Text_Error_Invalid_Base = 66 ;
const int ID_Text_Error_Numeric_Error = 67 ;
const int ID_Text_Error_Abstract_Method_Called = 68 ;
const int ID_Text_Other_Ellipse = 69 ;
const int ID_Text_Signed_Amp = 70 ;
const int ID_Text_Byte_Amp = 71 ;
const int ID_Text_Word_Amp = 72 ;
const int ID_Text_Long_Amp = 73 ;
const int ID_Text_Quad_Amp = 74 ;
const int ID_Text_EBCDIC_Amp = 75 ;
const int ID_Text_Goto_Address_Ellipse = 76 ;
const int ID_Text_Find_Ellipse = 77 ;
const int ID_Text_Modify_Ellipse = 78 ;
const int ID_Text_Nothing_Found = 79 ;
const int ID_Text_Month_Jan = 80 ;
const int ID_Text_Month_Feb = 81 ;
const int ID_Text_Month_Mar = 82 ;
const int ID_Text_Month_Apr = 83 ;
const int ID_Text_Month_May = 84 ;
const int ID_Text_Month_Jun = 85 ;
const int ID_Text_Month_Jul = 86 ;
const int ID_Text_Month_Aug = 87 ;
const int ID_Text_Month_Sep = 88 ;
const int ID_Text_Month_Oct = 89 ;
const int ID_Text_Month_Nov = 90 ;
const int ID_Text_Month_Dec = 91 ;
const int ID_Text_Month_January = 92 ;
const int ID_Text_Month_February = 93 ;
const int ID_Text_Month_March = 94 ;
const int ID_Text_Month_April = 95 ;
const int ID_Text_Month_June = 96 ;
const int ID_Text_Month_July = 97 ;
const int ID_Text_Month_August = 98 ;
const int ID_Text_Month_September = 99 ;
const int ID_Text_Month_October = 100 ;
const int ID_Text_Month_November = 101 ;
const int ID_Text_Month_December = 102 ;
const int ID_Text_ASCII_Amp = 103 ;
const int ID_Text_Day_Sunday = 104 ;
const int ID_Text_Day_Monday = 105 ;
const int ID_Text_Day_Tuesday = 106 ;
const int ID_Text_Day_Wednesday = 107 ;
const int ID_Text_Day_Thursday = 108 ;
const int ID_Text_Day_Friday = 109 ;
const int ID_Text_Day_Saturday = 110 ;
const int ID_Text_Application_x = 111 ;
const int ID_Text_Operating_System_x = 112 ;
const int ID_Text_There_Is_No_Debugging_Information_Available = 113 ;
const int ID_Text_Error_Opening_x = 114 ;
const int ID_Text_Search_String_Not_Found = 115 ;
const int ID_Text_Caption_Search = 116 ;
const int ID_Text_Caption_Replace = 117 ;
const int ID_Text_Replace_This_Instance = 118 ;
const int ID_Text_Save_Changes_To = 119 ;
const int ID_Text_Noname = 120 ;
const int ID_Text_Unknown_Error_Code = 121 ;
const int ID_Text_Facility_n_Error_n = 122 ;
const int ID_Text_Error_Severity_Success = 123 ;
const int ID_Text_Error_Severity_Notification = 124 ;
const int ID_Text_Error_Severity_Warning = 125 ;
const int ID_Text_Error_Severity_Error = 126 ;
const int ID_Text_Error_Severity_Fatal = 127 ;
const int ID_Text_DOS_Error_Success = 128 ;
const int ID_Text_DOS_Error_1 = 129 ;
const int ID_Text_DOS_Error_2 = 130 ;
const int ID_Text_DOS_Error_3 = 131 ;
const int ID_Text_DOS_Error_4 = 132 ;
const int ID_Text_DOS_Error_5 = 133 ;
const int ID_Text_DOS_Error_6 = 134 ;
const int ID_Text_DOS_Error_7 = 135 ;
const int ID_Text_DOS_Error_8 = 136 ;
const int ID_Text_DOS_Error_9 = 137 ;
const int ID_Text_DOS_Error_10 = 138 ;
const int ID_Text_DOS_Error_11 = 139 ;
const int ID_Text_DOS_Error_12 = 140 ;
const int ID_Text_DOS_Error_13 = 141 ;
const int ID_Text_DOS_Error_14 = 142 ;
const int ID_Text_DOS_Error_15 = 143 ;
const int ID_Text_DOS_Error_16 = 144 ;
const int ID_Text_DOS_Error_17 = 145 ;
const int ID_Text_DOS_Error_18 = 146 ;
const int ID_Text_DOS_Error_19 = 147 ;
const int ID_Text_DOS_Error_20 = 148 ;
const int ID_Text_DOS_Error_21 = 149 ;
const int ID_Text_DOS_Error_22 = 150 ;
const int ID_Text_DOS_Error_23 = 151 ;
const int ID_Text_DOS_Error_24 = 152 ;
const int ID_Text_DOS_Error_25 = 153 ;
const int ID_Text_DOS_Error_26 = 154 ;
const int ID_Text_DOS_Error_27 = 155 ;
const int ID_Text_DOS_Error_28 = 156 ;
const int ID_Text_DOS_Error_29 = 157 ;
const int ID_Text_DOS_Error_30 = 158 ;
const int ID_Text_DOS_Error_31 = 159 ;
const int ID_Text_DOS_Error_32 = 160 ;
const int ID_Text_DOS_Error_33 = 161 ;
const int ID_Text_DOS_Error_34 = 162 ;
const int ID_Text_DOS_Error_35 = 163 ;
const int ID_Text_DOS_Error_36 = 164 ;
const int ID_Text_DOS_Error_38 = 165 ;
const int ID_Text_DOS_Error_50 = 166 ;
const int ID_Text_DOS_Error_51 = 167 ;
const int ID_Text_DOS_Error_52 = 168 ;
const int ID_Text_DOS_Error_53 = 169 ;
const int ID_Text_DOS_Error_54 = 170 ;
const int ID_Text_DOS_Error_55 = 171 ;
const int ID_Text_DOS_Error_56 = 172 ;
const int ID_Text_DOS_Error_57 = 173 ;
const int ID_Text_DOS_Error_58 = 174 ;
const int ID_Text_DOS_Error_59 = 175 ;
const int ID_Text_DOS_Error_60 = 176 ;
const int ID_Text_DOS_Error_61 = 177 ;
const int ID_Text_DOS_Error_62 = 178 ;
const int ID_Text_DOS_Error_63 = 179 ;
const int ID_Text_DOS_Error_64 = 180 ;
const int ID_Text_DOS_Error_65 = 181 ;
const int ID_Text_DOS_Error_66 = 182 ;
const int ID_Text_DOS_Error_67 = 183 ;
const int ID_Text_DOS_Error_68 = 184 ;
const int ID_Text_DOS_Error_69 = 185 ;
const int ID_Text_DOS_Error_70 = 186 ;
const int ID_Text_DOS_Error_71 = 187 ;
const int ID_Text_DOS_Error_72 = 188 ;
const int ID_Text_DOS_Error_80 = 189 ;
const int ID_Text_DOS_Error_81 = 190 ;
const int ID_Text_DOS_Error_82 = 191 ;
const int ID_Text_DOS_Error_83 = 192 ;
const int ID_Text_DOS_Error_84 = 193 ;
const int ID_Text_DOS_Error_85 = 194 ;
const int ID_Text_DOS_Error_86 = 195 ;
const int ID_Text_DOS_Error_87 = 196 ;
const int ID_Text_DOS_Error_88 = 197 ;
const int ID_Text_DOS_Error_89 = 198 ;
const int ID_Text_DOS_Error_90 = 199 ;
const int ID_Text_DOS_Error_91 = 200 ;
const int ID_Text_DOS_Error_92 = 201 ;
const int ID_Text_DOS_Error_93 = 202 ;
const int ID_Text_DOS_Error_95 = 203 ;
const int ID_Text_DOS_Error_100 = 204 ;
const int ID_Text_DOS_Error_101 = 205 ;
const int ID_Text_DOS_Error_102 = 206 ;
const int ID_Text_DOS_Error_103 = 207 ;
const int ID_Text_DOS_Error_104 = 208 ;
const int ID_Text_DOS_Error_105 = 209 ;
const int ID_Text_DOS_Error_106 = 210 ;
const int ID_Text_DOS_Error_107 = 211 ;
const int ID_Text_DOS_Error_108 = 212 ;
const int ID_Text_DOS_Error_109 = 213 ;
const int ID_Text_DOS_Error_110 = 214 ;
const int ID_Text_DOS_Error_111 = 215 ;
const int ID_Text_DOS_Error_112 = 216 ;
const int ID_Text_DOS_Error_113 = 217 ;
const int ID_Text_DOS_Error_114 = 218 ;
const int ID_Text_DOS_Error_115 = 219 ;
const int ID_Text_DOS_Error_116 = 220 ;
const int ID_Text_DOS_Error_117 = 221 ;
const int ID_Text_DOS_Error_118 = 222 ;
const int ID_Text_DOS_Error_119 = 223 ;
const int ID_Text_DOS_Error_120 = 224 ;
const int ID_Text_DOS_Error_121 = 225 ;
const int ID_Text_DOS_Error_122 = 226 ;
const int ID_Text_DOS_Error_123 = 227 ;
const int ID_Text_DOS_Error_124 = 228 ;
const int ID_Text_DOS_Error_125 = 229 ;
const int ID_Text_DOS_Error_126 = 230 ;
const int ID_Text_DOS_Error_127 = 231 ;
const int ID_Text_DOS_Error_128 = 232 ;
const int ID_Text_DOS_Error_129 = 233 ;
const int ID_Text_DOS_Error_130 = 234 ;
const int ID_Text_DOS_Error_131 = 235 ;
const int ID_Text_DOS_Error_132 = 236 ;
const int ID_Text_DOS_Error_133 = 237 ;
const int ID_Text_DOS_Error_134 = 238 ;
const int ID_Text_DOS_Error_135 = 239 ;
const int ID_Text_DOS_Error_136 = 240 ;
const int ID_Text_DOS_Error_137 = 241 ;
const int ID_Text_DOS_Error_138 = 242 ;
const int ID_Text_DOS_Error_139 = 243 ;
const int ID_Text_DOS_Error_140 = 244 ;
const int ID_Text_DOS_Error_141 = 245 ;
const int ID_Text_DOS_Error_142 = 246 ;
const int ID_Text_DOS_Error_143 = 247 ;
const int ID_Text_DOS_Error_144 = 248 ;
const int ID_Text_DOS_Error_145 = 249 ;
const int ID_Text_DOS_Error_146 = 250 ;
const int ID_Text_DOS_Error_147 = 251 ;
const int ID_Text_DOS_Error_148 = 252 ;
const int ID_Text_DOS_Error_149 = 253 ;
const int ID_Text_DOS_Error_150 = 254 ;
const int ID_Text_DOS_Error_151 = 255 ;
const int ID_Text_DOS_Error_152 = 256 ;
const int ID_Text_DOS_Error_153 = 257 ;
const int ID_Text_DOS_Error_154 = 258 ;
const int ID_Text_DOS_Error_155 = 259 ;
const int ID_Text_DOS_Error_156 = 260 ;
const int ID_Text_DOS_Error_157 = 261 ;
const int ID_Text_DOS_Error_158 = 262 ;
const int ID_Text_DOS_Error_159 = 263 ;
const int ID_Text_DOS_Error_160 = 264 ;
const int ID_Text_DOS_Error_161 = 265 ;
const int ID_Text_DOS_Error_162 = 266 ;
const int ID_Text_DOS_Error_163 = 267 ;
const int ID_Text_DOS_Error_164 = 268 ;
const int ID_Text_DOS_Error_165 = 269 ;
const int ID_Text_DOS_Error_180 = 270 ;
const int ID_Text_DOS_Error_181 = 271 ;
const int ID_Text_DOS_Error_182 = 272 ;
const int ID_Text_DOS_Error_183 = 273 ;
const int ID_Text_DOS_Error_184 = 274 ;
const int ID_Text_DOS_Error_185 = 275 ;
const int ID_Text_DOS_Error_186 = 276 ;
const int ID_Text_DOS_Error_187 = 277 ;
const int ID_Text_DOS_Error_188 = 278 ;
const int ID_Text_DOS_Error_189 = 279 ;
const int ID_Text_DOS_Error_190 = 280 ;
const int ID_Text_DOS_Error_191 = 281 ;
const int ID_Text_DOS_Error_192 = 282 ;
const int ID_Text_DOS_Error_193 = 283 ;
const int ID_Text_DOS_Error_194 = 284 ;
const int ID_Text_DOS_Error_195 = 285 ;
const int ID_Text_DOS_Error_196 = 286 ;
const int ID_Text_DOS_Error_197 = 287 ;
const int ID_Text_DOS_Error_198 = 288 ;
const int ID_Text_DOS_Error_199 = 289 ;
const int ID_Text_DOS_Error_200 = 290 ;
const int ID_Text_DOS_Error_201 = 291 ;
const int ID_Text_DOS_Error_202 = 292 ;
const int ID_Text_DOS_Error_203 = 293 ;
const int ID_Text_DOS_Error_204 = 294 ;
const int ID_Text_DOS_Error_205 = 295 ;
const int ID_Text_DOS_Error_206 = 296 ;
const int ID_Text_DOS_Error_207 = 297 ;
const int ID_Text_DOS_Error_208 = 298 ;
const int ID_Text_DOS_Error_209 = 299 ;
const int ID_Text_DOS_Error_210 = 300 ;
const int ID_Text_DOS_Error_211 = 301 ;
const int ID_Text_DOS_Error_212 = 302 ;
const int ID_Text_DOS_Error_213 = 303 ;
const int ID_Text_DOS_Error_214 = 304 ;
const int ID_Text_DOS_Error_215 = 305 ;
const int ID_Text_DOS_Error_216 = 306 ;
const int ID_Text_DOS_Error_600 = 307 ;
const int ID_Text_DOS_Error_601 = 308 ;
const int ID_Text_DOS_Error_602 = 309 ;
const int ID_Text_DOS_Error_603 = 310 ;
const int ID_Text_DOS_Error_604 = 311 ;
const int ID_Text_DOS_Error_605 = 312 ;
const int ID_Text_DOS_Error_606 = 313 ;
const int ID_Text_DOS_Error_607 = 314 ;
const int ID_Text_DOS_Error_608 = 315 ;
const int ID_Text_DOS_Error_609 = 316 ;
const int ID_Text_DOS_Error_610 = 317 ;
const int ID_Text_DOS_Error_611 = 318 ;
const int ID_Text_DOS_Error_612 = 319 ;
const int ID_Text_DOS_Error_613 = 320 ;
const int ID_Text_DOS_Error_614 = 321 ;
const int ID_Text_DOS_Error_615 = 322 ;
const int ID_Text_DOS_Error_616 = 323 ;
const int ID_Text_DOS_Error_617 = 324 ;
const int ID_Text_DOS_Error_618 = 325 ;
const int ID_Text_DOS_Error_619 = 326 ;
const int ID_Text_DOS_Error_620 = 327 ;
const int ID_Text_DOS_Error_621 = 328 ;
const int ID_Text_DOS_Error_622 = 329 ;
const int ID_Text_DOS_Error_623 = 330 ;
const int ID_Text_DOS_Error_624 = 331 ;
const int ID_Text_DOS_Error_625 = 332 ;
const int ID_Text_DOS_Error_626 = 333 ;
const int ID_Text_DOS_Error_627 = 334 ;
const int ID_Text_DOS_Error_628 = 335 ;
const int ID_Text_DOS_Error_629 = 336 ;
const int ID_Text_DOS_Error_630 = 337 ;
const int ID_Text_DOS_Error_631 = 338 ;
const int ID_Text_DOS_Error_632 = 339 ;
const int ID_Text_DOS_Error_633 = 340 ;
const int ID_Text_DOS_Error_634 = 341 ;
const int ID_Text_DOS_Error_635 = 342 ;
const int ID_Text_DOS_Error_636 = 343 ;
const int ID_Text_DOS_Error_637 = 344 ;
const int ID_Text_DOS_Error_638 = 345 ;
const int ID_Text_DOS_Error_639 = 346 ;
const int ID_Text_DOS_Error_640 = 347 ;
const int ID_Text_DOS_Error_641 = 348 ;
const int ID_Text_DOS_Error_642 = 349 ;
const int ID_Text_DOS_Error_643 = 350 ;
const int ID_Text_DOS_Error_644 = 351 ;
const int ID_Text_DOS_Error_645 = 352 ;
const int ID_Text_DOS_Error_646 = 353 ;
const int ID_Text_DOS_Error_647 = 354 ;
const int ID_Text_DOS_Error_648 = 355 ;
const int ID_Text_DOS_Error_649 = 356 ;
const int ID_Text_DOS_Error_650 = 357 ;
const int ID_Text_DOS_Error_651 = 358 ;
const int ID_Text_DOS_Error_652 = 359 ;
const int ID_Text_DOS_Error_653 = 360 ;
const int ID_Text_DOS_Error_654 = 361 ;
const int ID_Text_DOS_Error_655 = 362 ;
const int ID_Text_DOS_Error_656 = 363 ;
const int ID_Text_DOS_Error_657 = 364 ;
const int ID_Text_DOS_Error_658 = 365 ;
const int ID_Text_DOS_Error_659 = 366 ;
const int ID_Text_DOS_Error_660 = 367 ;
const int ID_Text_DOS_Error_661 = 368 ;
const int ID_Text_DOS_Error_662 = 369 ;
const int ID_Text_DOS_Error_663 = 370 ;
const int ID_Text_DOS_Error_664 = 371 ;
const int ID_Text_DOS_Error_665 = 372 ;
const int ID_Text_DOS_Error_666 = 373 ;
const int ID_Text_DOS_Error_667 = 374 ;
const int ID_Text_DOS_Error_668 = 375 ;
const int ID_Text_DOS_Error_669 = 376 ;
const int ID_Text_DOS_Error_670 = 377 ;
const int ID_Text_DOS_Error_671 = 378 ;
const int ID_Text_DOS_Error_672 = 379 ;
const int ID_Text_DOS_Error_673 = 380 ;
const int ID_Text_DOS_Error_674 = 381 ;
const int ID_Text_DOS_Error_675 = 382 ;
const int ID_Text_DOS_Error_676 = 383 ;
const int ID_Text_DOS_Error_677 = 384 ;
const int ID_Text_DOS_Error_678 = 385 ;
const int ID_Text_DOS_Error_679 = 386 ;
const int ID_Text_DOS_Error_680 = 387 ;
const int ID_Text_DOS_Error_681 = 388 ;
const int ID_Text_DOS_Error_682 = 389 ;
const int ID_Text_DOS_Error_683 = 390 ;
const int ID_Text_DOS_Error_684 = 391 ;
const int ID_Text_DOS_Error_685 = 392 ;
const int ID_Text_DOS_Error_686 = 393 ;
const int ID_Text_DOS_Error_687 = 394 ;
const int ID_Text_DOS_Error_688 = 395 ;
const int ID_Text_DOS_Error_689 = 396 ;
const int ID_Text_DOS_Error_690 = 397 ;
const int ID_Text_DOS_Error_691 = 398 ;
const int ID_Text_DOS_Error_692 = 399 ;
const int ID_Text_DOS_Error_693 = 400 ;
const int ID_Text_DOS_Error_694 = 401 ;
const int ID_Text_DOS_Error_695 = 402 ;
const int ID_Text_DOS_Error_696 = 403 ;
const int ID_Text_DOS_Error_697 = 404 ;
const int ID_Text_DOS_Error_698 = 405 ;
const int ID_Text_DOS_Error_699 = 406 ;
const int ID_Text_DOS_Error_700 = 407 ;
const int ID_Text_DOS_Error_701 = 408 ;
const int ID_Text_DOS_Error_702 = 409 ;
const int ID_Text_DOS_Error_703 = 410 ;
const int ID_Text_DOS_Error_704 = 411 ;
const int ID_Text_DOS_Error_705 = 412 ;
const int ID_Text_DOS_Error_706 = 413 ;
const int ID_Text_DOS_Error_707 = 414 ;
const int ID_Text_DOS_Error_708 = 415 ;
const int ID_Text_DOS_Error_709 = 416 ;
const int ID_Text_DOS_Error_710 = 417 ;
const int ID_Text_DOS_Error_711 = 418 ;
const int ID_Text_DOS_Error_712 = 419 ;
const int ID_Text_DOS_Error_713 = 420 ;
const int ID_Text_DOS_Error_714 = 421 ;
const int ID_Text_DOS_Error_715 = 422 ;
const int ID_Text_DOS_Error_716 = 423 ;
const int ID_Text_DOS_Error_717 = 424 ;
const int ID_Text_DOS_Error_718 = 425 ;
const int ID_Text_DOS_Error_719 = 426 ;
const int ID_Text_DOS_Error_720 = 427 ;
const int ID_Text_DOS_Error_721 = 428 ;
const int ID_Text_DOS_Error_722 = 429 ;
const int ID_Text_DOS_Error_723 = 430 ;
const int ID_Text_DOS_Error_724 = 431 ;
const int ID_Text_DOS_Error_725 = 432 ;
const int ID_Text_DOS_Error_726 = 433 ;
const int ID_Text_DOS_Error_727 = 434 ;
const int ID_Text_DOS_Error_728 = 435 ;
const int ID_Text_DOS_Error_729 = 436 ;
const int ID_Text_DOS_Error_730 = 437 ;
const int ID_Text_DOS_Error_731 = 438 ;
const int ID_Text_DOS_Error_732 = 439 ;
const int ID_Text_DOS_Error_733 = 440 ;
const int ID_Text_DOS_Error_734 = 441 ;
const int ID_Text_DOS_Error_735 = 442 ;
const int ID_Text_DOS_Error_736 = 443 ;
const int ID_Text_DOS_Error_737 = 444 ;
const int ID_Text_DOS_Error_738 = 445 ;
const int ID_Text_DOS_Error_739 = 446 ;
const int ID_Text_DOS_Error_740 = 447 ;
const int ID_Text_DOS_Error_741 = 448 ;
const int ID_Text_DOS_Error_742 = 449 ;
const int ID_Text_DOS_Error_743 = 450 ;
const int ID_Text_DOS_Error_744 = 451 ;
const int ID_Text_DOS_Error_752 = 452 ;
const int ID_Text_Error_Unused_Error_Number = 453 ;
const int ID_Text_Express_Error_Expected_Comma = 454 ;
const int ID_Text_Express_Error_Syntax_Error = 455 ;
const int ID_Text_Express_Error_Illegal_Symbol = 456 ;
const int ID_Text_Express_Error_Expected_Left_Parenthesis = 457 ;
const int ID_Text_Express_Error_Division_By_Zero = 458 ;
const int ID_Text_Express_Error_Illegal_Number_for_factorial = 459 ;
const int ID_Text_Express_Error_Floating_point_error = 460 ;
const int ID_Text_Express_Error_Illegal_Number = 461 ;
const int ID_Text_Express_Error_Illegal_Argument = 462 ;
const int ID_Text_Express_Error_Imaginary_Number = 463 ;
const int ID_Text_Express_Error_Illegal_Argument_in_LOG = 464 ;
const int ID_Text_Express_Error_Argument_Too_large_in_EXP = 465 ;
const int ID_Text_Express_Error_Missing_Right_Parenthesis = 466 ;
const int ID_Text_FSErr_FileNotOpen = 467 ;
const int ID_Text_FSErr_EndOfFile = 468 ;
const int ID_Text_FSErr_FileNotFound = 469 ;
const int ID_Text_FSErr_FileNameLength = 470 ;
const int ID_Text_FSErr_FileName = 471 ;
const int ID_Text_FSErr_DirectoryNotFound = 472 ;
const int ID_Text_FSErr_InvalidPath = 473 ;
const int ID_Text_FSErr_NoRoomOnDevice = 474 ;
const int ID_Text_FSErr_ProtectionViolation = 475 ;
const int ID_Text_FSErr_DirectoryExists = 476 ;
const int ID_Text_FSErr_FileNotEmpty = 477 ;
const int ID_Text_FSErr_DirectoryNotEmpty = 478 ;
const int ID_Text_FSErr_CorruptedFileStructure = 479 ;
const int ID_Text_FSErr_FileExists = 480 ;
const int ID_Text_FSErr_IllegalOperationType = 481 ;
const int ID_Text_FSErr_LineTooLong = 482 ;
const int ID_Text_FSErr_InvalidDevice = 483 ;
const int ID_Text_FSErr_Internal_Duplicate = 484 ;
const int ID_Text_FSErr_Invalid_Open_Mode = 485 ;
const int ID_Text_FSErr_Unsupported_Operation = 486 ;
const int ID_Text_FSErr_Device_In_Use = 487 ;
const int ID_Text_FSErr_Unknown_Device_Type = 488 ;
const int ID_Text_FSErr_Internal_Error_On_Add = 489 ;
const int ID_Text_FSErr_Invalid_Record_Size = 490 ;
const int ID_Text_FSErr_Internal_Corruption = 491 ;
const int ID_Text_FSErr_Timeout = 492 ;
const int ID_Text_FSErr_Invalid_Handle = 493 ;
const int ID_Text_FSErr_Data_Format_Error = 494 ;
const int ID_Text_FSErr_Read_Only = 495 ;
const int ID_Text_FHErr_No_Room_On_Device = 496 ;
const int ID_Text_FHErr_Corrupted_File_Structure = 497 ;
const int ID_Text_FHErr_Invalid_Pointer_Operation = 498 ;
const int ID_Text_FHErr_Deallocation_Error = 499 ;
const int ID_Text_FHErr_Size_Mismatch = 450 ;
const int ID_Text_FHErr_Read_Out_Of_Range = 501 ;
const int ID_Text_FHErr_Read_Size_Error = 502 ;
const int ID_Text_FHErr_Write_Out_Of_Range = 503 ;
const int ID_Text_FHErr_Write_Size_Error = 504 ;
const int ID_Text_FHErr_Bad_Minimum = 505 ;
const int ID_Text_Error_Heap_Deallocation_Error = 506 ;
const int ID_Text_Error_Heap_Access_Error = 507 ;
const int ID_Text_Error_Illegal_Resolution_Size = 508 ;
const int ID_Text_Error_Invalid_Address = 509 ;
const int ID_Text_Further_Help_Is_Available_On = 510 ;
const int ID_Text_Sorry_No_Help_For_x_Found_At_This_Level = 511 ;
const int ID_Text_Warning_Nesting_Exceeds_40_Levels = 512 ;
const int ID_Text_Prompt_Topic = 513 ;
const int ID_Text_Error_Help_Not_Available = 514 ;
const int ID_Text_Error_HTML_No_Content = 515 ;
const int ID_Text_Error_HTML_Moved_Permanently = 516 ;
const int ID_Text_Error_HTML_Moved_Temporarily = 517 ;
const int ID_Text_Error_HTML_Bad_Request = 518 ;
const int ID_Text_Error_HTML_Unauthorized = 519 ;
const int ID_Text_Error_HTML_Payment_Required = 520 ;
const int ID_Text_Error_HTML_Forbidden = 521 ;
const int ID_Text_Error_HTML_Not_Found = 522 ;
const int ID_Text_Error_HTML_Method_Not_Allowed = 523 ;
const int ID_Text_Error_HTML_Proxy_Authentication_Required = 524 ;
const int ID_Text_Error_HTML_Request_Timeout = 525 ;
const int ID_Text_Error_HTML_Conflict = 526 ;
const int ID_Text_Error_HTML_Gone = 527 ;
const int ID_Text_Error_HTML_Bad_Gateway = 528 ;
const int ID_Text_Error_HTML_Service_Unavailable = 529 ;
const int ID_Text_Error_HTML_Gateway_Timeout = 530 ;
const int ID_Text_LibErr_Invalid_Library_File_Format = 531 ;
const int ID_Text_LibErr_Module_Not_Found = 532 ;
const int ID_Text_LibErr_Module_Already_Exists = 533 ;
const int ID_Text_LibErr_Illegal_Module_Format = 534 ;
const int ID_Text_Error_Imaginary_Number = 535 ;
const int ID_Text_Error_Store_Overwrite = 536 ;
const int ID_Text_Keystroke_Abort = 537 ;
const int ID_Text_Keystroke_Cancel = 538 ;
const int ID_Text_Keystroke_Ignore = 539 ;
const int ID_Text_Keystroke_No = 540 ;
const int ID_Text_Keystroke_OK = 541 ;
const int ID_Text_Keystroke_Retry = 542 ;
const int ID_Text_Keystroke_Yes = 543 ;
const int ID_Text_Prompt_Abort = 544 ;
const int ID_Text_Prompt_Cancel = 545 ;
const int ID_Text_Prompt_Ignore = 546 ;
const int ID_Text_Prompt_No = 547 ;
const int ID_Text_Prompt_OK = 548 ;
const int ID_Text_Prompt_Retry = 549 ;
const int ID_Text_Prompt_Yes = 550 ;
const int ID_Text_Prompt_Attempt_To_Delete_Alarm_For_Software_Configuration_Key = 551 ;
const int ID_Text_Prompt_Attempt_To_Delete_Software_Configuration_Key = 552 ;
const int ID_Text_Prompt_Attempt_To_Change_Alarm_For_Software_Configuration_Key = 553 ;
const int ID_Text_Prompt_Attempt_To_Change_Software_Configuration_Key = 554 ;
const int ID_Text_Prompt_Attempt_To_Read_Software_Configuration_Key = 555 ;
const int ID_Text_Error_SMU_Error = 556 ;
const int ID_Text_Error_Too_Many_Windows = 557 ;
const int ID_Text_Error_Window_Too_Large = 558 ;
const int ID_Text_Warning_Window_Collision = 559 ;
const int ID_Text_Pascal_Err_String_100 = 560 ;
const int ID_Text_Pascal_Err_String_101 = 561 ;
const int ID_Text_Pascal_Err_String_102 = 562 ;
const int ID_Text_Pascal_Err_String_103 = 563 ;
const int ID_Text_Pascal_Err_String_104 = 564 ;
const int ID_Text_Pascal_Err_String_105 = 565 ;
const int ID_Text_Pascal_Err_String_106 = 566 ;
const int ID_Text_Pascal_Err_String_162 = 567 ;
const int ID_Text_Pascal_Err_String_200 = 568 ;
const int ID_Text_Pascal_Err_String_201 = 569 ;
const int ID_Text_Pascal_Err_String_202 = 570 ;
const int ID_Text_Pascal_Err_String_203 = 571 ;
const int ID_Text_Pascal_Err_String_204 = 572 ;
const int ID_Text_Pascal_Err_String_205 = 573 ;
const int ID_Text_Pascal_Err_String_206 = 574 ;
const int ID_Text_Pascal_Err_String_207 = 575 ;
const int ID_Text_Pascal_Err_String_208 = 576 ;
const int ID_Text_Pascal_Err_String_209 = 577 ;
const int ID_Text_Pascal_Err_String_210 = 578 ;
const int ID_Text_Pascal_Err_String_211 = 579 ;
const int ID_Text_Pascal_Err_String_212 = 580 ;
const int ID_Text_Pascal_Err_String_213 = 581 ;
const int ID_Text_Pascal_Err_String_214 = 582 ;
const int ID_Text_Pascal_Err_String_215 = 583 ;
const int ID_Text_Pascal_Err_String_216 = 584 ;
const int ID_Text_Pascal_Err_String_217 = 585 ;
const int ID_Text_Pascal_Err_String_218 = 586 ;
const int ID_Text_Pascal_Err_String_219 = 587 ;
const int ID_Text_Pascal_Err_String_220 = 588 ;
const int ID_Text_Pascal_Err_String_221 = 589 ;
const int ID_Text_Pascal_Err_String_222 = 590 ;
const int ID_Text_Pascal_Err_String_223 = 591 ;
const int ID_Text_Pascal_Err_String_224 = 592 ;
const int ID_Text_Pascal_Err_String_225 = 593 ;
const int ID_Text_Pascal_Err_String_226 = 594 ;
const int ID_Text_Pascal_Err_String_227 = 595 ;
const int ID_Text_Pascal_Err_String_228 = 596 ;
const int ID_Text_Pascal_Err_String_229 = 597 ;
const int ID_Text_Pascal_Err_String_230 = 598 ;
const int ID_Text_Pascal_Err_String_231 = 599 ;
const int ID_Text_Pascal_Err_String_232 = 600 ;
const int ID_Text_Error_Invalid_List_Index = 601 ;
const int ID_Text_SHErr_No_Room_On_Device = 602 ;
const int ID_Text_SHErr_Corrupted_File_Structure = 603 ;
const int ID_Text_SHErr_Invalid_Pointer_Operation = 604 ;
const int ID_Text_SHErr_Deallocation_Error = 605 ;
const int ID_Text_SHErr_Size_Mismatch = 606 ;
const int ID_Text_SHErr_Read_Out_Of_Range = 607 ;
const int ID_Text_SHErr_Read_Size_Error = 608 ;
const int ID_Text_SHErr_Write_Out_Of_Range = 609 ;
const int ID_Text_SHErr_Write_Size_Error = 610 ;
const int ID_Text_SHErr_Bad_Minimum = 611 ;
const int ID_Text_Template_Illegally_Referenced = 612 ;
const int ID_Text_Object_Cannot_Call_Routine = 613 ;
const int ID_Text_Objects_In_Arrays_Must_Be_Size_4 = 614 ;
const int ID_Text_Maximum_Size_Of_Array_Object_Data_Exceeded = 615 ;
const int ID_Text_Error_Subscript_Out_Of_Range_In = 616 ;
const int ID_Text_Error_Static_Array_Is_Invalid = 617 ;
const int ID_Text_Error_Maximum_EMS_Array_Element_Size_IS_16384 = 618 ;
const int ID_Text_Error_Expanded_Memory_Device_Not_Responding = 619 ;
const int ID_Text_Error_Expanded_Memory_Device_Not_Present = 620 ;
const int ID_Text_Error_Incompatible_Version_Of_Expanded_Memory_Driver = 621 ;
const int ID_Text_Error_Requested_Array_Size_Is_Zero_Pages = 622 ;
const int ID_Text_Error_Insufficient_Expanded_Memory_Available_For_Array = 623 ;
const int ID_Text_Error_Static_EMS_Array_Is_Invalid = 624 ;
const int ID_Text_Error_Maximum_Stack_Size_Is_Exceeded = 625 ;
const int ID_Text_Error_Stack_Is_Empty_In = 626 ;
const int ID_Text_Error_Dynamic_Array_Is_Invalid = 627 ;
const int ID_Text_Error_Maximum_Dynamic_Stack_Size_Is_Exceeded = 628 ;
const int ID_Text_Error_While_Opening_Virtual_Array_Image_File = 629 ;
const int ID_Text_Error_Virtual_Array_Is_Invalid = 630 ;
const int ID_Text_Error_Maximum_Virtual_Stack_Size_Is_Exceeded = 631 ;
const int ID_Text_Error_Maximum_Size_Of_List_Object_Data_Is_Exceeded = 632 ;
const int ID_Text_Error_Objects_In_Lists_Must_Be_Size_4 = 633 ;
const int ID_Text_Error_End_Of_List_In = 634 ;
const int ID_Text_Error_No_Context_In = 635 ;
const int ID_Text_Error_Beginning_Of_List_In = 636 ;
const int ID_Text_Error_Empty_List_In = 637 ;
const int ID_Text_Error_Queue_Is_Empty_In = 638 ;
const int ID_Text_Error_Maximum_Size_Of_Array_Object_Data_Is_Exceeded = 639 ;
const int ID_Text_Error_Objects_In_Trees_Must_Be_Size_4 = 640 ;
const int ID_Text_Error_Maximum_Size_Of_B_Tree_Object_Data_Is_Exceeded = 641 ;
const int ID_Text_Error_Maximum_Size_Of_B_Tree_Bucket_Is_Exceeded = 642 ;
const int ID_Text_Error_Illegal_Record_Context = 643 ;
const int ID_Text_Dynamic_Stack = 644 ;
const int ID_Text_Virtual_Stack = 645 ;
const int ID_Text_List_Stack = 646 ;
const int ID_Text_Sparse_Array = 647 ;
const int ID_Text_Error_Key_Size_Cannot_Exceed_Total_Tree_Object_Data_Size = 648 ;
const int ID_Text_Error_Maximum_Size_Of_Tree_Object_Data_Is_Exceeded = 649 ;
const int ID_Text_Error_Duplicate_Items_Encountered_In_Tree = 650 ;
const int ID_Text_Error_Tree_Error = 651 ;
const int ID_Text_Error_Tree_is_Empty_In = 652 ;
const int ID_Text_Error_End_Of_Tree_In = 653 ;
const int ID_Text_Stack_Overflow_In = 654 ;
const int ID_Text_Error_While_Padding_Virtual_Array_Image_File = 655 ;
const int ID_Text_Invalid_Symbol_Name = 656 ;
const int ID_Text_Reserved_Name = 657 ;
const int ID_Text_Multiply_Defined_Symbol = 658 ;
const int ID_Text_Undefined_Reference = 659 ;
const int ID_Text_No_More_Matches = 660 ;
const int ID_Text_Unknown_Symbol_Error = 661 ;
const int ID_Text_Error_TEU_Not_Enough_Memory = 662 ;
const int ID_Text_Error_TEU_Backup_Past_Beginning_Of_Buffer = 663 ;
const int ID_Text_Error_TEU_Advance_Beyond_End_Of_Buffer = 664 ;
const int ID_Text_Error_TEU_Line_Length_Exceeds_255_Characters = 665 ;
const int ID_Text_Error_TEU_Text_Not_Found = 666 ;
const int ID_Text_Error_TEU_Nothing_Selected = 667 ;
const int ID_Text_Error_TEU_Selection_In_Progress = 668 ;
const int ID_Text_Error_Maximum_Memory_Exceeded = 669 ;
const int ID_Text_Error_Creating = 670 ;
const int ID_Text_Error_Opening = 671 ;
const int ID_Text_Warning_Some_Lines_Too_Long = 672 ;
const int ID_Text_More = 673 ;
const int ID_Text_Press_Enter_To_Continue1 = 674 ;
const int ID_Text_Searching_For = 675 ;
const int ID_Text_Enter_Keystroke_whose_Definition_You_Wish_To_Save = 676 ;
const int ID_Text_Store_Aborted = 677 ;
const int ID_Text_Modifications_Will_No_Be_Saved_Continue_Quitting_NO = 678 ;
const int ID_Text_1_Line = 679 ;
const int ID_Text_n_Lines = 680 ;
const int ID_Text_Error_Illegal_Command = 681 ;
const int ID_Text_Missing_Parameter = 682 ;
const int ID_Text_Error_Missing_Operand = 683 ;
const int ID_Text_Error_Invalid_Line_Number = 684 ;
const int ID_Text_Text_To_Search_For = 685 ;
const int ID_Text_Error_Nested_Key_Definitions_Are_Not_Allowed = 686 ;
const int ID_Text_Line = 687 ;
const int ID_Text_Column = 688 ;
const int ID_Text_Error_No_Keystrokes_Are_Being_Recorded = 689 ;
const int ID_Text_Error_No_Keystrokes_Were_Recorded = 690 ;
const int ID_Text_Press_The_Key_To_Which_To_Assign_The_Keystrokes = 691 ;
const int ID_Text_Keystrokes_Remembered = 692 ;
const int ID_Text_Error_Previous_Key_Macro_Recording_Must_Be_Finished = 693 ;
const int ID_Text_Enter_The_Keystrokes_To_Record = 694 ;
const int ID_Text_Command = 695 ;
const int ID_Text_Control_C_Ignored = 696 ;
const int ID_Text_Modified = 697 ;
const int ID_Text_File = 698 ;
const int ID_Text_n_Bytes_Available = 699 ;
const int ID_Text_Line_Column = 700 ;
const int ID_Text_Editing_File_x_Confirm = 701 ;
const int ID_Text_Parameters_Are_Not_Allowed_On = 702 ;
const int ID_Text_Recover_And_Read_Only_Are_Incompatible_Switches = 703 ;
const int ID_Text_Invalid_Switch = 704 ;
const int ID_Text_Error_Input_File_Does_Not_Exist = 705 ;
const int ID_Text_Error_While_Opening_Journal_File_Cant_Recover = 706 ;
const int ID_Text_Sun = 707 ;
const int ID_Text_Mon = 708 ;
const int ID_Text_Tue = 709 ;
const int ID_Text_Wed = 710 ;
const int ID_Text_Thu = 711 ;
const int ID_Text_Fri = 712 ;
const int ID_Text_Sat = 713 ;
const int ID_Text_Address = 714 ;
const int ID_Text_Data = 715 ;
const int ID_Text_Caption_Modify_Memory = 716 ;
const int ID_Text_Literal_Text = 717 ;
const int ID_Text_Caption_Size = 718 ;
const int ID_Text_Byte1 = 719 ;
const int ID_Text_Word1 = 720 ;
const int ID_Text_Long1 = 721 ;
const int ID_Text_Button_Caption_OK = 722 ;
const int ID_Text_Button_Caption_Cancel = 723 ;
const int ID_Text_Button_Caption_Help = 724 ;
const int ID_Text_New = 725 ;
const int ID_Text_Button_Caption_Delete = 726 ;
const int ID_Text_Button_Caption_New_Folder = 727 ;
const int ID_Text_Caption_Internals = 728 ;
const int ID_Text_Caption_Editor_Preferences = 729 ;
const int ID_Text_Persistant_Selection_Blocks = 730 ;
const int ID_Text_Bounded_Caret = 731 ;
const int ID_Text_Inactive_Selection = 732 ;
const int ID_Text_Tab_Processing = 733 ;
const int ID_Text_Sub_Window = 734 ;
const int ID_Text_Auto_Indent = 735 ;
const int ID_Text_Wrap_Caret = 736 ;
const int ID_Text_Menu_Caption_Edit_Amp = 737 ;
const int ID_Text_Menu_Caption_Undo_Amp = 738 ;
const int ID_Text_Menu_Undo_Hint = 739 ;
const int ID_Text_Menu_Caption_Cut_Amp = 740 ;
const int ID_Text_Menu_Cut_Hint = 741 ;
const int ID_Text_Menu_Caption_Copy_Amp = 742 ;
const int ID_Text_Menu_Copy_Hint = 743 ;
const int ID_Text_Menu_Caption_Paste_Amp = 744 ;
const int ID_Text_Menu_Paste_Hint = 745 ;
const int ID_Text_Menu_Caption_Delete_Amp = 746 ;
const int ID_Text_Menu_Delete_Hint = 747 ;
const int ID_Text_Menu_Caption_Include_Amp = 748 ;
const int ID_Text_Menu_Include_Hint = 749 ;
const int ID_Text_Menu_Caption_Search_Amp = 750 ;
const int ID_Text_Menu_Caption_Find_Amp = 751 ;
const int ID_Text_Menu_Find_Hint = 752 ;
const int ID_Text_Menu_Caption_Replace_Amp = 753 ;
const int ID_Text_Menu_Replace_Hint = 754 ;
const int ID_Text_Menu_Caption_Find_Next_Amp = 755 ;
const int ID_Text_Menu_Find_Next_Hint = 756 ;
const int ID_Text_Menu_Caption_Goto_Amp = 757 ;
const int ID_Text_Caption_Include_File = 758 ;
const int ID_Text_Caption_Find_Data = 759 ;
const int ID_Text_Search_For = 760 ;
const int ID_Text_Search_Options = 761 ;
const int ID_Text_Bytes = 762 ;
const int ID_Text_Case_Sensitive = 763 ;
const int ID_Text_Little_Endian = 764 ;
const int ID_Text_Caption_Enter_Numeric_Value = 765 ;
const int ID_Text_Enter_The_Value = 766 ;
const int ID_Text_ASCII = 767 ;
const int ID_Text_EBCDIC = 768 ;
const int ID_Text_Other = 769 ;
const int ID_Text_Caption_Goto_Address = 770 ;
const int ID_Text_Enter_New_Address = 771 ;
const int ID_Text_Button_Caption_Abort = 772 ;
const int ID_Text_Caption_Go_To_Line_Number = 773 ;
const int ID_Text_Enter_New_Line_Number_Amp = 774 ;
const int ID_Text_Caption_Outline_Editor = 775 ;
const int ID_Text_Button_Caption_Move = 776 ;
const int ID_Text_Button_Caption_Rename = 777 ;
const int ID_Text_Button_Caption_Add = 778 ;
const int ID_Text_Button_Caption_Create_Sub = 779 ;
const int ID_Text_Caption_Choose_Radix = 780 ;
const int ID_Text_Choose_The_Radix_For_Numeric_Display = 781 ;
const int ID_Text_Button_Caption_Help_Amp = 782 ;
const int ID_Text_Caption_File_Has_Changed = 783 ;
const int ID_Text_Save_Changes_To1 = 784 ;
const int ID_Text_Button_Caption_Yes = 785 ;
const int ID_Text_Button_Caption_No = 786 ;
const int ID_Text_Prompt_On_Replace = 787 ;
const int ID_Text_Text_To_Substitute = 788 ;
const int ID_Text_Scope = 789 ;
const int ID_Text_Search_From_Current_Position = 790 ;
const int ID_Text_Search_Entire_File = 791 ;
const int ID_Text_Button_Caption_Replace = 792 ;
const int ID_Text_Search = 793 ;
const int ID_Text_Error_Invalid_Key_Size = 794 ;
const int ID_Text_Files_Unit_Was_Not_Compiled_Correctly = 795 ;
const int ID_Text_Error_FiP_Is_A_Singleton_Object = 796 ;
const int ID_Text_Prompt_Enter_A_Filename = 797 ;
const int ID_Text_Error_Filesys_Unit_Was_Not_Compiled_Correctly = 798 ;
const int ID_Text_Error_Invalid_Syntax = 799 ;
const int ID_Text_Error_Object_Is_Missing_A_Name = 800 ;
const int ID_Text_Error_Expected_Colon = 801 ;
const int ID_Text_Error_Object_Is_Missing_Type = 802 ;
const int ID_Text_Error_Expected_Equal = 803 ;
const int ID_Text_Prompt_Press_Any_Key_To_Continue = 804 ;

string Substitute( const string Value, const string Sub, const string X )
{
    string Result = Value ;
    bool Recursed = Sub.find(X) != string::npos ; // Replacement string contains substring to search for
    int Dummy = Result.find( X ) ;
    while( Dummy != string::npos )
    {
        Result = Result.substr( 0, Dummy - 1 ) + Sub + Result.substr( Dummy + X.length(), Result.length() ) ;
        if( Recursed )
        {
            break ; // Only expand once
        }
        Dummy = Result.find( X ) ;
	}
	return Result;
}


string Substitute1( const string Value, const string Sub1 )
{
    return Substitute( Value, Sub1, "$1" ) ;
}


string Substitute2( const string Value, const string Sub1, const string Sub2 )
{
    string Result = Substitute1( Value, Sub1 ) ;
    return Substitute( Result, Sub2, "$2" ) ;
}


string Substitute3( const string Value, const string Sub1, const string Sub2, const string Sub3 )
{
	
    string Result = Substitute2( Value, Sub1, Sub2 ) ;
    return Substitute( Result, Sub3, "$3" ) ;
}


string Get_Text( const int ID, const string Default )
{
    if( (ID<0) || (ID >= Texts.size()) ) 
    {
        return Default ;
    }
    return Texts[ID];
}


void Load_Text( const string N )
{
  string S;
  ifstream F;
  F.open(N,ios::in);
  if(!F)
  {
  	return;
  }
  Texts.erase(Texts.begin(),Texts.end());
  while( !F.eof() )
  {
    getline(F, S);
    Texts.push_back(S);
  }
  F.close() ;
}


string Text_Error_Allocation_Table_Load_Failure()
{
    return Get_Text( ID_Text_Error_Allocation_Table_Load_Failure, _Text_Error_Allocation_Table_Load_Failure ) ;
}


string Text_Error_Execution_Exceeds_ms()
{
    return Get_Text( ID_Text_Error_Execution_Exceeds_ms, _Text_Error_Execution_Exceeds_ms ) ;
}


string Text_Error_Adding_Existing_Object_Or_Failure_To_Delete_Old_Object()
{
    return Get_Text( ID_Text_Error_Adding_Existing_Object_Or_Failure_To_Delete_Old_Object, _Text_Error_Adding_Existing_Object_Or_Failure_To_Delete_Old_Object ) ;
}


string Text_Error_Found_Object_Has_Facility_Mismatch()
{
    return Get_Text( ID_Text_Error_Found_Object_Has_Facility_Mismatch, _Text_Error_Found_Object_Has_Facility_Mismatch ) ;
}


string Text_Error_Facility_Out_Of_Range()
{
    return Get_Text( ID_Text_Error_Facility_Out_Of_Range, _Text_Error_Facility_Out_Of_Range ) ;
}


string Text_Error_Removing_Non_Existant_Object()
{
    return Get_Text( ID_Text_Error_Removing_Non_Existant_Object, _Text_Error_Removing_Non_Existant_Object ) ;
}


string Text_Error_Facility_Mismatch()
{
     return Get_Text( ID_Text_Error_Facility_Mismatch, _Text_Error_Facility_Mismatch ) ;
}


string Text_Press_Enter_To_Continue()
{
     return Get_Text( ID_Text_Press_Enter_To_Continue, _Text_Press_Enter_To_Continue ) ;
}


string Text_Application()
{
     return Get_Text( ID_Text_Application, _Text_Application ) ;
}


string Text_Unsigned()
{
     return Get_Text( ID_Text_Unsigned, _Text_Unsigned ) ;
}


string Text_Signed()
{
     return Get_Text( ID_Text_Signed, _Text_Signed ) ;
}


string Text_Byte()
{
     return Get_Text( ID_Text_Byte, _Text_Byte ) ;
}


string Text_Word()
{
     return Get_Text( ID_Text_Word, _Text_Word ) ;
}


string Text_Longint()
{
     return Get_Text( ID_Text_Longint, _Text_Longint ) ;
}


string Text_Binary()
{
     return Get_Text( ID_Text_Binary, _Text_Binary ) ;
}


string Text_Octal()
{
     return Get_Text( ID_Text_Octal, _Text_Octal ) ;
}


string Text_Decimal()
{
     return Get_Text( ID_Text_Decimal, _Text_Decimal ) ;
}


string Text_Hexadecimal()
{
     return Get_Text( ID_Text_Hexadecimal, _Text_Hexadecimal ) ;
}


string Text_Radix_50()
{
     return Get_Text( ID_Text_Radix_50, _Text_Radix_50 ) ;
}


string Text_Base_n()
{
     return Get_Text( ID_Text_Base_n, _Text_Base_n ) ;
}


string Text_Size_Amp()
{
     return Get_Text( ID_Text_Size_Amp, _Text_Size_Amp ) ;
}


string Text_Base_Amp()
{
     return Get_Text( ID_Text_Base_Amp, _Text_Base_Amp ) ;
}


string Text_Binary_Amp()
{
     return Get_Text( ID_Text_Binary_Amp, _Text_Binary_Amp ) ;
}


string Text_Octal_Amp()
{
     return Get_Text( ID_Text_Octal_Amp, _Text_Octal_Amp ) ;
}


string Text_Decimal_Amp()
{
     return Get_Text( ID_Text_Decimal_Amp, _Text_Decimal_Amp ) ;
}


string Text_Hexadecimal_Amp()
{
     return Get_Text( ID_Text_Hexadecimal_Amp, _Text_Hexadecimal_Amp ) ;
}


string Text_Radix_50_Amp()
{
     return Get_Text( ID_Text_Radix_50_Amp, _Text_Radix_50_Amp ) ;
}


string Text_Err_Writing_To_Log_File()
{
     return Get_Text( ID_Text_Err_Writing_To_Log_File, _Text_Err_Writing_To_Log_File ) ;
}


string Text_Volume_ID_Is()
{
     return Get_Text( ID_Text_Volume_ID_Is, _Text_Volume_ID_Is ) ;
}


string Text_Error_Invalid_Output_Drive()
{
     return Get_Text( ID_Text_Error_Invalid_Output_Drive, _Text_Error_Invalid_Output_Drive ) ;
}


string Text_Error_FAT_Is_Too_Big()
{
     return Get_Text( ID_Text_Error_FAT_Is_Too_Big, _Text_Error_FAT_Is_Too_Big ) ;
}


string Text_Initialization_Error_Correct_And_Press_Any_Key_To_Continue()
{
     return Get_Text( ID_Text_Initialization_Error_Correct_And_Press_Any_Key_To_Continue, _Text_Initialization_Error_Correct_And_Press_Any_Key_To_Continue ) ;
}


string Text_Initialization_Error()
{
     return Get_Text( ID_Text_Initialization_Error, _Text_Initialization_Error ) ;
}


string Text_Error_Unknown_Command_Or_Invalid_Drive()
{
     return Get_Text( ID_Text_Error_Unknown_Command_Or_Invalid_Drive, _Text_Error_Unknown_Command_Or_Invalid_Drive ) ;
}


string Text_Error_Bad_Address_Mark()
{
     return Get_Text( ID_Text_Error_Bad_Address_Mark, _Text_Error_Bad_Address_Mark ) ;
}


string Text_Error_Sector_Not_Found()
{
     return Get_Text( ID_Text_Error_Sector_Not_Found, _Text_Error_Sector_Not_Found ) ;
}


string Text_Error_DMA_Failure()
{
     return Get_Text( ID_Text_Error_DMA_Failure, _Text_Error_DMA_Failure ) ;
}


string Text_Error_Data_Error_CRC()
{
     return Get_Text( ID_Text_Error_Data_Error_CRC, _Text_Error_Data_Error_CRC ) ;
}


string Text_Error_Controller_Failure()
{
     return Get_Text( ID_Text_Error_Controller_Failure, _Text_Error_Controller_Failure ) ;
}


string Text_Error_Seek_Failure()
{
     return Get_Text( ID_Text_Error_Seek_Failure, _Text_Error_Seek_Failure ) ;
}


string Text_Error_Drive_Does_Not_Respond()
{
     return Get_Text( ID_Text_Error_Drive_Does_Not_Respond, _Text_Error_Drive_Does_Not_Respond ) ;
}


string Text_Error_Drive_Is_Write_Locked()
{
     return Get_Text( ID_Text_Error_Drive_Is_Write_Locked, _Text_Error_Drive_Is_Write_Locked ) ;
}


string Text_Error_Unknown_Unit()
{
     return Get_Text( ID_Text_Error_Unknown_Unit, _Text_Error_Unknown_Unit ) ;
}


string Text_Error_Drive_Not_Ready()
{
     return Get_Text( ID_Text_Error_Drive_Not_Ready, _Text_Error_Drive_Not_Ready ) ;
}


string Text_Error_Unknown_Command_In_Absolute_Sector_Write()
{
    return Get_Text( ID_Text_Error_Unknown_Command_In_Absolute_Sector_Write, _Text_Error_Unknown_Command_In_Absolute_Sector_Write ) ;
}


string Text_Error_Bad_Request_Structure_Length()
{
     return Get_Text( ID_Text_Error_Bad_Request_Structure_Length, _Text_Error_Bad_Request_Structure_Length ) ;
}


string Text_Error_Seek_Error()
{
     return Get_Text( ID_Text_Error_Seek_Error, _Text_Error_Seek_Error ) ;
}


string Text_Error_Unknown_Media_Type()
{
     return Get_Text( ID_Text_Error_Unknown_Media_Type, _Text_Error_Unknown_Media_Type ) ;
}


string Text_Error_Printer_Out_Of_Paper()
{
     return Get_Text( ID_Text_Error_Printer_Out_Of_Paper, _Text_Error_Printer_Out_Of_Paper ) ;
}


string Text_Error_Write_Fault()
{
     return Get_Text( ID_Text_Error_Write_Fault, _Text_Error_Write_Fault ) ;
}


string Text_Error_Read_Fault()
{
     return Get_Text( ID_Text_Error_Read_Fault, _Text_Error_Read_Fault ) ;
}


string Text_Error_General_Failure()
{
     return Get_Text( ID_Text_Error_General_Failure, _Text_Error_General_Failure ) ;
}


string Text_Error_Error_13_In_Absolute_Sector_Write()
{
     return Get_Text( ID_Text_Error_Error_13_In_Absolute_Sector_Write, _Text_Error_Error_13_In_Absolute_Sector_Write ) ;
}


string Text_Error_Error_14_In_Absolute_Sector_Write()
{
     return Get_Text( ID_Text_Error_Error_14_In_Absolute_Sector_Write, _Text_Error_Error_14_In_Absolute_Sector_Write ) ;
}


string Text_Error_Invalid_Disk_Change()
{
     return Get_Text( ID_Text_Error_Invalid_Disk_Change, _Text_Error_Invalid_Disk_Change ) ;
}


string Text_Place_Saveset_Volume_Into_Drive_And_Press_Return()
{
     return Get_Text( ID_Text_Place_Saveset_Volume_Into_Drive_And_Press_Return, _Text_Place_Saveset_Volume_Into_Drive_And_Press_Return ) ;
}


string Text_Place_Saveset_Volume_Into_Drive()
{
     return Get_Text( ID_Text_Place_Saveset_Volume_Into_Drive, _Text_Place_Saveset_Volume_Into_Drive ) ;
}


string Text_Success()
{
     return Get_Text( ID_Text_Success, _Text_Success ) ;
}


string Text_Error_No_Dictionary_Open()
{
     return Get_Text( ID_Text_Error_No_Dictionary_Open, _Text_Error_No_Dictionary_Open ) ;
}


string Text_Error_Already_Defined()
{
     return Get_Text( ID_Text_Error_Already_Defined, _Text_Error_Already_Defined ) ;
}


string Text_Error_Invalid_Syntax_Type()
{
     return Get_Text( ID_Text_Error_Invalid_Syntax_Type, _Text_Error_Invalid_Syntax_Type ) ;
}


string Text_Error_Not_Defined()
{
     return Get_Text( ID_Text_Error_Not_Defined, _Text_Error_Not_Defined ) ;
}


string Text_Error_Attach_Failed()
{
     return Get_Text( ID_Text_Error_Attach_Failed, _Text_Error_Attach_Failed ) ;
}


string Text_Error_Detach_Failed()
{
     return Get_Text( ID_Text_Error_Detach_Failed, _Text_Error_Detach_Failed ) ;
}


string Text_True()
{
     return Get_Text( ID_Text_True, _Text_True ) ;
}


string Text_False()
{
    return Get_Text( ID_Text_False, _Text_False ) ;
}


string Text_Error_Invalid_Base()
{
     return Get_Text( ID_Text_Error_Invalid_Base, _Text_Error_Invalid_Base ) ;
}


string Text_Error_Numeric_Error()
{
     return Get_Text( ID_Text_Error_Numeric_Error, _Text_Error_Numeric_Error ) ;
}


string Text_Error_Abstract_Method_Called()
{
     return Get_Text( ID_Text_Error_Abstract_Method_Called, _Text_Error_Abstract_Method_Called ) ;
}


string Text_Other_Ellipse()
{
     return Get_Text( ID_Text_Other_Ellipse, _Text_Other_Ellipse ) ;
}


string Text_Signed_Amp()
{
     return Get_Text( ID_Text_Signed_Amp, _Text_Signed_Amp ) ;
}


string Text_Byte_Amp()
{
     return Get_Text( ID_Text_Byte_Amp, _Text_Byte_Amp ) ;
}


string Text_Word_Amp()
{
     return Get_Text( ID_Text_Word_Amp, _Text_Word_Amp ) ;
}


string Text_Long_Amp()
{
     return Get_Text( ID_Text_Long_Amp, _Text_Long_Amp ) ;
}


string Text_Quad_Amp()
{
     return Get_Text( ID_Text_Quad_Amp, _Text_Quad_Amp ) ;
}


string Text_EBCDIC_Amp()
{
     return Get_Text( ID_Text_EBCDIC_Amp, _Text_EBCDIC_Amp ) ;
}


string Text_Goto_Address_Ellipse()
{
     return Get_Text( ID_Text_Goto_Address_Ellipse, _Text_Goto_Address_Ellipse ) ;
}


string Text_Find_Ellipse()
{
     return Get_Text( ID_Text_Find_Ellipse, _Text_Find_Ellipse ) ;
}


string Text_Modify_Ellipse()
{
     return Get_Text( ID_Text_Modify_Ellipse, _Text_Modify_Ellipse ) ;
}


string Text_Nothing_Found()
{
     return Get_Text( ID_Text_Nothing_Found, _Text_Nothing_Found ) ;
}


string Text_Month_Jan()
{
     return Get_Text( ID_Text_Month_Jan, _Text_Month_Jan ) ;
}


string Text_Month_Feb()
{
     return Get_Text( ID_Text_Month_Feb, _Text_Month_Feb ) ;
}


string Text_Month_Mar()
{
     return Get_Text( ID_Text_Month_Mar, _Text_Month_Mar ) ;
}


string Text_Month_Apr()
{
     return Get_Text( ID_Text_Month_Apr, _Text_Month_Apr ) ;
}


string Text_Month_May()
{
     return Get_Text( ID_Text_Month_May, _Text_Month_May ) ;
}


string Text_Month_Jun()
{
     return Get_Text( ID_Text_Month_Jun, _Text_Month_Jun ) ;
}


string Text_Month_Jul()
{
     return Get_Text( ID_Text_Month_Jul, _Text_Month_Jul ) ;
}


string Text_Month_Aug()
{
     return Get_Text( ID_Text_Month_Aug, _Text_Month_Aug ) ;
}


string Text_Month_Sep()
{
     return Get_Text( ID_Text_Month_Sep, _Text_Month_Sep ) ;
}


string Text_Month_Oct()
{
     return Get_Text( ID_Text_Month_Oct, _Text_Month_Oct ) ;
}


string Text_Month_Nov()
{
     return Get_Text( ID_Text_Month_Nov, _Text_Month_Nov ) ;
}


string Text_Month_Dec()
{
     return Get_Text( ID_Text_Month_Dec, _Text_Month_Dec ) ;
}


string Text_Month_January()
{
     return Get_Text( ID_Text_Month_January, _Text_Month_January ) ;
}


string Text_Month_February()
{
     return Get_Text( ID_Text_Month_February, _Text_Month_February ) ;
}


string Text_Month_March()
{
     return Get_Text( ID_Text_Month_March, _Text_Month_March ) ;
}


string Text_Month_April()
{
     return Get_Text( ID_Text_Month_April, _Text_Month_April ) ;
}


string Text_Month_June()
{
     return Get_Text( ID_Text_Month_June, _Text_Month_June ) ;
}


string Text_Month_July()
{
     return Get_Text( ID_Text_Month_July, _Text_Month_July ) ;
}


string Text_Month_August()
{
     return Get_Text( ID_Text_Month_August, _Text_Month_August ) ;
}


string Text_Month_September()
{
     return Get_Text( ID_Text_Month_September, _Text_Month_September ) ;
}


string Text_Month_October()
{
     return Get_Text( ID_Text_Month_October, _Text_Month_October ) ;
}


string Text_Month_November()
{
     return Get_Text( ID_Text_Month_November, _Text_Month_November ) ;
}


string Text_Month_December()
{
     return Get_Text( ID_Text_Month_December, _Text_Month_December ) ;
}


string Text_ASCII_Amp()
{
     return Get_Text( ID_Text_ASCII_Amp, _Text_ASCII_Amp ) ;
}


string Text_Day_Sunday()
{
     return Get_Text( ID_Text_Day_Sunday, _Text_Day_Sunday ) ;
}


string Text_Day_Monday()
{
     return Get_Text( ID_Text_Day_Monday, _Text_Day_Monday ) ;
}


string Text_Day_Tuesday()
{
     return Get_Text( ID_Text_Day_Tuesday, _Text_Day_Tuesday ) ;
}


string Text_Day_Wednesday()
{
     return Get_Text( ID_Text_Day_Wednesday, _Text_Day_Wednesday ) ;
}


string Text_Day_Thursday()
{
     return Get_Text( ID_Text_Day_Thursday, _Text_Day_Thursday ) ;
}


string Text_Day_Friday()
{
     return Get_Text( ID_Text_Day_Friday, _Text_Day_Friday ) ;
}


string Text_Day_Saturday()
{
     return Get_Text( ID_Text_Day_Saturday, _Text_Day_Saturday ) ;
}


string Text_Application_x()
{
     return Get_Text( ID_Text_Application_x, _Text_Application_x ) ;
}


string Text_Operating_System_x()
{
     return Get_Text( ID_Text_Operating_System_x, _Text_Operating_System_x ) ;
}


string Text_There_Is_No_Debugging_Information_Available()
{
     return Get_Text( ID_Text_There_Is_No_Debugging_Information_Available, _Text_There_Is_No_Debugging_Information_Available ) ;
}


string Text_Error_Opening_x()
{
     return Get_Text( ID_Text_Error_Opening_x, _Text_Error_Opening_x ) ;
}


string Text_Search_String_Not_Found()
{
     return Get_Text( ID_Text_Search_String_Not_Found, _Text_Search_String_Not_Found ) ;
}


string Text_Error_Creating()
{
     return Get_Text( ID_Text_Error_Creating, _Text_Error_Creating ) ;
}


string Text_Caption_Search()
{
     return Get_Text( ID_Text_Caption_Search, _Text_Caption_Search ) ;
}


string Text_Caption_Replace()
{
     return Get_Text( ID_Text_Caption_Replace, _Text_Caption_Replace ) ;
}


string Text_Replace_This_Instance()
{
     return Get_Text( ID_Text_Replace_This_Instance, _Text_Replace_This_Instance ) ;
}


string Text_Save_Changes_To()
{
     return Get_Text( ID_Text_Save_Changes_To, _Text_Save_Changes_To ) ;
}


string Text_Noname()
{
     return Get_Text( ID_Text_Noname, _Text_Noname ) ;
}


string Text_Unknown_Error_Code()
{
     return Get_Text( ID_Text_Unknown_Error_Code, _Text_Unknown_Error_Code ) ;
}


string Text_Facility_n_Error_n()
{
     return Get_Text( ID_Text_Facility_n_Error_n, _Text_Facility_n_Error_n ) ;
}


string Text_Error_Severity_Success()
{
     return Get_Text( ID_Text_Error_Severity_Success, _Text_Error_Severity_Success ) ;
}


string Text_Error_Severity_Notification()
{
     return Get_Text( ID_Text_Error_Severity_Notification, _Text_Error_Severity_Notification ) ;
}


string Text_Error_Severity_Warning()
{
     return Get_Text( ID_Text_Error_Severity_Warning, _Text_Error_Severity_Warning ) ;
}


string Text_Error_Severity_Error()
{
     return Get_Text( ID_Text_Error_Severity_Error, _Text_Error_Severity_Error ) ;
}


string Text_Error_Severity_Fatal()
{
     return Get_Text( ID_Text_Error_Severity_Fatal, _Text_Error_Severity_Fatal ) ;
}


string Text_DOS_Error_Success()
{
     return Get_Text( ID_Text_DOS_Error_Success, _Text_DOS_Error_Success ) ;
}


string Text_DOS_Error_1()
{
     return Get_Text( ID_Text_DOS_Error_1, _Text_DOS_Error_1 ) ;
}


string Text_DOS_Error_2()
{
     return Get_Text( ID_Text_DOS_Error_2, _Text_DOS_Error_2 ) ;
}


string Text_DOS_Error_3()
{
     return Get_Text( ID_Text_DOS_Error_3, _Text_DOS_Error_3 ) ;
}


string Text_DOS_Error_4()
{
     return Get_Text( ID_Text_DOS_Error_4, _Text_DOS_Error_4 ) ;
}


string Text_DOS_Error_5()
{
     return Get_Text( ID_Text_DOS_Error_5, _Text_DOS_Error_5 ) ;
}


string Text_DOS_Error_6()
{
     return Get_Text( ID_Text_DOS_Error_6, _Text_DOS_Error_6 ) ;
}


string Text_DOS_Error_7()
{
     return Get_Text( ID_Text_DOS_Error_7, _Text_DOS_Error_7 ) ;
}


string Text_DOS_Error_8()
{
     return Get_Text( ID_Text_DOS_Error_8, _Text_DOS_Error_8 ) ;
}


string Text_DOS_Error_9()
{
     return Get_Text( ID_Text_DOS_Error_9, _Text_DOS_Error_9 ) ;
}


string Text_DOS_Error_10()
{
     return Get_Text( ID_Text_DOS_Error_10, _Text_DOS_Error_10 ) ;
}


string Text_DOS_Error_11()
{
     return Get_Text( ID_Text_DOS_Error_11, _Text_DOS_Error_11 ) ;
}


string Text_DOS_Error_12()
{
     return Get_Text( ID_Text_DOS_Error_12, _Text_DOS_Error_12 ) ;
}


string Text_DOS_Error_13()
{
     return Get_Text( ID_Text_DOS_Error_13, _Text_DOS_Error_13 ) ;
}


string Text_DOS_Error_14()
{
     return Get_Text( ID_Text_DOS_Error_14, _Text_DOS_Error_14 ) ;
}


string Text_DOS_Error_15()
{
     return Get_Text( ID_Text_DOS_Error_15, _Text_DOS_Error_15 ) ;
}


string Text_DOS_Error_16()
{
     return Get_Text( ID_Text_DOS_Error_16, _Text_DOS_Error_16 ) ;
}


string Text_DOS_Error_17()
{
     return Get_Text( ID_Text_DOS_Error_17, _Text_DOS_Error_17 ) ;
}


string Text_DOS_Error_18()
{
     return Get_Text( ID_Text_DOS_Error_18, _Text_DOS_Error_18 ) ;
}


string Text_DOS_Error_19()
{
     return Get_Text( ID_Text_DOS_Error_19, _Text_DOS_Error_19 ) ;
}


string Text_DOS_Error_20()
{
     return Get_Text( ID_Text_DOS_Error_20, _Text_DOS_Error_20 ) ;
}


string Text_DOS_Error_21()
{
     return Get_Text( ID_Text_DOS_Error_21, _Text_DOS_Error_21 ) ;
}


string Text_DOS_Error_22()
{
     return Get_Text( ID_Text_DOS_Error_22, _Text_DOS_Error_22 ) ;
}


string Text_DOS_Error_23()
{
     return Get_Text( ID_Text_DOS_Error_23, _Text_DOS_Error_23 ) ;
}


string Text_DOS_Error_24()
{
     return Get_Text( ID_Text_DOS_Error_24, _Text_DOS_Error_24 ) ;
}


string Text_DOS_Error_25()
{
     return Get_Text( ID_Text_DOS_Error_25, _Text_DOS_Error_25 ) ;
}


string Text_DOS_Error_26()
{
     return Get_Text( ID_Text_DOS_Error_26, _Text_DOS_Error_26 ) ;
}


string Text_DOS_Error_27()
{
     return Get_Text( ID_Text_DOS_Error_27, _Text_DOS_Error_27 ) ;
}


string Text_DOS_Error_28()
{
     return Get_Text( ID_Text_DOS_Error_28, _Text_DOS_Error_28 ) ;
}


string Text_DOS_Error_29()
{
     return Get_Text( ID_Text_DOS_Error_29, _Text_DOS_Error_29 ) ;
}


string Text_DOS_Error_30()
{
     return Get_Text( ID_Text_DOS_Error_30, _Text_DOS_Error_30 ) ;
}


string Text_DOS_Error_31()
{
     return Get_Text( ID_Text_DOS_Error_31, _Text_DOS_Error_31 ) ;
}


string Text_DOS_Error_32()
{
     return Get_Text( ID_Text_DOS_Error_32, _Text_DOS_Error_32 ) ;
}


string Text_DOS_Error_33()
{
     return Get_Text( ID_Text_DOS_Error_33, _Text_DOS_Error_33 ) ;
}


string Text_DOS_Error_34()
{
     return Get_Text( ID_Text_DOS_Error_34, _Text_DOS_Error_34 ) ;
}


string Text_DOS_Error_35()
{
     return Get_Text( ID_Text_DOS_Error_35, _Text_DOS_Error_35 ) ;
}


string Text_DOS_Error_36()
{
     return  Get_Text( ID_Text_DOS_Error_36, _Text_DOS_Error_36 ) ;
}


string Text_DOS_Error_38()
{
     return Get_Text( ID_Text_DOS_Error_38, _Text_DOS_Error_38 ) ;
}


string Text_DOS_Error_50()
{
     return Get_Text( ID_Text_DOS_Error_50, _Text_DOS_Error_50 ) ;
}


string Text_DOS_Error_51()
{
     return Get_Text( ID_Text_DOS_Error_51, _Text_DOS_Error_51 ) ;
}


string Text_DOS_Error_52()
{
     return Get_Text( ID_Text_DOS_Error_52, _Text_DOS_Error_52 ) ;
}


string Text_DOS_Error_53()
{
     return Get_Text( ID_Text_DOS_Error_53, _Text_DOS_Error_53 ) ;
}


string Text_DOS_Error_54()
{
     return Get_Text( ID_Text_DOS_Error_54, _Text_DOS_Error_54 ) ;
}


string Text_DOS_Error_55()
{
     return   Get_Text( ID_Text_DOS_Error_55, _Text_DOS_Error_55 ) ;
}


string Text_DOS_Error_56()
{
     return Get_Text( ID_Text_DOS_Error_56, _Text_DOS_Error_56 ) ;
}


string Text_DOS_Error_57()
{
     return Get_Text( ID_Text_DOS_Error_57, _Text_DOS_Error_57 ) ;
}


string Text_DOS_Error_58()
{
     return Get_Text( ID_Text_DOS_Error_58, _Text_DOS_Error_58 ) ;
}


string Text_DOS_Error_59()
{
     return Get_Text( ID_Text_DOS_Error_59, _Text_DOS_Error_59 ) ;
}


string Text_DOS_Error_60()
{
     return Get_Text( ID_Text_DOS_Error_60, _Text_DOS_Error_60 ) ;
}


string Text_DOS_Error_61()
{
     return Get_Text( ID_Text_DOS_Error_61, _Text_DOS_Error_61 ) ;
}


string Text_DOS_Error_62()
{
     return Get_Text( ID_Text_DOS_Error_62, _Text_DOS_Error_62 ) ;
}


string Text_DOS_Error_63()
{
     return Get_Text( ID_Text_DOS_Error_63, _Text_DOS_Error_63 ) ;
}


string Text_DOS_Error_64()
{
     return Get_Text( ID_Text_DOS_Error_64, _Text_DOS_Error_64 ) ;
}


string Text_DOS_Error_65()
{
     return Get_Text( ID_Text_DOS_Error_65, _Text_DOS_Error_65 ) ;
}


string Text_DOS_Error_66()
{
     return Get_Text( ID_Text_DOS_Error_66, _Text_DOS_Error_66 ) ;
}


string Text_DOS_Error_67()
{
     return Get_Text( ID_Text_DOS_Error_67, _Text_DOS_Error_67 ) ;
}


string Text_DOS_Error_68()
{
     return Get_Text( ID_Text_DOS_Error_68, _Text_DOS_Error_68 ) ;
}


string Text_DOS_Error_69()
{
     return Get_Text( ID_Text_DOS_Error_69, _Text_DOS_Error_69 ) ;
}


string Text_DOS_Error_70()
{
     return Get_Text( ID_Text_DOS_Error_70, _Text_DOS_Error_70 ) ;
}


string Text_DOS_Error_71()
{
     return Get_Text( ID_Text_DOS_Error_71, _Text_DOS_Error_71 ) ;
}


string Text_DOS_Error_72()
{
     return Get_Text( ID_Text_DOS_Error_72, _Text_DOS_Error_72 ) ;
}


string Text_DOS_Error_80()
{
     return Get_Text( ID_Text_DOS_Error_80, _Text_DOS_Error_80 ) ;
}


string Text_DOS_Error_81()
{
     return Get_Text( ID_Text_DOS_Error_81, _Text_DOS_Error_81 ) ;
}


string Text_DOS_Error_82()
{
     return Get_Text( ID_Text_DOS_Error_82, _Text_DOS_Error_82 ) ;
}


string Text_DOS_Error_83()
{
     return Get_Text( ID_Text_DOS_Error_83, _Text_DOS_Error_83 ) ;
}


string Text_DOS_Error_84()
{
     return Get_Text( ID_Text_DOS_Error_84, _Text_DOS_Error_84 ) ;
}


string Text_DOS_Error_85()
{
     return Get_Text( ID_Text_DOS_Error_85, _Text_DOS_Error_85 ) ;
}


string Text_DOS_Error_86()
{
     return Get_Text( ID_Text_DOS_Error_86, _Text_DOS_Error_86 ) ;
}


string Text_DOS_Error_87()
{
     return Get_Text( ID_Text_DOS_Error_87, _Text_DOS_Error_87 ) ;
}


string Text_DOS_Error_88()
{
     return Get_Text( ID_Text_DOS_Error_88, _Text_DOS_Error_88 ) ;
}


string Text_DOS_Error_89()
{
     return Get_Text( ID_Text_DOS_Error_89, _Text_DOS_Error_89 ) ;
}


string Text_DOS_Error_90()
{
     return Get_Text( ID_Text_DOS_Error_90, _Text_DOS_Error_90 ) ;
}


string Text_DOS_Error_91()
{
     return Get_Text( ID_Text_DOS_Error_91, _Text_DOS_Error_91 ) ;
}


string Text_DOS_Error_92()
{
     return Get_Text( ID_Text_DOS_Error_92, _Text_DOS_Error_92 ) ;
}


string Text_DOS_Error_93()
{
     return Get_Text( ID_Text_DOS_Error_93, _Text_DOS_Error_93 ) ;
}


string Text_DOS_Error_95()
{
     return Get_Text( ID_Text_DOS_Error_95, _Text_DOS_Error_95 ) ;
}


string Text_DOS_Error_100()
{
     return Get_Text( ID_Text_DOS_Error_100, _Text_DOS_Error_100 ) ;
}


string Text_DOS_Error_101()
{
     return Get_Text( ID_Text_DOS_Error_101, _Text_DOS_Error_101 ) ;
}


string Text_DOS_Error_102()
{
     return Get_Text( ID_Text_DOS_Error_102, _Text_DOS_Error_102 ) ;
}


string Text_DOS_Error_103()
{
     return Get_Text( ID_Text_DOS_Error_103, _Text_DOS_Error_103 ) ;
}


string Text_DOS_Error_104()
{
     return Get_Text( ID_Text_DOS_Error_104, _Text_DOS_Error_104 ) ;
}


string Text_DOS_Error_105()
{
     return Get_Text( ID_Text_DOS_Error_105, _Text_DOS_Error_105 ) ;
}


string Text_DOS_Error_106()
{
     return Get_Text( ID_Text_DOS_Error_106, _Text_DOS_Error_106 ) ;
}


string Text_DOS_Error_107()
{
     return Get_Text( ID_Text_DOS_Error_107, _Text_DOS_Error_107 ) ;
}


string Text_DOS_Error_108()
{
     return  Get_Text( ID_Text_DOS_Error_108, _Text_DOS_Error_108 ) ;
}


string Text_DOS_Error_109()
{
     return Get_Text( ID_Text_DOS_Error_109, _Text_DOS_Error_109 ) ;
}


string Text_DOS_Error_110()
{
     return Get_Text( ID_Text_DOS_Error_110, _Text_DOS_Error_110 ) ;
}


string Text_DOS_Error_111()
{
     return Get_Text( ID_Text_DOS_Error_111, _Text_DOS_Error_111 ) ;
}


string Text_DOS_Error_112()
{
     return Get_Text( ID_Text_DOS_Error_112, _Text_DOS_Error_112 ) ;
}


string Text_DOS_Error_113()
{
     return Get_Text( ID_Text_DOS_Error_113, _Text_DOS_Error_113 ) ;
}


string Text_DOS_Error_114()
{
     return   Get_Text( ID_Text_DOS_Error_114, _Text_DOS_Error_114 ) ;
}


string Text_DOS_Error_115()
{
     return Get_Text( ID_Text_DOS_Error_115, _Text_DOS_Error_115 ) ;
}


string Text_DOS_Error_116()
{
     return Get_Text( ID_Text_DOS_Error_116, _Text_DOS_Error_116 ) ;
}


string Text_DOS_Error_117()
{
     return Get_Text( ID_Text_DOS_Error_117, _Text_DOS_Error_117 ) ;
}


string Text_DOS_Error_118()
{
     return Get_Text( ID_Text_DOS_Error_118, _Text_DOS_Error_118 ) ;
}


string Text_DOS_Error_119()
{
     return Get_Text( ID_Text_DOS_Error_119, _Text_DOS_Error_119 ) ;
}


string Text_DOS_Error_120()
{
     return Get_Text( ID_Text_DOS_Error_120, _Text_DOS_Error_120 ) ;
}


string Text_DOS_Error_121()
{
     return Get_Text( ID_Text_DOS_Error_121, _Text_DOS_Error_121 ) ;
}


string Text_DOS_Error_122()
{
     return Get_Text( ID_Text_DOS_Error_122, _Text_DOS_Error_122 ) ;
}


string Text_DOS_Error_123()
{
     return Get_Text( ID_Text_DOS_Error_123, _Text_DOS_Error_123 ) ;
}


string Text_DOS_Error_124()
{
     return Get_Text( ID_Text_DOS_Error_124, _Text_DOS_Error_124 ) ;
}


string Text_DOS_Error_125()
{
     return Get_Text( ID_Text_DOS_Error_125, _Text_DOS_Error_125 ) ;
}


string Text_DOS_Error_126()
{
     return Get_Text( ID_Text_DOS_Error_126, _Text_DOS_Error_126 ) ;
}


string Text_DOS_Error_127()
{
     return Get_Text( ID_Text_DOS_Error_127, _Text_DOS_Error_127 ) ;
}


string Text_DOS_Error_128()
{
    return Get_Text( ID_Text_DOS_Error_128, _Text_DOS_Error_128 ) ;
}


string Text_DOS_Error_129()
{
     return Get_Text( ID_Text_DOS_Error_129, _Text_DOS_Error_129 ) ;
}


string Text_DOS_Error_130()
{
     return Get_Text( ID_Text_DOS_Error_130, _Text_DOS_Error_130 ) ;
}


string Text_DOS_Error_131()
{
     return Get_Text( ID_Text_DOS_Error_131, _Text_DOS_Error_131 ) ;
}


string Text_DOS_Error_132()
{
     return Get_Text( ID_Text_DOS_Error_132, _Text_DOS_Error_132 ) ;
}


string Text_DOS_Error_133()
{
     return Get_Text( ID_Text_DOS_Error_133, _Text_DOS_Error_133 ) ;
}


string Text_DOS_Error_134()
{
     return Get_Text( ID_Text_DOS_Error_134, _Text_DOS_Error_134 ) ;
}


string Text_DOS_Error_135()
{
     return Get_Text( ID_Text_DOS_Error_135, _Text_DOS_Error_135 ) ;
}


string Text_DOS_Error_136()
{
     return Get_Text( ID_Text_DOS_Error_136, _Text_DOS_Error_136 ) ;
}


string Text_DOS_Error_137()
{
     return Get_Text( ID_Text_DOS_Error_137, _Text_DOS_Error_137 ) ;
}


string Text_DOS_Error_138()
{
     return Get_Text( ID_Text_DOS_Error_138, _Text_DOS_Error_138 ) ;
}


string Text_DOS_Error_139()
{
     return Get_Text( ID_Text_DOS_Error_139, _Text_DOS_Error_139 ) ;
}


string Text_DOS_Error_140()
{
     return Get_Text( ID_Text_DOS_Error_140, _Text_DOS_Error_140 ) ;
}


string Text_DOS_Error_141()
{
     return Get_Text( ID_Text_DOS_Error_141, _Text_DOS_Error_141 ) ;
}


string Text_DOS_Error_142()
{
     return Get_Text( ID_Text_DOS_Error_142, _Text_DOS_Error_142 ) ;
}


string Text_DOS_Error_143()
{
     return Get_Text( ID_Text_DOS_Error_143, _Text_DOS_Error_143 ) ;
}


string Text_DOS_Error_144()
{
     return Get_Text( ID_Text_DOS_Error_144, _Text_DOS_Error_144 ) ;
}


string Text_DOS_Error_145()
{
     return Get_Text( ID_Text_DOS_Error_145, _Text_DOS_Error_145 ) ;
}


string Text_DOS_Error_146()
{
     return Get_Text( ID_Text_DOS_Error_146, _Text_DOS_Error_146 ) ;
}


string Text_DOS_Error_147()
{
     return Get_Text( ID_Text_DOS_Error_147, _Text_DOS_Error_147 ) ;
}


string Text_DOS_Error_148()
{
     return Get_Text( ID_Text_DOS_Error_148, _Text_DOS_Error_148 ) ;
}


string Text_DOS_Error_149()
{
     return Get_Text( ID_Text_DOS_Error_149, _Text_DOS_Error_149 ) ;
}


string Text_DOS_Error_150()
{
     return Get_Text( ID_Text_DOS_Error_150, _Text_DOS_Error_150 ) ;
}


string Text_DOS_Error_151()
{
     return Get_Text( ID_Text_DOS_Error_151, _Text_DOS_Error_151 ) ;
}


string Text_DOS_Error_152()
{
     return Get_Text( ID_Text_DOS_Error_152, _Text_DOS_Error_152 ) ;
}


string Text_DOS_Error_153()
{
     return Get_Text( ID_Text_DOS_Error_153, _Text_DOS_Error_153 ) ;
}


string Text_DOS_Error_154()
{
     return Get_Text( ID_Text_DOS_Error_154, _Text_DOS_Error_154 ) ;
}


string Text_DOS_Error_155()
{
     return  Get_Text( ID_Text_DOS_Error_155, _Text_DOS_Error_155 ) ;
}


string Text_DOS_Error_156()
{
     return Get_Text( ID_Text_DOS_Error_156, _Text_DOS_Error_156 ) ;
}


string Text_DOS_Error_157()
{
     return Get_Text( ID_Text_DOS_Error_157, _Text_DOS_Error_157 ) ;
}


string Text_DOS_Error_158()
{
     return Get_Text( ID_Text_DOS_Error_158, _Text_DOS_Error_158 ) ;
}


string Text_DOS_Error_159()
{
     return Get_Text( ID_Text_DOS_Error_159, _Text_DOS_Error_159 ) ;
}


string Text_DOS_Error_160()
{
     return Get_Text( ID_Text_DOS_Error_160, _Text_DOS_Error_160 ) ;
}


string Text_DOS_Error_161()
{
     return Get_Text( ID_Text_DOS_Error_161, _Text_DOS_Error_161 ) ;
}


string Text_DOS_Error_162()
{
     return Get_Text( ID_Text_DOS_Error_162, _Text_DOS_Error_162 ) ;
}


string Text_DOS_Error_163()
{
     return Get_Text( ID_Text_DOS_Error_163, _Text_DOS_Error_163 ) ;
}


string Text_DOS_Error_164()
{
     return Get_Text( ID_Text_DOS_Error_164, _Text_DOS_Error_164 ) ;
}


string Text_DOS_Error_165()
{
     return Get_Text( ID_Text_DOS_Error_165, _Text_DOS_Error_165 ) ;
}


string Text_DOS_Error_180()
{
     return Get_Text( ID_Text_DOS_Error_180, _Text_DOS_Error_180 ) ;
}


string Text_DOS_Error_181()
{
     return Get_Text( ID_Text_DOS_Error_181, _Text_DOS_Error_181 ) ;
}


string Text_DOS_Error_182()
{
     return Get_Text( ID_Text_DOS_Error_182, _Text_DOS_Error_182 ) ;
}


string Text_DOS_Error_183()
{
     return Get_Text( ID_Text_DOS_Error_183, _Text_DOS_Error_183 ) ;
}


string Text_DOS_Error_184()
{
     return Get_Text( ID_Text_DOS_Error_184, _Text_DOS_Error_184 ) ;
}


string Text_DOS_Error_185()
{
     return Get_Text( ID_Text_DOS_Error_185, _Text_DOS_Error_185 ) ;
}


string Text_DOS_Error_186()
{
     return Get_Text( ID_Text_DOS_Error_186, _Text_DOS_Error_186 ) ;
}


string Text_DOS_Error_187()
{
     return Get_Text( ID_Text_DOS_Error_187, _Text_DOS_Error_187 ) ;
}


string Text_DOS_Error_188()
{
     return Get_Text( ID_Text_DOS_Error_188, _Text_DOS_Error_188 ) ;
}


string Text_DOS_Error_189()
{
     return Get_Text( ID_Text_DOS_Error_189, _Text_DOS_Error_189 ) ;
}


string Text_DOS_Error_190()
{
     return Get_Text( ID_Text_DOS_Error_190, _Text_DOS_Error_190 ) ;
}


string Text_DOS_Error_191()
{
     return Get_Text( ID_Text_DOS_Error_191, _Text_DOS_Error_191 ) ;
}


string Text_DOS_Error_192()
{
     return Get_Text( ID_Text_DOS_Error_192, _Text_DOS_Error_192 ) ;
}


string Text_DOS_Error_193()
{
     return Get_Text( ID_Text_DOS_Error_193, _Text_DOS_Error_193 ) ;
}


string Text_DOS_Error_194()
{
     return Get_Text( ID_Text_DOS_Error_194, _Text_DOS_Error_194 ) ;
}


string Text_DOS_Error_195()
{
     return Get_Text( ID_Text_DOS_Error_195, _Text_DOS_Error_195 ) ;
}


string Text_DOS_Error_196()
{
     return Get_Text( ID_Text_DOS_Error_196, _Text_DOS_Error_196 ) ;
}


string Text_DOS_Error_197()
{
     return Get_Text( ID_Text_DOS_Error_197, _Text_DOS_Error_197 ) ;
}


string Text_DOS_Error_198()
{
     return Get_Text( ID_Text_DOS_Error_198, _Text_DOS_Error_198 ) ;
}


string Text_DOS_Error_199()
{
     return Get_Text( ID_Text_DOS_Error_199, _Text_DOS_Error_199 ) ;
}


string Text_DOS_Error_200()
{
     return Get_Text( ID_Text_DOS_Error_200, _Text_DOS_Error_200 ) ;
}


string Text_DOS_Error_201()
{
     return Get_Text( ID_Text_DOS_Error_201, _Text_DOS_Error_201 ) ;
}


string Text_DOS_Error_202()
{
     return Get_Text( ID_Text_DOS_Error_202, _Text_DOS_Error_202 ) ;
}


string Text_DOS_Error_203()
{
     return Get_Text( ID_Text_DOS_Error_203, _Text_DOS_Error_203 ) ;
}


string Text_DOS_Error_204()
{
     return Get_Text( ID_Text_DOS_Error_204, _Text_DOS_Error_204 ) ;
}


string Text_DOS_Error_205()
{
     return Get_Text( ID_Text_DOS_Error_205, _Text_DOS_Error_205 ) ;
}


string Text_DOS_Error_206()
{
     return Get_Text( ID_Text_DOS_Error_206, _Text_DOS_Error_206 ) ;
}


string Text_DOS_Error_207()
{
     return Get_Text( ID_Text_DOS_Error_207, _Text_DOS_Error_207 ) ;
}


string Text_DOS_Error_208()
{
     return Get_Text( ID_Text_DOS_Error_208, _Text_DOS_Error_208 ) ;
}


string Text_DOS_Error_209()
{
     return Get_Text( ID_Text_DOS_Error_209, _Text_DOS_Error_209 ) ;
}


string Text_DOS_Error_210()
{
     return Get_Text( ID_Text_DOS_Error_210, _Text_DOS_Error_210 ) ;
}


string Text_DOS_Error_211()
{
     return Get_Text( ID_Text_DOS_Error_211, _Text_DOS_Error_211 ) ;
}


string Text_DOS_Error_212()
{
     return Get_Text( ID_Text_DOS_Error_212, _Text_DOS_Error_212 ) ;
}


string Text_DOS_Error_213()
{
     return Get_Text( ID_Text_DOS_Error_213, _Text_DOS_Error_213 ) ;
}


string Text_DOS_Error_214()
{
     return Get_Text( ID_Text_DOS_Error_214, _Text_DOS_Error_214 ) ;
}


string Text_DOS_Error_215()
{
     return Get_Text( ID_Text_DOS_Error_215, _Text_DOS_Error_215 ) ;
}


string Text_DOS_Error_216()
{
     return Get_Text( ID_Text_DOS_Error_216, _Text_DOS_Error_216 ) ;
}


string Text_DOS_Error_600()
{
     return Get_Text( ID_Text_DOS_Error_600, _Text_DOS_Error_600 ) ;
}


string Text_DOS_Error_601()
{
     return Get_Text( ID_Text_DOS_Error_601, _Text_DOS_Error_601 ) ;
}


string Text_DOS_Error_602()
{
     return Get_Text( ID_Text_DOS_Error_602, _Text_DOS_Error_602 ) ;
}


string Text_DOS_Error_603()
{
     return Get_Text( ID_Text_DOS_Error_603, _Text_DOS_Error_603 ) ;
}


string Text_DOS_Error_604()
{
     return Get_Text( ID_Text_DOS_Error_604, _Text_DOS_Error_604 ) ;
}


string Text_DOS_Error_605()
{
     return Get_Text( ID_Text_DOS_Error_605, _Text_DOS_Error_605 ) ;
}


string Text_DOS_Error_606()
{
     return Get_Text( ID_Text_DOS_Error_606, _Text_DOS_Error_606 ) ;
}


string Text_DOS_Error_607()
{
     return Get_Text( ID_Text_DOS_Error_607, _Text_DOS_Error_607 ) ;
}


string Text_DOS_Error_608()
{
     return Get_Text( ID_Text_DOS_Error_608, _Text_DOS_Error_608 ) ;
}


string Text_DOS_Error_609()
{
     return Get_Text( ID_Text_DOS_Error_609, _Text_DOS_Error_609 ) ;
}


string Text_DOS_Error_610()
{
     return Get_Text( ID_Text_DOS_Error_610, _Text_DOS_Error_610 ) ;
}


string Text_DOS_Error_611()
{
     return Get_Text( ID_Text_DOS_Error_611, _Text_DOS_Error_611 ) ;
}


string Text_DOS_Error_612()
{
     return Get_Text( ID_Text_DOS_Error_612, _Text_DOS_Error_612 ) ;
}


string Text_DOS_Error_613()
{
     return Get_Text( ID_Text_DOS_Error_613, _Text_DOS_Error_613 ) ;
}


string Text_DOS_Error_614()
{
     return Get_Text( ID_Text_DOS_Error_614, _Text_DOS_Error_614 ) ;
}


string Text_DOS_Error_615()
{
     return Get_Text( ID_Text_DOS_Error_615, _Text_DOS_Error_615 ) ;
}


string Text_DOS_Error_616()
{
     return Get_Text( ID_Text_DOS_Error_616, _Text_DOS_Error_616 ) ;
}


string Text_DOS_Error_617()
{
     return Get_Text( ID_Text_DOS_Error_617, _Text_DOS_Error_617 ) ;
}


string Text_DOS_Error_618()
{
     return Get_Text( ID_Text_DOS_Error_618, _Text_DOS_Error_618 ) ;
}


string Text_DOS_Error_619()
{
     return Get_Text( ID_Text_DOS_Error_619, _Text_DOS_Error_619 ) ;
}


string Text_DOS_Error_620()
{
     return Get_Text( ID_Text_DOS_Error_620, _Text_DOS_Error_620 ) ;
}


string Text_DOS_Error_621()
{
     return Get_Text( ID_Text_DOS_Error_621, _Text_DOS_Error_621 ) ;
}


string Text_DOS_Error_622()
{
     return Get_Text( ID_Text_DOS_Error_622, _Text_DOS_Error_622 ) ;
}


string Text_DOS_Error_623()
{
     return Get_Text( ID_Text_DOS_Error_623, _Text_DOS_Error_623 ) ;
}


string Text_DOS_Error_624()
{
     return Get_Text( ID_Text_DOS_Error_624, _Text_DOS_Error_624 ) ;
}


string Text_DOS_Error_625()
{
     return Get_Text( ID_Text_DOS_Error_625, _Text_DOS_Error_625 ) ;
}


string Text_DOS_Error_626()
{
     return Get_Text( ID_Text_DOS_Error_626, _Text_DOS_Error_626 ) ;
}


string Text_DOS_Error_627()
{
     return Get_Text( ID_Text_DOS_Error_627, _Text_DOS_Error_627 ) ;
}


string Text_DOS_Error_628()
{
     return Get_Text( ID_Text_DOS_Error_628, _Text_DOS_Error_628 ) ;
}


string Text_DOS_Error_629()
{
     return Get_Text( ID_Text_DOS_Error_629, _Text_DOS_Error_629 ) ;
}


string Text_DOS_Error_630()
{
     return Get_Text( ID_Text_DOS_Error_630, _Text_DOS_Error_630 ) ;
}


string Text_DOS_Error_631()
{
     return Get_Text( ID_Text_DOS_Error_631, _Text_DOS_Error_631 ) ;
}


string Text_DOS_Error_632()
{
     return Get_Text( ID_Text_DOS_Error_632, _Text_DOS_Error_632 ) ;
}


string Text_DOS_Error_633()
{
     return Get_Text( ID_Text_DOS_Error_633, _Text_DOS_Error_633 ) ;
}


string Text_DOS_Error_634()
{
     return Get_Text( ID_Text_DOS_Error_634, _Text_DOS_Error_634 ) ;
}


string Text_DOS_Error_635()
{
     return Get_Text( ID_Text_DOS_Error_635, _Text_DOS_Error_635 ) ;
}


string Text_DOS_Error_636()
{
     return Get_Text( ID_Text_DOS_Error_636, _Text_DOS_Error_636 ) ;
}


string Text_DOS_Error_637()
{
     return Get_Text( ID_Text_DOS_Error_637, _Text_DOS_Error_637 ) ;
}


string Text_DOS_Error_638()
{
     return Get_Text( ID_Text_DOS_Error_638, _Text_DOS_Error_638 ) ;
}


string Text_DOS_Error_639()
{
     return Get_Text( ID_Text_DOS_Error_639, _Text_DOS_Error_639 ) ;
}


string Text_DOS_Error_640()
{
     return Get_Text( ID_Text_DOS_Error_640, _Text_DOS_Error_640 ) ;
}


string Text_DOS_Error_641()
{
     return Get_Text( ID_Text_DOS_Error_641, _Text_DOS_Error_641 ) ;
}


string Text_DOS_Error_642()
{
     return Get_Text( ID_Text_DOS_Error_642, _Text_DOS_Error_642 ) ;
}


string Text_DOS_Error_643()
{
     return Get_Text( ID_Text_DOS_Error_643, _Text_DOS_Error_643 ) ;
}


string Text_DOS_Error_644()
{
     return Get_Text( ID_Text_DOS_Error_644, _Text_DOS_Error_644 ) ;
}


string Text_DOS_Error_645()
{
     return Get_Text( ID_Text_DOS_Error_645, _Text_DOS_Error_645 ) ;
}


string Text_DOS_Error_646()
{
     return Get_Text( ID_Text_DOS_Error_646, _Text_DOS_Error_646 ) ;
}


string Text_DOS_Error_647()
{
     return Get_Text( ID_Text_DOS_Error_647, _Text_DOS_Error_647 ) ;
}


string Text_DOS_Error_648()
{
     return Get_Text( ID_Text_DOS_Error_648, _Text_DOS_Error_648 ) ;
}


string Text_DOS_Error_649()
{
     return Get_Text( ID_Text_DOS_Error_649, _Text_DOS_Error_649 ) ;
}


string Text_DOS_Error_650()
{
     return Get_Text( ID_Text_DOS_Error_650, _Text_DOS_Error_650 ) ;
}


string Text_DOS_Error_651()
{
     return Get_Text( ID_Text_DOS_Error_651, _Text_DOS_Error_651 ) ;
}


string Text_DOS_Error_652()
{
     return Get_Text( ID_Text_DOS_Error_652, _Text_DOS_Error_652 ) ;
}


string Text_DOS_Error_653()
{
     return Get_Text( ID_Text_DOS_Error_653, _Text_DOS_Error_653 ) ;
}


string Text_DOS_Error_654()
{
     return Get_Text( ID_Text_DOS_Error_654, _Text_DOS_Error_654 ) ;
}


string Text_DOS_Error_655()
{
     return Get_Text( ID_Text_DOS_Error_655, _Text_DOS_Error_655 ) ;
}


string Text_DOS_Error_656()
{
     return Get_Text( ID_Text_DOS_Error_656, _Text_DOS_Error_656 ) ;
}


string Text_DOS_Error_657()
{
     return Get_Text( ID_Text_DOS_Error_657, _Text_DOS_Error_657 ) ;
}


string Text_DOS_Error_658()
{
     return  Get_Text( ID_Text_DOS_Error_658, _Text_DOS_Error_658 ) ;
}


string Text_DOS_Error_659()
{
     return Get_Text( ID_Text_DOS_Error_659, _Text_DOS_Error_659 ) ;
}


string Text_DOS_Error_660()
{
     return Get_Text( ID_Text_DOS_Error_660, _Text_DOS_Error_660 ) ;
}


string Text_DOS_Error_661()
{
     return Get_Text( ID_Text_DOS_Error_661, _Text_DOS_Error_661 ) ;
}


string Text_DOS_Error_662()
{
     return Get_Text( ID_Text_DOS_Error_662, _Text_DOS_Error_662 ) ;
}


string Text_DOS_Error_663()
{
     return Get_Text( ID_Text_DOS_Error_663, _Text_DOS_Error_663 ) ;
}


string Text_DOS_Error_664()
{
     return Get_Text( ID_Text_DOS_Error_664, _Text_DOS_Error_664 ) ;
}


string Text_DOS_Error_665()
{
     return Get_Text( ID_Text_DOS_Error_665, _Text_DOS_Error_665 ) ;
}


string Text_DOS_Error_666()
{
     return Get_Text( ID_Text_DOS_Error_666, _Text_DOS_Error_666 ) ;
}


string Text_DOS_Error_667()
{
     return Get_Text( ID_Text_DOS_Error_667, _Text_DOS_Error_667 ) ;
}


string Text_DOS_Error_668()
{
     return Get_Text( ID_Text_DOS_Error_668, _Text_DOS_Error_668 ) ;
}


string Text_DOS_Error_669()
{
     return Get_Text( ID_Text_DOS_Error_669, _Text_DOS_Error_669 ) ;
}


string Text_DOS_Error_670()
{
     return Get_Text( ID_Text_DOS_Error_670, _Text_DOS_Error_670 ) ;
}


string Text_DOS_Error_671()
{
     return Get_Text( ID_Text_DOS_Error_671, _Text_DOS_Error_671 ) ;
}


string Text_DOS_Error_672()
{
     return Get_Text( ID_Text_DOS_Error_672, _Text_DOS_Error_672 ) ;
}


string Text_DOS_Error_673()
{
     return Get_Text( ID_Text_DOS_Error_673, _Text_DOS_Error_673 ) ;
}


string Text_DOS_Error_674()
{
     return Get_Text( ID_Text_DOS_Error_674, _Text_DOS_Error_674 ) ;
}


string Text_DOS_Error_675()
{
     return Get_Text( ID_Text_DOS_Error_675, _Text_DOS_Error_675 ) ;
}


string Text_DOS_Error_676()
{
     return Get_Text( ID_Text_DOS_Error_676, _Text_DOS_Error_676 ) ;
}


string Text_DOS_Error_677()
{
     return Get_Text( ID_Text_DOS_Error_677, _Text_DOS_Error_677 ) ;
}


string Text_DOS_Error_678()
{
     return  Get_Text( ID_Text_DOS_Error_678, _Text_DOS_Error_678 ) ;
}


string Text_DOS_Error_679()
{
     return Get_Text( ID_Text_DOS_Error_679, _Text_DOS_Error_679 ) ;
}


string Text_DOS_Error_680()
{
     return Get_Text( ID_Text_DOS_Error_680, _Text_DOS_Error_680 ) ;
}


string Text_DOS_Error_681()
{
     return Get_Text( ID_Text_DOS_Error_681, _Text_DOS_Error_681 ) ;
}


string Text_DOS_Error_682()
{
     return Get_Text( ID_Text_DOS_Error_682, _Text_DOS_Error_682 ) ;
}


string Text_DOS_Error_683()
{
     return Get_Text( ID_Text_DOS_Error_683, _Text_DOS_Error_683 ) ;
}


string Text_DOS_Error_684()
{
     return Get_Text( ID_Text_DOS_Error_684, _Text_DOS_Error_684 ) ;
}


string Text_DOS_Error_685()
{
     return Get_Text( ID_Text_DOS_Error_685, _Text_DOS_Error_685 ) ;
}


string Text_DOS_Error_686()
{
     return Get_Text( ID_Text_DOS_Error_686, _Text_DOS_Error_686 ) ;
}


string Text_DOS_Error_687()
{
     return Get_Text( ID_Text_DOS_Error_687, _Text_DOS_Error_687 ) ;
}


string Text_DOS_Error_688()
{
     return Get_Text( ID_Text_DOS_Error_688, _Text_DOS_Error_688 ) ;
}


string Text_DOS_Error_689()
{
     return  Get_Text( ID_Text_DOS_Error_689, _Text_DOS_Error_689 ) ;
}


string Text_DOS_Error_690()
{
     return Get_Text( ID_Text_DOS_Error_690, _Text_DOS_Error_690 ) ;
}


string Text_DOS_Error_691()
{
     return Get_Text( ID_Text_DOS_Error_691, _Text_DOS_Error_691 ) ;
}


string Text_DOS_Error_692()
{
     return Get_Text( ID_Text_DOS_Error_692, _Text_DOS_Error_692 ) ;
}


string Text_DOS_Error_693()
{
     return Get_Text( ID_Text_DOS_Error_693, _Text_DOS_Error_693 ) ;
}


string Text_DOS_Error_694()
{
     return Get_Text( ID_Text_DOS_Error_694, _Text_DOS_Error_694 ) ;
}


string Text_DOS_Error_695()
{
     return Get_Text( ID_Text_DOS_Error_695, _Text_DOS_Error_695 ) ;
}


string Text_DOS_Error_696()
{
     return Get_Text( ID_Text_DOS_Error_696, _Text_DOS_Error_696 ) ;
}


string Text_DOS_Error_697()
{
     return Get_Text( ID_Text_DOS_Error_697, _Text_DOS_Error_697 ) ;
}


string Text_DOS_Error_698()
{
     return Get_Text( ID_Text_DOS_Error_698, _Text_DOS_Error_698 ) ;
}


string Text_DOS_Error_699()
{
     return Get_Text( ID_Text_DOS_Error_699, _Text_DOS_Error_699 ) ;
}


string Text_DOS_Error_700()
{
     return Get_Text( ID_Text_DOS_Error_700, _Text_DOS_Error_700 ) ;
}


string Text_DOS_Error_701()
{
     return Get_Text( ID_Text_DOS_Error_701, _Text_DOS_Error_701 ) ;
}


string Text_DOS_Error_702()
{
     return Get_Text( ID_Text_DOS_Error_702, _Text_DOS_Error_702 ) ;
}


string Text_DOS_Error_703()
{
     return Get_Text( ID_Text_DOS_Error_703, _Text_DOS_Error_703 ) ;
}


string Text_DOS_Error_704()
{
     return Get_Text( ID_Text_DOS_Error_704, _Text_DOS_Error_704 ) ;
}


string Text_DOS_Error_705()
{
     return Get_Text( ID_Text_DOS_Error_705, _Text_DOS_Error_705 ) ;
}


string Text_DOS_Error_706()
{
     return Get_Text( ID_Text_DOS_Error_706, _Text_DOS_Error_706 ) ;
}


string Text_DOS_Error_707()
{
     return Get_Text( ID_Text_DOS_Error_707, _Text_DOS_Error_707 ) ;
}


string Text_DOS_Error_708()
{
     return Get_Text( ID_Text_DOS_Error_708, _Text_DOS_Error_708 ) ;
}


string Text_DOS_Error_709()
{
     return Get_Text( ID_Text_DOS_Error_709, _Text_DOS_Error_709 ) ;
}


string Text_DOS_Error_710()
{
     return Get_Text( ID_Text_DOS_Error_710, _Text_DOS_Error_710 ) ;
}


string Text_DOS_Error_711()
{
    return Get_Text( ID_Text_DOS_Error_711, _Text_DOS_Error_711 ) ;
}


string Text_DOS_Error_712()
{
    return Get_Text( ID_Text_DOS_Error_712, _Text_DOS_Error_712 ) ;
}


string Text_DOS_Error_713()
{
    return Get_Text( ID_Text_DOS_Error_713, _Text_DOS_Error_713 ) ;
}


string Text_DOS_Error_714()
{
    return Get_Text( ID_Text_DOS_Error_714, _Text_DOS_Error_714 ) ;
}


string Text_DOS_Error_715()
{
    return Get_Text( ID_Text_DOS_Error_715, _Text_DOS_Error_715 ) ;
}


string Text_DOS_Error_716()
{
    return Get_Text( ID_Text_DOS_Error_716, _Text_DOS_Error_716 ) ;
}


string Text_DOS_Error_717()
{
    return Get_Text( ID_Text_DOS_Error_717, _Text_DOS_Error_717 ) ;
}


string Text_DOS_Error_718()
{
    return Get_Text( ID_Text_DOS_Error_718, _Text_DOS_Error_718 ) ;
}


string Text_DOS_Error_719()
{
    return Get_Text( ID_Text_DOS_Error_719, _Text_DOS_Error_719 ) ;
}


string Text_DOS_Error_720()
{
    return Get_Text( ID_Text_DOS_Error_720, _Text_DOS_Error_720 ) ;
}


string Text_DOS_Error_721()
{
    return Get_Text( ID_Text_DOS_Error_721, _Text_DOS_Error_721 ) ;
}


string Text_DOS_Error_722()
{
    return Get_Text( ID_Text_DOS_Error_722, _Text_DOS_Error_722 ) ;
}


string Text_DOS_Error_723()
{
    return Get_Text( ID_Text_DOS_Error_723, _Text_DOS_Error_723 ) ;
}


string Text_DOS_Error_724()
{
    return Get_Text( ID_Text_DOS_Error_724, _Text_DOS_Error_724 ) ;
}


string Text_DOS_Error_725()
{
    return Get_Text( ID_Text_DOS_Error_725, _Text_DOS_Error_725 ) ;
}


string Text_DOS_Error_726()
{
    return Get_Text( ID_Text_DOS_Error_726, _Text_DOS_Error_726 ) ;
}


string Text_DOS_Error_727()
{
    return Get_Text( ID_Text_DOS_Error_727, _Text_DOS_Error_727 ) ;
}


string Text_DOS_Error_728()
{
    return Get_Text( ID_Text_DOS_Error_728, _Text_DOS_Error_728 ) ;
}


string Text_DOS_Error_729()
{
    return Get_Text( ID_Text_DOS_Error_729, _Text_DOS_Error_729 ) ;
}


string Text_DOS_Error_730()
{
    return Get_Text( ID_Text_DOS_Error_730, _Text_DOS_Error_730 ) ;
}


string Text_DOS_Error_731()
{
    return Get_Text( ID_Text_DOS_Error_731, _Text_DOS_Error_731 ) ;
}


string Text_DOS_Error_732()
{
    return Get_Text( ID_Text_DOS_Error_732, _Text_DOS_Error_732 ) ;
}


string Text_DOS_Error_733()
{
    return Get_Text( ID_Text_DOS_Error_733, _Text_DOS_Error_733 ) ;
}


string Text_DOS_Error_734()
{
    return Get_Text( ID_Text_DOS_Error_734, _Text_DOS_Error_734 ) ;
}


string Text_DOS_Error_735()
{
    return Get_Text( ID_Text_DOS_Error_735, _Text_DOS_Error_735 ) ;
}


string Text_DOS_Error_736()
{
    return Get_Text( ID_Text_DOS_Error_736, _Text_DOS_Error_736 ) ;
}


string Text_DOS_Error_737()
{
    return Get_Text( ID_Text_DOS_Error_737, _Text_DOS_Error_737 ) ;
}


string Text_DOS_Error_738()
{
    return Get_Text( ID_Text_DOS_Error_738, _Text_DOS_Error_738 ) ;
}


string Text_DOS_Error_739()
{
    return Get_Text( ID_Text_DOS_Error_739, _Text_DOS_Error_739 ) ;
}


string Text_DOS_Error_740()
{
    return Get_Text( ID_Text_DOS_Error_740, _Text_DOS_Error_740 ) ;
}


string Text_DOS_Error_741()
{
    return Get_Text( ID_Text_DOS_Error_741, _Text_DOS_Error_741 ) ;
}


string Text_DOS_Error_742()
{
    return Get_Text( ID_Text_DOS_Error_742, _Text_DOS_Error_742 ) ;
}


string Text_DOS_Error_743()
{
    return Get_Text( ID_Text_DOS_Error_743, _Text_DOS_Error_743 ) ;
}


string Text_DOS_Error_744()
{
    return Get_Text( ID_Text_DOS_Error_744, _Text_DOS_Error_744 ) ;
}


string Text_DOS_Error_752()
{
    return Get_Text( ID_Text_DOS_Error_752, _Text_DOS_Error_752 ) ;
}


string Text_Error_Unused_Error_Number()
{
    return Get_Text( ID_Text_Error_Unused_Error_Number, _Text_Error_Unused_Error_Number ) ;
}


string Text_Express_Error_Expected_Comma()
{
    return Get_Text( ID_Text_Express_Error_Expected_Comma, _Text_Express_Error_Expected_Comma ) ;
}


string Text_Express_Error_Syntax_Error()
{
    return Get_Text( ID_Text_Express_Error_Syntax_Error, _Text_Express_Error_Syntax_Error ) ;
}


string Text_Express_Error_Illegal_Symbol()
{
    return Get_Text( ID_Text_Express_Error_Illegal_Symbol, _Text_Express_Error_Illegal_Symbol ) ;
}


string Text_Express_Error_Expected_Left_Parenthesis()
{
    return Get_Text( ID_Text_Express_Error_Expected_Left_Parenthesis, _Text_Express_Error_Expected_Left_Parenthesis ) ;
}


string Text_Express_Error_Division_By_Zero()
{
    return Get_Text( ID_Text_Express_Error_Division_By_Zero, _Text_Express_Error_Division_By_Zero ) ;
}


string Text_Express_Error_Illegal_Number_for_factorial()
{
    return Get_Text( ID_Text_Express_Error_Illegal_Number_for_factorial, _Text_Express_Error_Illegal_Number_for_factorial ) ;
}


string Text_Express_Error_Floating_point_error()
{
    return Get_Text( ID_Text_Express_Error_Floating_point_error, _Text_Express_Error_Floating_point_error ) ;
}


string Text_Express_Error_Illegal_Number()
{
    return Get_Text( ID_Text_Express_Error_Illegal_Number, _Text_Express_Error_Illegal_Number ) ;
}


string Text_Express_Error_Illegal_Argument()
{
    return Get_Text( ID_Text_Express_Error_Illegal_Argument, _Text_Express_Error_Illegal_Argument ) ;
}


string Text_Express_Error_Imaginary_Number()
{
    return Get_Text( ID_Text_Express_Error_Imaginary_Number, _Text_Express_Error_Imaginary_Number ) ;
}


string Text_Express_Error_Illegal_Argument_in_LOG()
{
    return Get_Text( ID_Text_Express_Error_Illegal_Argument_in_LOG, _Text_Express_Error_Illegal_Argument_in_LOG ) ;
}


string Text_Express_Error_Argument_Too_large_in_EXP()
{
    return Get_Text( ID_Text_Express_Error_Argument_Too_large_in_EXP, _Text_Express_Error_Argument_Too_large_in_EXP ) ;
}


string Text_Express_Error_Missing_Right_Parenthesis()
{
    return Get_Text( ID_Text_Express_Error_Missing_Right_Parenthesis, _Text_Express_Error_Missing_Right_Parenthesis ) ;
}


string Text_Error_Invalid_Key_Size()
{
    return Get_Text( ID_Text_Error_Invalid_Key_Size, _Text_Error_Invalid_Key_Size ) ;
}


string Text_Files_Unit_Was_Not_Compiled_Correctly()
{
    return Get_Text( ID_Text_Files_Unit_Was_Not_Compiled_Correctly, _Text_Files_Unit_Was_Not_Compiled_Correctly ) ;
}


string Text_Error_FiP_Is_A_Singleton_Object()
{
    return Get_Text( ID_Text_Error_FiP_Is_A_Singleton_Object, _Text_Error_FiP_Is_A_Singleton_Object ) ;
}


string Text_Prompt_Enter_A_Filename()
{
    return Get_Text( ID_Text_Prompt_Enter_A_Filename, _Text_Prompt_Enter_A_Filename ) ;
}


string Text_Error_Filesys_Unit_Was_Not_Compiled_Correctly()
{
    return Get_Text( ID_Text_Error_Filesys_Unit_Was_Not_Compiled_Correctly, _Text_Error_Filesys_Unit_Was_Not_Compiled_Correctly ) ;
}


string Text_Error_Invalid_Syntax()
{
    return Get_Text( ID_Text_Error_Invalid_Syntax, _Text_Error_Invalid_Syntax ) ;
}


string Text_Error_Object_Is_Missing_A_Name()
{
    return Get_Text( ID_Text_Error_Object_Is_Missing_A_Name, _Text_Error_Object_Is_Missing_A_Name ) ;
}


string Text_Error_Expected_Colon()
{
    return Get_Text( ID_Text_Error_Expected_Colon, _Text_Error_Expected_Colon ) ;
}


string Text_Error_Object_Is_Missing_Type()
{
    return Get_Text( ID_Text_Error_Object_Is_Missing_Type, _Text_Error_Object_Is_Missing_Type ) ;
}


string Text_Error_Expected_Equal()
{
    return Get_Text( ID_Text_Error_Expected_Equal, _Text_Error_Expected_Equal ) ;
}


string Text_FSErr_FileNotOpen()
{
    return Get_Text( ID_Text_FSErr_FileNotOpen, _Text_FSErr_FileNotOpen ) ;
}


string Text_FSErr_EndOfFile()
{
    return Get_Text( ID_Text_FSErr_EndOfFile, _Text_FSErr_EndOfFile ) ;
}


string Text_FSErr_FileNotFound()
{
    return Get_Text( ID_Text_FSErr_FileNotFound, _Text_FSErr_FileNotFound ) ;
}


string Text_FSErr_FileNameLength()
{
    return Get_Text( ID_Text_FSErr_FileNameLength, _Text_FSErr_FileNameLength ) ;
}


string Text_FSErr_FileName()
{
    return Get_Text( ID_Text_FSErr_FileName, _Text_FSErr_FileName ) ;
}


string Text_FSErr_DirectoryNotFound()
{
    return Get_Text( ID_Text_FSErr_DirectoryNotFound, _Text_FSErr_DirectoryNotFound ) ;
}


string Text_FSErr_InvalidPath()
{
    return Get_Text( ID_Text_FSErr_InvalidPath, _Text_FSErr_InvalidPath ) ;
}


string Text_FSErr_NoRoomOnDevice()
{
    return Get_Text( ID_Text_FSErr_NoRoomOnDevice, _Text_FSErr_NoRoomOnDevice ) ;
}


string Text_FSErr_ProtectionViolation()
{
    return Get_Text( ID_Text_FSErr_ProtectionViolation, _Text_FSErr_ProtectionViolation ) ;
}


string Text_FSErr_DirectoryExists()
{
    return Get_Text( ID_Text_FSErr_DirectoryExists, _Text_FSErr_DirectoryExists ) ;
}


string Text_FSErr_FileNotEmpty()
{
    return Get_Text( ID_Text_FSErr_FileNotEmpty, _Text_FSErr_FileNotEmpty ) ;
}


string Text_FSErr_DirectoryNotEmpty()
{
    return Get_Text( ID_Text_FSErr_DirectoryNotEmpty, _Text_FSErr_DirectoryNotEmpty ) ;
}


string Text_FSErr_CorruptedFileStructure()
{
    return Get_Text( ID_Text_FSErr_CorruptedFileStructure, _Text_FSErr_CorruptedFileStructure ) ;
}


string Text_FSErr_FileExists()
{
    return Get_Text( ID_Text_FSErr_FileExists, _Text_FSErr_FileExists ) ;
}


string Text_FSErr_IllegalOperationType()
{
    return Get_Text( ID_Text_FSErr_IllegalOperationType, _Text_FSErr_IllegalOperationType ) ;
}


string Text_FSErr_LineTooLong()
{
    return Get_Text( ID_Text_FSErr_LineTooLong, _Text_FSErr_LineTooLong ) ;
}


string Text_FSErr_InvalidDevice()
{
    return Get_Text( ID_Text_FSErr_InvalidDevice, _Text_FSErr_InvalidDevice ) ;
}


string Text_FSErr_Internal_Duplicate()
{
    return Get_Text( ID_Text_FSErr_Internal_Duplicate, _Text_FSErr_Internal_Duplicate ) ;
}


string Text_FSErr_Invalid_Open_Mode()
{
    return Get_Text( ID_Text_FSErr_Invalid_Open_Mode, _Text_FSErr_Invalid_Open_Mode ) ;
}


string Text_FSErr_Unsupported_Operation()
{
    return Get_Text( ID_Text_FSErr_Unsupported_Operation, _Text_FSErr_Unsupported_Operation ) ;
}


string Text_FSErr_Device_In_Use()
{
    return Get_Text( ID_Text_FSErr_Device_In_Use, _Text_FSErr_Device_In_Use ) ;
}


string Text_FSErr_Unknown_Device_Type()
{
    return Get_Text( ID_Text_FSErr_Unknown_Device_Type, _Text_FSErr_Unknown_Device_Type ) ;
}


string Text_FSErr_Internal_Error_On_Add()
{
    return Get_Text( ID_Text_FSErr_Internal_Error_On_Add, _Text_FSErr_Internal_Error_On_Add ) ;
}


string Text_FSErr_Invalid_Record_Size()
{
    return Get_Text( ID_Text_FSErr_Invalid_Record_Size, _Text_FSErr_Invalid_Record_Size ) ;
}


string Text_FSErr_Internal_Corruption()
{
    return Get_Text( ID_Text_FSErr_Internal_Corruption, _Text_FSErr_Internal_Corruption ) ;
}


string Text_FSErr_Timeout()
{
    return Get_Text( ID_Text_FSErr_Timeout, _Text_FSErr_Timeout ) ;
}


string Text_FSErr_Invalid_Handle()
{
    return Get_Text( ID_Text_FSErr_Invalid_Handle, _Text_FSErr_Invalid_Handle ) ;
}


string Text_FSErr_Data_Format_Error()
{
    return Get_Text( ID_Text_FSErr_Data_Format_Error, _Text_FSErr_Data_Format_Error ) ;
}


string Text_FSErr_Read_Only()
{
    return Get_Text( ID_Text_FSErr_Read_Only, _Text_FSErr_Read_Only ) ;
}


string Text_FHErr_No_Room_On_Device()
{
    return Get_Text( ID_Text_FHErr_No_Room_On_Device, _Text_FHErr_No_Room_On_Device ) ;
}


string Text_FHErr_Corrupted_File_Structure()
{
    return Get_Text( ID_Text_FHErr_Corrupted_File_Structure, _Text_FHErr_Corrupted_File_Structure ) ;
}


string Text_FHErr_Invalid_Pointer_Operation()
{
    return Get_Text( ID_Text_FHErr_Invalid_Pointer_Operation, _Text_FHErr_Invalid_Pointer_Operation ) ;
}


string Text_FHErr_Deallocation_Error()
{
    return Get_Text( ID_Text_FHErr_Deallocation_Error, _Text_FHErr_Deallocation_Error ) ;
}


string Text_FHErr_Size_Mismatch()
{
    return Get_Text( ID_Text_FHErr_Size_Mismatch, _Text_FHErr_Size_Mismatch ) ;
}


string Text_FHErr_Read_Out_Of_Range()
{
    return Get_Text( ID_Text_FHErr_Read_Out_Of_Range, _Text_FHErr_Read_Out_Of_Range ) ;
}


string Text_FHErr_Read_Size_Error()
{
    return Get_Text( ID_Text_FHErr_Read_Size_Error, _Text_FHErr_Read_Size_Error ) ;
}


string Text_FHErr_Write_Out_Of_Range()
{
    return Get_Text( ID_Text_FHErr_Write_Out_Of_Range, _Text_FHErr_Write_Out_Of_Range ) ;
}


string Text_FHErr_Write_Size_Error()
{
    return Get_Text( ID_Text_FHErr_Write_Size_Error, _Text_FHErr_Write_Size_Error ) ;
}


string Text_FHErr_Bad_Minimum()
{
    return Get_Text( ID_Text_FHErr_Bad_Minimum, _Text_FHErr_Bad_Minimum ) ;
}


string Text_Error_Heap_Deallocation_Error()
{
    return Get_Text( ID_Text_Error_Heap_Deallocation_Error, _Text_Error_Heap_Deallocation_Error ) ;
}


string Text_Error_Heap_Access_Error()
{
    return Get_Text( ID_Text_Error_Heap_Access_Error, _Text_Error_Heap_Access_Error ) ;
}


string Text_Error_Illegal_Resolution_Size()
{
    return Get_Text( ID_Text_Error_Illegal_Resolution_Size, _Text_Error_Illegal_Resolution_Size ) ;
}


string Text_Error_Invalid_Address()
{
    return Get_Text( ID_Text_Error_Invalid_Address, _Text_Error_Invalid_Address ) ;
}


string Text_Prompt_Press_Any_Key_To_Continue()
{
    return Get_Text( ID_Text_Prompt_Press_Any_Key_To_Continue, _Text_Prompt_Press_Any_Key_To_Continue ) ;
}


string Text_Further_Help_Is_Available_On()
{
    return Get_Text( ID_Text_Further_Help_Is_Available_On, _Text_Further_Help_Is_Available_On ) ;
}


string Text_Sorry_No_Help_For_x_Found_At_This_Level()
{
    return Get_Text( ID_Text_Sorry_No_Help_For_x_Found_At_This_Level, _Text_Sorry_No_Help_For_x_Found_At_This_Level ) ;
}


string Text_Warning_Nesting_Exceeds_40_Levels()
{
    return Get_Text( ID_Text_Warning_Nesting_Exceeds_40_Levels, _Text_Warning_Nesting_Exceeds_40_Levels ) ;
}


string Text_Prompt_Topic()
{
    return Get_Text( ID_Text_Prompt_Topic, _Text_Prompt_Topic ) ;
}


string Text_Error_Help_Not_Available()
{
    return Get_Text( ID_Text_Error_Help_Not_Available, _Text_Error_Help_Not_Available ) ;
}


string Text_Error_HTML_No_Content()
{
    return Get_Text( ID_Text_Error_HTML_No_Content, _Text_Error_HTML_No_Content ) ;
}


string Text_Error_HTML_Moved_Permanently()
{
    return Get_Text( ID_Text_Error_HTML_Moved_Permanently, _Text_Error_HTML_Moved_Permanently ) ;
}


string Text_Error_HTML_Moved_Temporarily()
{
    return Get_Text( ID_Text_Error_HTML_Moved_Temporarily, _Text_Error_HTML_Moved_Temporarily ) ;
}


string Text_Error_HTML_Bad_Request()
{
    return Get_Text( ID_Text_Error_HTML_Bad_Request, _Text_Error_HTML_Bad_Request ) ;
}


string Text_Error_HTML_Unauthorized()
{
    return Get_Text( ID_Text_Error_HTML_Unauthorized, _Text_Error_HTML_Unauthorized ) ;
}


string Text_Error_HTML_Payment_Required()
{
    return Get_Text( ID_Text_Error_HTML_Payment_Required, _Text_Error_HTML_Payment_Required ) ;
}


string Text_Error_HTML_Forbidden()
{
    return Get_Text( ID_Text_Error_HTML_Forbidden, _Text_Error_HTML_Forbidden ) ;
}


string Text_Error_HTML_Not_Found()
{
    return Get_Text( ID_Text_Error_HTML_Not_Found, _Text_Error_HTML_Not_Found ) ;
}


string Text_Error_HTML_Method_Not_Allowed()
{
    return Get_Text( ID_Text_Error_HTML_Method_Not_Allowed, _Text_Error_HTML_Method_Not_Allowed ) ;
}


string Text_Error_HTML_Proxy_Authentication_Required()
{
    return Get_Text( ID_Text_Error_HTML_Proxy_Authentication_Required, _Text_Error_HTML_Proxy_Authentication_Required ) ;
}


string Text_Error_HTML_Request_Timeout()
{
    return Get_Text( ID_Text_Error_HTML_Request_Timeout, _Text_Error_HTML_Request_Timeout ) ;
}


string Text_Error_HTML_Conflict()
{
    return Get_Text( ID_Text_Error_HTML_Conflict, _Text_Error_HTML_Conflict ) ;
}


string Text_Error_HTML_Gone()
{
    return Get_Text( ID_Text_Error_HTML_Gone, _Text_Error_HTML_Gone ) ;
}


string Text_Error_HTML_Bad_Gateway()
{
    return Get_Text( ID_Text_Error_HTML_Bad_Gateway, _Text_Error_HTML_Bad_Gateway ) ;
}


string Text_Error_HTML_Service_Unavailable()
{
    return Get_Text( ID_Text_Error_HTML_Service_Unavailable, _Text_Error_HTML_Service_Unavailable ) ;
}


string Text_Error_HTML_Gateway_Timeout()
{
    return Get_Text( ID_Text_Error_HTML_Gateway_Timeout, _Text_Error_HTML_Gateway_Timeout ) ;
}


string Text_LibErr_Invalid_Library_File_Format()
{
    return Get_Text( ID_Text_LibErr_Invalid_Library_File_Format, _Text_LibErr_Invalid_Library_File_Format ) ;
}


string Text_LibErr_Module_Not_Found()
{
    return Get_Text( ID_Text_LibErr_Module_Not_Found, _Text_LibErr_Module_Not_Found ) ;
}


string Text_LibErr_Module_Already_Exists()
{
    return Get_Text( ID_Text_LibErr_Module_Already_Exists, _Text_LibErr_Module_Already_Exists ) ;
}


string Text_LibErr_Illegal_Module_Format()
{
    return Get_Text( ID_Text_LibErr_Illegal_Module_Format, _Text_LibErr_Illegal_Module_Format ) ;
}


string Text_Error_Imaginary_Number()
{
    return Get_Text( ID_Text_Error_Imaginary_Number, _Text_Error_Imaginary_Number ) ;
}


string Text_Error_Store_Overwrite()
{
    return Get_Text( ID_Text_Error_Store_Overwrite, _Text_Error_Store_Overwrite ) ;
}


string Text_Keystroke_Abort()
{
    return Get_Text( ID_Text_Keystroke_Abort, _Text_Keystroke_Abort ) ;
}


string Text_Keystroke_Cancel()
{
    return Get_Text( ID_Text_Keystroke_Cancel, _Text_Keystroke_Cancel ) ;
}


string Text_Keystroke_Ignore()
{
    return Get_Text( ID_Text_Keystroke_Ignore, _Text_Keystroke_Ignore ) ;
}


string Text_Keystroke_No()
{
    return Get_Text( ID_Text_Keystroke_No, _Text_Keystroke_No ) ;
}


string Text_Keystroke_OK()
{
    return Get_Text( ID_Text_Keystroke_OK, _Text_Keystroke_OK ) ;
}


string Text_Keystroke_Retry()
{
    return Get_Text( ID_Text_Keystroke_Retry, _Text_Keystroke_Retry ) ;
}


string Text_Keystroke_Yes()
{
    return Get_Text( ID_Text_Keystroke_Yes, _Text_Keystroke_Yes ) ;
}


string Text_Prompt_Abort()
{
    return Get_Text( ID_Text_Prompt_Abort, _Text_Prompt_Abort ) ;
}


string Text_Prompt_Cancel()
{
    return Get_Text( ID_Text_Prompt_Cancel, _Text_Prompt_Cancel ) ;
}


string Text_Prompt_Ignore()
{
    return Get_Text( ID_Text_Prompt_Ignore, _Text_Prompt_Ignore ) ;
}


string Text_Prompt_No()
{
    return Get_Text( ID_Text_Prompt_No, _Text_Prompt_No ) ;
}


string Text_Prompt_OK()
{
    return Get_Text( ID_Text_Prompt_OK, _Text_Prompt_OK ) ;
}


string Text_Prompt_Retry()
{
    return Get_Text( ID_Text_Prompt_Retry, _Text_Prompt_Retry ) ;
}


string Text_Prompt_Yes()
{
    return Get_Text( ID_Text_Prompt_Yes, _Text_Prompt_Yes ) ;
}


string Text_Prompt_Attempt_To_Delete_Alarm_For_Software_Configuration_Key()
{
    return  Get_Text( ID_Text_Prompt_Attempt_To_Delete_Alarm_For_Software_Configuration_Key, _Text_Prompt_Attempt_To_Delete_Alarm_For_Software_Configuration_Key ) ;
}


string Text_Prompt_Attempt_To_Delete_Software_Configuration_Key()
{
    return Get_Text( ID_Text_Prompt_Attempt_To_Delete_Software_Configuration_Key, _Text_Prompt_Attempt_To_Delete_Software_Configuration_Key ) ;
}


string Text_Prompt_Attempt_To_Change_Alarm_For_Software_Configuration_Key()
{
    return Get_Text( ID_Text_Prompt_Attempt_To_Change_Alarm_For_Software_Configuration_Key, _Text_Prompt_Attempt_To_Change_Alarm_For_Software_Configuration_Key ) ;
}


string Text_Prompt_Attempt_To_Change_Software_Configuration_Key()
{
    return Get_Text( ID_Text_Prompt_Attempt_To_Change_Software_Configuration_Key, _Text_Prompt_Attempt_To_Change_Software_Configuration_Key ) ;
}


string Text_Prompt_Attempt_To_Read_Software_Configuration_Key()
{
    return Get_Text( ID_Text_Prompt_Attempt_To_Read_Software_Configuration_Key, _Text_Prompt_Attempt_To_Read_Software_Configuration_Key ) ;
}


string Text_Error_SMU_Error()
{
    return Get_Text( ID_Text_Error_SMU_Error, _Text_Error_SMU_Error ) ;
}


string Text_Error_Too_Many_Windows()
{
    return Get_Text( ID_Text_Error_Too_Many_Windows, _Text_Error_Too_Many_Windows ) ;
}


string Text_Error_Window_Too_Large()
{
    return Get_Text( ID_Text_Error_Window_Too_Large, _Text_Error_Window_Too_Large ) ;
}


string Text_Warning_Window_Collision()
{
    return Get_Text( ID_Text_Warning_Window_Collision, _Text_Warning_Window_Collision ) ;
}


string Text_Pascal_Err_String_100()
{
    return Get_Text( ID_Text_Pascal_Err_String_100, _Text_Pascal_Err_String_100 ) ;
}


string Text_Pascal_Err_String_101()
{
    return Get_Text( ID_Text_Pascal_Err_String_101, _Text_Pascal_Err_String_101 ) ;
}


string Text_Pascal_Err_String_102()
{
    return Get_Text( ID_Text_Pascal_Err_String_102, _Text_Pascal_Err_String_102 ) ;
}


string Text_Pascal_Err_String_103()
{
    return Get_Text( ID_Text_Pascal_Err_String_103, _Text_Pascal_Err_String_103 ) ;
}


string Text_Pascal_Err_String_104()
{
    return Get_Text( ID_Text_Pascal_Err_String_104, _Text_Pascal_Err_String_104 ) ;
}


string Text_Pascal_Err_String_105()
{
    return Get_Text( ID_Text_Pascal_Err_String_105, _Text_Pascal_Err_String_105 ) ;
}


string Text_Pascal_Err_String_106()
{
    return Get_Text( ID_Text_Pascal_Err_String_106, _Text_Pascal_Err_String_106 ) ;
}


string Text_Pascal_Err_String_162()
{
    return Get_Text( ID_Text_Pascal_Err_String_162, _Text_Pascal_Err_String_162 ) ;
}


string Text_Pascal_Err_String_200()
{
    return Get_Text( ID_Text_Pascal_Err_String_200, _Text_Pascal_Err_String_200 ) ;
}


string Text_Pascal_Err_String_201()
{
    return Get_Text( ID_Text_Pascal_Err_String_201, _Text_Pascal_Err_String_201 ) ;
}


string Text_Pascal_Err_String_202()
{
    return Get_Text( ID_Text_Pascal_Err_String_202, _Text_Pascal_Err_String_202 ) ;
}


string Text_Pascal_Err_String_203()
{
    return Get_Text( ID_Text_Pascal_Err_String_203, _Text_Pascal_Err_String_203 ) ;
}


string Text_Pascal_Err_String_204()
{
    return Get_Text( ID_Text_Pascal_Err_String_204, _Text_Pascal_Err_String_204 ) ;
}


string Text_Pascal_Err_String_205()
{
    return Get_Text( ID_Text_Pascal_Err_String_205, _Text_Pascal_Err_String_205 ) ;
}


string Text_Pascal_Err_String_206()
{
    return Get_Text( ID_Text_Pascal_Err_String_206, _Text_Pascal_Err_String_206 ) ;
}


string Text_Pascal_Err_String_207()
{
    return Get_Text( ID_Text_Pascal_Err_String_207, _Text_Pascal_Err_String_207 ) ;
}


string Text_Pascal_Err_String_208()
{
    return Get_Text( ID_Text_Pascal_Err_String_208, _Text_Pascal_Err_String_208 ) ;
}


string Text_Pascal_Err_String_209()
{
    return  Get_Text( ID_Text_Pascal_Err_String_209, _Text_Pascal_Err_String_209 ) ;
}


string Text_Pascal_Err_String_210()
{
    return Get_Text( ID_Text_Pascal_Err_String_210, _Text_Pascal_Err_String_210 ) ;
}


string Text_Pascal_Err_String_211()
{
    return Get_Text( ID_Text_Pascal_Err_String_211, _Text_Pascal_Err_String_211 ) ;
}


string Text_Pascal_Err_String_212()
{
    return Get_Text( ID_Text_Pascal_Err_String_212, _Text_Pascal_Err_String_212 ) ;
}


string Text_Pascal_Err_String_213()
{
    return Get_Text( ID_Text_Pascal_Err_String_213, _Text_Pascal_Err_String_213 ) ;
}


string Text_Pascal_Err_String_214()
{
    return Get_Text( ID_Text_Pascal_Err_String_214, _Text_Pascal_Err_String_214 ) ;
}


string Text_Pascal_Err_String_215()
{
    return Get_Text( ID_Text_Pascal_Err_String_215, _Text_Pascal_Err_String_215 ) ;
}


string Text_Pascal_Err_String_216()
{
    return Get_Text( ID_Text_Pascal_Err_String_216, _Text_Pascal_Err_String_216 ) ;
}


string Text_Pascal_Err_String_217()
{
    return Get_Text( ID_Text_Pascal_Err_String_217, _Text_Pascal_Err_String_217 ) ;
}


string Text_Pascal_Err_String_218()
{
    return Get_Text( ID_Text_Pascal_Err_String_218, _Text_Pascal_Err_String_218 ) ;
}


string Text_Pascal_Err_String_219()
{
    return Get_Text( ID_Text_Pascal_Err_String_219, _Text_Pascal_Err_String_219 ) ;
}


string Text_Pascal_Err_String_220()
{
    return Get_Text( ID_Text_Pascal_Err_String_220, _Text_Pascal_Err_String_220 ) ;
}


string Text_Pascal_Err_String_221()
{
    return Get_Text( ID_Text_Pascal_Err_String_221, _Text_Pascal_Err_String_221 ) ;
}


string Text_Pascal_Err_String_222()
{
    return Get_Text( ID_Text_Pascal_Err_String_222, _Text_Pascal_Err_String_222 ) ;
}


string Text_Pascal_Err_String_223()
{
    return Get_Text( ID_Text_Pascal_Err_String_223, _Text_Pascal_Err_String_223 ) ;
}


string Text_Pascal_Err_String_224()
{
    return Get_Text( ID_Text_Pascal_Err_String_224, _Text_Pascal_Err_String_224 ) ;
}


string Text_Pascal_Err_String_225()
{
    return Get_Text( ID_Text_Pascal_Err_String_225, _Text_Pascal_Err_String_225 ) ;
}


string Text_Pascal_Err_String_226()
{
    return Get_Text( ID_Text_Pascal_Err_String_226, _Text_Pascal_Err_String_226 ) ;
}


string Text_Pascal_Err_String_227()
{
    return Get_Text( ID_Text_Pascal_Err_String_227, _Text_Pascal_Err_String_227 ) ;
}


string Text_Pascal_Err_String_228()
{
    return Get_Text( ID_Text_Pascal_Err_String_228, _Text_Pascal_Err_String_228 ) ;
}


string Text_Pascal_Err_String_229()
{
    return Get_Text( ID_Text_Pascal_Err_String_229, _Text_Pascal_Err_String_229 ) ;
}


string Text_Pascal_Err_String_230()
{
    return Get_Text( ID_Text_Pascal_Err_String_230, _Text_Pascal_Err_String_230 ) ;
}


string Text_Pascal_Err_String_231()
{
    return Get_Text( ID_Text_Pascal_Err_String_231, _Text_Pascal_Err_String_231 ) ;
}


string Text_Pascal_Err_String_232()
{
    return Get_Text( ID_Text_Pascal_Err_String_232, _Text_Pascal_Err_String_232 ) ;
}


string Text_Error_Invalid_List_Index()
{
    return Get_Text( ID_Text_Error_Invalid_List_Index, _Text_Error_Invalid_List_Index ) ;
}


string Text_SHErr_No_Room_On_Device()
{
    return Get_Text( ID_Text_SHErr_No_Room_On_Device, _Text_SHErr_No_Room_On_Device ) ;
}


string Text_SHErr_Corrupted_File_Structure()
{
    return Get_Text( ID_Text_SHErr_Corrupted_File_Structure, _Text_SHErr_Corrupted_File_Structure ) ;
}


string Text_SHErr_Invalid_Pointer_Operation()
{
    return Get_Text( ID_Text_SHErr_Invalid_Pointer_Operation, _Text_SHErr_Invalid_Pointer_Operation ) ;
}


string Text_SHErr_Deallocation_Error()
{
    return Get_Text( ID_Text_SHErr_Deallocation_Error, _Text_SHErr_Deallocation_Error ) ;
}


string Text_SHErr_Size_Mismatch()
{
    return  Get_Text( ID_Text_SHErr_Size_Mismatch, _Text_SHErr_Size_Mismatch ) ;
}


string Text_SHErr_Read_Out_Of_Range()
{
    return Get_Text( ID_Text_SHErr_Read_Out_Of_Range, _Text_SHErr_Read_Out_Of_Range ) ;
}


string Text_SHErr_Read_Size_Error()
{
    return Get_Text( ID_Text_SHErr_Read_Size_Error, _Text_SHErr_Read_Size_Error ) ;
}


string Text_SHErr_Write_Out_Of_Range()
{
    return Get_Text( ID_Text_SHErr_Write_Out_Of_Range, _Text_SHErr_Write_Out_Of_Range ) ;
}


string Text_SHErr_Write_Size_Error()
{
    return Get_Text( ID_Text_SHErr_Write_Size_Error, _Text_SHErr_Write_Size_Error ) ;
}


string Text_SHErr_Bad_Minimum()
{
    return Get_Text( ID_Text_SHErr_Bad_Minimum, _Text_SHErr_Bad_Minimum ) ;
}


string Text_Template_Illegally_Referenced()
{
    return Get_Text( ID_Text_Template_Illegally_Referenced, _Text_Template_Illegally_Referenced ) ;
}


string Text_Object_Cannot_Call_Routine()
{
    return Get_Text( ID_Text_Object_Cannot_Call_Routine, _Text_Object_Cannot_Call_Routine ) ;
}


string Text_Objects_In_Arrays_Must_Be_Size_4()
{
    return Get_Text( ID_Text_Objects_In_Arrays_Must_Be_Size_4, _Text_Objects_In_Arrays_Must_Be_Size_4 ) ;
}


string Text_Maximum_Size_Of_Array_Object_Data_Exceeded()
{
    return Get_Text( ID_Text_Maximum_Size_Of_Array_Object_Data_Exceeded, _Text_Maximum_Size_Of_Array_Object_Data_Exceeded ) ;
}


string Text_Error_Subscript_Out_Of_Range_In()
{
    return Get_Text( ID_Text_Error_Subscript_Out_Of_Range_In, _Text_Error_Subscript_Out_Of_Range_In ) ;
}


string Text_Error_Static_Array_Is_Invalid()
{
    return Get_Text( ID_Text_Error_Static_Array_Is_Invalid, _Text_Error_Static_Array_Is_Invalid ) ;
}


string Text_Error_Maximum_EMS_Array_Element_Size_IS_16384()
{
    return Get_Text( ID_Text_Error_Maximum_EMS_Array_Element_Size_IS_16384, _Text_Error_Maximum_EMS_Array_Element_Size_IS_16384 ) ;
}


string Text_Error_Expanded_Memory_Device_Not_Responding()
{
    return Get_Text( ID_Text_Error_Expanded_Memory_Device_Not_Responding, _Text_Error_Expanded_Memory_Device_Not_Responding ) ;
}


string Text_Error_Expanded_Memory_Device_Not_Present()
{
    return Get_Text( ID_Text_Error_Expanded_Memory_Device_Not_Present, _Text_Error_Expanded_Memory_Device_Not_Present ) ;
}


string Text_Error_Incompatible_Version_Of_Expanded_Memory_Driver()
{
    return Get_Text( ID_Text_Error_Incompatible_Version_Of_Expanded_Memory_Driver, _Text_Error_Incompatible_Version_Of_Expanded_Memory_Driver ) ;
}


string Text_Error_Requested_Array_Size_Is_Zero_Pages()
{
    return Get_Text( ID_Text_Error_Requested_Array_Size_Is_Zero_Pages, _Text_Error_Requested_Array_Size_Is_Zero_Pages ) ;
}


string Text_Error_Insufficient_Expanded_Memory_Available_For_Array()
{
    return Get_Text( ID_Text_Error_Insufficient_Expanded_Memory_Available_For_Array, _Text_Error_Insufficient_Expanded_Memory_Available_For_Array ) ;
}


string Text_Error_Static_EMS_Array_Is_Invalid()
{
    return Get_Text( ID_Text_Error_Static_EMS_Array_Is_Invalid, _Text_Error_Static_EMS_Array_Is_Invalid ) ;
}


string Text_Error_Maximum_Stack_Size_Is_Exceeded()
{
    return Get_Text( ID_Text_Error_Maximum_Stack_Size_Is_Exceeded, _Text_Error_Maximum_Stack_Size_Is_Exceeded ) ;
}


string Text_Stack_Overflow_In()
{
    return Get_Text( ID_Text_Stack_Overflow_In, _Text_Stack_Overflow_In ) ;
}


string Text_Error_Stack_Is_Empty_In()
{
    return Get_Text( ID_Text_Error_Stack_Is_Empty_In, _Text_Error_Stack_Is_Empty_In ) ;
}


string Text_Error_Dynamic_Array_Is_Invalid()
{
    return Get_Text( ID_Text_Error_Dynamic_Array_Is_Invalid, _Text_Error_Dynamic_Array_Is_Invalid ) ;
}


string Text_Error_Maximum_Dynamic_Stack_Size_Is_Exceeded()
{
    return Get_Text( ID_Text_Error_Maximum_Dynamic_Stack_Size_Is_Exceeded, _Text_Error_Maximum_Dynamic_Stack_Size_Is_Exceeded ) ;
}


string Text_Error_While_Opening_Virtual_Array_Image_File()
{
    return Get_Text( ID_Text_Error_While_Opening_Virtual_Array_Image_File, _Text_Error_While_Opening_Virtual_Array_Image_File ) ;
}


string Text_Error_Virtual_Array_Is_Invalid()
{
    return Get_Text( ID_Text_Error_Virtual_Array_Is_Invalid, _Text_Error_Virtual_Array_Is_Invalid ) ;
}


string Text_Error_Maximum_Virtual_Stack_Size_Is_Exceeded()
{
    return Get_Text( ID_Text_Error_Maximum_Virtual_Stack_Size_Is_Exceeded, _Text_Error_Maximum_Virtual_Stack_Size_Is_Exceeded ) ;
}


string Text_Error_Maximum_Size_Of_List_Object_Data_Is_Exceeded()
{
    return Get_Text( ID_Text_Error_Maximum_Size_Of_List_Object_Data_Is_Exceeded, _Text_Error_Maximum_Size_Of_List_Object_Data_Is_Exceeded ) ;
}


string Text_Error_Objects_In_Lists_Must_Be_Size_4()
{
    return Get_Text( ID_Text_Error_Objects_In_Lists_Must_Be_Size_4, _Text_Error_Objects_In_Lists_Must_Be_Size_4 ) ;
}


string Text_Error_End_Of_List_In()
{
    return Get_Text( ID_Text_Error_End_Of_List_In, _Text_Error_End_Of_List_In ) ;
}


string Text_Error_No_Context_In()
{
    return Get_Text( ID_Text_Error_No_Context_In, _Text_Error_No_Context_In ) ;
}


string Text_Error_Begnning_Of_List_In()
{
    return Get_Text( ID_Text_Error_Beginning_Of_List_In, _Text_Error_Beginning_Of_List_In ) ;
}


string Text_Error_Empty_List_In()
{
    return Get_Text( ID_Text_Error_Empty_List_In, _Text_Error_Empty_List_In ) ;
}


string Text_Error_Queue_Is_Empty_In()
{
    return Get_Text( ID_Text_Error_Queue_Is_Empty_In, _Text_Error_Queue_Is_Empty_In ) ;
}


string Text_Error_Maximum_Size_Of_Array_Object_Data_Is_Exceeded()
{
    return Get_Text( ID_Text_Error_Maximum_Size_Of_Array_Object_Data_Is_Exceeded, _Text_Error_Maximum_Size_Of_Array_Object_Data_Is_Exceeded ) ;
}


string Text_Error_Objects_In_Trees_Must_Be_Size_4()
{
    return Get_Text( ID_Text_Error_Objects_In_Trees_Must_Be_Size_4, _Text_Error_Objects_In_Trees_Must_Be_Size_4 ) ;
}


string Text_Error_Maximum_Size_Of_B_Tree_Object_Data_Is_Exceeded()
{
    return Get_Text( ID_Text_Error_Maximum_Size_Of_B_Tree_Object_Data_Is_Exceeded, _Text_Error_Maximum_Size_Of_B_Tree_Object_Data_Is_Exceeded ) ;
}


string Text_Error_Maximum_Size_Of_B_Tree_Bucket_Is_Exceeded()
{
    return Get_Text( ID_Text_Error_Maximum_Size_Of_B_Tree_Bucket_Is_Exceeded, _Text_Error_Maximum_Size_Of_B_Tree_Bucket_Is_Exceeded ) ;
}


string Text_Error_Illegal_Record_Context()
{
    return Get_Text( ID_Text_Error_Illegal_Record_Context, _Text_Error_Illegal_Record_Context ) ;
}


string Text_Dynamic_Stack()
{
    return Get_Text( ID_Text_Dynamic_Stack, _Text_Dynamic_Stack ) ;
}


string Text_Virtual_Stack()
{
    return Get_Text( ID_Text_Virtual_Stack, _Text_Virtual_Stack ) ;
}


string Text_List_Stack()
{
    return Get_Text( ID_Text_List_Stack, _Text_List_Stack ) ;
}


string Text_Sparse_Array()
{
    return Get_Text( ID_Text_Sparse_Array, _Text_Sparse_Array ) ;
}


string Text_Error_Key_Size_Cannot_Exceed_Total_Tree_Object_Data_Size()
{
    return Get_Text( ID_Text_Error_Key_Size_Cannot_Exceed_Total_Tree_Object_Data_Size, _Text_Error_Key_Size_Cannot_Exceed_Total_Tree_Object_Data_Size ) ;
}


string Text_Error_Maximum_Size_Of_Tree_Object_Data_Is_Exceeded()
{
    return Get_Text( ID_Text_Error_Maximum_Size_Of_Tree_Object_Data_Is_Exceeded, _Text_Error_Maximum_Size_Of_Tree_Object_Data_Is_Exceeded ) ;
}


string Text_Error_Duplicate_Items_Encountered_In_Tree()
{
    return Get_Text( ID_Text_Error_Duplicate_Items_Encountered_In_Tree, _Text_Error_Duplicate_Items_Encountered_In_Tree ) ;
}


string Text_Error_Tree_Error()
{
    return Get_Text( ID_Text_Error_Tree_Error, _Text_Error_Tree_Error ) ;
}


string Text_Error_Tree_is_Empty_In()
{
    return Get_Text( ID_Text_Error_Tree_is_Empty_In, _Text_Error_Tree_is_Empty_In ) ;
}


string Text_Error_End_Of_Tree_In()
{
    return Get_Text( ID_Text_Error_End_Of_Tree_In, _Text_Error_End_Of_Tree_In ) ;
}


string Text_Error_While_Padding_Virtual_Array_Image_File()
{
    return Get_Text( ID_Text_Error_While_Padding_Virtual_Array_Image_File, _Text_Error_While_Padding_Virtual_Array_Image_File ) ;
}


string Text_Invalid_Symbol_Name()
{
    return Get_Text( ID_Text_Invalid_Symbol_Name, _Text_Invalid_Symbol_Name ) ;
}


string Text_Reserved_Name()
{
    return Get_Text( ID_Text_Reserved_Name, _Text_Reserved_Name ) ;
}


string Text_Multiply_Defined_Symbol()
{
    return Get_Text( ID_Text_Multiply_Defined_Symbol, _Text_Multiply_Defined_Symbol ) ;
}


string Text_Undefined_Reference()
{
    return Get_Text( ID_Text_Undefined_Reference, _Text_Undefined_Reference ) ;
}


string Text_No_More_Matches()
{
    return Get_Text( ID_Text_No_More_Matches, _Text_No_More_Matches ) ;
}


string Text_Unknown_Symbol_Error()
{
    return Get_Text( ID_Text_Unknown_Symbol_Error, _Text_Unknown_Symbol_Error ) ;
}


string Text_Error_TEU_Not_Enough_Memory()
{
    return Get_Text( ID_Text_Error_TEU_Not_Enough_Memory, _Text_Error_TEU_Not_Enough_Memory ) ;
}


string Text_Error_TEU_Backup_Past_Beginning_Of_Buffer()
{
    return Get_Text( ID_Text_Error_TEU_Backup_Past_Beginning_Of_Buffer, _Text_Error_TEU_Backup_Past_Beginning_Of_Buffer ) ;
}


string Text_Error_TEU_Advance_Beyond_End_Of_Buffer()
{
    return  Get_Text( ID_Text_Error_TEU_Advance_Beyond_End_Of_Buffer, _Text_Error_TEU_Advance_Beyond_End_Of_Buffer ) ;
}


string Text_Error_TEU_Line_Length_Exceeds_255_Characters()
{
    return Get_Text( ID_Text_Error_TEU_Line_Length_Exceeds_255_Characters, _Text_Error_TEU_Line_Length_Exceeds_255_Characters ) ;
}


string Text_Error_TEU_Text_Not_Found()
{
    return Get_Text( ID_Text_Error_TEU_Text_Not_Found, _Text_Error_TEU_Text_Not_Found ) ;
}


string Text_Error_TEU_Nothing_Selected()
{
    return Get_Text( ID_Text_Error_TEU_Nothing_Selected, _Text_Error_TEU_Nothing_Selected ) ;
}


string Text_Error_TEU_Selection_In_Progress()
{
    return Get_Text( ID_Text_Error_TEU_Selection_In_Progress, _Text_Error_TEU_Selection_In_Progress ) ;
}


string Text_Error_Maximum_Memory_Exceeded()
{
    return Get_Text( ID_Text_Error_Maximum_Memory_Exceeded, _Text_Error_Maximum_Memory_Exceeded ) ;
}


string Text_Error_Opening()
{
    return Get_Text( ID_Text_Error_Opening, _Text_Error_Opening ) ;
}


string Text_Warning_Some_Lines_Too_Long()
{
    return Get_Text( ID_Text_Warning_Some_Lines_Too_Long, _Text_Warning_Some_Lines_Too_Long ) ;
}


string Text_More()
{
    return Get_Text( ID_Text_More, _Text_More ) ;
}


string Text_Press_Enter_To_Continue1()
{
    return Get_Text( ID_Text_Press_Enter_To_Continue1, _Text_Press_Enter_To_Continue1 ) ;
}


string Text_Searching_For()
{
    return Get_Text( ID_Text_Searching_For, _Text_Searching_For ) ;
}


string Text_Enter_Keystroke_Whose_Definition_You_Wish_To_Save()
{
    return Get_Text( ID_Text_Enter_Keystroke_whose_Definition_You_Wish_To_Save, _Text_Enter_Keystroke_whose_Definition_You_Wish_To_Save ) ;
}


string Text_Store_Aborted()
{
    return Get_Text( ID_Text_Store_Aborted, _Text_Store_Aborted ) ;
}


string Text_Modifications_Will_No_Be_Saved_Continue_Quitting_NO()
{
    return Get_Text( ID_Text_Modifications_Will_No_Be_Saved_Continue_Quitting_NO,
        _Text_Modifications_Will_No_Be_Saved_Continue_Quitting_NO ) ;
}


string Text_1_Line()
{
    return Get_Text( ID_Text_1_Line, _Text_1_Line ) ;
}


string Text_n_Lines()
{
    return Get_Text( ID_Text_n_Lines, _Text_n_Lines ) ;
}


string Text_Error_Illegal_Command()
{
    return Get_Text( ID_Text_Error_Illegal_Command, _Text_Error_Illegal_Command ) ;
}


string Text_Missing_Parameter()
{
    return Get_Text( ID_Text_Missing_Parameter, _Text_Missing_Parameter ) ;
}


string Text_Error_Missing_Operand()
{
    return Get_Text( ID_Text_Error_Missing_Operand, _Text_Error_Missing_Operand ) ;
}


string Text_Error_Invalid_Line_Number()
{
    return Get_Text( ID_Text_Error_Invalid_Line_Number, _Text_Error_Invalid_Line_Number ) ;
}


string Text_Text_To_Search_For()
{
    return Get_Text( ID_Text_Text_To_Search_For, _Text_Text_To_Search_For ) ;
}


string Text_Error_Nested_Key_Definitions_Are_Not_Allowed()
{
    return Get_Text( ID_Text_Error_Nested_Key_Definitions_Are_Not_Allowed,
        _Text_Error_Nested_Key_Definitions_Are_Not_Allowed ) ;
}


string Text_Line()
{
    return Get_Text( ID_Text_Line, _Text_Line ) ;
}


string Text_Column()
{
    return Get_Text( ID_Text_Column, _Text_Column ) ;
}


string Text_Error_No_Keystrokes_Are_Being_Recorded()
{
    return Get_Text( ID_Text_Error_No_Keystrokes_Are_Being_Recorded, _Text_Error_No_Keystrokes_Are_Being_Recorded ) ;
}


string Text_Error_No_Keystrokes_Were_Recorded()
{
    return Get_Text( ID_Text_Error_No_Keystrokes_Were_Recorded, _Text_Error_No_Keystrokes_Were_Recorded ) ;
}


string Text_Press_The_Key_To_Which_To_Assign_The_Keystrokes()
{
    return Get_Text( ID_Text_Press_The_Key_To_Which_To_Assign_The_Keystrokes,
        _Text_Press_The_Key_To_Which_To_Assign_The_Keystrokes ) ;
}


string Text_Keystrokes_Remembered()
{
    return  Get_Text( ID_Text_Keystrokes_Remembered, _Text_Keystrokes_Remembered ) ;
}


string Text_Error_Previous_Key_Macro_Recording_Must_Be_Finished()
{
    return Get_Text( ID_Text_Error_Previous_Key_Macro_Recording_Must_Be_Finished, _Text_Error_Previous_Key_Macro_Recording_Must_Be_Finished ) ;
}


string Text_Enter_The_Keystrokes_To_Record()
{
    return Get_Text( ID_Text_Enter_The_Keystrokes_To_Record, _Text_Enter_The_Keystrokes_To_Record ) ;
}


string Text_Command()
{
    return Get_Text( ID_Text_Command, _Text_Command ) ;
}


string Text_Control_C_Ignored()
{
    return Get_Text( ID_Text_Control_C_Ignored, _Text_Control_C_Ignored ) ;
}


string Text_Modified()
{
    return Get_Text( ID_Text_Modified, _Text_Modified ) ;
}


string Text_File()
{
    return Get_Text( ID_Text_File, _Text_File ) ;
}


string Text_n_Bytes_Available()
{
    return Get_Text( ID_Text_n_Bytes_Available, _Text_n_Bytes_Available ) ;
}


string Text_Line_Column()
{
    return Get_Text( ID_Text_Line_Column, _Text_Line_Column ) ;
}


string Text_Editing_File_x_Confirm()
{
    return Get_Text( ID_Text_Editing_File_x_Confirm, _Text_Editing_File_x_Confirm ) ;
}


string Text_Parameters_Are_Not_Allowed_On()
{
    return Get_Text( ID_Text_Parameters_Are_Not_Allowed_On, _Text_Parameters_Are_Not_Allowed_On ) ;
}


string Text_Recover_And_Read_Only_Are_Incompatible_Switches()
{
    return Get_Text( ID_Text_Recover_And_Read_Only_Are_Incompatible_Switches,
        _Text_Recover_And_Read_Only_Are_Incompatible_Switches ) ;
}


string Text_Invalid_Switch()
{
    return Get_Text( ID_Text_Invalid_Switch, _Text_Invalid_Switch ) ;
}


string Text_Error_While_Opening_Journal_File_Cant_Recover()
{
    return Get_Text( ID_Text_Error_While_Opening_Journal_File_Cant_Recover, _Text_Error_While_Opening_Journal_File_Cant_Recover ) ;
}


string Text_Error_Input_File_Does_Not_Exist()
{
    return Get_Text( ID_Text_Error_Input_File_Does_Not_Exist, _Text_Error_Input_File_Does_Not_Exist ) ;
}


string Text_Sun()
{
    return Get_Text( ID_Text_Sun, _Text_Sun ) ;
}


string Text_Mon()
{
     return Get_Text( ID_Text_Mon, _Text_Mon ) ;
}


string Text_Tue()
{
    return Get_Text( ID_Text_Tue, _Text_Tue ) ;
}


string Text_Wed()
{
    return Get_Text( ID_Text_Wed, _Text_Wed ) ;
}


string Text_Thu()
{
    return  Get_Text( ID_Text_Thu, _Text_Thu ) ;
}


string Text_Fri()
{
    return Get_Text( ID_Text_Fri, _Text_Fri ) ;
}


string Text_Sat()
{
    return Get_Text( ID_Text_Sat, _Text_Sat ) ;
}


string Text_Address()
{
    return Get_Text( ID_Text_Address, _Text_Address ) ;
}


string Text_Data()
{
    return Get_Text( ID_Text_Data, _Text_Data ) ;
}


string Text_Caption_Modify_Memory()
{
    return Get_Text( ID_Text_Caption_Modify_Memory, _Text_Caption_Modify_Memory ) ;
}


string Text_Literal_Text()
{
    return Get_Text( ID_Text_Literal_Text, _Text_Literal_Text ) ;
}


string Text_Caption_Size()
{
    return Get_Text( ID_Text_Caption_Size, _Text_Caption_Size ) ;
}


string Text_Byte1()
{
    return Get_Text( ID_Text_Byte1, _Text_Byte1 ) ;
}


string Text_Word1()
{
    return Get_Text( ID_Text_Word1, _Text_Word1 ) ;
}


string Text_Long1()
{
    return Get_Text( ID_Text_Long1, _Text_Long1 ) ;
}


string Text_Button_Caption_OK()
{
    return Get_Text( ID_Text_Button_Caption_OK, _Text_Button_Caption_OK ) ;
}


string Text_Button_Caption_Cancel()
{
    return Get_Text( ID_Text_Button_Caption_Cancel, _Text_Button_Caption_Cancel ) ;
}


string Text_Button_Caption_Help()
{
    return Get_Text( ID_Text_Button_Caption_Help, _Text_Button_Caption_Help ) ;
}


string Text_New()
{
    return Get_Text( ID_Text_New, _Text_New ) ;
}


string Text_Button_Caption_Delete()
{
    return Get_Text( ID_Text_Button_Caption_Delete, _Text_Button_Caption_Delete ) ;
}


string Text_Button_Caption_New_Folder()
{
    return Get_Text( ID_Text_Button_Caption_New_Folder, _Text_Button_Caption_New_Folder ) ;
}


string Text_Caption_Internals()
{
    return Get_Text( ID_Text_Caption_Internals, _Text_Caption_Internals ) ;
}


string Text_Persistant_Selection_Blocks()
{
    return Get_Text( ID_Text_Persistant_Selection_Blocks, _Text_Persistant_Selection_Blocks ) ;
}


string Text_Bounded_Caret()
{
    return Get_Text( ID_Text_Bounded_Caret, _Text_Bounded_Caret ) ;
}


string Text_Inactive_Selection()
{
    return Get_Text( ID_Text_Inactive_Selection, _Text_Inactive_Selection ) ;
}


string Text_Tab_Processing()
{
    return Get_Text( ID_Text_Tab_Processing, _Text_Tab_Processing ) ;
}


string Text_Sub_Window()
{
    return Get_Text( ID_Text_Sub_Window, _Text_Sub_Window ) ;
}


string Text_Auto_Indent()
{
    return Get_Text( ID_Text_Auto_Indent, _Text_Auto_Indent ) ;
}


string Text_Wrap_Caret()
{
    return Get_Text( ID_Text_Wrap_Caret, _Text_Wrap_Caret ) ;
}


string Text_Menu_Caption_Edit_Amp()
{
    return Get_Text( ID_Text_Menu_Caption_Edit_Amp, _Text_Menu_Caption_Edit_Amp ) ;
}


string Text_Menu_Caption_Undo_Amp()
{
    return Get_Text( ID_Text_Menu_Caption_Undo_Amp, _Text_Menu_Caption_Undo_Amp ) ;
}


string Text_Menu_Undo_Hint()
{
    return Get_Text( ID_Text_Menu_Undo_Hint, _Text_Menu_Undo_Hint ) ;
}


string Text_Menu_Caption_Cut_Amp()
{
    return Get_Text( ID_Text_Menu_Caption_Cut_Amp, _Text_Menu_Caption_Cut_Amp ) ;
}


string Text_Menu_Cut_Hint()
{
    return Get_Text( ID_Text_Menu_Cut_Hint, _Text_Menu_Cut_Hint ) ;
}


string Text_Menu_Caption_Copy_Amp()
{
    return Get_Text( ID_Text_Menu_Caption_Copy_Amp, _Text_Menu_Caption_Copy_Amp ) ;
}


string Text_Menu_Copy_Hint()
{
    return Get_Text( ID_Text_Menu_Copy_Hint, _Text_Menu_Copy_Hint ) ;
}


string Text_Menu_Caption_Paste_Amp()
{
    return Get_Text( ID_Text_Menu_Caption_Paste_Amp, _Text_Menu_Caption_Paste_Amp ) ;
}


string Text_Menu_Paste_Hint()
{
    return Get_Text( ID_Text_Menu_Paste_Hint, _Text_Menu_Paste_Hint ) ;
}


string Text_Menu_Caption_Delete_Amp()
{
    return Get_Text( ID_Text_Menu_Caption_Delete_Amp, _Text_Menu_Caption_Delete_Amp ) ;
}


string Text_Menu_Delete_Hint()
{
    return Get_Text( ID_Text_Menu_Delete_Hint, _Text_Menu_Delete_Hint ) ;
}


string Text_Menu_Caption_Include_Amp()
{
    return Get_Text( ID_Text_Menu_Caption_Include_Amp, _Text_Menu_Caption_Include_Amp ) ;
}


string Text_Menu_Include_Hint()
{
    return Get_Text( ID_Text_Menu_Include_Hint, _Text_Menu_Include_Hint ) ;
}


string Text_Menu_Caption_Search_Amp()
{
    return Get_Text( ID_Text_Menu_Caption_Search_Amp, _Text_Menu_Caption_Search_Amp ) ;
}


string Text_Menu_Caption_Find_Amp()
{
    return Get_Text( ID_Text_Menu_Caption_Find_Amp, _Text_Menu_Caption_Find_Amp ) ;
}


string Text_Menu_Find_Hint()
{
    return Get_Text( ID_Text_Menu_Find_Hint, _Text_Menu_Find_Hint ) ;
}


string Text_Menu_Caption_Replace_Amp()
{
    return Get_Text( ID_Text_Menu_Caption_Replace_Amp, _Text_Menu_Caption_Replace_Amp ) ;
}


string Text_Menu_Replace_Hint()
{
    return Get_Text( ID_Text_Menu_Replace_Hint, _Text_Menu_Replace_Hint ) ;
}


string Text_Menu_Caption_Find_Next_Amp()
{
    return Get_Text( ID_Text_Menu_Caption_Find_Next_Amp, _Text_Menu_Caption_Find_Next_Amp ) ;
}


string Text_Menu_Find_Next_Hint()
{
    return Get_Text( ID_Text_Menu_Find_Next_Hint, _Text_Menu_Find_Next_Hint ) ;
}


string Text_Menu_Caption_Goto_Amp()
{
    return Get_Text( ID_Text_Menu_Caption_Goto_Amp, _Text_Menu_Caption_Goto_Amp ) ;
}


string Text_Caption_Include_File()
{
    return Get_Text( ID_Text_Caption_Include_File, _Text_Caption_Include_File ) ;
}


string Text_Caption_Find_Data()
{
    return Get_Text( ID_Text_Caption_Find_Data, _Text_Caption_Find_Data ) ;
}


string Text_Search_For()
{
    return Get_Text( ID_Text_Search_For, _Text_Search_For ) ;
}


string Text_Search_Options()
{
    return Get_Text( ID_Text_Search_Options, _Text_Search_Options ) ;
}


string Text_Bytes()
{
    return Get_Text( ID_Text_Bytes, _Text_Bytes ) ;
}


string Text_Case_Sensitive()
{
    return Get_Text( ID_Text_Case_Sensitive, _Text_Case_Sensitive ) ;
}


string Text_Little_Endian()
{
    return Get_Text( ID_Text_Little_Endian, _Text_Little_Endian ) ;
}


string Text_Caption_Editor_Preferences()
{
    return Get_Text( ID_Text_Caption_Editor_Preferences, _Text_Caption_Editor_Preferences ) ;
}


string Text_Caption_Enter_Numeric_Value()
{
    return Get_Text( ID_Text_Caption_Enter_Numeric_Value, _Text_Caption_Enter_Numeric_Value ) ;
}


string Text_Enter_The_Value()
{
    return Get_Text( ID_Text_Enter_The_Value, _Text_Enter_The_Value ) ;
}


string Text_ASCII()
{
    return Get_Text( ID_Text_ASCII, _Text_ASCII ) ;
}


string Text_EBCDIC()
{
    return Get_Text( ID_Text_EBCDIC, _Text_EBCDIC ) ;
}


string Text_Other()
{
    return Get_Text( ID_Text_Other, _Text_Other ) ;
}


string Text_Caption_Goto_Address()
{
    return Get_Text( ID_Text_Caption_Goto_Address, _Text_Caption_Goto_Address ) ;
}


string Text_Enter_New_Address()
{
    return Get_Text( ID_Text_Enter_New_Address, _Text_Enter_New_Address ) ;
}


string Text_Button_Caption_Abort()
{
    return Get_Text( ID_Text_Button_Caption_Abort, _Text_Button_Caption_Abort ) ;
}


string Text_Caption_Go_To_Line_Number()
{
    return Get_Text( ID_Text_Caption_Go_To_Line_Number, _Text_Caption_Go_To_Line_Number ) ;
}


string Text_Enter_New_Line_Number_Amp()
{
    return Get_Text( ID_Text_Enter_New_Line_Number_Amp, _Text_Enter_New_Line_Number_Amp ) ;
}


string Text_Caption_Outline_Editor()
{
    return Get_Text( ID_Text_Caption_Outline_Editor, _Text_Caption_Outline_Editor ) ;
}


string Text_Button_Caption_Rename()
{
    return Get_Text( ID_Text_Button_Caption_Rename, _Text_Button_Caption_Rename ) ;
}


string Text_Button_Caption_Add()
{
    return Get_Text( ID_Text_Button_Caption_Add, _Text_Button_Caption_Add ) ;
}


string Text_Button_Caption_Create_Sub()
{
    return Get_Text( ID_Text_Button_Caption_Create_Sub, _Text_Button_Caption_Create_Sub ) ;
}


string Text_Button_Caption_Move()
{
    return Get_Text( ID_Text_Button_Caption_Move, _Text_Button_Caption_Move ) ;
}


string Text_Caption_Choose_Radix()
{
    return Get_Text( ID_Text_Caption_Choose_Radix, _Text_Caption_Choose_Radix ) ;
}


string Text_Choose_The_Radix_For_Numeric_Display()
{
    return Get_Text( ID_Text_Choose_The_Radix_For_Numeric_Display, _Text_Choose_The_Radix_For_Numeric_Display ) ;
}


string Text_Button_Caption_Help_Amp()
{
    return Get_Text( ID_Text_Button_Caption_Help_Amp, _Text_Button_Caption_Help_Amp ) ;
}


string Text_Caption_File_Has_Changed()
{
    return Get_Text( ID_Text_Caption_File_Has_Changed, _Text_Caption_File_Has_Changed ) ;
}


string Text_Save_Changes_To1()
{
    return Get_Text( ID_Text_Save_Changes_To1, _Text_Save_Changes_To1 ) ;
}


string Text_Button_Caption_Yes()
{
    return Get_Text( ID_Text_Button_Caption_Yes, _Text_Button_Caption_Yes ) ;
}


string Text_Button_Caption_No()
{
    return Get_Text( ID_Text_Button_Caption_No, _Text_Button_Caption_No ) ;
}


string Text_Text_To_Substitute()
{
    return Get_Text( ID_Text_Text_To_Substitute, _Text_Text_To_Substitute ) ;
}


string Text_Scope()
{
    return Get_Text( ID_Text_Scope, _Text_Scope ) ;
}


string Text_Search_From_Current_Position()
{
    return Get_Text( ID_Text_Search_From_Current_Position, _Text_Search_From_Current_Position ) ;
}


string Text_Search_Entire_File()
{
    return Get_Text( ID_Text_Search_Entire_File, _Text_Search_Entire_File ) ;
}


string Text_Button_Caption_Replace()
{
    return Get_Text( ID_Text_Button_Caption_Replace, _Text_Button_Caption_Replace ) ;
}


string Text_Prompt_On_Replace()
{
    return Get_Text( ID_Text_Prompt_On_Replace, _Text_Prompt_On_Replace ) ;
}


string Text_Search()
{
    return Get_Text( ID_Text_Search, _Text_Search ) ;
}
